#include <bits/stdc++.h>

#define sz(x) int((x).size())
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int maxn = int(5e3) + 53;
int timer = 0;
int dp[maxn][maxn] = {};
vector<pair<int, int>> g[maxn] = {};

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    for (int v = 0; v < maxn; ++v) {
        g[v].clear();
    }
    for (int i = 0; i < m; ++i) {
        int u, v, x;
        cin >> u >> v >> x;
        if (x >= maxn) {
            continue;
        }
        --u; --v;
        g[v].push_back(mp(u, x));
    }
    ++timer;
    dp[0][0] = timer;
    for (int v = 1; v < n; ++v) {
        for (auto p : g[v]) {
            int u = p.first;
            int x = p.second;
            for (int d = 0; d < maxn; ++d) {
                if (dp[u][d] != timer) {
                    continue;
                }
                if (d + x >= maxn) {
                    continue;
                }
                dp[v][d + x] = timer;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int v, x;
        cin >> v >> x;
        --v;
        int ans = 0;
        for (int d = 0; d < maxn; ++d) {
            if (d >= x && (x * p) / (p - 1) >= d && dp[v][d] == timer) {
                ans = 1;
                break;
            }
        }
        cout << ans;
    }
    cout << "\n";
}

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
