#include <bits/stdc++.h>

#define sz(x) int((x).size())
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

typedef long long ll;

const ll root = 0;

ll n, m, q, p;
vector<vector<pair<ll, ll>>> g;
vector<set<ll>> st;

void clr() {
    n = 0;
    m = 0;
    q = 0;
    p = 0;
    g.clear();
    st.clear();
}

void read() {
    cin >> n >> m >> q >> p;
    g.resize(n);
    st.resize(n);
    for (ll i = 0; i < m; ++i) {
        ll u, v, x;
        cin >> u >> v >> x;
        --u; --v;
        g[u].push_back(mp(v, x));
        g[v].push_back(mp(u, x));
    }
}

void solve() {
    read();
    st[root].insert(0);
    for (ll v = 1; v < n; ++v) {
        for (auto p : g[v]) {
            ll u = p.first;
            ll x = p.second;
            if (u >= v) {
                continue;
            }
            for (auto d : st[u]) {
                st[v].insert(d + x);
            }
        }
    }
    for (ll i = 0; i < q; ++i) {
        ll v, r;
        cin >> v >> r;
        --v;
        auto it = st[v].lower_bound(r);
        if (it != st[v].end() && *it <= p * r / (p - 1)) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    cout << "\n";
    clr();
}

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
