#include <bits/stdc++.h>

using namespace std;

int cur_time = 1;
int n, m;
const int N = 50, M = 50;

int a[N][M];
int used[N][M];
int d[N][M];

int ng[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
int st = 0;
int bfs(int x1, int y1, int x2, int y2, int k, int dist) {
    if (a[x1][y1] > k) return -1;
    queue <pair <int, int> > que;
    if (x1 == x2 && y1 == y2) return dist;
    used[x1][y1] = cur_time;
    while (que.size() > 0) que.pop();
    st = que.size();
    que.push({x1, y1});
    d[x1][y1] = 0;
    //int st = 0;
    bool not_p = false;
    while (que.size() > 0) {
        pair <int, int> cur = que.front();
        //cout << cur.first << " " << cur.second << "-------\n";
        if (que.size() > 0) que.pop();
        if (cur.first == x2 && cur.second == y2) {
            return d[cur.first][cur.second];
        }
        used[cur.first][cur.second] = cur_time;
        for (int j = 0; j < 4 && !not_p; j++) {
            int x = cur.first + ng[j][0];
            int y = cur.second + ng[j][1];
            if (0 <= x && x < n && 0 <= y && y < m) {
                if (used[x][y] != cur_time && a[x][y] <= k) {
                    que.push({x, y});
                    d[x][y] = d[cur.first][cur.second] + 1;
                    if (x == x2 && y == y2) {
                        return d[x][y];
                    }
                }
            }
        }
    }

    return -1;
}

int main()
{
    int q;

    ios_base::sync_with_stdio(false);
    cin.tie();

    cin >> n >> m >> q;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            a[i][j]++;
            d[i][j] = 100000;
        }
    }


    for (int qq = 0; qq < q; qq++) {
        int type;
        cin >> type;

        if (type == 1) {
            int r;
            cin >> r;
            r--;
            for (int i = 0; i < m; i++) {
                a[r][i] = 0;
            }
        }
        if (type == 2) {
            int s;
            cin >> s;
            s--;
            for (int i = 0; i < n; i++) {
                a[i][s] = 0;
            }
        }
        if (type == 3) {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            cout << bfs(x1, y1, x2, y2, k, 0) << "\n";
            cur_time++;
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j]++;
                d[i][j] = 100000;
            }
        }
    }
}
