#include <bits/stdc++.h>
using namespace std;
 
#define INF 1000000010
#define MOD 1000000007
#define pb push_back
#define f first
#define s second
 
using vi = vector <int>;
using ll = long long;
using pii = pair <int, int>;
 
void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
}
 
const int MAXN = 1e6 + 10;
 
int n, m, q;
int col[MAXN], row[MAXN];
vi v1, v2;
bool was1[MAXN], was2[MAXN];
 
int get_case(int x, int y, int k){
    if(row[x] < k && col[y] < k) return 0;
    else if(row[x] >= k && col[y] >= k) return 3;
    else if(row[x] >= k && col[y] < k) return 1;
    return 2;
}
 
int solve1(int a, int b, int c, int d, int k){
   	int cnt = 0;
    for(int i = 0; i < v1.size(); i++){
     	if(v1[i] >= min(a, c) && v1[i] <= max(a, c) && row[v1[i]] >= k)
     		cnt++;  
    }
    if(cnt == max(a, c) - min(a, c) + 1)    
        return abs(a - c) + abs(b - d);
    int ans = INF;
    for(int i = 0; i < v2.size(); i++){
        if(col[v2[i]] >= k)
            ans = min(ans, abs(a - c) + abs(v2[i] - b) + abs(v2[i] - d));
    }
    if(ans == INF)
        return -1;
    return ans;
}

int tree[4 * MAXN];

void upd(int u, int l, int r, int pos, int val){
	if(l == r){
		tree[u] = val;
		return;
	}
	if(pos <= (l + r) / 2)
		upd(u * 2 + 1, l, (l + r) / 2, pos, val);
	else
		upd(u * 2 + 2, (l + r) / 2 + 1, r, pos, val);
	tree[u] = min(tree[u * 2 + 1], tree[u * 2 + 2]);
}

int get(int u, int l, int r, int ql, int qr){
	if(l >= ql && r <= qr)
		return tree[u];
	if(l > qr || r < ql)
		return INF;
	return min(get(u * 2 + 1, l, (l + r) / 2, ql, qr), get(u * 2 + 2, (l + r) / 2 + 1, r, ql, qr));
}
 
int solve2(int a, int b, int c, int d, int k){
    int cnt = 0;
    for(int i = 0; i < v2.size(); i++){
    	if(v2[i] >= min(b, d) && v2[i] <= max(b, d) && col[v2[i]] >= k)
    		cnt++;
    }
    if(cnt == max(b, d) - min(b, d) + 1)
        return abs(a - c) + abs(b - d);
    int ans = INF;
    for(int i = 0; i < v1.size(); i++){
        if(row[v1[i]] >= k)
            ans = min(ans, abs(b - d) + abs(a - v1[i]) + abs(c - v1[i]));
    }
    if(ans == INF)
        return -1;
    return ans;
}
 
int main(){
    fastIO();
    cin >> n >> m >> q;
    bool aaa = 0;
    for(int num = 1; num <= q; num++){
        int id;
        cin >> id;
        if(id == 1){
            int r;
            cin >> r;
            r--;
            row[r] = num;
            upd(0, 0, n - 1, r, num);
        	if(was1[r] == 0){
        		was1[r] = 1;
        		v1.pb(r);
        	}
        }
        else if(id == 2){
        	aaa = 1;
            int c;
            cin >> c;
            c--;
            col[c] = num;
            if(was2[c] == 0){
            	was2[c] = 1;
            	v2.pb(c);
            }
        }
        else{
            int a, b, c, d, k;
            cin >> a >> b >> c >> d >> k;
            a--; b--; c--; d--;
            k = num - k;
            if(k == 0){
            	cout << abs(a - c) + abs(b - d) << '\n';
            	continue;
            }
            int c1 = get_case(a, b, k), c2 = get_case(c, d, k);
            if(c1 == 0 || c2 == 0)
                cout << -1 << '\n';
            else if(c1 == 3 || c2 == 3 || (c1 != c2))
                cout << abs(a - c) + abs(b - d) << '\n';
            else if(aaa == 0){
            	if(get(0, 0, n - 1, min(a, c), max(a, c)) >= k)
            		cout << abs(b - d) + abs(a - c) << '\n';
            	else
            		cout << -1 << '\n'; 
            }
            else if(c1 == 1)
                cout << solve1(a, b, c, d, k) << '\n';  
            else
                cout << solve2(a, b, c, d, k) << '\n';
        }
    }
     
     
     
    return 0;
}