#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

const int MAXN = 4e5 + 27;

int ans = 0;

int n, m;
vector<vector<int>> g(MAXN);

vector<int> a(MAXN);

int num = 0;

int used[MAXN];

vector<int> l(MAXN, INF);
vector<int> r(MAXN, -INF);

vector<pair<int, pair<int, int>>> res;

int cnt = 0;

void dfs(int u, int pr)
{
    if (l[u] != INF)
    {
        res.push_back({u + 1, {l[u] + 1, r[u] + 1}});
    }
    ++cnt;
    used[u] = true;
    if (num == r[u])
    {
        ++num;
        return;
    }
    ++num;
    if (num >= n)
    {
        return;
    }
    if (a[num] == pr)
    {
        return;
    }
    while (num < n)
    {
        if (num == r[u])
        {
            ++num;
            return;
        }
        while (num < n && a[num] == u)
        {
            ++num;
        }
        if (num >= n)
        {
            return;
        }
        if (a[num] == pr)
        {
            ++num;
            return;
        }
        if (used[a[num]])
        {
            ++num;
            ans = -1;
            return;
        }
        dfs(a[num], u);
        ++num;
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        --a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        l[a[i]] = min(l[a[i]], i);
        r[a[i]] = max(r[a[i]], i);
    }
    while (num < n)
    {
        dfs(a[num], -1);
    }
    if (ans == -1)
    {
        cout << -1 << endl;
        return 0;
    }
    cout << cnt << "\n";
    for (auto el : res)
    {
        cout << el.first << " " << el.second.first << " " << el.second.second << "\n";
    }
    cout << endl;
    return 0;
}
