#include <bits/stdc++.h>
#define int long long

using namespace std;

struct node {
    int ind, type, col;
};

int a[(int)3e5 + 10];

int used[(int)3e5 + 10];
int color[(int)3e5 + 10];
int lop[(int)3e5 + 10][2];

vector <node> v;

bool cmp(node a, node b) {
    if (a.ind == b.ind)
        return a.type > b.type;
    return a.ind < b.ind;
}

vector <vector <int>> ans;

int sol[(int)3e5 + 10];

int pans[(int)3e5 + 10];

signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        color[a[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        if (used[a[i]] == 0)
            used[a[i]] = i + 1;
    }
    for (int i = 1; i <= k; i++) {
        if (color[i] != 0) {
            v.push_back({color[i], -1, i});
            v.push_back({used[i], 1, i});
            if (color[i] == used[i]) {
                sol[color[i] - 1] = i + 1e9;
            } else {
                sol[color[i] - 1] = i;
                sol[used[i] - 1] = i;
            }
        }
    }
    deque <int> d;
    for (int i = 0; i < n; i++) {
        if (sol[i] >= 1e9) {
            pans[i] = sol[i] - 1e9;
            continue;
        }
        if (sol[i] != 0 && d.size() != 0 && d.back() == sol[i]) {
            pans[i] = d.back();
            d.pop_back();
            continue;
        }
        if (sol[i] == 0) {
            pans[i] = d.back();
            continue;
        }
        d.push_back(sol[i]);
        pans[i] = d.back();
    }
    for (int i = 0; i < n; i++) {
        if (pans[i] != a[i]) {
            cout << -1 << endl;
            return 0;
        }
    }
    sort(v.begin(), v.end(), cmp);
    int bal = 0;
    int mn = 1e9;
    for (int i = 0; i < v.size(); i++) {
        bal += v[i].type;
        mn = min(mn, bal);
    }
    if (bal != 0 || mn < 0) {
        cout << -1 << endl;
        return 0;
    }
    for (int i = 0; i < v.size(); i++) {
        if (lop[v[i].col][0] == 0) {
            lop[v[i].col][0] = v[i].ind;
        } else {
            lop[v[i].col][1] = v[i].ind;
        }
    }
    for (int i = 0; i < v.size(); i++) {
        if (v[i].type == 1) {
            ans.push_back({v[i].col, lop[v[i].col][0], lop[v[i].col][1]});
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i[0] << " " << i[1] << " " << i[2] << endl;
    }
    return 0;
}
