#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#define int long long
#define MAXN 300005
#define INF 1000000000
//#define first ff
//#define second ss

using namespace std;

int n, m, i, l[MAXN], r[MAXN], a[MAXN], t[MAXN * 4], f[MAXN * 4];
vector <pair<int, int> > p;

struct ST{
    int t[MAXN * 4], sz;

    void build(int v, int tl, int tr){
        sz = tr - tl + 1;
        fill(t, t + sz, 1);
    }

    void upd(int v, int tl, int tr, int pos, int x){
        t[pos] = x;
    }

    int get(int v, int tl, int tr, int pos){
        return t[pos];
    }

    int getL(int v, int tl, int tr, int x, int k){
        for(int i = x; i >= 0; i--){
            if(t[i] <= k)
                return i;
        }

        return -INF;
    }

    int getR(int v, int tl, int tr, int x, int k){
        for(int i = x; i < sz; i++){
            if(t[i] <= k)
                return i;
        }

        return INF;
    }

    int getR1(int v, int tl, int tr, int x, int k){
        int i;
        for(i = x; i < sz; i++){
            if(t[i] > k)
                return i - 1;
        }
        return sz;
    }


    int getL1(int v, int tl, int tr, int x, int k){
        int i;
        for(i = x; i >= 0; i--){
            if(t[i] > k)
                return i + 1;
        }

        return -1;
    }

} t1, t2;
main(){
    int n, m, q, type, x;
    freopen("input.txt", "r", stdin);
    cin >> n >> m >> q;

    t1.build(1, 0, n - 1);
    t2.build(1, 0, n - 1);

    for(i = 0; i < q; i++){
        cin >> type;

        if(type == 3){
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;

            //if(i == q - 1)
            //    cout << "*"<< i << " " << t1.get(1, 0, n - 1, x1) + i << endl;
            if(t1.get(1, 0, n - 1, x1) + i <= k && t2.get(1, 0, m - 1, y2) + i <= k){
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
            if(t2.get(1, 0, m - 1, y1) + i <= k && t1.get(1, 0, n - 1, x2) + i <= k){
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }

            int ans = INF;

            cout << t2.get(1, 0, m - 1, y1) + i << endl;
            if(t2.get(1, 0, m - 1, y1) + i <= k && t2.get(1, 0, m - 1, y2) + i <= k){
                int lf = t1.getL(1, 0, n - 1, x1, k - i);
                int rg = t1.getR(1, 0, n - 1, x1, k - i);
                int r;

                if(y1 < y2)
                    r = t2.getR2(1, 0, m - 1, y1, k - i);
                else
                    r = t2.getL2(1, 0, m - 1, y1, k - i);

                ans = min(ans, min(abs(lf - x1) + abs(lf - x2),
                    abs(rg - x1) + abs(rg - x2)) + max(0, abs(lf1 - r)));
            }

            if(t1.get(1, 0, n - 1, x1) + i <= k && t1.get(1, 0, n - 1, x2) + i <= k){
                int lf = t2.getL(1, 0, m - 1, y1, k - i);
                int rg = t2.getR(1, 0, m - 1, y1, k - i);

                int rg1 = t1.getR2(1, 0, n - 1, x1, k - i);
                int lf1 = t1.getL2(1, 0, n - 1, x2, k - i);
                ans = min(ans, min(abs(lf - y1) + abs(lf - y2),
                    abs(rg - y1) + abs(rg - y2)) + max(0, lf1 - rg1));
            }

            if(ans > INF / 2)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
        else{
            cin >> x;
            x--;

            if(type == 1)
                t1.upd(1, 0, n - 1, x, -i);
            else
                t2.upd(1, 0, m - 1, x, -i);
        }
    }

    return 0;
}
