#include <bits/stdc++.h>

using namespace std;
const int MN = 1e6 + 11, INF  = 1e9 + 7;
int rowdate[MN], coldate[MN], dorL[4 * MN], dorR[4 * MN], docL[4 * MN], docR[4 * MN];
int colmin[4 * MN], rowmin[4 * MN];
void setval(int t, int l, int r, int pos, int val, int *dt, int *mi, int *maL, int *maR) {
    if(l > pos || r <= pos) {
        return;
    } else if(r - l == 1) {
        dt[l] = val;
        mi[t] = val;
        maL[t] = l;
        maR[t] = l;
    } else {
        setval(t * 2 + 1, l, l + r>> 1, pos, val, dt, mi, maL, maR);
        setval(t * 2 + 2, l + r>> 1, r, pos, val, dt, mi, maL, maR);

        if(mi[t * 2 + 1] < mi[t * 2 + 2]) {
            mi[t] = mi[t * 2 + 1];
        } else {
            mi[t] = mi[t * 2 + 2];
        }

        if(dt[maL[t * 2 + 1]] >= dt[maL[t * 2 + 2]]) {
            maL[t] = maL[t * 2 + 1];
        } else {
            maL[t] = maL[t * 2 + 2];
        }

        if(dt[maR[t * 2 + 1]] > dt[maR[t * 2 + 2]]) {
            maR[t] = maR[t * 2 + 1];
        } else {
            maR[t] = maR[t * 2 + 2];
        }
    }
}
int fnd(int *dt, int *tree, int t, int lg, int rg, int l, int r) {//max [l, r]
    if(lg >= r || rg <= l) {
        return 0;
    } else if(lg >= l && rg <= r){
        return tree[t];
    } else {
        int p1 = fnd(dt, tree, t * 2 + 1, lg, lg + rg >> 1, l, r);
        int p2 = fnd(dt, tree, t * 2 + 2, lg + rg >> 1, rg, l, r);
        if(dt[p1] > dt[p2]) return  p1;
        else return p2;
    }
}

int fndMin(int *tree, int t, int lg, int rg, int l, int r) {//min [l, r]
    if(lg >= r || rg <= l) {
        return INF;
    } else if(lg >= l && rg <= r){
        return tree[t];
    } else {
        int p1 = fndMin(tree, t * 2 + 1, lg, lg + rg >> 1, l, r);
        int p2 = fndMin(tree, t * 2 + 2, lg + rg >> 1, rg, l, r);
        if(p1 < p2) return  p1;
        else return p2;
    }
}

int colserP(int *dt, int *tree, int t, int lg, int rg, int l, int r, int v) {
    if(lg >= r || rg <= l) {
        return 0;
    } else if(lg >= l && rg <= r){
        return tree[t];
    } else {
        int p1 = colserP(dt, tree, t * 2 + 1, lg, lg + rg >> 1, l, r, v);
        int p2 = colserP(dt, tree, t * 2 + 2, lg + rg >> 1, rg, l, r, v);
        if(p2 && dt[p2] >= v) return p2;
        return p1;
    }
}
int colserS(int *dt, int *tree, int t, int lg, int rg, int l, int r, int v) {
    if(lg >= r || rg <= l) {
        return MN - 1;
    } else if(lg >= l && rg <= r){
        return tree[t];
    } else {
        int p1 = colserS(dt, tree, t * 2 + 1, lg, lg + rg >> 1, l, r, v);
        int p2 = colserS(dt, tree, t * 2 + 2, lg + rg >> 1, rg, l, r, v);
        if(p1 && dt[p1] >= v) return p1;
        return p2;
    }
}

int tr(int lt, int r1, int c1, int r2, int c2, int *rowdate, int *coldate, int *colmin, int *docL, int *docR, int *rowmin, int *dorL, int *dolR) {
    if(r1 > r2) {
        swap(r1, r2);
        swap(c1, c2);
    }
    if(fndMin(colmin, 0, 0, MN, min(c1, c2), max(c1, c2) + 1) >= lt) {
        return abs(c1 - c2) + abs(r1 - r2);
    }

    if(coldate[c1] >= lt && rowdate[r2] >= lt) {
        return abs(c1 - c2) + abs(r1 - r2);
    }
    if(rowdate[r1] >= lt && coldate[c2] >= lt) {
        return abs(c1 - c2) + abs(r1 - r2);
    }

    if(r1 == r2) {
        if(rowdate[r1] >= lt) return abs(c1 - c2);
        else return INF;
    } else {
        if(rowdate[r1] < lt || rowdate[r2] < lt)
            return INF;
        if(coldate[fnd(coldate, docL, 0, 0, MN, min(c1, c2), max(c1, c2) + 1)] >= lt) {
            return abs(c1 - c2) + abs(r1 - r2);
        }
        int p1 = colserP(coldate, docR, 0, 0, MN, 0, min(c1, c2) + 1, lt);
        int p2 = colserS(coldate, docL, 0, 0, MN, max(c1, c2), MN, lt);
        if(coldate[p1] < lt) p1 = -INF;
        if(coldate[p2] < lt) p2 = INF;


        int d1 = abs(r1 - r2) + abs(p1 - c1) + abs(p1 - c2);
        int d2 = abs(r1 - r2) + abs(p2 - c1) + abs(p2 - c2);
        return min(d1, d2);
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, q;
    cin >> n >> m >> q;

    for(int i = 0; i < q; ++i) {
        int ty;
        cin >> ty;
        if(ty == 1) {
            int r;
            cin >> r;
            setval(0, 0, MN, r, i + 1, rowdate, rowmin, dorL, dorR);
        } else if(ty == 2) {
            int c;
            cin >> c;
            setval(0, 0, MN, c, i + 1, coldate, colmin, docL, docR);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            int re1 = tr(i + 1 - k, r1, c1, r2, c2, rowdate, coldate, colmin, docL, docR, rowmin, dorL, dorR);
            int re2 = tr(i + 1 - k, c1, r1, c2, r2, coldate, rowdate, rowmin, dorL, dorR, colmin, docL, docR);

            int re = min(re1, re2);
            if(re >= MN * 4) {
                cout << -1 << "\n";
            } else {
                cout << re << "\n";
            }
        }
    }

}