#include <bits/stdc++.h>

#define mp make_pair

using namespace std;

const int MAX_N = 51, MAX_M = 51;
int verts[MAX_M], hors[MAX_N];
int n, m;
int time_elapsed = 0;
int global_min = 0;

int bfs(int r1, int c1, int r2, int c2, int prohod) {
    if (min(hors[r1] + time_elapsed, global_min) <= prohod && min(verts[c2] + time_elapsed, global_min) <= prohod) {
        return abs(r1 - r2) + abs(c1 - c2);
    }
    if (min(hors[r2] + time_elapsed, global_min) <= prohod && min(verts[c1] + time_elapsed, global_min) <= prohod) {
        return abs(r1 - r2) + abs(c1 - c2);
    }

    int minnn = 1000000000;

    if (hors[r1] + time_elapsed <= prohod && hors[r2] + time_elapsed <= prohod) {
        int minn = 1000000000;
        for (int i = 0; i < m; ++i) {
            if (min(global_min, verts[i] + time_elapsed) > prohod) continue;
            minn = min(minn, abs(c1 - i) + abs(c2 - i));
        }
        minnn = min(minnn, minn + abs(r1 - r2));
    }

    if (verts[c1] + time_elapsed <= prohod && verts[c2] + time_elapsed <= prohod) {
        int minn = 1000000000;
        for (int i = 0; i < n; ++i) {
            if (min(global_min, hors[i] + time_elapsed) > prohod) continue;
            minn = min(minn, abs(r1 - i) + abs(r2 - i));
        }
        minnn = min(minnn, minn + abs(c1 - c2));
    }
    if (minnn == 1000000000) return -1;
    return minnn;
}

int main() {

    cin.tie(0); cout.tie(0);
    ios::sync_with_stdio(false);

    int q;
    cin >> n >> m >> q;
    for (int ii = 0; ii < q; ++ii) {
        time_elapsed++;
        global_min++;
        int code;
        cin >> code;
        if (code == 1) {
            int r;
            cin >> r;
            r--;
            hors[r] = -time_elapsed;
        }
        if (code == 2) {
            int c;
            cin >> c;
            c--;
            verts[c] = -time_elapsed;
        }
        if (code == 1 || code == 2) {
            int tmp_i = -1000000000;
            for (int i = 0; i < n; ++i) {
                tmp_i = max(tmp_i, hors[i]);
            }
            global_min = min(global_min, time_elapsed + tmp_i);
            int tmp_j = -1000000000;
            for (int j = 0; j < m; ++j) {
                tmp_j = max(tmp_j, verts[j]);
            }
            global_min = min(global_min, time_elapsed + tmp_j);
        }
        if (code == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;

            cout << bfs(r1, c1, r2, c2, k) << '\n';
        }
    }
}
