#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

struct Node
{
    int l;
    int r;
    int fld;
    struct Node *past;
};

struct Node *addel(int a, int b, int x, struct Node *p)
{
    struct Node *el;
    el = (struct Node *)malloc(sizeof(struct Node));
    el->l = a;
    el->r = b;
    el->fld = x;
    el->past = p;
    return el;
};

struct Node *delel(struct Node *el)
{
    struct Node *p;
    p = el->past;
    free(el);
    return p;
};

int main()
{
    int n, m;
    cin >> m >> n;
    vector<int> st(n, -1);
    vector<int> fn(n, -1);
    vector<int> Ver(m);
    int sum = 0;
    for (int i = 0; i < m; i++){
        cin >> Ver[i];
        int k =  Ver[i] - 1;
        if (st[k] == -1){
            st[k] = i + 1;
            fn[k] = i + 1;
            sum += 1;
        }else{
            fn[k] = i + 1;
        }
    }
    vector<pair<int, int> > ans(sum);
    vector<pair<int, int> > L(sum);
    vector<pair<int, int> > R(sum);
    map<pair<int, int>, int> d;
    int g = 0;
    for (int i = 0; i < n; i++){
        if (st[i] != -1){
            L[g] = make_pair(st[i], i + 1);
            R[g] = make_pair(fn[i], i + 1);
            ans[g] = make_pair(st[i], fn[i]);
            g += 1;
            d[make_pair(st[i], fn[i])] = i + 1;
        }
    }
    sort(ans.begin(), ans.end());
    g = 1;
    struct Node *cov;
    cov = addel(ans[0].first - 1, ans[0].second - 1, d[ans[0]], NULL);
    for (int i = 0; i < m; i++){
        while (cov != NULL && cov->r < i)
            cov = cov->past;
        if (g < sum && ans[g].first == i + 1){
            cov = addel(ans[g].first - 1, ans[g].second - 1, d[ans[g]], cov);
            g += 1;
        }
        if (Ver[i] != cov->fld){
            cout << -1;
            return 0;
        }
    }
    cout << sum << endl;
    for (int i = 0; i < sum; i++){
        cout << d[ans[i]] << " " << ans[i].first << " " << ans[i].second << endl;
    }
    return 0;
}
