#define _USE_MATH_DEFINES
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>
#include <cmath>
using namespace std;

#define kekek ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

long long inf = 1e7;

bool is(int x, int p, int r) {
	return ((r <= x) && ((p - 1) * x <= p * r));
}

void solve() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;

	vector<vector<int>> kek(n + 1);
	vector<vector<pair<int, int>>> e(n + 1);
	for (int i = 0; i < m; i++) {
		int f, s;
		long long c;
		cin >> f >> s >> c;
		c = min(c, inf);
		e[s].push_back({ f, c });
	}

	kek[1].push_back(0);
	for (int i = 2; i <= n; i++) {
		for (auto j : e[i]) {
			for (auto k : kek[j.first]) {
				if (k + j.second <= 10000) kek[i].push_back(k + j.second);
			}
		}
		sort(kek[i].begin(), kek[i].end());
	}
	vector<int> ans;

	for (int i = 0; i < q; i++) {
		int f, r1;
		cin >> f >> r1;

		int nn = kek[f].size();
		if (is(kek[f][0], p, r1) || is(kek[f][nn - 1], p, r1)) {
			ans.push_back(1);
			continue;
		}

		int l = 0, r = nn - 1;
		if (kek[f][l] > r1 || kek[f][r] * (p - 1) < p * r1) {
			ans.push_back(0);
			continue;
		}

		bool abc = false;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (is(kek[f][m], p, r1)) {
				abc = true;
				break;
			}

			if (kek[f][m] < r1) {
				l = m;
			}
			else r = m;
		}

		if (abc) {
			ans.push_back(1);
		}
		else ans.push_back(0);
	}

	for (auto i : ans) cout << i;
	cout << '\n';
}

signed main() {
	int v;
	cin >> v;

	for (int o = 0; o < v; o++) {
		solve();
	}

	//system("pause");
	return 0;
}


