#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

const int MAXN = 1e2 + 5;
int n, m, q;
int rs[MAXN];
int cs[MAXN];
int a[MAXN][MAXN];

void update_row(int r, int v) {
    v = -v;
    rs[r] = v;
}

void update_col(int c, int v) {
    v = -v;
    cs[c] = v;
}

int d[MAXN][MAXN];
int dx[] = {-1, 0, 0, 1};
int dy[] = {0, -1, 1, 0};
int solve(int r1, int c1, int r2, int c2, int k) {
    rep(i, n) {
        rep(j, m) {
            a[i][j] = min(rs[i], cs[j]);
        }
    }

    rep(i, n) {
        rep(j, m) {
            d[i][j] = -1;
        }
    }
    d[r1][c1] = 0;
    queue<pii> q;
    q.push({r1, c1});
    while (!q.empty()) {
        int x = q.front().f, y = q.front().s;
        q.pop();
        rep(t, 4) {
            int nx = x + dx[t], ny = y + dy[t];
            if (nx < 0 || nx >= n || ny < 0 || ny >= m || d[nx][ny] != -1 || a[nx][ny] > k) continue;
            d[nx][ny] = d[x][y] + 1;
            q.push({nx, ny});
        }
    }

    return d[r2][c2];
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> q;
    rep(i, q) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            update_row(r - 1, i);
        } else if (t == 2) {
            int c;
            cin >> c;
            update_col(c - 1, i);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << solve(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k - (i + 1)) << endl;
        }
    }
}