#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

struct edge {
    int to;
    ll w;
};

const int MAXN = 5005;
int n, m, q, p;
vector<edge> g[MAXN];
bitset<MAXN * 2> dp[MAXN];

void solve() {
    cin >> n >> m >> q >> p;
    rep(i, n) {
        g[i].clear();
    }
    rep(i, m) {
        int p, q;
        ll w;
        cin >> p >> q >> w;
        p--; q--;
        g[p].push_back({q, w});
    }

    rep(i, n) {
        dp[i].reset();
    }

    dp[0][0] = 1;
    rep(v, n) {
        for (auto it : g[v]) {
            int to = it.to;
            ll w = it.w;
            if (w > MAXN * 2) continue;
            dp[to] |= (dp[v] << w);
        }
    }

    string res(q, '0');
    rep(i, q) {
        int v;
        ll c;
        cin >> v >> c;
        v--;

        for (int x = 0; x < MAXN; ++x) {
            if (dp[v][x] && c <= x && x * (p - 1) <= c * p) {
                res[i] = '1';
                break;
            }
        }
    }

    cout << res << endl;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int tt;
    cin >> tt;
    rep(ttt, tt) {
        solve();
    }
}