#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#define int long long

struct seq {
    int i, r;
};

struct edge {
    int to, c;
};

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;

    // TODO: DO NOT use vector<vector>

    vector<vector<edge>> edges(n);
    vector<vector<int>> dists(n);

    int x, y, c;
    for (int i = 0; i < m; i++) {
        cin >> x >> y >> c;
        if (x > y) {
            swap(x, y);
        }
        edges[x - 1].push_back({y - 1, c});
    }
    dists[0].push_back(0);
    for (int i = 0; i < n; i++) {
        for (int d : dists[i]) {
            for (auto e : edges[i]) {
                dists[e.to].push_back(d + e.c);
            }
        }
    }
    int f, r;
    for (int i = 0; i < q; i++) {
        cin >> f >> r;
        bool found = false;
        for (int d : dists[f - 1]) {
            if (r <= d && d * (p - 1) <= r * p) {
                cout << 1;
                found = true;
                break;
            }
        }
        if (!found) {
            cout << 0;
        }
    }
    cout << '\n';
}

int32_t main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    for (int i = 0; i < T; i++) {
        solve();
    }
    return 0;
}