#pragma GCC optimize("Ofast", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(12);
#define RANDOM srand(342308)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define popb pop_back
#define f first
#define s second
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

signed main() {
	FAST; FIXED; RANDOM;
	int n, m;
	cin >> m >> n;
	vector<vector<pii>> add(m), del(m + 1);
	vector<int> a(m);
	cin >> a;
	map<int, int> first, last;
	for (int i = 0; i < m; ++i)
		last[a[i]] = i;
	for (int i = m - 1; i >= 0; --i)
		first[a[i]] = i;
	vector<pair<int, pair<pii, int>>> arr;
	for (auto &i : first) {
		int f = i.s;
		int s = last[i.f];
		arr.pb({s - f, {{f, s}, i.f}});
	}
	rsort(arr);
	for (int i = 0; i < sz(arr); ++i) {
		//cout << arr[i].s.f.f << ' ' << arr[i].s.f.s << endl;
		add[arr[i].s.f.f].pb({i, arr[i].s.s});
		del[arr[i].s.f.s + 1].pb({i, arr[i].s.s});
	}
	set<pii> curr;
	vector<int> b(m);
	for (int i = 0; i < m; ++i) {
		for (auto j : add[i]) curr.insert(j);
		for (auto j : del[i]) curr.erase(j);
		if (sz(curr)) b[i] = (--curr.end())->s;
	}
	if (b == a) {	
		cout << sz(arr) << '\n';
		for (auto i : arr) {
			cout << i.s.s << ' ' << i.s.f.f + 1 << ' ' << i.s.f.s + 1 << '\n';
		}
	} else cout << -1;
	return 0;
}