#pragma GCC optimize("Ofast", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(12);
#define RANDOM srand(342308)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define popb pop_back
#define f first
#define s second
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

graph G;

signed main() {
	FAST; FIXED; RANDOM;
	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < q; ++i) {
		int mode;
		cin >> mode;
		if (mode == 3) {
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j)
					++a[i][j];
			/*for (auto i : a) {
				for (auto j : i) cout << j << ' ';
				cout << '\n';
			}*/
			int x1, y1, x2, y2, k;
			cin >> y1 >> x1 >> y2 >> x2 >> k;
			--x1, --y1, --x2, --y2;
			G = graph(n * m);
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j) 
					if (a[i][j] <= k) {
						int from, to;
						if (i > 0 && a[i - 1][j] <= k) {
							from = i * m + j;
							to = (i - 1) * m + j;
							G[from].pb(to);
						}
						if (i < n - 1 && a[i + 1][j] <= k) {
							from = i * m + j;
							to = (i + 1) * m + j;
							G[from].pb(to);
						}
						if (j > 0 && a[i][j - 1] <= k) {
							from = i * m + j;
							to = i * m + j - 1;
							G[from].pb(to);
						}
						if (j < m - 1 && a[i][j + 1] <= k) {
							from = i * m + j;
							to = i * m + j + 1;
							G[from].pb(to);
						}
					}
			queue<int> que;
			que.push(y1 * m + x1);
			vector<int> dp(n * m, mod);
			vector<bool> used(n * m);
			dp[que.front()] = 0;
			used[que.front()] = true;
			while (sz(que)) {
				int f = que.front();
				que.pop();
				for (auto i : G[f]) {
					if (!used[i]) {
						used[i] = true;
						dp[i] = dp[f] + 1;
						que.push(i);
					}
				}
			}
			cout << (dp[y2 * m + x2] + 1) % (mod + 1) - 1 << endl;
		} else if (mode == 1) {
			int y;
			cin >> y;
			--y;
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j)
					++a[i][j];
			for (int x = 0; x < m; ++x) 
				a[y][x] = 0;
		} else if (mode == 2) {
			int x;
			cin >> x;
			--x;
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j)
					++a[i][j];
			for (int y = 0; y < n; ++y) 
				a[y][x] = 0;
		}
	}
	return 0;
}