#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

const int N = 5500;
const int MAXSUM = 15000;

vector <pair<int, int>> a[N], g[N];

int dp[N][MAXSUM];
int vis[N];

vector <int> path;

void run() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	for (int i = 1; i <= n; ++i)
		a[i].clear();
	for (int i = 0; i < m; ++i) {
		int u, v, l;
		cin >> u >> v >> l;
		a[u].push_back(make_pair(v, l));
		g[v].push_back(make_pair(u, l));
	}
	dp[1][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < MAXSUM; ++j) {
			if (dp[i][j]) {
				for (auto k : a[i]) {
					if (j + k.second >= MAXSUM) continue;
					dp[k.first][j + k.second] = 1;
				}
			}
		}
	}
	while (q--) {
		int st, f;
		cin >> st >> f;
		bool is = 0;
		for (int j = 0; j < MAXSUM; ++j) {
			if (dp[st][j] == 1) {
				if (f <= j && j * (p - 1) <= p * f)
					is = 1;
			}
		}
		cout << is;
	}
	cout << '\n';
}

void solve() {
	int t;
	cin >> t;
	while (t--) run();
}

int main(){
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}