#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge
{
    int to;
    ll price;
};

vector<vector<edge>> g;
vector<vector<edge>> rev;
vector<unordered_set<ll>> vars;

void calc(int a)
{
    if (!vars[a].empty())
        return;

    for (auto e : rev[a])
    {
        calc(e.to);

        for (ll x : vars[e.to])
            vars[a].insert(x + e.price);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;

    for (int test = 0; test < tests; test++)
    {
        int n, m, q;
        ll p;
        cin >> n >> m >> q >> p;

        g.assign(n, vector<edge>());
        rev.assign(n, vector<edge>());
        vars.assign(n, unordered_set<ll>());
        vars[0].insert(0);
        for (int i = 0; i < m; i++)
        {
            int a, b;
            ll c;
            cin >> a >> b >> c;

            g[a - 1].push_back({b - 1, c});
            rev[b - 1].push_back({a - 1, c});
        }

        for (int i = 0; i < n; i++)
            calc(i);

        for (int i = 0; i < q; i++)
        {
            int f;
            ll r;
            cin >> f >> r;
            f--;

            bool flag = false;
            for (ll j : vars[f])
            {
                if (r * (p - 1) <= j * (p - 1) &&
                    j * (p - 1) <= p * r)
                {
                    cout << "1";
                    flag = true;
                    break;
                }
            }

            if (!flag)
                cout << "0";
        }

        cout << endl;
    }

    return 0;
}