#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;

    for (int test = 0; test < tests; test++)
    {
        int n, m, q;
        ll p;
        cin >> n >> m >> q >> p;
        n--;

        vector<vector<ll>> vars(n);
        for (int i = 0; i < m; i++)
        {
            int a, b;
            ll c;
            cin >> a >> b >> c;

            vars[a - 1].push_back(c);
        }

        for (int i = 0; i < n; i++)
            sort(vars[i].begin(), vars[i].end());

        sort(vars.begin(), vars.end(), [](vector<ll> a, vector<ll> b)
        {
            return a[1] - a[0] < b[1] - b[0];
        });

        vector<ll> num(n);
        for (int i = 0; i < n; i++)
            num[i] = vars[i][1] - vars[i][0];

        vector<vector<pair<ll, int>>> queries(n);
        for (int i = 0; i < q; i++)
        {
            int f;
            ll r;
            cin >> f >> r;
            f -= 2;

            queries[f].push_back({r, i});
        }

        ll tmin = 0;
        ll tmax = 0;
        string ans(q, '0');
        for (int i = 0; i < n; i++)
        {
            tmin += vars[i][0];
            tmax += vars[i][1];
            ll cmin = tmin;
            ll cmax = tmax;

            for (auto p : queries[i])
            {
                ll x = p.first;

                for (int j = 0; j < i; j++)
                    if (cmin + num[j] > 2ll * x)
                        cmax -= num[j];

                for (int j = 0; j < i; j++)
                {
                    if (cmin + num[j] >= x && cmin + num[j] <= 2ll * x)
                    {
                        ans[p.second] = '1';
                        break;
                    }
                }

                if (cmax >= x)
                    ans[p.second] = '1';
            }
        }

        cout << ans << endl;
    }

    return 0;
}