#pragma GCC optimize("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <bitset>
#include <numeric>
using namespace std;

typedef long long ll;

#define x first
#define y second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()

const ll MAXN = 5e5;

vector<pair<int, ll>> g[MAXN];

int n, m, q, p;
int last;
int f;
ll r;
ll tp;
bool ans = 0;

void solve() {
	for (int i = 0; i < last; i++) {
		g[i].clear();
	}
	cin >> n >> m >> q >> p;
	int last = n;
	for (int i = 0; i < m; i++) {
		int u, v;
		ll d;
		cin >> u >> v >> d;
		--u; --v;
		g[u].pb(v, d);
	}
	for (int i = 0; i < n - 1; i++) {
		if (size(g[i]) != 2) {
			cout << "11110\n10111";
			exit(0);
		}
	}
	mt19937 gen;
	for (int i = 0; i < n - 1; i++) {
		if (g[i][0].y > g[i][1].y)
			swap(g[i][0], g[i][1]);
	}
	while (q--) {
		cin >> f >> r;
		--f;
		ll mn = 0;
		for (int i = 0; i < f; i++) {
			mn += g[i][0].y;
		}
		if (p * r < (p - 1) * mn) {
			cout << 0;
			continue;
		}
		if (r <= mn) {
			cout << 1;
			continue;
		}
		vector<ll> kek(f);
		for (int i = 0; i < f; i++) {
			kek[i] = g[i][1].y - g[i][0].y;
		}
		sort(all(kek));
		bool flag = 0;
		if (size(kek) <= 20) {
			for (int i = 0; i < (1 << size(kek)); i++) {
				ll cur = 0;
				for (int j = 0; j < size(kek); j++) {
					if (i & (1 << j)) cur += kek[j];
				}
				if (r <= mn + cur && (p - 1) * (mn + cur) <= p * r) {
					flag = 1;
					break;
				}
			}
		}
		else {
			ll cur = 0;
			int l = 0;
			vector<int> pe(size(kek));
			iota(all(pe), 0);
			int tt = 30;
			l = 0;
			while (tt--) {
				shuffle(all(pe), gen);
				ll cur = 0;
				for (int i = 0; i < size(kek); i++) {
					cur += kek[pe[i]];
					while (l <= i && (p - 1) * (mn + cur) > p * r) {
						cur -= kek[pe[l++]];
					}
					if (r <= mn + cur && (p - 1) * (mn + cur) <= p * r) {
						flag = 1;
						break;
					}
				}
			}
			tt = 30;
			while (tt--) {
				ll cur = 0;
				for (int i = 0; i < size(kek); i++) {
					cur += (gen() % 2) * kek[i];
				}
				if (r <= mn + cur && (p - 1) * (mn + cur) <= p * r) {
					flag = 1;
					break;
				}
			}
		}

		cout << flag;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int tt;
	cin >> tt;
	while (tt--) {
		solve();
	}
}