#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>
#include <ctime>
#include <fstream>
#include <cassert>
#include <cmath>

#pragma warning(4996:disable)
#pragma comment(linker, "/STACK:512000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)

const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const char el = '\n';

mt19937 rnd(time(NULL));

struct seg {
	int l, r, i;
	seg(int _l, int _r, int _i) { l = _l, r = _r, i = _i; }
};
bool operator <(const seg & a, const seg & b) {
	return a.l < b.l;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> m >> n;
	vector<int> a(m);
	forn(i, m) {
		cin >> a[i];
		a[i]--;
	}
	vector<int> l(n, -1), r(n, inf);
	vector<seg> t;
	forn(i, m) {
		if (l[a[i]] == -1)
			l[a[i]] = i;
		r[a[i]] = i;
	}
	forn(i, n) {
		if (l[i] >= 0)
			t.emplace_back(l[i], r[i], i);
	}
	sort(all(t));
	bool ok = 1;
	vector<seg> st;
	st.push_back(t[0]);
	int j = 1;
	firn(i, t.size()) {
		if (t[i].l <= t[i - 1].r && t[i].r >= t[i - 1].r) {
			ok = 0;
			break;
		}
	}
	forn(i, m) {
		while (!st.empty() && st.back().r < i) {
			st.pop_back();
		}
		while (j < (int)t.size() && t[j].l <= i) {
			st.push_back(t[j]);
			j++;
		}
		if (st.empty() || st.back().i != a[i]) {
			ok = 0;
			break;
		}
	}
	if (!ok)
		cout << -1;
	else {
		cout << (int)t.size() << el;
		forn(i, t.size())
			cout << t[i].i + 1 << ' ' << t[i].l + 1 << ' ' << t[i].r + 1 << el;
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}