#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>
#include <ctime>
#include <fstream>
#include <cassert>
#include <cmath>

#pragma warning(4996:disable)
#pragma comment(linker, "/STACK:512000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)

const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const char el = '\n';

mt19937 rnd(time(NULL));

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> r(n), c(m);
	firn(it, q + 1) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			r[x - 1] = it;
			continue;
		}
		if (type == 2) {
			int x;
			cin >> x;
			c[x - 1] = it;
			continue;
		}
		int x1, y1, x2, y2, k;
		cin >> x1 >> y1 >> x2 >> y2 >> k;
		x1--; y1--; x2--; y2--;
		k = it - k;
		if (r[x1] < k && c[y1] < k) {
			cout << -1 << el;
			continue;
		}
		if (r[x2] < k && c[y2] < k) {
			cout << -1 << el;
			continue;
		}
		if ((r[x1] >= k && c[y1] >= k) || (r[x2] >= k && c[y2] >= k)) {
			cout << abs(x1 - x2) + abs(y1 - y2) << el;
			continue;
		}
		if ((r[x1] >= k && r[x2] >= k) || (c[y1] >= k && c[y2] >= k)) {
			bool ans1 = 1;
			int ans = inf;
			if (r[x1] >= k) {
				for (int i = min(x1, x2); i <= max(x1, x2); ++i)
					if (r[i] < k) {
						ans1 = 0;
						break;
					}
				forn(i, m) {
					if (c[i] >= k)
						ans = min(ans, abs(x1 - x2) + abs(y1 - i) + abs(y2 - i));
				}
			}
			else {
				for (int i = min(y1, y2); i <= max(y1, y2); ++i) {
					if (c[i] < k) {
						ans1 = 0;
						break;
					}
				}
				forn(i, n)
					if (r[i] >= k)
						ans = min(ans, abs(y1 - y2) + abs(x1 - i) + abs(x2 - i));
			}
			if (ans1)
				cout << abs(x1 - x2) + abs(y1 - y2) << el;
			else {
				if (ans >= inf) cout << -1 << el;
				else cout << ans << el;
			}
		}
		else {
			cout << abs(x1 - x2) + abs(y1 - y2) << el;
		}
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}