#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 3e5 + 47;

vector<tuple<int, int, int>> ans;

int m, n, a[MAX_N], how[MAX_N];

int sz[MAX_N], l[MAX_N], r[MAX_N], pr[MAX_N], c[MAX_N];

int find(int u)
{
  if (u == pr[u])
  {
    return u;
  }
  return pr[u] = find(pr[u]);
}

void merge(int a, int b, int cc)
{
  a = find(a);
  b = find(b);
  if (sz[a] > sz[b])
  {
    swap(a, b);
  }
  pr[a] = b;
  c[b] = cc;
  sz[b] += sz[a];
  l[b] = min(l[b], l[a]);
  r[b] = max(r[b], r[a]);
}

void $main()
{
  cin >> m >> n;
  a[0] = -1;
  set<int> s;
  for (int i = 1; i <= m; i++)
  {
    cin >> a[i];
    s.insert(a[i]);
    pr[i] = i;
    sz[i] = 1;
    c[i] = a[i];
    l[i] = i;
    r[i] = i;
    if (a[i] != a[i - 1])
    {
      how[a[i]]++;
    }
    else
    {
      merge(i - 1, i, a[i]);
    }
  }
  vector<int> roots;
  for (int i = 1; i <= m; i++)
  {
    if (how[a[i]] == 1 && a[i] != a[i - 1])
    {
      roots.push_back(i);
    }
  }
  while (roots.size())
  {
    int u = roots.back();
    roots.pop_back();
    u = find(u);
    ans.push_back({c[u], l[u], r[u]});
    int ll = l[u];
    int rr = r[u];
    how[c[u]]--;
    if (rr + 1 <= m && how[c[find(rr + 1)]] > 1)
    {
      merge(rr, rr + 1, c[find(rr + 1)]);
      if (ll - 1 >= 1 && how[c[find(ll - 1)]] > 1 && c[find(ll - 1)] == c[find(rr + 1)])
      {
        how[c[find(rr + 1)]]--;
        merge(ll - 1, ll, c[find(rr + 1)]);
      }
      if (how[c[find(rr + 1)]] == 1)
      {
        roots.push_back(find(rr + 1));
      }
    }
    else if (ll - 1 >= 1 && how[c[find(ll - 1)]] > 1)
    {
      merge(ll, ll - 1, c[find(ll - 1)]);
      if (rr + 1 <= m && how[c[find(rr + 1)]] > 1 && c[find(ll - 1)] == c[find(rr + 1)])
      {
        how[c[find(ll - 1)]]--;
        merge(rr, rr + 1, c[find(ll - 1)]);
      }
      if (how[c[find(ll - 1)]] == 1)
      {
        roots.push_back(find(ll - 1));
      }
    }
  }
  if (ans.size() == s.size())
  {
    reverse(ans.begin(), ans.end());
    for (auto [c, l, r] : ans)
    {
      cout << c << ' ' << l << ' ' << r << '\n';
    }
  }
  else
  {
    cout << -1;
  }
}

signed main()
{
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  #ifdef _47
    freopen("4.cpp", "r", stdin), freopen("7.cpp", "w", stdout);
  #endif // _47
  $main();
  return 0;
}
