#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

signed main()
{
#ifdef POSPELOV
    freopen("in", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int m, n;
    cin >> m >> n;
    vector <int> arr(m);
    struct T
    {
        int l, r, i;
        bool operator <(const T &b) const
        {
            return l < b.l;
        }
    };
    vector <T> pos(n + 1, {m, 0, 0});
    for (int i = 1; i <= n; i++)
        pos[i].i = i;
    for (int i = 0; i < m; i++)
    {
        cin >> arr[i];
        pos[arr[i]].l = min(pos[arr[i]].l, i);
        pos[arr[i]].r = max(pos[arr[i]].r, i);
    }
    int k = 0;
    vector <pair <int, int>> st;
    for (int i = 1; i <= n; i++)
        if (pos[i].l != m)
        {
            st.push_back({pos[i].l, -i});
            st.push_back({pos[i].r, i});
            k++;
        }
    vector <int> val(m);
    sort(st.begin(), st.end());
    int last = 0, color = 1;
    for (auto i : st)
    {
        if (i.second < 0)
        {
            for (int j = last; j < i.first; j++)
                val[j] = color;
            color = abs(i.second);
            last = i.first;
        }
        else
        {
            color = abs(i.second);
            for (int j = last; j <= i.first; j++)
                val[j] = color;
            last = i.first + 1;
        }
    }
    if (val != arr)
        return cout << -1, 0;

    cout << k << "\n";
    sort(pos.begin() + 1, pos.end());
    for (int i = 1; i <= n; i++)
        if (pos[i].l != m)
            cout << pos[i].i << " " << pos[i].l + 1 << " " << pos[i].r + 1 << "\n";

    return 0;
}
