#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long
#define double long double
const int MAXN = 3 * 1e5 + 10;
int n, m;
int arr[MAXN];

void read() {
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		cin >> arr[i];
	}
}

vector < pair <int, pair <int, int> > > ans;
int last_pos[MAXN];
int first[MAXN];
int last[MAXN];

bool cmp(pair <int, pair <int, int> > a, pair <int, pair <int, int> > b) {
	return a.second.first < b.second.first;
}

vector <pair <int, int> > help;
void run() {
	for (int i = 1; i <= n; i++) {
		if (last_pos[arr[i]] > 0) {
			help.push_back({ last_pos[arr[i]], 1});
			help.push_back({ i, -1 });
		}
		last_pos[arr[i]] = i;
	}
	sort(help.begin(), help.end());
	vector <int> st;
	for (auto i : help) {
		if (i.second == -1 && st.back() != arr[i.first]) {
			cout << -1 << endl;
			exit(0);
		}
		else if (i.second == -1) {
			st.pop_back();
		}
		else {
			st.push_back(arr[i.first]);
		}
	}

	for (int i = 1; i <= n; i++) {
		if (first[arr[i]] == 0)
			first[arr[i]] = i;
		last[arr[i]] = i;
	}

	for (int i = 1; i <= m; i++) {
		if (first[i] != 0) {
			ans.push_back({ i, {first[i], last[i]} });
		}
	}
	sort(ans.begin(), ans.end(), cmp);
}

void write() {
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first << " " << i.second.first << " " << i.second.second << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}