#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cmath>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e9 + 7;
const int eps = 1e-9;

bool ask(int x)
{
	cout << "? " << x << endl;
	string ans;
	cin >> ans;
	return ans == "Yes";
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;

	string state;
	do
	{
		int l = 1, r = n + 1;
		bool corr = false;
		while (r - l > 1)
		{
			int m = (l + r) / 2;

			bool ans = ask(m);
			if (!corr)
			{
				bool ans2 = ask(m);
				if (ans != ans2)
				{
					corr = true;
					ans = ask(m);
				}
			}

			if (ans)
				l = m;
			else
				r = m;
		}

		cout << "! " << l << endl;
		cin >> state;
	} while (state == "Correct");

	//system("pause");
	return 0;
}