#include <iostream>
#include <vector>
#include <random>
#include <string>
#include <algorithm>
#include <random>
#include <cmath>
# include <stack>

using namespace std;

const int L = 1e4;

int main() {
	int t;
	cin >> t;
	for (int qwert = 0; qwert < t; qwert++) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<vector<pair<int, int>>> g(n);
		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			--a;
			--b;
			g[a].push_back({ b,c });
		}
		vector<vector<bool>> dp(n, vector<bool>(L,false));
		dp[0][0] = true;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < L; j++) {
				if (dp[i][j])
					for (auto p : g[i]) {
						if (j + p.second < L) {
							dp[p.first][j + p.second] = true;
						}
					}
			}
		}
		vector<bool> ans(q);
		for (int ii = 0; ii < q; ii++) {
			int f, r;
			cin >> f >> r;
			bool flag = false;
			for (int i = r; (p - 1)*i <= r * p; i++) {
				if (dp[f - 1][i]) flag = true;
			}
			ans[ii] = flag;
		}
		for (int i = 0; i < q; i++) {
			if (ans[i]) cout << 1;
			else cout << 0;
		}
		cout << endl;

	}
	cin >> t;
}
/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44


*/