#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define y1 y1228
template<class T1, class T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<class T1, class T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}
const int MAXN = 300228;


struct rmq
{
	int ss = 1;
	vector<int> d;
	vector<int> d1;
	void init(int n) {
		while (ss < n) {
			ss <<= 1;
		}
		d.resize(2 * ss, 0);
		d1.resize(2 * ss, 0);
	}
	void change(int i, int val) {
		i += ss;
		d1[i] = val;
		int is = i;
		while (i) {
			chkmax(d[i], val);
			i >>= 1;
		}
		while (is >> 1 > 0) {
			is >>= 1;
			d1[is] = min(d1[is * 2], d1[is * 2 + 1]);
		}
	}
	int getm(int l, int r) {
		l += ss;
		r += ss;
		int ans = 1e9;
		while (l <= r) {
			if (l & 1) {
				chkmin(ans, d1[l]);
				l++;
			}
			if (!(r & 1)) {
				chkmin(ans, d1[r]);
				r--;
			}
			l >>= 1;
			r >>= 1;
		}
		return ans;
	}
	int boost(int v, int vl, int vr, int l, int need) {
		if (d[v] < need) {
			return -1;
		}
		if (vl > l) {
			return -1;
		}
		if (vl == vr) {
			return vl - 1;
		}
		int f =  boost(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, need);
		if (f != -1) {
			return f;
		}
		return boost(v * 2, vl, (vl + vr) / 2, l, need);
	}
	int boost1(int v, int vl, int vr, int l, int need) {
		if (d[v] < need) {
			return -1;
		}
		if (vr < l) {
			return -1;
		}
		if (vl == vr) {
			return vl - 1;
		}
		int f =   boost1(v * 2, vl, (vl + vr) / 2, l, need);
		if (f != -1) {
			return f;
		}
		return boost1(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, need);
	}
	int getl(int i, int need) {
		return boost(1, 1, ss, i + 1, need);
	}
	int getr(int i, int need) {
		return boost1(1, 1, ss, i + 1, need);
	}
};


rmq kek[2];


int lastr[MAXN], lastc[MAXN];

void rowup(int i, int t) {
	lastr[i] = t;
	kek[0].change(i, t);
}


void colup(int i, int t) {
	lastc[i] = t;
	kek[1].change(i, t);
}



vector<int> getr(int i, int gr) {
	vector<int> res;
	if (lastr[i] >= gr) {
		res.pb(i);
		//cout << "opa" << '\n';
		return res;
	}
	int f = kek[0].getl(i, gr);
	if (f != -1) {
		res.pb(f);
	}
	int f1 = kek[0].getr(i, gr);
	if (f1 != -1) {
		res.pb(f1);
	}
	return res;
}


vector<int> getc(int i, int gr) {
	vector<int> res;
	if (lastc[i] >= gr) {
		res.pb(i);
		return res;
	}
	int f = kek[1].getl(i, gr);
	if (f != -1) {
		res.pb(f);
	}
	int f1 = kek[1].getr(i, gr);
	if (f1 != -1) {
		res.pb(f1);
	}
	return res;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//assert(freopen("input.in", "r", stdin));
	int n, m, q;
	cin >> n >> m >> q;
	kek[0].init(n);
	kek[1].init(m);
	for (int it = 1; it <= q; it++) {
		int t;
		cin >> t;
		if (t == 1 || t == 2) {
			int id;
			cin >> id;
			id--;
			if (t == 1) {
				rowup(id, it);
			} else {
				colup(id, it);
			}
		} else {
			int x, y, x1, y1, k;
			cin >> x >> y >> x1 >> y1 >> k;
			x--, y--, x1--, y1--;
			int border = it - k;
			if (lastr[x] < border && lastc[y] < border) {
				cout << -1 << '\n';
				continue;
			}
			if (lastr[x1] < border && lastc[y1] < border) {
				cout << -1 << '\n';
				continue;
			}
			if (x == x1) {
				if (lastr[x] >= border) {
					cout << abs(y - y1) << '\n';
					continue;
				}
			}
			if (y == y1) {
				if (lastc[y] >= border) {
					cout << abs(x - x1) << '\n';
					continue;
				}
			}
			vector<int> vx = getr(x, border);
			vector<int> vy = getc(y, border);
			vector<int> vx1 = getr(x1, border);
			vector<int> vy1 = getc(y1, border);
			int ans = 1e9;
			for (auto xx: vx) {
				for (auto yy: vy) {
					for (auto xz: vx1) {
						for (auto yz: vy1) {
							chkmin(ans, abs(xx - xz) + abs(yy - yz) + abs(xx - x) + abs(yy - y) + abs(xz - x1) + abs(yz - y1));
						}
					}
				}
			}
			if (kek[0].getm(min(x, x1), max(x, x1)) >= border) {
				chkmin(ans, abs(x - x1) + abs(y - y1));
			}
			//cout << kek[1].getm(min(y, y1), max(y, y1)) << endl;
			if (kek[1].getm(min(y, y1), max(y, y1)) >= border) {
				chkmin(ans, abs(x - x1) + abs(y - y1));
			}
			if (ans == 1e9) {
				ans = -1;
			}
			cout << ans << '\n';
		}
	}
}