#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define ld long double
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)1e6 + 10;
const int INF = (int)1e9 + 10;

pii t[2][4 * MAXN];
int r[MAXN], c[MAXN];

void update(int num, int v, int tl, int tr, int ind, int val)
{
    if (tl == tr)
    {
        t[num][v] = mp(val, val);
        return;
    }
    int tm = (tl + tr) / 2;
    if (tm >= ind)
        update(num, 2 * v, tl, tm, ind, val);
    else
        update(num, 2 * v + 1, tm + 1, tr, ind, val);
    t[num][v].X = min(t[num][2 * v].X, t[num][2 * v + 1].X);
    t[num][v].Y = max(t[num][2 * v].Y, t[num][2 * v + 1].Y);
    return;
}

int get_min(int num, int v, int tl, int tr, int l, int r)
{
    if (tl > r || tr < l)
        return INF;
    if (tl >= l && tr <= r)
        return t[num][v].X;
    int tm = (tl + tr) / 2;
    return min(get_min(num, 2 * v, tl, tm, l, r), get_min(num, 2 * v + 1, tm + 1, tr, l, r));
}

int get_max(int num, int v, int tl, int tr, int l, int r)
{
    if (tl > r || tr < l)
        return -INF;
    if (tl >= l && tr <= r)
        return t[num][v].Y;
    int tm = (tl + tr) / 2;
    return max(get_max(num, 2 * v, tl, tm, l, r), get_max(num, 2 * v + 1, tm + 1, tr, l, r));
}

int solve()
{
    int n, m, q;
    cin >> n >> m >> q;
    for (int x = 1; x <= q; x++)
    {
        int type;
        cin >> type;
        if (type == 1)
        {
            int a;
            cin >> a;
            r[a] = x;
            update(0, 1, 1, n, a, x);
        }
        if (type == 2)
        {
            int a;
            cin >> a;
            c[a] = x;
            update(1, 1, 1, m, a, x);
        }
        if (type == 3)
        {
            /*for (int i = 1; i <= n; i++)
            {
                for (int j = 1; j <= m; j++)
                    cerr << x - max(r[i], c[j]) << ' ';
                cerr << endl;
            }*/
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            bool f1, f2, f3, f4;
            f1 = f2 = f3 = f4 = false;
            if (x - r[x1] <= k)
                f1 = 1;
            if (x - c[y1] <= k)
                f2 = 1;
            if (x - r[x2] <= k)
                f3 = 1;
            if (x - c[y2] <= k)
                f4 = 1;
            int ans = INF;
            if (f1 && f4 || f2 && f3)
                ans = abs(x1 - x2) + abs(y1 - y2);
            if (f1 && f3)
            {
                if (x - get_min(0, 1, 1, n, min(x1, x2), max(x1, x2)) <= k)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                if (x - get_max(1, 1, 1, m, min(y1, y2), max(y1, y2)) <= k)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                int L = 0, R = min(y1, y2) + 1;
                while (L + 1 < R)
                {
                    int M = (L + R) / 2;
                    if (x - get_max(1, 1, 1, m, M, min(y1, y2)) <= k)
                        L = M;
                    else
                        R = M;
                }
                if (L != 0)
                    ans = min(ans, abs(y1 - L) + abs(y2 - L) + abs(x1 - x2));

                L = max(y1, y2) - 1, R = m + 1;
                while (L + 1 < R)
                {
                    int M = (L + R) / 2;
                    if (x - get_max(1, 1, 1, m, max(y1, y2), M) <= k)
                        R = M;
                    else
                        L = M;
                }
                if (R != m + 1)
                    ans = min(ans, abs(y1 - R) + abs(y2 - R) + abs(x1 - x2));
            }
            if (f2 && f4)
            {
                if (x - get_min(1, 1, 1, m, min(y1, y2), max(y1, y2)) <= k)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                if (x - get_max(0, 1, 1, n, min(x1, x2), max(x1, x2)) <= k)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                int L = 0, R = min(x1, x2) + 1;
                while (L + 1 < R)
                {
                    int M = (L + R) / 2;
                    if (x - get_max(0, 1, 1, n, M, min(x1, x2)) <= k)
                        L = M;
                    else
                        R = M;
                }
                if (L != 0)
                    ans = min(ans, abs(x1 - L) + abs(x2 - L) + abs(y1 - y2));
                L = max(x1, x2) - 1, R = n + 1;
                while (L + 1 < R)
                {
                    int M = (L + R) / 2;
                    if (x - get_max(0, 1, 1, n, max(x1, x2), M) <= k)
                        R = M;
                    else
                        L = M;
                }
                if (R != n + 1)
                    ans = min(ans, abs(x1 - R) + abs(x2 - R) + abs(y1 - y2));
            }
            if (ans == INF)
                cout << -1 << '\n';
            else
                cout << ans << '\n';
        }
    }
    return 0;
}
