#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int INF = (int)1e9 + 10;

struct Edge {
	int v;
	ll w;
	Edge(int v = 0, ll w = 0) : v(v), w(w) {};
};

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for (int ii = 0; ii < t; ++ii) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<vector<Edge>> a(n);
		for (int i = 0; i < m; ++i) {
			int v, u;
			ll d;
			cin >> v >> u >> d;
			--v; --u;
			a[u].pb({ v, d });
		}
		vector<set<ll>> dp(n);
		dp[0] = { 0 };
		for (int i = 1; i < n; ++i) {
			for (int j = 0; j < (int)a[i].size(); ++j) {
				for (ll x : dp[a[i][j].v]) {
					if ((n <= 10 && m <= 10 && q <= 10) || x + a[i][j].w <= 5000 * p / (p - 1))
						dp[i].insert(x + a[i][j].w);
				}
			}
		}
		for (int i = 0; i < q; ++i) {
			int f;
			ll r;
			cin >> f >> r;
			--f;
			auto x = dp[f].lower_bound(r);
			if (x == dp[f].end())
				cout << 0;
			else if ((*x) <= p * r / (p - 1))
				cout << 1;
			else
				cout << 0;
		}
		cout << endl;
	}

	return 0;
}