#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

#define mp make_pair
#define pb push_back
//#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int INF = (int)1e9 + 10;

bool ask(int x) {
	cout << "? " << x << endl;
	string ans;
	cin >> ans;
	return ans[0] == 'Y';
}

bool check(bool f, int x) {
	if (ask(x) == f)
		return 1;
	return ask(x) == f;
}

signed main() {/*
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif*/

	int n;
	cin >> n;
	while (true) {
		vi a, b;
		int l = 1, r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (ask(m)) {
				l = m;
				b.pb(m);
			}
			else {
				r = m;
				a.pb(m);
			}
		}
		sort(a.begin(), a.end());
		sort(b.rbegin(), b.rend());
		if (a.size() && !check(0, a[0])) {
			int l1 = a[0], r1 = n + 1;
			if (a.size() > 1)
				r1 = a[1];
			while (r1 - l1 > 1) {
				int m = (l1 + r1) / 2;
				if (ask(m))
					l1 = m;
				else
					r1 = m;
			}
			cout << "! " << l1 << endl;
		}
		else if (b.size() && !check(1, b[0])) {
			int l1 = 1, r1 = b[0];
			if (b.size() > 1)
				l1 = b[1];
			while (r1 - l1 > 1) {
				int m = (l1 + r1) / 2;
				if (ask(m))
					l1 = m;
				else
					r1 = m;
			}
			cout << "! " << l1 << endl;
		}
		else {
			cout << "! " << l << endl;
		}
		string s;
		cin >> s;
		if (s[0] == 'D')
			break;
	}

	return 0;
}