#include <bits/stdc++.h>

using namespace std;

#define int unsigned long long

const int N = 15;

vector<pair<int, int>> g[N];

void clear(int n) {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
}

bool dfs(int v, int path, int f, int r, int p) {
    if (v == f) {
        return path >= r && path * (p - 1) <= p * r;
    }

    for (auto e : g[v]) {
        int u = e.first;
        int d = e.second;
        if (dfs(u, path + d, f, r, p)) {
            return true;
        }
    }
    return false;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int test = 0; test < t; ++test) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        clear(n);
        for (int i = 0; i < m; ++i) {
            int v, u, d;
            cin >> v >> u >> d;
            v--;
            u--;
            g[v].emplace_back(u, d);
        }
        for (int i = 0; i < q; ++i) {
            int f, r;
            cin >> f >> r;
            f--;
            if (dfs(0, 0, f, r, p)) {
                cout << 1;
            }
            else {
                cout << 0;
            }
        }
        cout << "\n";
    }
}

