#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e6 + 10;

int t, n, m, q, p;
vector<vector<pair<int, ll> > > g;
vector<set<ll> > s;

void solve() {
    cin >> n >> m >> q >> p;
    g.resize(n);
    s.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        ll d;
        cin >> v >> u >> d;
        v--;
        u--;
        g[u].push_back({v, d});
    }
    s[0].insert(0);
    for (int i = 1; i < n; i++)
        for (auto j : g[i]) {
            int v = j.first;
            ll d = j.second;
            for (auto k : s[v])
                s[i].insert(k + d);
        }
    for (int i = 0; i < q; i++) {
        int f;
        ll l, r;
        cin >> f >> r;
        f--;
        l = r;
        r = (r * p) / (p - 1);
        auto x = s[f].lower_bound(l);
        cout << (x != s[f].end() && *x <= r);
    }
    cout << endl;
    s[0].insert(0);
    g.clear();
    s.clear();
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> t;
    for (int i = 0; i < t; i++)
        solve();

    return 0;
}
