#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e6 + 10, M = 5010;

int t, n, m, q, p;
vector<vector<pair<int, ll> > > g;
bool dp[M][M];

void solve() {
    cin >> n >> m >> q >> p;
    g.resize(n);
    s.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        ll d;
        cin >> v >> u >> d;
        v--;
        u--;
        g[u].push_back({v, d});
    }
    dp[0][0] = 1;
    for (int i = 1; i < n; i++)
        for (auto j : g[i]) {
            int v = j.first;
            ll d = j.second;
            for (int k = d; k <= 5000; k++)
                dp[i][k] ||= dp[v][k - d];
        }
    for (int i = 0; i < q; i++) {
        int f;
        ll l, r;
        cin >> f >> r;
        f--;
        l = r;
        r = (r * p) / (p - 1);
        bool b = 0;
        for (int j = l; !b && j <= r; j++)
            if (dp[i][j])
                b = 1;
        cout << b;
    }
    cout << endl;
    s[0].insert(0);
    g.clear();
    s.clear();
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> t;
    for (int i = 0; i < t; i++)
        solve();

    return 0;
}
