#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct action {
	int c, left, right;
	void print() {
		cout << c << " " << left << " " << right << "\n";
	}
	action() {}
	action(int c, int left, int right) : c(c), left(left), right(right) {}
};

int main() {
	int m, n;
	cin >> m >> n;
	vector<int> num(m);
	for (int i = 0; i < m; ++i) {
		cin >> num[i];
		--num[i];
	}

	vector<int> last(n);
	for (int i = 0; i < m; ++i)
		last[num[i]] = i;

	vector<int> stack;
	stack.reserve(n);
	for (int i = 0; i < m; ++i) {
		if ((stack.size() == 0) || (stack.back() != num[i]))
			stack.push_back(num[i]);
		if (last[num[i]] == i)
			stack.pop_back();
	}
	if (stack.size() != 0) {
		cout << -1;
		exit(0);
	}

	vector<char> first(n, 1);
	vector<action> act;
	act.reserve(n);
	for (int i = 0; i < m; ++i)
		if (first[num[i]]) {
			first[num[i]] = 0;
			act.emplace_back(num[i] + 1, i + 1, last[num[i]] + 1);
		}
	cout << act.size() << "\n";
	for (int i = 0; i < act.size(); ++i)
		act[i].print();
}
