#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,abm,sse,sse2,sse3,ssse3,sse4,tune=native")

#include <bits/stdc++.h>

#define int ll
#define mp make_pair
#define pb emplace_back
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define dbg(x) cerr << #x << " : " << x << endl 

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

/*
const int MAX_MEM = 1e8;
char MEM[MAX_MEM];
int MEM_POS = 0;
inline void* operator new(size_t x)
{
    auto ret = MEM + MEM_POS;
    MEM_POS += x;
    assert(MEM_POS < MAX_MEM);
    return ret;
}
inline void operator delete(void*) {}
*/

template<class T> istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template<class T> ostream& operator<< (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template<class T, class U> istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template<class T, class U> ostream& operator<< (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

signed main()
{
    Start();
    int n, m, q;
    cin >> n >> m >> q;
    vector <int> r(n, -1), c(m, -1);
    for (int i = 0; i < q; ++i)
    {
        int ty;
        cin >> ty;
        if (ty == 1)
        {
            int j;
            cin >> j, --j;
            r[j] = i;
        }
        else if (ty == 2)
        {
            int j;
            cin >> j, --j;
            c[j] = i;
        }
        else
        {
            //dbg(r), dbg(c);
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k, --r1, --c1, --r2, --c2;
            k = i - k;
            if (r[r1] >= k && c[c2] >= k)
            {
                cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                continue;
            }
            if (c[c1] >= k && r[r2] >= k)
            {
                cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                continue;
            }
            if (c[c1] >= k && c[c2] >= k)
            {
                bool f = true;
                for (int i = min(c1, c2); i <= max(c1, c2); ++i)
                    f = f && (c[i] >= k);
                if (f)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                int ans = 1e9;
                for (int i = 0; i < n; ++i)
                {
                    int x = r1 - i, y = r1 + i;
                    if (x >= 0 && r[x] >= k)
                    {
                        ans = min(ans, llabs(c2 - c1) + llabs(r2 - x) + llabs(r1 - x));
                    }
                    if (y < n && r[y] >= k)
                    {
                        ans = min(ans, llabs(c2 - c1) + llabs(r2 - y) + llabs(r1 - y));
                    }
                }
                if (ans != 1e9)
                    cout << ans << endl;
                else
                    cout << -1 << endl;
                continue;
            }
            if (r[r1] >= k && r[r2] >= k)
            {
                bool f = true;
                for (int i = min(r1, r2); i <= max(r1, r2); ++i)
                    f = f && (r[i] >= k);
                if (f)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                int ans = 1e9;
                for (int i = 0; i < m; ++i)
                {
                    int x = c1 - i, y = c1 + i;
                    if (x >= 0 && c[x] >= k)
                    {
                        ans = min(ans, llabs(r2 - r1) + llabs(c2 - x) + llabs(c1 - x));
                    }
                    if (y < m && c[y] >= k)
                    {
                        ans = min(ans, llabs(r2 - r1) + llabs(c2 - y) + llabs(c1 - y));
                    }
                }
                if (ans != 1e9)
                    cout << ans << endl;
                else
                    cout << -1 << endl;
                continue;
            }
            cout << -1 << endl;
            
        }
    }
    return 0;
}

