#include <bits/stdc++.h>
 
#define int long long
  
using namespace std;
  
typedef long long ll;
 
const int N = 5e5 + 7;
const int Inf = 2e18 + 7; 
vector <pair <int, int>> g[N];
vector <pair <int, int>> gr[N];

int d[N];
bool used[N];

int n, m, q, p;

mt19937 rnd(228);

bool fl = false;

int lf, rg;

void dfs(int u, int take) {
	if (u == 0 && lf <= take && take <= rg) fl = 1;
 	used[u] = 1;
 	for (auto &[v, w] : gr[u]) {
 	 	if (!used[v] && take + w + d[v] <= rg) {
 	 		dfs(v, take + w);
        }
 	}
}
 
void solve() {
    cin >> n >> m >> q >> p;
    for (int i = 0; i < n; ++i) g[i].clear();
    for (int i = 0; i < N; ++i) d[i] = Inf;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        //w *= p - 1;
        --u, --v;
        g[u].emplace_back(v, w);
        gr[v].emplace_back(u, w);
    }
    for (int i = 0; i < n; ++i) shuffle(gr[i].begin(), gr[i].end(), rnd);
    d[0] = 0;
    for (int i = 0; i < n; ++i) {
     	for (auto &[v, w] : g[i]) d[v] = min(d[v], d[i] + w);
    }
    for (int i = 0; i < q; ++i) {
    	memset(used, 0, sizeof (used));
        int f, r;
        cin >> f >> r;
        --f;
        lf = r;
        rg = (r * p) / (p - 1);
        int ds = d[f];
        if (ds > rg) {
         	cout << '0';
         	continue;
        }
        if (lf <= ds && ds <= rg) {
         	cout << '1';
         	continue;
        }
        fl = false;
        dfs(f, 0);
        cout << fl;
    }
    cout << '\n';
}
  
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int t;
    cin >> t;
    while (t--) solve();                                                                              
}