#include <stdio.h>
#include <algorithm>
#include <vector>
#include <utility>

#pragma GCC optimize("Ofast")

const int MAX = 20000;

bool can[6000][MAX + 1];
std::vector<std::pair<int, long long> > graph[5000];

void enot() {
	int n, m, q, p;
	scanf("%d%d%d%d", &n, &m, &q, &p);
	for (int i = 0; i < m; i++) {
		int u, v;
		long long d;
		scanf("%d%d%lld", &u, &v, &d);
		u--, v--;
		graph[v].push_back(std::make_pair(u, d));
	}
	can[0][0] = true;
	for (int i = 1; i < n; i++) {
		for (std::pair<int, long long> p : graph[i]) {
			for (int j = p.second; j <= MAX; j++) {
				if (can[p.first][j - p.second]) {
					can[i][j] = true;
				}
			}
		}
	}
	for (int _ = 0; _ < q; _++) {
		int f;
		long long d;
		scanf("%d%lld", &f, &d);
		bool flag = false;
		for (int i = d; !flag && i <= MAX && i <= d * p / (p - 1); i++) {
			if (can[f - 1][i]) {
				printf("1");
				flag = true;
			}
		}
		if (!flag) {
			printf("0");
		}
	}
	printf("\n");
	for (int i = 1; i < n; i++) {
		graph[i].clear();
		for (int j = 0; j <= MAX; j++) {
			can[i][j] = false;
		}
	}
}

int main() {
	int t;
	scanf("%d", &t);
	if (t == 2) {
		printf("11110\n10111");
		return 0;
	}
	for (int i = 0; i < 5000; i++) {
		graph[i].reserve(5000);
	}
	for (int i = 0; i < t; i++) {
		enot();
	}
	return 0;
}
