#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>

using namespace std;

void re() {
	system("pause");
	exit(0);
}
#define re re();

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int n, m;
ll p;
vector < vector < pair<int, ll>> > g;

int rec(int v, ll time, ll r) {
	if (v == 0 && r <= time && (p - 1) * time <= p * r)
		return 1;
	for (auto cur : g[v]) {
		int to = cur.first;
		ll w = cur.second;
		if (rec(to, time + w, r))
			return 1;
	}
	return 0;
}

void solve() {
	int q;
	cin >> n >> m >> q >> p;
	g.clear();
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u;
		ll d;
		cin >> v >> u >> d;
		v--, u--;
		g[v].push_back({ u, d });
	}
	vector < map <int, ll> > dp(n);
	dp[0][0] = 1;
	for (int v = 0; v < n; v++) {
		for (auto cur : dp[v]) {
			int w = cur.first;
			for (auto to : g[v]) {
				dp[to.first][w + to.second] = 1;
			}
		}
	}

	while (q--) {
		int v;
		ll r;
		cin >> v >> r;
		v--;
		int f = 0;
		for (ll x = r;(p - 1) * x <= p * r; x++)
			if (dp[v].find(x) != dp[v].end()) {
				f = 1;
				break;
			}
		cout << f;
	}
	cout << '\n';
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	re
}