#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>

using namespace std;

void re() {
	system("pause");
	exit(0);
}
#define re re();

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int n, m;
ll p;
vector < vector < pair<int, ll>> > g;

int rec(int l, int r, vector <int> &items, int id = 0) {
	if (l <= 0 && 0 <= r)
		return 1;
	if (id >= items.size())
		return 0;
	bool res = 0;
	if (items[id] <= r && rec(l - items[id], r - items[id], items, id + 1))
			return 1;
	return rec(l, r, items, id + 1);
}

void solve() {
	int q;
	cin >> n >> m >> q >> p;
	vector <int> a(n), b(n);
	for (int i = 0; i < m; i++) {
		int v, u;
		ll d;
		cin >> v >> u >> d;
		if (a[v] == 0)
			a[v] = d;
		else
			b[v] = d;
	}
	while (q--) {
		int v;
		ll r;
		cin >> v >> r;
		v--;
		vector <int> items;
		int sum = 0;
		for (int i = 0; i < v; i++) {
			sum += min(a[i], b[i]);
			items.push_back(abs(a[i] - b[i]));
		}
		sort(items.rbegin(), items.rend());
		cout << (int)rec(r - sum, p * r / (p - 1) - sum, items);
	}
	cout << '\n';

}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	re
}