#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

ll n, m, q;

const ll inf = (ll)1e13;

vector < ll > ax;
vector < ll > ay;

void solve(){
    cin >> n >> m >> q;
    ax.resize(m, 0);
    ay.resize(n, 0);
    ll ct = 1;
    for(ll i = 0; i < q; ++i){
//        cerr << i << "\n";
        ll type;
        cin >> type;
        if(type == 2){
            ll x;
            cin >> x;
            x--;
            ax[x] = ct;
        } else if(type == 1){
            ll y;
            cin >> y;
            y--;
            ay[y] = ct;
        } else {
            ll y1, x1, y2, x2, k;
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            --y1, --x1, --y2, --x2;
            ll ans = inf;
            if(x1 > x2){
                swap(x1, x2);
                swap(y1, y2);
            }
            ll ly1 = y1 + 1;
            ll ry1 = y1 - 1;
            ll ly2 = y2 + 1;
            ll ry2 = y2 - 1;
            for(ll i = y1; i >= 0; --i){
                if(ct - ay[i] <= k){
                    ly1 = i;
                } else {
                    break;
                }
            }
            for(ll i = y1; i < n; ++i){
                if(ct - ay[i] <= k){
                    ry1 = i;
                } else {
                    break;
                }
            }
            for(ll i = y2; i >= 0; --i){
                if(ct - ay[i] <= k){
                    ly2 = i;
                } else {
                    break;
                }
            }
            for(ll i = y2; i < n; ++i){
                if(ct - ay[i] <= k){
                    ry2 = i;
                } else {
                    break;
                }
            }
            if(ly1 >= ry2 || ly2 >= ry1){
                ans = abs(x1 - x2) + abs(y1 - y2);
            }
            if(ct - ax[x1] <= k){
                ans = min(ans, abs(y1 - ly2) + abs(x1 - x2) + abs(ly2 - y2));
                ans = min(ans, abs(y1 - ry2) + abs(x1 - x2) + abs(ry2 - y2));
            }
            if(ct - ax[x2] <= k){
                ans = min(ans, abs(y2 - ly1) + abs(x1 - x2) + abs(ly1 - y1));
                ans = min(ans, abs(y2 - ry1) + abs(x1 - x2) + abs(ry1 - y1));
            }
            if(y1 > y2){
                swap(x1, x2);
                swap(y1, y2);
            }

            ll lx1 = x1 + 1;
            ll rx1 = x1 - 1;
            ll lx2 = x2 + 1;
            ll rx2 = x2 - 1;
            for(ll i = x1; i >= 0; --i){
                if(ct - ax[i] <= k){
                    lx1 = i;
                } else {
                    break;
                }
            }
            for(ll i = x1; i < m; ++i){
                if(ct - ax[i] <= k){
                    rx1 = i;
                } else {
                    break;
                }
            }
            for(ll i = x2; i >= 0; --i){
                if(ct - ax[i] <= k){
                    lx2 = i;
                } else {
                    break;
                }
            }
            for(ll i = x2; i < m; ++i){
                if(ct - ax[i] <= k){
                    rx2 = i;
                } else {
                    break;
                }
            }
            for(ll x = 0; x < m; ++x){
                bool up = 0;
                if(ct - ay[y1] <= k && ct - ay[y2] <= k && ct - ax[x] <= k){
                    up = 1;
                }
                if(lx1 <= x && x <= rx1 && ct - ay[y2] <= k){
                    up = 1;
                }
                if(lx2 <= x && x <= rx2 && ct - ay[y1] <= k){
                    up = 1;
                }
                if(lx1 <= x && x <= rx1 && lx2 <= x && x <= rx2){
                    up = 1;
                }
                if(up){
                    ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x - x2));
                }
            }
            if(ans == inf){
                cout << -1 << "\n";
            } else {
                cout << ans << "\n";
            }
        }
        ct++;
    }
}


signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
