#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define all(x) (x).begin(), (x).end()
#define ff first
#define ss second

#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_p(x) cout << #x << " " << x.ff << " " << x.ss << endl;
    #define debug_v(x) cout << #x << " : "; for (auto i : x) cout << i << " " ; cout << endl;
    #define PO cout << "Pomelo" << endl;
    #define OL cout << "Oliva" << endl;
#else
    #define debug(x) 0;
    #define debug_p(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

vector<pair<int, pair<int, int>>> ans;
vector<vector<int>> nums;
vector<int> arr;

void dfs(int l, int r)
{
    if (l > r)
        return;
    ans.push_back({arr[l], {l, nums[arr[l]].back()}});
    for (int i : nums[arr[l]])
    {
        if (i < l || i > r)
        {
            cout << -1;
            exit(0);
        }
        dfs(l + 1, i - 1);
    }
    dfs(nums[arr[l]].back() + 1, r);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int n, m;
    cin >> m >> n;
    arr.resize(m);
    nums.resize(n);
    for (int i = 0; i < m; ++i){
        cin >> arr[i];
        --arr[i];
        nums[arr[i]].push_back(i);
    }

    dfs(0, m - 1);
    cout << ans.size() << '\n';
    for (auto i : ans)
    {
        cout << i.ff + 1 << " " << i.ss.ff + 1 << " " << i.ss.ss + 1 << '\n';
    }
}
