#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define f first
#define s second
#define add push_back
#define sz(x) (int)(x).size()

const ll INF = (ll)1e9 + 2019;

const int N = 3e5 + 10;
int arr[N], ans[N];
pii seg[N];

bool cmp(pii a, pii b) {
	return (a.s - a.f) > (b.s - b.f);
}

void go(int l, int r, int c) {
	for (int i = l; i <= r; i++) {
		ans[i] = c;
	}
}

void mane() {
	int n, m;
	cin >> m >> n;
	for (int i = 0; i < N; i++) {
		seg[i] = {INF, -INF};
	}
	for (int i = 0; i < m; i++) {
		cin >> arr[i];
		seg[arr[i]].f = min(seg[arr[i]].f, i);
		seg[arr[i]].s = max(seg[arr[i]].s, i);
	}
	sort(seg, seg + n + 1, cmp);
	vector <pair <int, pii>> res;
	for (int i = 0; i <= n; i++) {
		if (seg[i].f == INF) {
			continue;
		}
		go(seg[i].f, seg[i].s, arr[seg[i].f]);
		res.add({arr[seg[i].f], seg[i]});
	}
	for (int i = 0; i < m; i++) {
		if (ans[i] != arr[i]) {
			cout << -1;
			return;
		}
	}
	cout << sz(res) << endl;
	for (auto it : res) {
		cout << it.f << " " << it.s.f + 1 << " " << it.s.s + 1 << "\n";
	}
}

int main() {
	ios::sync_with_stdio(0);
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}