#include <bits/stdc++.h>
using namespace std;

#define vi vector<int>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define len(x) (int)(x).size()
#define pb push_back

const int MAXN = 300'000+100; //OVERFLOW?

int n, m; //be quiet
vi v, l_border, r_border, flag;
vi st;
vi res;

void read() {
    cin >> n >> m;
    v.resize(n);
    for (int &x : v) cin >> x;
}

void solve() {
    for (int &x : v) --x;
    //DEBUG START
    //for (int x : v) cerr << x << " "; cerr << endl;
    //DEBUG END
    for (int i = 0; i < n; ++i) r_border[v[i]] = i;
    for (int i = n - 1; i >= 0; --i) l_border[v[i]] = i;

    for (int i = 0; i < n; ++i) {
        if (flag[v[i]] == 0) {
            flag[v[i]] = 1;
            st.pb(i);
        } else if (flag[v[i]] == 1) {
            int last = st.back();
            while (v[last] != v[i]) {
                flag[v[last]] = 2;
                res.pb(v[last]);
                st.pop_back();
                last = st.back();
            }
        } else if (flag[v[i]] == 2) { cout << -1; exit(0); }
    }

    while (!st.empty()) {
        res.pb(v[st.back()]);
        st.pop_back();
    }

    reverse(all(res));
    cout << len(res) << '\n';
    for (int x : res)
        cout << x + 1 << ' ' << l_border[x] + 1 << ' ' << r_border[x] + 1 << '\n';
}

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r+", stdin);
//    freopen("output.txt", "w+", stdout);
    l_border.resize(MAXN, -1);
    r_border.resize(MAXN, -1);
    flag.resize(MAXN, 0);
}

int main() {
    init();
    read();
    solve();
}

/*
5 2
1 2 1 2 1

7 10
10 5 5 10 4 2 4
*/
