#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>
#include <chrono>
#include <random>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 5e5 + 228;
int mn[MAXN];
int mx[MAXN];

signed main() {
	fast_io();
	int test;
	cin >> test;
	for (int t = 0; t < test; t++) {
		string ans;
		fill(mn, mn + MAXN - 1, -1);
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		for (int i = 0; i < m; i++) {
			int u, v, d;
			cin >> u >> v >> d;
			u--;
			v--;
			if (u > v) swap(u, v);
			if (mn[u] == -1) {
				mn[u] = d;
			}
			else {
				mx[u] = d;
			}
		}
		for (int i = 0; i < n - 1; i++) {
			if (mn[i] > mx[i]) {
				swap(mn[i], mx[i]);
			}
		}
		for (int i = 0; i < q; i++) {
			int f, r;
			cin >> f >> r;
			f--;
			int toget = 0;
			vector<int> dif;
			for (int j = 0; j < f; j++) {
				toget += mn[j];
				dif.pb(mx[j] - mn[j]);
			}
			if (toget > 2 * r) {
				ans += '0';
				continue;
			}
			if (toget >= r) {
				ans += '1';
				continue;
			}
			sort(dif.begin(), dif.end());
			int it = lower_bound(dif.begin(), dif.end(), 2 * r - toget + 1) - dif.begin() - 1;
			while (toget < r && it != -1) {
				toget += dif[it];
				it--;
			}
			if (toget >= r) {
				ans += '1';
			}
			else {
				ans += '0';
			}
		}
		cout << ans << '\n';
	}
	return 0;
}