#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll
const int INF = 1e9 + 10;
const ll BINF = 1e18 + 10;
mt19937 rnd(2281337);

int cnt = 1;
const int N = 1e6 + 10;
const int T = 13;
int dp[N];
int to[N][T][2];
pair<int, int> best[N];

void play(int n, int v, int cur, vector<int> &q) {
  if (SZ(q) > 6) {
    dp[v] = INF;
    return;
  }
  for (int i = 1; i <= n; i++) {
    int cnt = 0;
    for (auto it : q) {
      if (it == i) {
        cnt++;
      }
    }
    if (cnt > 3) {
      dp[v] = INF;
      return;
    }
  }
  vector<pair<int, bool>> can;
  for (int i = 2; i <= n; i++) {
    bool ok = true, was = false;
    for (int j = 0; j < SZ(q); j++) {
      if (i >= q[j]) {
        if ((cur >> j) & 1) {
          continue;
        }
        if (was) {
          ok = false;
          break;
        }
        was = true;
      }
      else {
        if ((cur >> j) & 1) {
          if (was) {
            ok = false;
            break;
          }
          else {
            was = true;
          }
        }
      }
    }
    if (ok) {
      can.pb({i, was});
    }
  }
  assert(!can.empty());
  if (SZ(can) == 1) {
    dp[v] = 1;
    best[v].S = can[0].F;
    return;
  }
  best[v] = {INF, INF};
  dp[v] = INF;
  for (int i = 1; i <= n; i++) {
    bool can_yes = false, can_no = false;
    for (auto it : can) {
      if (it.F >= i || !it.S) {
        can_yes = true;
      }
      if (it.F < i || !it.S) {
        can_no = true;
      }
    }
    q.pb(i);
    int res = 0;
    if (can_yes) {
      to[v][i][0] = ++cnt;
      int sz = SZ(q) - 1;
      play(n, to[v][i][0], cur | (1 << sz), q);
      res = dp[to[v][i][0]] + 1;
    }
    if (can_no) {
      to[v][i][1] = ++cnt;
      int sz = SZ(q) - 1;
      play(n, to[v][i][1], cur, q);
      res = max(res, dp[to[v][i][1]] + 1);
    }
    q.pop_back();
    dp[v] = min(dp[v], res);
    best[v] = min(best[v], make_pair(res, i));
  }
}

void source() {
  int n;
  cin >> n;
  vector<int> cc = {};
  play(n, 1, 0, cc);
  for (;;) {
    int v = 1;
    for (;;) {
      if (dp[v] == 1) {
        cout << "! " << best[v].S << endl;
        break;
      }
      cout << "? " << best[v].S << endl;
      string res;
      cin >> res;
      if (res == "Yes") {
        v = to[v][best[v].S][0];
      }
      else {
        v = to[v][best[v].S][1];
      }
    }
    string res;
    cin >> res;
    if (res == "Done") {
      exit(0);
    }
  }
}

signed main() {
#ifdef extraterrestrial_
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
 #endif
  source();
#ifdef extraterrestrial_
  cerr << "\n\nTIME :: " << clock() * 1.0 / CLOCKS_PER_SEC;
 #endif
  return 0;
}
