#include <bits/stdc++.h>

using namespace std;
int inf = 1e9;

struct neww {
    vector<int> maxx;
    vector<int> minn;
    int N;
    void init(int _N) {
        N = _N;
        maxx = vector<int> (2 * N, 0);
        minn = vector<int> (2 * N, 0);
    }
    void update(int v) {
        if(v == 0)
            return;
        maxx[v] = max(maxx[v * 2], maxx[v * 2 + 1]);
        minn[v] = min(minn[v * 2], minn[v * 2 + 1]);
        update(v / 2);
    }
    void upd(int pos, int val) {
        maxx[N + pos] = val;
        minn[N + pos] = val;
        update((N + pos) / 2);
    }
    int get_max(int v, int l, int r, int vl, int vr) {
        if(r <= vl || vr <= l)
            return -1;
        if(vl <= l && r <= vr)
            return maxx[v];
        int m = (l + r) / 2;
        return max(get_max(v * 2, l, m, vl, vr), get_max(v* 2 + 1, m, r, vl, vr));
    }
    int get_min(int v, int l, int r, int vl, int vr) {
        if(r <= vl || vr <= l)
            return inf;
        if(vl <= l && r <= vr)
            return minn[v];
        int m = (l + r) / 2;
        return min(get_min(v * 2, l, m, vl, vr), get_min(v* 2 + 1, m, r, vl, vr));
    }
    int get(int pos) {
        return minn[N + pos];
    }
};




int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, m, q;
    cin >> n >> m >> q;
    int N = 1;
    while(N <= max(n, m))
        N *= 2;
    neww str;
    neww st;
    str.init(N);
    st.init(N);
    int t = 0;
    for (int i = 0; i < q; i++) {
        int tp;
        cin >> tp;
        t++;
        if(tp == 1) {
            int r;
            cin >> r;
            r--;
            str.upd(r, t);
        }
        if(tp == 2) {
            int r;
            cin >> r;
            r--;
            st.upd(r, t);
        }
        if(tp == 3) {
            int ans = inf;
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--, y1--, x2--, y2--;
            bool flag = 0;
            if(st.get(y2) >= t - k) {
                if(y1 == y2 || st.get_min(1, 0, N,  min(y1, y2), max(y1, y2) + 1) >= t - k) {
                    ans = (abs(x1 - x2) + abs(y1 - y2));
                }
                else if(str.get(x1) >= t - k) {
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                }
                else {
                    if(st.get(y1) < t - k) {
                        flag = 1;
                    }
                    int l = x1, r = n;
                    while(r - l > 1) {
                        int m = (l + r) / 2;
                        int gg = str.get_max(1, 0, N, x1, m + 1);
                        if(gg >= t - k) {
                            r = m;
                        }
                        else {
                            l = m;
                        }
                    }
                    if(r != n) {
                        ans = min(ans, abs(x1 - r) + abs(y1 - y2) + abs(x2 - r));
                    }
                    l = -1, r = x1;
                    while(r - l > 1) {
                        int m = (l + r) / 2;
                        int gg = str.get_max(1, 0, N, m, x1 + 1);
                        if(gg >= t - k) {
                            l = m;
                        }
                        else {
                            r = m;
                        }
                    }
                    if(l != -1) {
                        ans = min(ans, abs(x1 - l) + abs(y1 - y2) + abs(x2 - l));
                    }
                }
            }
            if(str.get(x2) >= t - k) {
                if(x1 == x2 || str.get_min(1, 0, N,  min(x1, x2), max(x1, x2) + 1) >= t - k) {
                    ans = (abs(x1 - x2) + abs(y1 - y2));
                }
                else if(st.get(y1) >= t - k) {
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                }
                else {
                    if(str.get(x1) < t - k) {
                        flag = 1;
                    }
                    int l = y1, r = m;
                    while(r - l > 1) {
                        int mid = (l + r) / 2;
                        int gg = st.get_max(1, 0, N, y1, mid + 1);
                        if(gg >= t - k) {
                            r = mid;
                        }
                        else {
                            l = mid;
                        }
                    }
                    if(r != m) {
                        ans = min(ans, abs(y1 - r) + abs(x1 - x2) + abs(y2 - r));
                    }
                    l = -1, r = y1;
                    while(r - l > 1) {
                        int mid = (l + r) / 2;
                        int gg = st.get_max(1, 0, N, mid, y1 + 1);
                        if(gg >= t - k) {
                            l = mid;
                        }
                        else {
                            r = mid;
                        }
                    }
                    if(l != -1) {
                        ans = min(ans, abs(y1 - l) + abs(x1 - x2) + abs(y2 - l));
                    }
                }
            }
            if(flag || ans == inf) {
                cout << -1 << '\n';
                continue;
            }
            cout << ans << '\n';
        }
    }


}
