#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("rename-registers")

#define ALL(a) (a).begin(), (a).end()
#define endl "\n"

typedef long long ll;
typedef long double ld;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

struct edge {
    int to;
    ll x;
};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int tt;
    cin >> tt;
    for (int t = 0; t < tt; t++) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;

        vector<vector<edge>> g(n);
        for (int i = 0; i < m; i++) {
            ll u, v, d;
            cin >> u >> v >> d;
            u--; v--;
            g[u].push_back({v, d});
        }

        const int maxr = 10005;
        vector<vector<int>> gg(n, vector<int>(maxr));
        gg[0][0] = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < g[i].size(); j++) {
                for (auto e : gg[i]) {
                    if (e + g[i][j].x < maxr) gg[g[i][j].to][e + g[i][j].x] = 1;
                }
            }
        }
        for (auto &e : gg) {
            for (int i = 1; i < maxr; i++) {
                e[i] += e[i - 1];
            }
        }

        for (int i = 0; i < q; i++) {
            int f;
            ll r;
            cin >> f >> r;
            assert(r <= 5000);
            f--;

            if (gg[f][r * p / (p - 1)] - gg[f][r - 1]) cout << 1;
            else cout << 0;
        }

        cout << endl;
    }

    return 0;
}

/*

4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6

*/


/*



*/
