#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define printvi(arr) for (int x: arr) cout << x << " "; cout << endl;
#define myreverse(arr) reverse(arr.begin(), arr.end())

const int maxn = 3e5 + 2;

int main() {
    init();
    int n, m;
    cin >> n >> m;
    vi a(n);
    vvi idx(maxn);
    vi cnt(maxn);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        idx[a[i]].pb(i);
    }
    vvi ans;
    set<int> used;
    for (int i = 0; i < n; ++i){
        if (i == idx[a[i]][0]){
            used.insert(a[i]);
            cnt[a[i]] = used.size();
        }
        if (cnt[a[i]] != used.size()){
            cout << -1 << endl;
            return 0;
        }
        if (i == idx[a[i]].back()){
            used.erase(a[i]);
            ans.pb(vi());
            ans.back().pb(a[i]);
            ans.back().pb(idx[a[i]][0] + 1);
            ans.back().pb(i + 1);
        }
    }
    cout << ans.size() << endl;
    myreverse(ans);
    for (int i = 0; i < ans.size(); ++i){
        printvi(ans[i]);
    }
    return 0;
}
