#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int INF = 1e9 + 1337;
const int MAXN = 1000006;
int R[MAXN], C[MAXN];

bool good(int x, int y, int v) {
    return R[x] >= v || C[y] >= v;
}

int dist(int x1, int y1, int x2, int y2) {
    return (int)abs(x1 - x2) + (int)abs(y1 - y2);
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    for (int t = 1; t <= q; ++t) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int r;
            cin >> r;
            R[r] = t;
        } else if (tp == 2) {
            int c;
            cin >> c;
            C[c] = t;
        } else {
            int x1, y1, x2, y2, v;
            cin >> x1 >> y1 >> x2 >> y2 >> v;
            v = t - v;

            if (!good(x1, y1, v) || !good(x2, y2, v)) {
                cout << "-1\n";
                continue;
            }

            if (R[x1] >= v && C[y2] >= v ||
                C[y1] >= v && R[x2] >= v)
            {
                cout << dist(x1, y1, x2, y2) << '\n';
                continue;
            }

            int ans = INF;
            if (R[x1] >= v && R[x2] >= v) {
                for (int c = 1; c <= m; ++c) {
                    if (C[c] >= v) {
                        chkmin(ans, (int)abs(x1 - x2) + (int)abs(y1 - c) + (int)abs(y2 - c));
                    }
                }
                bool canRow = true;
                for (int r = min(x1, x2); r <= max(x1, x2); ++r) {
                    canRow &= R[r] >= v;
                }
                if (canRow) chkmin(ans, dist(x1, y1, x2, y2));
            } else if (C[y1] >= v && C[y2] >= v) {
                for (int r = 1; r <= n; ++r) {
                    if (R[r] >= v) {
                        chkmin(ans, (int)abs(y1 - y2) + (int)abs(x1 - r) + (int)abs(x2 - r));
                    }
                }
                bool canRow = true;
                for (int c = min(y1, y2); c <= max(y1, y2); ++c) {
                    canRow &= C[c] >= v;
                }
                if (canRow) chkmin(ans, dist(x1, y1, x2, y2));
            }
            else assert(false);

            if (ans == INF)
                cout << "-1\n";
            else
                cout << ans << '\n';
        }
    }

    return 0;
}