#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define ever (;;)
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()
#define debug(v) cout << #v << ' ' << v << endl;
#define debugV(v) cout << #v << " : "; for (auto& i : v) cout << i << ' '; cout << endl;

const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 3e5 + 7;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

int rnd(int a, int b) {
    uniform_int_distribution<> dis(a, b);
    return dis(myRand);
}

int v[MAXN], fin[MAXN], fout[MAXN], t[MAXN], used[MAXN];
vector<int> g[MAXN], topsort;

void dfs1(int v) {
    used[v] = 1;
    for (int i : g[v]) {
        if (used[i] == 1) {
            cout << -1;
            exit(0);
        }
        if (!used[i]) {
            dfs1(i);
        }
    }
    used[v] = 2;
    topsort.pb(v);
}

void dfs2(int v) {
    used[v] = 1;
    cout << v + 1 << ' ' << fin[v] + 1 << ' ' << fout[v] + 1 << '\n';
    for (int i : g[v]) {
        if (!used[i]) {
            dfs2(i);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m;
    cin >> m >> n;
    for (int i = 0; i < m; ++i) {
        cin >> v[i];
        v[i]--;
    }
    fill(&fin[0], &fin[0] + MAXN, -1);
    fill(&fout[0], &fout[0] + MAXN, -1);
    for (int i = 0; i < m; ++i) {
        if (fin[v[i]] == -1)
            fin[v[i]] = i;
        fout[v[i]] = i;
    }
    set<pii> s;
    for (int i = 0; i < m; ++i) {
        if (i == fin[v[i]]) {
            if (s.empty()) {
                s.insert(mp(t[v[i]] = 0, v[i]));
            } else {
                pii maxV = *s.begin();
                s.insert(mp(t[v[i]] = maxV.f - 1, v[i]));
                g[maxV.s].pb(v[i]);
            }
            if (i == fout[v[i]]) {
                s.erase(mp(t[v[i]], v[i]));
            }
        } else if (i == fout[v[i]]) {
            pii maxV = *s.begin();
            s.erase(mp(t[v[i]], v[i]));
            if (maxV.s != v[i]) {
                t[v[i]] = maxV.f - 1;
                g[maxV.s].pb(v[i]);
            }
        } else {
            pii maxV = *s.begin();
            if (maxV.s != v[i]) {
                s.erase(mp(t[v[i]], v[i]));
                t[v[i]] = maxV.f - 1;
                s.insert(mp(t[v[i]], v[i]));
                g[maxV.s].pb(v[i]);
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (fin[i] == -1)
            continue;
        if (!used[i]) {
            dfs1(i);
        }
        cnt++;
    }
    reverse(all(topsort));
    fill(&used[0], &used[0] + MAXN, 0);
    cout << cnt << endl;
    for (int i : topsort) {
        if (!used[i]) {
            dfs2(i);
        }
    }
}
