#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 3e5 + 7;
const ll MAXN1 = 1 << 11;
const ll MAXN2 = 1e6 + 7;
const ll MOD = 1e9 + 7;
const ll PW = 239;
const ll BLOCK = 316;

void solve();
mt19937 mt(1e9 + 7);

signed main() {
	srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

int str[MAXN1], st[MAXN1];
int dist[MAXN1][MAXN1];
vector<pii> go = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; ++i) {
		int t, r1;
		cin >> t >> r1;
		if (t == 1) {
			str[r1] = -i;
		}
		else if (t == 2) {
			st[r1] = -i;
		}
		else {
			int c1, r2, c2, k;
			cin >> c1 >> r2 >> c2 >> k;
			k -= i;
			for (int j = 1; j <= n; ++j) fill(dist[j] + 1, dist[j] + m + 1, INF);
			dist[r1][c1] = 0;
			queue<pii> q;
			if (min(st[c1], str[r1]) <= k) q.emplace(r1, c1);
			while (!q.empty()) {
				int r = q.front().X;
				int c = q.front().Y;
				q.pop();
				for (auto &j : go) {
					int a = r + j.X;
					int b = c + j.Y;
					if (a > 0 && b > 0 && a <= n && b <= m && min(st[b], str[a]) <= k && dist[a][b] > dist[r][c] + 1) {
						dist[a][b] = dist[r][c] + 1;
						q.emplace(a, b);
					}
				}
			}
			if (dist[r2][c2] == INF) dist[r2][c2] = -1;
			cout << dist[r2][c2] << "\n";
		}
	}
}