#include <bits/stdc++.h>
#define right right228 
#define left left228 
#define pii pair<int, int>
#define int long long 
#define pb push_back 
#define ff first 
#define ss second 
#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace std; 
const int maxn = 3e5, inf = 1e18, mod = 1e9 + 7; 
int m, n; 
int cnt[maxn]; 
int left[maxn]; 
int right[maxn];

struct state {
    int l, r, val; 
    state(int l, int r, int val) : l(l), r(r), val(val) {} 
    state() : l(0), r(0), val(0) {} 
};                                                 

bool cmp(state p1, state p2) {
    return p1.l < p2.l; 
}

struct ver {
    int val, push; 
    ver(int val, int push) : val(val), push(push) {}
    ver() : val(0), push(-1) {}  
};

int cur[maxn]; 
int len = 1; 
vector<ver> tree; 

void build() {
    while (len < maxn) len <<= 1; 
    tree.resize(len + len - 1); 
}

void push(int l, int r, int rt) {
    int psh = tree[rt].push; 
    tree[rt].push = -1; 
    if (psh == -1) return; 
    tree[rt].val = psh;
    if (l != r) {
        tree[rt * 2 + 1].push = psh; 
        tree[rt * 2 + 2].push = psh; 
    }
}

void upd(int l, int r, int l1, int r1, int rt, int x) {
    push(l, r, rt);
    if (l >= l1 && r <= r1) {
        tree[rt].push = x; 
        push(l, r, rt); 
        return; 
    }
    if (max(l, l1) > min(r, r1)) return; 
    int t = (l + r) / 2; 
    upd(l, t, l1, r1, rt * 2 + 1, x); 
    upd(t + 1, r, l1, r1, rt * 2 + 2, x); 
}

int get(int l, int r, int l1, int r1, int rt) {
    push(l, r, rt);
    if (l >= l1 && r <= r1) {
        return tree[rt].val;  
    }
    if (max(l, l1) > min(r, r1)) return -inf; 
    int t = (l + r) / 2; 
    return max(get(l, t, l1, r1, rt* 2 + 1), get(t + 1, r, l1, r1, rt * 2 + 2)); 
}

void solve() {
    build();  
    cin >> m >> n; 
    for (int i = 0; i < maxn; ++i) {
        left[i] = inf;
        right[i] = -1;  
    }
    for (int i = 0; i < m; ++i) {
        cin >> cnt[i];
        left[cnt[i]] = min(left[cnt[i]], i); 
        right[cnt[i]] = i; 
    }         
    vector<state> have;
    for (int i = 0; i < maxn; ++i) {
        if (left[i] != inf) {
            have.pb({left[i], right[i], i}); 
        }
    } 
    sort(all(have), cmp); 
    for (auto v : have) {
        upd(0, len - 1, v.l, v.r, 0, v.val);
    }
    for (int i = 0; i < m; ++i) {
        if (get(0, len - 1, i, i, 0) != cnt[i]) {
            cout << "-1"; 
            return; 
        }               
    }
    cout << have.size() << '\n'; 
    for (auto v : have) {
        cout << v.val << " " << v.l + 1 << " " << v.r + 1 << '\n'; 
    }
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);
#else

#endif
    solve();       
    return 0; 
}