#include <iostream>
#include "set"
#include "vector"
using namespace std;
#define int long long
const int maxn = 5e3;
set<int> values[maxn];

vector<pair<int, int>> graph[maxn];

signed main() {
    ios_base::sync_with_stdio(false);
    int ktests;
    cin >> ktests;
    for (int test = 0; test < ktests; test++) {
        for (int i = 0; i < maxn; i++) {
            values[i].clear();
            graph[i].clear();
        }
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        for (int i = 0; i  < m; i++) {
            int v, u, d;
            cin >> v >> u >> d;
            v--; u--;
            graph[v].push_back({u, d});
        }
        values[0].insert(0);
        for (int i = 0; i < n; i++) {
            for (auto& val: values[i]) {
                // cout << val << " ";
                for (auto& u: graph[i]) {
                    values[u.first].insert(u.second + val);
                }
            }
            // cout << endl;
        }
        for (int i = 0; i < q; i++) {
            int v, d;
            cin >> v >> d; v--;
            int res = 0;
            auto it= values[v].lower_bound(d);
            if (it != values[v].end()) {
                if (d <= (*it) && (p - 1) * (*it) <= p * d) {
                    res = 1;
                }
            }
            /*for (auto& val: values[v]) {
                if (d <= val && (p - 1) * val <= p * d) {
                    res = 1;
                }
            }*/
            cout << res;
        }
        cout << "\n";
    }
}