#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;

string ask(ll val)
{
	cout <<"? " << val << endl;

	string ans;

	cin >> ans;

	return ans;
}

string ans(ll midl)
{
	cout << "! " << midl << endl;

	string ans;

	cin >> ans;

	return ans;
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll n;

	cin >> n;


	while (1)
	{
		bool tre = 0;

		ll l = 1, r = n + 1;
		while (l < r - 1)
		{
			ll midl = (l + r) / 2;

			if (tre)
			{
				string s = ask(midl);

				if (s == "Yes")
					l = midl;
				else
					r = midl;
			}
			else
			{
				string s1, s2, s3;
				s1 = ask(midl);
				s2 = ask(midl);
				s3 = ask(midl);

				if (s1 == s2 && s2 == s3)
				{
					if (s1 == "Yes")
						l = midl;
					else
						r = midl;
				}
				else
				{
					tre = 1;
					map<string, ll> mapp;
					mapp[s1] += 1;
					mapp[s2] += 1;
					mapp[s3] += 1;

					string res;
					for (auto in : mapp)
						if (in.second == 2)
							res = in.first;

					if (res == "Yes")
						l = midl;
					else
						r = midl;
				}
			}

		}
		
		string res = ans(l);

		if (res == "Done")
			return 0;
	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/