#include <vector>
#include <iostream>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;

ll const T = 500;
ll const K = 40000;

short d[T][T][T], pam[T][T][T], p2[K];

short dp(ll i, ll j, ll k) {
	if (d[i][j][k] != -1) {
		return d[i][j][k];
	}
	short min1 = 1000;
	for (ll r = j; r >= 0; r--) {
		if (((r == 0) && (i == 0)) || ((r == j) && (k == 0))) {
			continue;
		}
		short k1 = max(dp(r, j - r, k), dp(i, r, j - r)) + 1;
		if (r == 0) {
			k1 = max(k1, p2[i + j]);
		}
		if (r == j) {
			k1 = max(k1, p2[k + j]);
		}
		if (k1 < min1) {
			min1 = k1;
			pam[i][j][k] = r;
		}
	}
	d[i][j][k] = min1;
	return min1;
}

ll zap(ll s) {
	cout << "? " << s << endl;
	string qr;
	cin >> qr;
	if (qr[0] == 'Y') {
		return 1;
	}
	else {
		return 0;
	}
}

void otv(ll s) {
	cout << "!  " << s << endl;
	string qr;
	cin >> qr;
	if (qr[0] == 'D') {
		exit(0);
	}
}

void bin(ll min1, ll max1) {
	while (max1 - min1 > 1) {
		ll mid = (min1 + max1) / 2;
		if (zap(mid) == 1) {
			min1 = mid;
		}
		else {
			max1 = mid;
		}
	}
	otv(min1);
}

int main() {
	ll pow2 = 1;
	ll pow3 = 0;
	for (ll i = 1; i < K; i++) {
		if (pow2 * 2 <= i) {
			pow2 *= 2;
			pow3++;
		}
		p2[i] = pow3;
	}
	for (ll i = 0; i < T; i++) {
		for (ll j = 0; j < T; j++) {
			for (ll k = 0; k < T; k++) {
				d[i][j][k] = -1;
			}
		}
	}
	for (ll i = 0; i < T; i++) {
		for (ll j = 0; j < T; j++) {
			d[i][0][j] = -1000;
		}
	}
	d[0][1][0] = 0;
	ll n;
	cin >> n;
	dp(0, n, 0);
	while (true) {
		ll i = 0; ll j = n; ll k = 0;
		ll s = 1;
		while (true) {
			ll ry = pam[i][j][k];
			ll a = zap(s + ry);
			if (a == 1) {
				s += i;
				i = ry;
				j = j - ry;
			}
			else {
				k = j - ry;
				j = ry;
			}
			if (j == 0) {
				bin(s - i, s + k);
				break;
			}
			if ((i == 0) && (k == 0) && (j == 1)) {
				otv(s);
				break;
			}
		}
	}
}

/*
for (ll n = 1; n <= 100; n++) {
		cout << n << ' ' << dp(0, n, 0) << "   ";
		ll t = pam[0][n][0];
		cout << pam[0][n][0] << "    " << pam[pam[0][n][0]][n - pam[0][n][0]][0] << ' ' << pam[0][pam[0][n][0]][n - pam[0][n][0]] << "    ";
		ll q = pam[0][t][n - t];
		ll w = pam[q][t - q][n - t];
		cout << pam[q][t - q][n - t] << ' ' << pam[0][q][t - q] << ' ' << pam[w][t - q - w][n - t];
		cout << endl;
	}
*/