#include <bits/stdc++.h>

using namespace std;

struct query{
    int c;
    int l;
    int r;

    query(int c_, int l_, int r_){
        c = c_;
        l = l_;
        r = r_;
    }
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int m, n, t;
    cin >> m >> n;
    vector<int> a(m);
    vector<pair<int, int> > p(n, {-1, -1});
    for(int i = 0; i < m; ++i){
        cin >> t;
        --t;
        a[i] = t;
        if (p[t].first == -1){
            p[t] = {i, i};
        } else {
            p[t].second = i;
        }
    }
    vector<int> st;
    st.reserve(m);
    vector<query> q;
    q.reserve(n);
    for (int i = 0; i < m; ++i){
        if (!st.empty() && p[a[i]].second > p[*st.rbegin()].second){
            cout << -1 << endl;
            return 0;
        }
        if (i == p[a[i]].first){
            q.push_back({a[i] + 1, i + 1, p[a[i]].second + 1});
            st.push_back(a[i]);
        }
        if (i == p[a[i]].second) {
            st.pop_back();
        }
    }
    cout << q.size() << endl;
    for (auto e: q){
        cout << e.c << " " << e.l << " " << e.r << "\n";
    }
    cout << endl;
    return 0;
}
