#include <bits/stdc++.h>

using namespace std;
int n, m, q, p;
const int MAXN = 5e3 + 7;
const int MAXC = 1e11 + 5;
vector<pair<int, int64_t>> g[MAXN];
bitset<20 * MAXC> w[MAXN];
int deg[MAXN];

inline void init() {
    for (int i = 0; i < MAXN; i++) {
        g[i].clear();
        w[i].reset();
        deg[i] = 0;
    }
}
int dfs(int v){
    for (auto [u, d] : g[v]){
        w[u] |= w[v] << d;
        deg[u]--;
        if (deg[u] == 0)
            dfs(u);
    }
}
inline void solve() {
    init();
    for (int i = 0; i < m; i++) {
        int v, u;
        int64_t d;
        cin >> v >> u >> d;
        --v;
        if (d > MAXC * p)
            continue;
        g[v].emplace_back(u - 1, d);
        deg[u - 1]++;
    }
    w[0][0] = 1;
    dfs(0);
    for (int i = 0; i < q; i++){
        int f;
        int64_t r;
        cin >> f >> r;
        --f;
        char ans = '0';
        for (int64_t j = r; j <= (p * r) / (p - 1); j++) {
            if (w[f][j]){
                ans = '1';
                break;
            }
        }
        cout << ans;
    }
    cout << '\n';
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#endif

    int t;
    cin >> t;
    while (cin >> n >> m >> q >> p) {
        solve();
    }
}