#include <bits/stdc++.h>

using namespace std;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	for (auto &t : a) {
		cin >> t;
		t--;
	}
	vector<int> pmn(n, m + 1);
	vector<int> pmx(n, -1);
	for (int i = 0; i < m; i++) {
		pmn[a[i]] = min(pmn[a[i]], i);
		pmx[a[i]] = max(pmx[a[i]], i);
	}
	vector<tuple<int, int, int>>  ans;
	vector<int> cur(m, -1);
	vector<int> cnt(n);
	for (int i = 0; i < m; i++) {
		if (a[i] != cur[i]) {
			if (cnt[a[i]]) {
				cout << -1 << endl;
				exit(0);
			}
			cnt[a[i]]++;
			ans.push_back(make_tuple(pmn[a[i]], pmx[a[i]], a[i]));
			for (int j = pmn[a[i]]; j <= pmx[a[i]]; j++) {
				cur[j] = a[i];
			}
		}	
	}
	cout << ans.size() << endl;
	for (auto t : ans) {
		int c, l, r;
		tie(c, l, r) = t;
		c++;
		l++;
		r++;
		cout << c << ' ' << l << ' ' << r << '\n';
	}
}