#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <queue>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

struct R {
	int u, v;
	ll d;

	void read() {
		cin >> u >> v >> d;
		u--;
		v--;
	}

};

vector<R> rebr;
set<ld> dist[500000];
vector<pair<int, ld>> matr[500000];

int main() {
#ifdef LOCAL3 
	freopen("In.txt", "r", stdin);
	freopen("Out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	string s = "", s1, s2;
	while (s != "Done") {
		int l = 0;
		int r = n;
		int m;
		bool sl = true;
		while (r - l > 1) {
			m = (r + l) / 2;
			cout << "? " << m << endl;
			cin >> s1;
			if (sl) {
				cout << "? " << m << endl;
				cin >> s2;
				if (s1 != s2) {
					cout << "? " << m << endl;
					cin >> s1;
				}
				sl = false;
			}
			if (s1[0] == 'Y') {
				r = m;
			}
			else {
				l = m;
			}
		}
		cout << "! " << r << endl;
		cin >> s;
	}
	return 0;
}