#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

vector<pair<int, int> > graph[5600];
bitset<10001> can[5010];

void cl()
{
    for (int i = 0; i <= 5000; i++)
    {
        graph[i].resize(0);
        can[i] = 0;
    }
}

void solve()
{
    cl();
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    for (int i = 0; i < m; i++)
    {
        int v, u;
        long long t;
        cin >> v >> u >> t;
        if (t > 10000)
        {
            continue;
        }
        graph[u].push_back({v, t});
    }
    can[1][0] = 1;
    for (int i = 2; i <= n; i++)
    {
        for (int j = 0; j < graph[i].size(); j++)
        {
            int from = graph[i][j].first;
            int t = graph[i][j].second;
            can[i] = can[i] | (can[from] << t);
        }
    }
    while (q--)
    {
        int to, r;
        int t = 0;
        cin >> to >> r;
        for (int j = r; j <= 10000; j++)
        {
            if (can[to][j] && r <= j && j * (p - 1) <= p * r)
            {
                cout << 1;
                t = 1;
                break;
            }
            if (j * (p - 1) > p * r)
                break;
        }
        if (!t)
            cout << 0;
    }
    cout << endl;
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        solve();
    }
}
