#include <bits/stdc++.h>

using namespace std;

const int INF = 1e8;
const int MAXN = +100500 * 10;

int hor[MAXN], ver[MAXN];
int n, m, q;
int timer = 0;

pair<int, int> th[MAXN * 4], tv[MAXN * 4];

void changeh(int v, int l, int r, int pos, int val) {
    if (l + 1 == r) {
        th[v] = {l, l};
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        changeh(v * 2 + 1, l, m, pos, val);
    } else {
        changeh(v * 2 + 2, m, r, pos, val);
    }
    if (hor[th[v * 2 + 1].first] < hor[th[v * 2 + 2].first]) {
        th[v].first = th[v * 2 + 1].first;
    } else {
        th[v].first = th[v * 2 + 2].first;
    }
    if (hor[th[v * 2 + 1].second] > hor[th[v * 2 + 2].second]) {
        th[v].second = th[v * 2 + 1].second;
    } else {
        th[v].second = th[v * 2 + 2].second;
    }
}
void changev(int v, int l, int r, int pos, int val) {
    if (l + 1 == r) {
        tv[v] = {l, l};
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        changev(v * 2 + 1, l, m, pos, val);
    } else {
        changev(v * 2 + 2, m, r, pos, val);
    }
    if (ver[tv[v * 2 + 1].first] < ver[tv[v * 2 + 2].first]) {
        tv[v].first = tv[v * 2 + 1].first;
    } else {
        tv[v].first = tv[v * 2 + 2].first;
    }
    if (ver[tv[v * 2 + 1].second] > ver[tv[v * 2 + 2].second]) {
        tv[v].second = tv[v * 2 + 1].second;
    } else {
        tv[v].second = tv[v * 2 + 2].second;
    }
}
int mngeth(int v, int l, int r, int a, int b) {
    if (a <= l && r <= b) {
        return th[v].first;
    }
    int m = (l + r) / 2;
    int res = a;

    if (a < m) {
        int x = mngeth(v * 2 + 1, l, m, a, b);
        if (hor[res] > hor[x]) {
            res = x;
        }
    }

    if (m < b) {
        int x = mngeth(v * 2 + 2, m, r, a, b);
        if (hor[res] > hor[x]) {
            res = x;
        }
    }
    return res;
}
int mngetv(int v, int l, int r, int a, int b) {
    if (a <= l && r <= b) {
        return tv[v].first;
    }
    int m = (l + r) / 2;
    int res = a;

    if (a < m) {
        int x = mngetv(v * 2 + 1, l, m, a, b);
        if (ver[res] > ver[x]) {
            res = x;
        }
    }

    if (m < b) {
        int x = mngetv(v * 2 + 2, m, r, a, b);
        if (ver[res] > ver[x]) {
            res = x;
        }
    }
    return res;
}

int mxgeth(int v, int l, int r, int a, int b) {
    if (a <= l && r <= b) {
        return th[v].second;
    }
    int m = (l + r) / 2;
    int res = a;

    if (a < m) {
        int x = mxgeth(v * 2 + 1, l, m, a, b);
        if (hor[res] < hor[x]) {
            res = x;
        }
    }

    if (m < b) {
        int x = mxgeth(v * 2 + 2, m, r, a, b);
        if (hor[res] < hor[x]) {
            res = x;
        }
    }
    return res;
}
int mxgetv(int v, int l, int r, int a, int b) {
    if (a <= l && r <= b) {
        return tv[v].second;
    }
    int m = (l + r) / 2;
    int res = a;

    if (a < m) {
        int x = mxgetv(v * 2 + 1, l, m, a, b);
        if (ver[res] < ver[x]) {
            res = x;
        }
    }

    if (m < b) {
        int x = mxgetv(v * 2 + 2, m, r, a, b);
        if (ver[res] < ver[x]) {
            res = x;
        }
    }
    return res;
}

bool checkh(int l, int r, int k) {
    return hor[mngeth(0, 0, n, l, r + 1)] + timer <= k;
}
bool checkv(int l, int r, int k) {
   return ver[mngetv(0, 0, m, l, r + 1)] + timer <= k;
}

bool allh(int l, int r, int k) {
    return hor[mxgeth(0, 0, n, l, r + 1)] + timer <= k;
}

bool allv(int l, int r, int k) {
    return ver[mxgetv(0, 0, m, l, r + 1)] + timer <= k;
}

int geth(int l_, int d, int k) {
    if (d == 1) {
        int l = l_, r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (hor[mngeth(0, 0, n, l_, mid)] + timer <= k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (hor[mngeth(0, 0, n, l_, r)] + timer <= k) {
            return r - 1;
        } else {
            return INF * d;
        }
    } else {
        int l = 0, r = l_;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (hor[mngeth(0, 0, n, mid, l_)] + timer <= k) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (hor[mngeth(0, 0, n, l, l_)] + timer <= k) {
            return l;
        } else {
            return INF * d;
        }
    }
}

int getv(int l_, int d, int k) {
    if (d == 1) {
        int l = l_, r = m;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (ver[mngetv(0, 0, m, l_, mid)] + timer <= k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (ver[mngetv(0, 0, m, l_, r)] + timer <= k) {
            return r - 1;
        } else {
            return INF * d;
        }
    } else {
        int l = 0, r = l_;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (ver[mngetv(0, 0, m, mid, l_)] + timer <= k) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (ver[mngetv(0, 0, m, l, l_)] + timer <= k) {
            return l;
        } else {
            return INF * d;
        }
    }
}

void buildh(int v, int l, int r) {
    th[v] = {l, l};
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    buildh(v * 2 + 1, l, m);
    buildh(v * 2 + 2, m, r);
}

void buildv(int v, int l, int r) {
    tv[v] = {l, l};
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    buildv(v * 2 + 1, l, m);
    buildv(v * 2 + 2, m, r);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ///freopen("input.txt", "r", stdin);

    cin >> n >> m >> q;

    buildh(0, 0, n);
    buildv(0, 0, m);

    while (q--) {
        timer++;
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            x--;
            hor[x] = -timer;
            changeh(0, 0, n, x, -timer);
        } else if (t == 2) {
            int y;
            cin >> y;
            y--;
            ver[y] = -timer;
            changev(0, 0, m, y, -timer);
        } else {
            int x0, y0, x1, y1, k;
            cin >> x0 >> y0 >> x1 >> y1 >> k;
            x0--; x1--; y0--; y1--;
            if ((hor[x0] + timer > k && ver[y0] + timer > k) ||
                (hor[x1] + timer > k && ver[y1] + timer > k)) {
                cout << -1 << "\n";
            } else if ((checkh(min(x0, x1), max(x0, x1), k) && checkv(min(y0, y1), max(y0, y1), k)) ||
                       allh(min(x0, x1), max(x0, x1), k) || allv(min(y0, y1), max(y0, y1), k)) {
                cout << abs(x0 - x1) + abs(y0 - y1) << "\n";
            } else {
                int upx = geth(x0, +1, k);
                int downx = geth(x0, -1, k);
                int upy = getv(y0, +1, k);
                int downy = getv(y0, -1, k);
                int res1 = abs(upx - x0) + abs(y1 - y0) + abs(upx - x1);
                int res2 = abs(upy - y0) + abs(x1 - x0) + abs(upy - y1);
                int res3 = abs(downx - x0) + abs(y1 - y0) + abs(downx - x1);
                int res4 = abs(downy - y0) + abs(x1 - x0) + abs(downy - y1);
                int res = INF;
                if (ver[y0] + timer <= k && ver[y1] + timer <= k) {
                    res = min(res, min(res1, res3));
                }
                if (hor[x0] + timer <= k && hor[x1] + timer <= k)  {
                    res = min(res, min(res2, res4));
                }
                if (res != INF) {
                    cout << res << "\n";
                } else {
                    cout << -1 << "\n";
                }
            }
        }
    }
    return 0;
}

