#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <deque>
#pragma optimize("Ofast");
#pragma optimize("unroll-loops");
using namespace std;
#define int long long
int f, r;
int n, m, q, p;
vector <vector <pair <int, int>>> w;
vector <int> used;

int dfs(int u, int time) {
	if (u == f && r * (p - 1) <= time * (p - 1) && time * (p - 1) <= r * p) return 1;
	if (time * (p - 1) > r * p) return 0;
	for (auto& vt : w[u]) {
		if (dfs(vt.first, time + vt.second)) return 1;
	}
	return 0;
}

void solve() {
	
	cin >> n >> m >> q >> p;
	w.clear();
	w.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].push_back({ v, cost });
		//w[v].push_back({ u, cost });
	}
	for (int i = 0; i < q; ++i) {
		cin >> f >> r;
		--f;
		cout << dfs(0, 0);
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef _DEBUG
	cout << "Exec. time: " << (clock() + 0.0) / 1000 << "s.\n";
#endif
}