#include <bits/stdc++.h>
using namespace std;

struct Node
{
    int sz, int pr;
    Node* l, r;
    int mx, val;

    Node(int k) {
        sz = 1;
        val = k;
        mx = k;
        l = r = nullptr;
        pr = rand() << 16 + rand();
    }
};

int sz(Node* v) {
    if (v == nullptr) {
        return 0;
    } else {
        return v->sz;
    }
}
int mx(Node* v) {
    if (v == nullptr) {
        return 0;
    } else {
        return v->mx;
    }
}

Node* pull(Node* v) {
    v->sz = 1;
    v->mx = v->val;
    v->sz += sz(v->l) + sz(v->r);
    v->mx = max(v->mx, max(mx(v->l), mx(v->r)));
    return v;
}

Node* Merge(Node* l, Node* r) {
    if (l == nullptr) {
        return r;
    }
    if (r == nullptr) {
        return l;
    }
    l->r = Merge(l->r, r);
    return pull(l);
}

pair<Node*, Node*> Split(Node* v, int x) {
    if (v == nullptr) {
        return {nullptr, nullptr};
    }
    if (sz(x->l) >= x) {
        auto res = Split(v->l, x);
        v->l = res.second;
        res.second = pull(v);
        return res;
    }
    auto res = Split(v->r, x);
    v->r = res.first;
    res.first = v;
    return res;
}

main() {
    cout << "Hello world!" << endl;
    return 0;
}
