#pragma warning(disable:4996)
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<math.h>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, q;
	cin >> n >> m >> q;

	vector<int> r(n, -1), c(m, -1);

	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			r[x - 1] = i;
		}
		else if (type == 2) {
			int y;
			cin >> y;
			c[y - 1] = i;
		}
		else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--;
			x2--;
			y1--;
			y2--;
			if ((i - r[x1] <= k && i - c[y2] <= k) || (i - r[x2] <= k && i - c[y1] <= k) ||
				(x1 == x2 && i - r[x1] <= k) || (y1 == y2 && i - c[y1] <= k)) {
				cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
			}
			else {
				if (i - r[x1] <= k && i - r[x2] <= k) {
					bool fl = false;
					int ma = max(y1, y2);
					int mi = min(y1, y2);
					for (int j = mi + 1; j < ma; j++) {
						if (i - c[j] <= k) {
							fl = true;
							break;
						}
					}
					if (fl) {
						cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
						continue;
					}
					fl = true;
					for (int j = min(x1, x2) + 1; j < max(x1, x2); j++) {
						if (i - r[j] > k) {
							fl = false;
							break;
						}
					}
					if (fl) {
						cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
						continue;
					}

					for (int j = 1; j < max(m - ma, mi + 1); j++) {
						if (mi - j > -1) {
							if (i - c[mi - j] <= k) {
								cout << abs(x1 - x2) + abs(y1 - y2) + 2*j << "\n";
								fl = true;
								break;
							}
						}
						if (ma + j < m) {
							if (i - c[ma + j] <= k) {
								cout << abs(x1 - x2) + abs(y1 - y2) + 2*j << "\n";
								fl = true;
								break;
							}
						}
					}
					if (!fl) {
						cout << "-1\n";
					}
				}
				else if (i - c[y1] <= k && i - c[y2] <= k) {
					bool fl = false;
					int ma = max(x1, x2);
					int mi = min(x1, x2);
					for (int j = mi + 1; j < ma; j++) {
						if (i - r[j] <= k) {
							fl = true;
							break;
						}
					}
					if (fl) {
						cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
						continue;
					}
					fl = true;
					for (int j = min(y1, y2) + 1; j < max(y1, y2); j++) {
						if (i - c[j] > k) {
							fl = false;
							break;
						}
					}
					if (fl) {
						cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
						continue;
					}

					for (int j = 1; j < max(n - ma, mi + 1); j++) {
						if (mi - j > -1) {
							if (i - c[mi - j] <= k) {
								cout << abs(x1 - x2) + abs(y1 - y2) + 2 * j << "\n";
								fl = true;
								break;
							}
						}
						if (ma + j < n) {
							if (i - c[ma + j] <= k) {
								cout << abs(x1 - x2) + abs(y1 - y2) + 2 * j << "\n";
								fl = true;
								break;
							}
						}
					}
					if (!fl) {
						cout << "-1\n";
					}
				}
				else {
					cout << "-1\n";
				}
			}
		}
	}
}