#pragma GCC optimaze("Ofast, no-stack-protectors");
#pragma GCC optimaze("unroll-loops");
//#pragma GCC target("sse,sse2,sse3,sse4,sse4.2,abm,mmx,popcnt,tune=native");
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<random>
#include<chrono>
#include<string>
#include<algorithm>
#include<math.h>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#define int long long

const int maxn = 113;
vector<pair<int, long long>> gr[maxn];

vector<long long> fd[maxn];
void dfs(int v, long long s)
{
	fd[v].push_back(s);
	for (int i = 0; i < gr[v].size(); i++)
		dfs(gr[v][i].first, gr[v][i].second + s);
}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr), cout.tie(nullptr);
	cout.setf(ios::fixed);
	cout.precision(12);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		string out;
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		for (int i = 1; i <= n; i++)
		{
			gr[i].clear();
			fd[i].clear();
		}
		for (int i = 0; i < m; i++)
		{
			long long a, b, c;
			cin >> a >> b >> c;
			gr[a].push_back({ b, c });
		}
		dfs(1, 0);
		for (int i = 0; i < q; i++)
		{
			long long f, c;
			cin >> f >> c;
			long long c2 = c * p / (p - 1);
			bool tr = false;
			for (int i = 0; i < fd[f].size(); i++)
			{
				if (fd[f][i] >= c && fd[f][i] <= c2)
					tr = true;
			}
			if (tr)
				out.push_back('1');
			else
				out.push_back('0');
		}
		cout << out << "\n";
	}
	//system("pause");
}

/*
1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
4 34

2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9

7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44
*/