#include <bits/stdc++.h>
#define move asdsadasdasdas

using namespace std;

typedef long long ll;

mt19937 rnd(228);

vector <int> f(vector <int> a, int x, bool sign)
{
    vector <int> b;
    for (int y : a) if ((y >= x) == sign) b.push_back(y);
    return b;
}

vector <int> unite(vector <int> a, vector <int> b)
{
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector <int> c(a.size() + b.size());
    merge(a.begin(), a.end(), b.begin(), b.end(), c.begin());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    return c;
}

map <pair <vector <int>, vector <int> >, int> resolve;
map <pair <vector <int>, vector <int> >, int> move;

const int inf = 1e9;

int states = 0;

vector <int> lol(vector <int> a)
{
    int n = (int) a.size();
    sort(a.begin(), a.end());
    vector <int> t;
    t.push_back(a[n / 2]);
    for (int i = 1; i < 20 && i < n; i++)
    {
        if (n / 2 - i >= 0) t.push_back(a[n / 2 - i]);
        if (n / 2 + i < n) t.push_back(a[n / 2 + i]);
    }
    return t;
}

void relax(vector <int> &not_lie, vector <int> &lie)
{
    vector <int> t = unite(not_lie, lie);
    for (int &x : not_lie)
    {
        x = lower_bound(t.begin(), t.end(), x) - t.begin();
    }
    for (int &x : lie)
    {
        x = lower_bound(t.begin(), t.end(), x) - t.begin();
    }
}

int brute(int n, vector <int> not_lie, vector <int> lie, int alphabeta = 1e9)
{
   relax(not_lie, lie);
    if (resolve.count({not_lie, lie}))
    {
        return resolve[{not_lie, lie}];
    }
    states++;
    if (states % 1000 == 0) cout << states << endl;
    resolve[{not_lie, lie}] = inf;
    if (unite(not_lie, lie).size() == 1)
    {
        resolve[{not_lie, lie}] = 0;
        return 0;
    }
    int kek = inf;
    vector <int> kk = lol(unite(not_lie, lie));
    for (int x : kk)
    {
        int val = 0;
        for (int t = 0; t < 2; t++)
        {
            vector <int> new_not_lie = f(not_lie, x, t ^ 1);
            vector <int> new_lie = unite(f(not_lie, x, t), f(lie, x, t ^ 1));
            if (new_not_lie == not_lie && new_lie == lie)
            {
                val = inf;
                continue;
            }
            val = max(val, brute(n, new_not_lie, new_lie, min(alphabeta, kek)));
            if (val + 1 >= min(alphabeta, kek)) break;
        }
        if (val + 1 < kek)
        {
            move[{not_lie, lie}] = x;
        }
        kek = min(kek, val + 1);
    }
    return resolve[{not_lie, lie}] = kek;
}

int main() {
    //  freopen("a.in", "r", stdin);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <int> not_lie;
    for (int i = 1; i <= n; i++) not_lie.push_back(i);
    vector <int> lie;
    brute(n, not_lie, lie);
    while (true)
    {
        vector <int> not_lie;
        for (int i = 1; i <= n; i++) not_lie.push_back(i);
        vector <int> lie;
        vector <int> _not_lie;
        for (int i = 1; i <= n; i++) _not_lie.push_back(i);
        vector <int> _lie;
        while (unite(not_lie, lie).size() != 1)
        {
            relax(not_lie, lie);
            auto pep = unite(_not_lie, _lie);
            int x = move[{not_lie, lie}];
            int y = pep[x];
            cout << "? " << y << endl;
            string s;
            cin >> s;
            int t = (s == "No");
            vector <int> new_not_lie = f(not_lie, x, t ^ 1);
            vector <int> new_lie = unite(f(not_lie, x, t), f(lie, x, t ^ 1));

            vector <int> _new_not_lie = f(_not_lie, y, t ^ 1);
            vector <int> _new_lie = unite(f(_not_lie, y, t), f(_lie, y, t ^ 1));
            not_lie = new_not_lie;
            lie = new_lie;
            _not_lie = _new_not_lie;
            _lie = _new_lie;
        }
        cout << "! " << unite(_not_lie, _lie)[0] << endl;
        string str;
        cin >> str;
        if (str == "Correct") continue;
        else break;
    }
}
