#include <bits/stdc++.h>
#define pb push_back
#define sz(_a) (ll)(_a.size())

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;

const int INF = 1e9 + 9;
//const int N = 1024 * 1024;
const int N = 100010;
const int K = 5010;

bitset <N> s[K];
vector <par> a[K];
queue <ll> q;

inline void bfs(ll v, ll p)
{
    q.push(v);
    s[v][0] = 1;
    while (!q.empty())
    {
        ll z = q.front();
        q.pop();
        for (auto i: a[z])
        {
            q.push(i.first);
            s[i.first] |= (s[z] << i.second * p);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef MAKS
    freopen("input.txt", "r", stdin);
#endif // MAKS

    int t;
    cin >> t;
    int lst = 0;
    while (t--)
    {
        ll n, m, q, p;
        cin >> n >> m >> q >> p;
        for (int i = 0; i < m; i++)
        {
            ll w, e, r;
            cin >> w >> e >> r;
            w--, e--;
            a[w + lst].pb({e + lst, r});
        }
        bfs(lst, p - 1);

        for (int i = 0; i < q; i++)
        {
            ll f, r;
            cin >> f >> r;
            f--;
            /*int r2 = r * p / (p - 1);
            bool b = 0;
            for (auto j: s[f])
            {
                if (r * (p - 1) <= j && j <= r * p)
                {
                    b = 1;
                    break;
                }
            }
            cout << b;*/
            int z = s[f + lst]._Find_next(r * (p - 1) - 1);
            cout << (z <= r * p && z < N);
            /*auto z = s[f].lower_bound(r * (p - 1));
            auto z2 = s[f].upper_bound(r * p);
            //cout << r << ' ' << *z << ' ' << *z2 << ' ' << r2 << '\n';
            cout << (z != z2);*/
        }
        cout << '\n';
        lst += n;
    }
    return 0;
}
