//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <queue>
//#define int long long
using namespace std;

vector<vector<pair<int, long long>>> g;
long long r;
int p, f;

bool dfs(int v, long long t) {
    if (v > f) return false;
    if (v == f) {
        if (r <= t && t <= (long long)(r * (p * 1. / (p - 1)))) return true;
        return false;
    }
    for (int i = 0; i < g[v].size(); ++i) {
        if (dfs(g[v][i].first, t + g[v][i].second)) return true;
    }
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m, q;
        cin >> n >> m >> q >> p;
        g.resize(n);
        for (int i = 0; i < n; ++i) g[i].clear();
        for (int i = 0; i < m; ++i) {
            int v, u;
            long long timer;
            cin >> v >> u >> timer;
            g[v - 1].push_back({u - 1, timer});
        }
        for (int i = 0; i < q; ++i) {
            cin >> f >> r;
            --f;
            if (dfs(0, 0)) cout << 1;
            else cout << 0;
        }
        cout << "\n";
    }
    return 0;
}