#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void z_function(string &s, vector<int> &z) {
	int n = (int)s.size(), l = -1, r = -1;
	z.resize(n);
	z[0] = 0;
	for (int i = 1; i < n; i++) {
		z[i] = 0;
		if (r >= i)
			z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r) {
			l = i;
			r = i + z[i] - 1;
		}
	}
}

int n, m, type, pos, len, ans;
string t, s, sub;
vector<int> z;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> m >> n;
	cin >> s;
	for (int i = 0; i < n; i++) {
		cin >> type;
		if (type == 1) {
			cin >> sub;
			t += sub;
		}
		if (type == 2) {
			cin >> pos >> len;
			pos--;
			for (int i = pos; i - pos < len; i++)
				t.push_back(t[i]);
		}
	}

	s = s + "#" + t;
	z_function(s, z);

	ans = 0;
	for (int i : z) {
		if (i >= m)
			ans++;
	}
	cout << ans << endl;

	//system("pause");
	return 0;
}