#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

void z_function(string &s, vector<int> &z) {
	int n = (int)s.size(), l = -1, r = -1;
	z.resize(n);
	z[0] = 0;
	for (int i = 1; i < n; i++) {
		z[i] = 0;
		if (r >= i)
			z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r) {
			l = i;
			r = i + z[i] - 1;
		}
	}
}

int n, m, type;
string t, s, sub;
vector<int> z;
ll pos, len, cnt, x, vh, ans;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> m >> n;
	cin >> s;
	cnt = 1;
	for (int i = 0; i < n; i++) {
		cin >> type;
		if (type == 1)
			cin >> sub;
		if (type == 2) {
			cin >> pos >> len;
			pos--;
			cnt += (len / (ll)sub.size());
		}
	}

	x = ((int)s.size() + (int)sub.size() - 1) / (int)sub.size() + 1;
	for (int i = 0; i < x; i++)
		for (char c : sub)
			t.push_back(c);

	t = s + "#" + t;
	z_function(t, z);
	for (int i = (int)s.size(); i <= (int)s.size() + (int)sub.size(); i++)
		if (i >= m)
			vh++;

	ans = (cnt - x + 1) * vh;
	cout << ans << endl;

	//system("pause");
	return 0;
}