#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<iomanip>
#include<vector>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<algorithm>
#include<math.h>
#include<cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 2*(1e18);
ll inf = 1e9 + 10;
ld  eps = 1e-9;

string gen(string s, int cnt) {
	string ans;
	int cur = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '0') {
			if (cur < cnt) {
				cur++;
				ans += '0';
			}
		}
		if (s[i] == '1') {
			if (cur == cnt && int(s.size()) - i - 1 >= cnt) {
				ans += s[i];
				cur = 0;
			}
		}
	}
	if (cur == cnt && ans.size() > cur) return ans;
	return "";

}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
#endif // DEBUG

	int n;
	string s;
	cin >> n >> s;
	if (n <= 1000) {
		string ans = "";
		for (int cnt = 0; cnt < n; cnt++) {
			string cur = gen(s, cnt);
			if (cur.size() > ans.size()) {
				ans = cur;
			}
		}
		cout << ans.size() << '\n' << ans;
		return 0;
	}



	string ans = "";

	int sz = max(n / 10,1);

	for (int it = 0; it < 10; it++) {
		int l = it*sz, r = (it+1)*sz;
		while (r - l >= 3) {
			int m1 = l + (r - l) / 3;
			int m2 = r - (r - l) / 3;
			string cur1 = gen(s, m1);
			string cur2 = gen(s, m2);
			if (cur2.size() <= cur1.size()) {
				r = m2;
			} else {
				l = m1;
			}
		}

		for (int i = l; i <= r; i++) {
			string cur = gen(s, i);
			if (cur.size() > ans.size()) {
				ans = cur;
			}
		}

	}
	/*for (int i = 0; i <= n; i++) {
		string cur = gen(s, i);
		cout << cur.size() << ' ';
	}
	cout << endl;
	*/




	cout << ans.size() << '\n' << ans;

	return 0;
}