#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define INF 1000000010
#define MOD 1000000007
#define f first
#define s second

using vi = vector <int>;
using pii = pair <int, int>;
using ll = long long;

void fastIO(){
 	ios_base::sync_with_stdio(0);
 	cin.tie(0);
 	#ifdef LOCAL
 		freopen("input.txt", "r", stdin);
 		freopen("output.txt", "w", stdout);
 	#endif
}
  
const int MAXN = 1e6 + 10;

int m, n, k, num; 

vector <pii> v;
vector <vi> a;
vi c;

ll calc1(int x){
	vi b;
	for(int i = 0; i < m; i++){
		b.pb(a[i][x * 2]);
		b.pb(a[i][x * 2 + 1]);
	}
	sort(b.begin(), b.end());
	int mid = b[b.size() / 2];
	int pos1 = lower_bound(c.begin(), c.end(), mid) - c.begin();
	ll best = (ll)INF * (ll)INF;
	if(pos1 != c.size()){
		ll cur = 0;
		for(int i = 0; i < b.size(); i++)
			cur += (ll)abs(c[pos1] - b[i]);
		best = min(best, cur);
	}
	pos1--;
	if(pos1 >= 0){
		ll cur = 0;
		for(int i = 0; i < b.size(); i++)
			cur += (ll)abs(c[pos1] - b[i]);
		best = min(best, cur);
	}
	return best;
}

void solve1(){
	ll ans = 0;
	for(int i = 0; i < v.size(); i++)
		c.pb(v[i].f);
	for(int i = 0; i < n; i++){
		ans += calc1(i);
	}
	cout << ans;
	exit(0);
}

ll calc(int x){
	vi b;
	for(int i = 0; i < m; i++){
		b.pb(a[i][x * 2]);
		b.pb(a[i][x * 2 + 1]);
	}
	sort(b.begin(), b.end());
	vector <ll> pref(b.size()), suf(b.size());
	for(int i = 0; i < b.size(); i++){
		pref[i] = (ll)INF - (ll)b[i] + (i == 0 ? 0 : pref[i - 1]);
	}
	for(int i = b.size() - 1; i >= 0; i--){
		suf[i] = (ll)b[i] + (i == b.size() - 1 ? 0 : suf[i + 1]);
	}
	ll best = (ll)INF * (ll)INF;
	for(int i = 0; i < k; i++){
		int l = v[i].f, r = v[i].s;
		ll cur = 0;
		int pos = upper_bound(b.begin(), b.end(), l) - b.begin() - 1;
		if(pos >= 0)
			cur += pref[pos] - (ll)(pos + 1) * (ll)(INF - l);
		pos = lower_bound(b.begin(), b.end(), r) - b.begin();
		if(pos < b.size())
			cur += suf[pos] - (ll)(b.size() - pos) * (ll)r;
		best = min(best, cur); 
	}
	return best;
}

int main(){
	fastIO();
	cin >> m >> n >> k;
	v.resize(k);
	bool good = 1;
	for(int i = 0; i < k; i++){
		cin >> v[i].f >> v[i].s;
		good &= (v[i].f == v[i].s);
	}
	sort(v.begin(), v.end());
	a.resize(m);
	for(int i = 0; i < m; i++){
		a[i].resize(2 * n);
		for(int j = 0; j < 2 * n; j++){
			cin >> a[i][j];
		}
		sort(a[i].begin(), a[i].end());
	}
	if(good)
		solve1();
	ll ans = 0;
	for(int i = 0; i < n; i++){
		ans += calc(i);
	}
	cout << ans;
	
	
	return 0;
}	
