#include "bits/stdc++.h"

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
#define io ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#endif

int32_t main() {
    io;

    int m, n, k;
    cin >> m >> n >> k;
    pair<int, int> tables[k];
    forn(i, k) {
        cin >> tables[i].first >> tables[i].second;
    }

    int temp[m][n * 2];
    forn(i, m) {
        forn(j, n * 2) cin >> temp[i][j];
        sort(temp[i], temp[i] + n * 2);
    }

    int req[n][m * 2];
    int ctr = 0;
    forn(i, m) {
        forn(j, n) {
            req[j][ctr] = temp[i][j * 2];
            req[j][ctr + 1] = temp[i][j * 2 + 1];
        }
        ctr += 2;
    }
    forn(i, n) sort(req[i], req[i] + m * 2);

    int ans = 0;
    forn(i, n) {
        int minn = 1e9;
        forn(j, k) {
            int ctr = 0;
            forn(l, 2 * m) {
                if (req[i][l] >= tables[j].first && req[i][l] <= tables[j].second) continue;
                ctr += min(abs(req[i][l] - tables[j].first), abs(req[i][l] - tables[j].second));
            }
            minn = min(minn, ctr);
        }
        ans += minn;
    }
    cout << ans;
}