#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <string>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;

int n, m, t;
ll ans, pos, len;
string p, s, w;

void calc_z_function(const string& s, vector<int>& z)
{
	for (int i = 1, l = 0, r = 0; i < s.length(); i++)
	{
		if (i < r)
			z[i] = min(z[i - l], r - i);
		while (i + z[i] < s.length() && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] > r)
		{
			l = i;
			r = i + z[i];
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> m >> n >> p;
	for (int i = 0; i < n; i++)
	{
		cin >> t;
		if (t == 1)
		{
			cin >> w;
			s += w;
		}
		else
		{
			cin >> pos >> len;
			pos--;
			while (len > 0)
			{
				s += s[pos];
				pos++;
				len--;
			}
		}
	}
	s = p + '#' + s;
	vector <int> z(s.length());
	calc_z_function(s, z);
	for (int i = p.length() + 1; i < s.length(); i++)
		ans += (z[i] == p.length());
	cout << ans;
	return 0;
}