#include <iostream>
#include <vector>

const int INF = 1e9;

int main(void) {
    int m = 0, n = 0, k = 0;
    std::cin >> m >> n >> k;
    std::vector <int> L(k), R(k);
    for (int i = 0; i < k; i++)
        std::cin >> L[i] >> R[i];
    int **group = new int *[m];
    for (int i = 0; i < m; i++) {
        group[i] = new int[2 * n];
        for (int j = 0; j < 2 * n; j++)
            std::cin >> group[i][j];
    }

    long long cost = 0, bestCost = INF;
    for (int partId = 0; partId < k; partId++) {
        for (int groupId = 0; groupId < m; groupId++) {
                for (int i = 0; i < 2 * n; i++) {
                    cost += std::max(std::max(L[partId] - group[groupId][i], group[groupId][i] - R[partId]), 0);
                }
        }
        if (cost < bestCost)
            bestCost = cost;
    }
    std::cout << bestCost << std::endl;
    return 0;
}
