#include <iostream>

long long MOD = 1e9 + 7;

long long Hash(std::string text, int start, int end);

long long meet(std::string text, int textSize, std::string p, int m, long long pHash);

int main(void) {
    int m = 0, n = 0;
    std::cin >> m >> n;
    std::string p = "";
    std::cin >> p;

    std::string t = "";
    int com = 0;
    for (int i = 0; i < n; i++) {
        std::cin >> com;
        if (com == 1) {
            std::string w = "";
            std::cin >> w;
            t += w;
        }
        else { // com == 2
            int pos = 0, len = 0;
            std::cin >> pos >> len;
            pos--;
            for (int j = 0; j < len; j++)
                t += t[pos + j];
        }
    }

    std::cout << meet(t, t.size(), p, m, Hash(p, 0, m - 1)) << std::endl;
    return 0;
}

long long meet(std::string text, int textSize, std::string p, int m, long long pHash) {
    long long res = 0;
    long long textHash = Hash(text, 0, m - 1);
    long long pow2 = 1;

    for (int i = 0; i < m - 1; i++)
        pow2 = (pow2 * 2) % MOD;

    for (int i = 0; i <= textSize - m; i++) {
        if (textHash == pHash) {
            int j = 0;
            while (j < m) {
                if (text[i + j] != p[j])
                    break;
                j++;
            }
            res += (j == m);
        }
        if (i < textSize - m)
            textHash = ((textHash - text[i]) / 2 + text[i + m] * pow2) % MOD;
    }
    return res;
}

long long Hash(std::string text, int start, int end) {
    long long ans = 0;
    for (int i = end; i >= start; i--)
        ans = (ans * 2 + text[i]) % MOD;
    return ans;
}
