#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int MN = 4e5 + 111;
int l[MN], r[MN];

ll ftree[MN];

void ad(int p, int val) {
    for(; p < MN; p |= p + 1) ftree[p] += val;
}
ll gt(int p) {
    ll res = 0;
    for(; p >= 0; p = (p & ( p + 1)) - 1) {
        res += ftree[p];
    }
    return res;
}

ll delta(int l, int r, vector<int> &h) {
    int lp = lower_bound(h.begin(), h.end(), l) - h.begin();
    int rp = lower_bound(h.begin(), h.end(), r) - h.begin();

    int n = h.size();
    ll res = lp * l - gt(lp - 1);
    res += gt(MN - 1) - gt(rp - 1) - (ll)(n - rp) * r;
    return res;

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int m, n, k;
    cin >> m >> n >> k;
    for(int i = 0; i < k; ++i) {
        cin >> l[i] >> r[i];
    }
    vector<vector<int>> in(m, vector<int>(2 * n));
    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < 2 * n; ++j) {
            cin >> in[i][j];
        }
        sort(in[i].begin(), in[i].end());
    }
    ll ans = 0;
    for(int i = 0; i < n; ++i) {
        ll res = 1e18 + 11;
        vector<int> f(2 * m);
        for(int j= 0; j < m; ++j) {
            f[2 * j] = in[j][2 * i];
            f[2 * j + 1] = in[j][2 * i + 1];
        }
        for(int i  = 0; i < 2 * m; ++i) {
            ad(i, f[i]);
        }

        for(int j = 0; j < k; ++j) {
            ll re = delta(l[j], r[j], f);
            res = min(res, re);
        }
        ans += res;

        for(int i  = 0; i < 2 * m; ++i) {
            ad(i, -f[i]);
        }
    }
    cout << ans;
}