#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const ll N = 500010;
const ll INF = 1000000000000;

pair < ll, ll > SL[N];
ll h[N];

ll d(ll a, pair < ll, ll > b) {
	if (a >= b.first && a <= b.second)
		return 0;
	return min(abs(a - b.first), abs(a - b.second));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	ll m, n, k;
	cin >> m >> n >> k;
	for (ll i = 1; i <= k; ++i)
		cin >> SL[i].first >> SL[i].second;
	sort(SL + 1, SL + (k + 1));
	ll P = 0;
	while (m--) {
		for (ll i = 1; i <= 2 * n; ++i)
			cin >> h[i];
		sort(h + 1, h + (2 * n + 1));
		for (ll l = 0; l < n; ++l) {
			ll i = 2 * l + 1;
			ll Min = 2 * INF + 1;
			for (ll j = 1; j <= k; ++j) {
				Min = min(Min, d(h[i], SL[j]) + d(h[i + 1], SL[j]));
			}
			P += Min;
		}
	}
	cout << P;
}