#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const ll N = 500010;
const ll INF = 1000000000000;
const ll C = 100;

pair < ll, ll > SL[N];
ll m, n, k;
ll h[N];

ll d(ll a, pair < ll, ll > b) {
	if (a >= b.first && a <= b.second)
		return 0;
	return min(abs(a - b.first), abs(a - b.second));
}

ll check(ll l, ll i) {
	ll sum = 0;
	for (int j = 0; j < m; ++j) {
		int ind = (2 * i + j * 2 * n) + 1;
		sum += d(h[ind], SL[l]) + d(h[ind + 1], SL[l]);
	}
	return sum;
}

ll tern(ll tl, ll tr, ll i) {
	ll Min = INF;
	ll l = tl, r = tr;
	while (r - l > 1) {
		ll mid = (l + r) >> 1;
		if (mid <= tl || mid >= tr)
			break;
		int f = (l + r) / 3;
		int s = 2 * f;
		ll fc = check(f, i);
		ll mc = check(mid, i);
		ll sc = check(s, i);
		Min = min(Min, fc);
		Min = min(Min, sc);
		Min = min(Min, mc);
		if (fc - mc > mc - sc)
			r = mid;
		else
			l = mid;
	}
	Min = min({ check(l, i), check(r, i), check(1, i), check(k, i) });
	return Min;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cin >> m >> n >> k;
	for (ll i = 1; i <= k; ++i)
		cin >> SL[i].first >> SL[i].second;
	sort(SL + 1, SL + (k + 1));
	ll P = 0;
	for (int i = 1; i <= 2 * n * m; ++i)
		cin >> h[i];
	for (int j = 0; j < m; ++j) {
		sort(h + 2 * n * j + 1, h + 2 * n * (j + 1) + 1);
	}
	for (int i = 0; i < n; ++i) {
		ll Min = INF;
		ll l = 1, r = k;
		Min = min(Min, tern(l, r, i));
		for (int iter = 0; iter < C; ++iter) {
			l = rand() % k + 1, r = rand() % k + 1;
			if (r < l)
				swap(l, r);
			Min = min(Min, tern(l, r, i));
		}
		Min = min({ check(l, i), check(r, i), check(1, i), check(k, i) });
		//for (int l = 1; l <= k; ++l) {
		//	Min = min(Min, check(l, i));
		//}
		P += Min;
	}
	cout << P;
}