#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
 
using namespace std;
 
#define int long long
#define left left228
#define right right228
 
template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
 
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}
 
const int N = 1200 * 1000;
const int mod = 998244353;
 
void add(int &x, int y) {
    x = (x + y + mod + mod) % mod;
}
 
int addi(int a, int b) {
    add(a, b);
    return a;
}
 
int mx[7][N], mn[7][N];
map< pair<int, int>, bool> lov;
map< pair<int, int>, int> value;
 
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector< pair<int, int > > e;
    for (int i = 0; i < k; ++i) {
    	int r, c, v;
    	cin >> r >> c >> v;
    	lov[{r, c}] = 1;
    	value[{r, c}] = v;
    	e.push_back({max(1LL, c - 5), 1});
    	e.push_back({min(m, c), -1});
    }
    sort(e.begin(), e.end());
    vector< pair<int, int> > segs;
    int bal = 0;
    int last = -1;
    for (auto p : e) {
    	bal += p.second;
    	if (bal == 0) {
    		segs.push_back({last, p.first});
    		last = -1;
    	}
    	if (bal == 1 && p.second == 1 && last == -1) {
    		last = p.first;
    	}
    }
    int res = 0;
    for (auto seg : segs) {
    	int l = seg.first, r = seg.second;
    	// cout << "(" << l << ", " << r << ")" << endl;
    	for (int i = 1; i <= n + 1; ++i) {
    		for (int j = 1; j <= r - l + 10; ++j) {
    			mx[i][j] = mn[i][j] = 0;
    		}
    	}
    	for (int i = n; i >= 1; --i) {
    		for (int j = r; j >= l; --j) {
    			if (lov[{i, j}]) {
    				// cout << "i=" << i << " j=" << j << endl;
    				mx[i][j - l + 1] = mn[i][j - l + 1] = value[{i, j}];
    				// cout << "mx[" << i << "][" << j - l + 1 << "]=" << value[{i, j}] << endl;
    			} else {
	                mn[i][j - l + 1] = min(mx[i + 1][j - l + 1], mx[i][j + 1 - l + 1]);
	                mx[i][j - l + 1] = max(mn[i + 1][j - l + 1], mn[i][j + 1 - l + 1]);
    			}
    			add(res, (mn[i][j - l + 1] + mod + mod + mod) % mod);
    		}
    	}
    	// for (int i = 1; i <= n; ++i) {
    	// 	for (int j = 1; j <= r - l + 1; ++j) {
    	// 		cout << mn[i][j] << " ";
    	// 	}
    	// 	cout << endl;
    	// }
    }
    cout << res << endl;
    return 0;
}