#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

vector<int> get_pf(string s) {
	int n = (int)s.size();
	vector<int> p(n);
	for (int i = 1; i < n; ++i) {
		int j = p[i - 1];
		while (j && s[i] != s[j]) {
			j = p[j - 1];
		}
		if (s[i] == s[j]) p[i] = j + 1;
	}
	return p;
}

int cntsp(string s, string t) {
	// int n = (qint)s.size();
	int m = (int)t.size();
	string ns = t + '#' + s;
	vector<int> pf = get_pf(ns);
	int cnt = 0;
	for (int i = m + 1; i < (int)ns.size(); ++i) {
		if (pf[i] >= m) ++cnt;
	}
	return cnt;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	if (m <= 2000 && n == 1) {
		string s = "";
		for (int i = 0; i < n; ++i) {
			int t;
			cin >> t;
			if (t == 1) {
				string w;
				cin >> w;
				s += w;
			} else {
				int pos, len;
				cin >> pos >> len;
				for (int i = pos - 1; i <= pos - 1 + len - 1; ++i) {
					s += s[i];
				}
			}
		}
		cout << cntsp(s, p) << endl;
	} else {
		int t;
		cin >> t;
		string w;
		cin >> w;
		int sz = (int)w.size();
		int K = 1;
		for (int i = 0; i < n - 1; ++i) {
			int t;
			cin >> t;
			int pos, len;
			cin >> pos >> len;
			K += len / (int)w.size();
		}
		if (sz * K <= 3000 * 1000) {
			string s = "";
			for (int i = 0; i < K; ++i) {
				s += w;
			}
			cout << cntsp(s, p) << endl;
		} else {
			string s = "";
			int bl = 0;
			while ((int)s.size() < m) {
				s += w;
				++bl;
			}
			s += w;
			++bl;
			string ns = p + '#' + s;
			vector<int> pf = get_pf(ns);
			int cnt = 0;
			for (int i = m + 1; i < (int)ns.size(); ++i) {
				if (pf[i] == m && i - pf[i] + 1 <= m + sz) {
					++cnt;
				}
			}
			string str = "";
			for (int i = 0; i < bl - 1; ++i) {
				str += w;
			}
			cout << cnt * (K - bl + 1) + cntsp(str, p) << endl;
		}
	}
	return 0;
}