#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector< vector<long long> > Ver(n + 1, vector<long long>(m + 1, -1));
    vector< vector<long long> > Verx(n + 1, vector<long long>(m + 1, -1));
    vector< vector<bool> > us(n, vector<bool>(m, true));
    for (int i = 0; i <= n; i++){
        Verx[i][m] = 0;
        Ver[i][m] = 0;
    }
    for (int i = 0; i <= m; i++){
        Verx[n][i] = 0;
        Ver[n][i] = 0;
    }
    for (int i = 0; i < k; i++){
        int a, b, c;
        cin >> a;
        cin >> b;
        cin >> c;
        Ver[a - 1][b - 1] = c;
        Verx[a - 1][b - 1] = c;
        us[a - 1][b - 1] = false;
    }
    long long sum = 0;
    for (int i = n - 1; i >= 0; i--){
        for (int g = m - 1; g >= 0; g--){
            if (us[i][g]){
                Ver[i][g] = min(Verx[i + 1][g], Verx[i][g + 1]);
                Verx[i][g] = max(Ver[i + 1][g], Ver[i][g + 1]);
            }
            sum = (sum + Ver[i][g] + 998244353) % 998244353;
        }
    }
    cout << sum % 998244353 ;
    return 0;

}
