#include <bits/stdc++.h>

using namespace std;

#define int long long

int mod = 998244353;
int big = 1e18;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <vector <int> > table(n + 2, vector <int> (m + 2));
    map <pair <int, int>, int> ebal;
    for (int i = 0; i < k; ++i) {
        int r, c, w;
        cin >> r >> c >> w;
        --r;
        --c;
        if (w == 0) w = big;
        ebal[{r, c}] = w;
    }
    int sum = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (ebal[{i, j}]) {
                table[i][j] = ebal[{i, j}] % big;
            }
            else {
                int t1 = max(table[i + 1][j + 1], table[i + 2][j]);
                if (ebal[{i + 1, j}] != 0) t1 = ebal[{i + 1, j}] % big;
                int t2 = max(table[i + 1][j + 1], table[i][j + 2]);
                if (ebal[{i, j + 1}] != 0) t2 = ebal[{i, j + 1}] % big;
                table[i][j] = min(t1, t2);
            }
            //cout << table[i][j] << ' ';
            sum = ((sum + table[i][j]) % mod + mod) % mod;
        }
        //cout << '\n';
    }
    cout << sum % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
