#include <iostream>
#include <fstream>

#include <vector>
#include <set>

#include <algorithm>
#include <functional>

#include <cstring>
#include <cstdio>
using namespace std;
//#define DEBUG
#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif


int inf = 1000000000;
vector<int> vals;
int mini() {
	int minpos = 0;
	for (int i = 0; i < vals.size(); i++) {
		if (vals[i] < vals[minpos])minpos = i;
	}
	return minpos;
}

int getval(int ind) {
	return (ind == -1) ? inf : vals[ind];
}
	int best = 0, a = -1, b = -1;

void updateans(int b1) {
	int a1 = getval(mini());
	int res = a1 * b1 + b1 - 1;
	if (res > best) {
		best = res;
		a = a1;
		b = b1;
	}
}

int main() {
	int n;
	cin >> n;
	int val = 0;
	for (int i = 0; i < n; i++) {
		char c; cin >> c;
		if (c == '1') {
			vals.push_back(val);
			val = 0;
		}
		else val++;
	}
	vals.push_back(val);

	n = vals.size();
	updateans(n);
	for (int i = 0; i < (n - 2); i++) {

		int pos = mini();
		int nl = -1, nr = -1;
		for (int j = pos - 1; j >= 0; j--) {
			if (vals[j] != inf) {
				nl = j; break;
			}
		}

		for (int j = pos + 1; j < n; j++) {
			if (vals[j] != inf) {
				nr = j; break;
			}
		}
		if (nl == -1)swap(nl, nr);
		vals[pos] += vals[nl];
		vals[nl] = inf;

		updateans(n - i - 1);
	}

	cout << best << endl;
	for (int i = 0; i < a; i++)cout << "0";
	for (int i = 1; i < b; i++) {
		cout << "1";
		for (int i = 0; i < a; i++)cout << "0";
	}
	return 0;
}