#include <iostream>
#include <string>
#include <bitset>
#include <set>
#include <vector>
#include <deque>
#include <algorithm>
#include <ctime>

#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
using namespace std;
int mod = 998244353;

signed main() {
	kekek;
	
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> g(n + 1, vector<int>(m + 1, 0));
	vector<vector<bool>> tr(n + 1, vector<bool>(m + 1, 0));

	for (int i = 0; i < k; i++) {
		int r, c, v;
		cin >> r >> c >> v;
		tr[r - 1][c - 1] = true;
		g[r - 1][c - 1] = v;
	}
	for (int i = 0; i <= m; i++) {
		tr[n][i] = true;
	}
	for (int i = 0; i <= n; i++) {
		tr[i][m] = true;
	}

	long long ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (tr[i][j]) continue;

			int f, s;
			if (tr[i + 1][j]) {
				f = g[i + 1][j];
			}
			else f = max(g[i + 2][j], g[i + 1][j + 1]);

			if (tr[i][j + 1]) {
				s = g[i][j + 1];
			}
			else s = max(g[i + 1][j + 1], g[i][j + 2]);

			g[i][j] = min(f, s);
		}
	}

	for (auto i : g) {
		for (auto j : i) {
			ans += j;
			//cout << j << " ";
		}
		//cout << '\n';
	}

	while (ans < 0) {
		ans += mod;
	}

	ans %= mod;
	cout << ans;

	//system("pause");
	return 0;
}