#include <iostream>
#include <string>
#include <bitset>
#include <set>
#include <vector>
#include <deque>
#include <algorithm>
#include <ctime>

#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
using namespace std;

string p, s;

int Zfunc() {
	s = p + '#' + s;
	int n = s.size();
	vector<int> z(n + 1, 0);

	for (int i = 1, l = 0, r = 0; i < n; i++) {
		z[i] = min(z[i - l], max(0, r - i));

		while (i + z[i] < n && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] > r) {
			l = i;
			r = i + z[i];
		}
	}

	int cnt = 0;
	for (int i = 1; i < n; i++) {
		if (z[i] == p.size()) {
			cnt++;
		}
	}
	return cnt;
}

signed main() {
	kekek;
	
	int m, n;
	cin >> m >> n >> p;

	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			string k;
			cin >> k;
			s += k;
		}
		else {
			int pos, len;
			cin >> pos >> len;

			pos--;
			for (int i = 0; i < len; i++) {
				s += s[i + pos];
			}
		}
	}

	//cout << p << " " << s << '\n';
	cout << Zfunc();

	//system("pause");
	return 0;
}