#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 1e6 + 5;
const ll mod = 998244353;
int n, m, k;
int mn[5][MAXN];
int mx[5][MAXN];
int a[5][MAXN];

struct hole {
    int x, y, v;
};
hole h[MAXN];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> k;
    rep(i, n) {
        rep(j, m) {
            a[i][j] = INT_MAX;
        }
    }

    rep(i, k) {
        cin >> h[i].x >> h[i].y >> h[i].v;
        h[i].x--;
        h[i].y--;
    }

    sort(h, h + k, [&](const hole &a, const hole &b){
        return a.y < b.y;
    });

    // rep(i, k) {
    //     cout << h[i].x << ' ' << h[i].y << ' ' << h[i].v << endl;
    // }

    h[0].y = min(h[0].y, 7);
    a[h[0].x][h[0].y] = h[0].v;
    for (int i = 1; i < k; ++i) {
        h[i].y = min(h[i].y, h[i - 1].y + 7);
        // cout << "add " << h[i].x << ' ' << h[i].y << ' ' << h[i].v << endl;
        a[h[i].x][h[i].y] = h[i].v;
    }



    for (int i = n - 1; i >= 0; --i) {
        for (int j = MAXN - 1; j >= 0; --j) {
            if (a[i][j] != INT_MAX) {
                mn[i][j] = mx[i][j] = a[i][j];
                continue;
            }

            mn[i][j] = min(mx[i + 1][j], mx[i][j + 1]);
            mx[i][j] = max(mn[i + 1][j], mn[i][j + 1]);
        }
    }

    ll res = 0;
    rep(i, n) {
        rep(j, MAXN) {
            res += mn[i][j];
            res %= mod;
        }
    }

    res = (res + mod) % mod;

    cout << res << endl;
}