#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

const int MOD = 998244353;

void prt(vector<vector<int> > & a){
    for (auto i : a){
        for (auto j : i){
            cout << j << ' ';
        }
        cout << "\n";
    }
    cout << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > h(n, vector<int>(m));
    vector<vector<int> > mn(n + 1, vector<int>(m + 1, INF));
    vector<vector<int> > mx(n + 1, vector<int>(m + 1, -INF));
    for (int i = 0; i <= n; i++){
        mx[i][m] = mn[i][m] = 0;
    }
    for (int i = 0; i <= m; i++){
        mx[n][i] = mn[n][i] = 0;
    }
    for (int i = 0; i < k; i++){
        int x, y, v;
        cin >> x >> y >> v;
        x--;
        y--;
        h[x][y] = v;
    }
    int ans = 0;
    for (int i = n - 1; i >= 0; i--){
        for (int j = m - 1; j >= 0; j--){
            if (h[i][j]){
                mn[i][j] = mx[i][j] = h[i][j];
            }else{
                mn[i][j] = min(mx[i + 1][j], mx[i][j + 1]);
                mx[i][j] = max(mn[i + 1][j], mn[i][j + 1]);
            }
            ans = (ans + mn[i][j] + MOD) % MOD;
        }
    }
    //prt(mn);
    //prt(mx);
    cout << ans << endl;
    return 0;
}
