#include <string>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;
#define int long long
typedef pair<int, int> pii;

const int N = 2e5 + 40;
vector <vector<int>> perms;
vector <pair<int, int>> d[N];

vector <int> path;	

void calc(int &cur, int L, int R, pair<int, int> b) {
	if (b.first < L || b.first > R) cur += min(abs(b.first - L), abs(b.first - R));
	if (b.second < L || b.second > R) cur += min(abs(b.second - L), abs(b.second - R));
}

signed main()
{
	//freopen("true.txt", "r", stdin);
	int m, n, k;
	cin >> m >> n >> k;
	vector <pii> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < m; ++i) {
		vector <int> tab(2 * n);
		for (int j = 0; j < 2 * n; ++j)
			cin >> tab[j];
		sort(tab.begin(), tab.end());
		for (int j = 0; j < 2 * n; j += 2)
			d[i].push_back({ tab[j], tab[j + 1] });
	}
	int res = 0;
	for (int j = 0; j < n; ++j) {
		int add = 1e18;
	    // d[K][j]
		int l = 0, r = k - 1;
		while (r - l > 10) {
			int lm = l + (r - l) / 3;
			int rm = r - (r - l) / 3;
			int ans1 = 0, ans2 = 0;
			for (int K = 0; K < m; ++K) calc(ans1, a[lm].first, a[lm].second, d[K][j]);
			for (int K = 0; K < m; ++K) calc(ans2, a[rm].first, a[rm].second, d[K][j]);
			if (ans1 < ans2) {
				r = rm;
			}
			else {
				l = lm;
			}
		}
		for (int fi = l; fi <= r; ++fi) {
			int src = 0;
			for (int K = 0; K < m; ++K)
				calc(src, a[fi].first, a[fi].second, d[K][j]);
			add = min(add, src);
		}
		res += add;
	}
	cout << res;
	return 0;
}