#include <string>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;
#define int long long
typedef pair<int, int> pii;

int tab[1150][1150];
vector <vector<int>> perms;

vector <int> path;

void perm(int n, int k) {
	if (path.size() == n)
	{
		perms.push_back(path);
		return;
	}
	for (int i = 0; i < k; ++i) {
		path.push_back(i);
		perm(n, k);
		path.pop_back();
	}
}

signed main()
{
//	freopen("true.txt", "r", stdin);
	int m, n, k;
	cin >> m >> n >> k;
	vector <pii> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j)
			cin >> tab[i][j];
		sort(tab[i], tab[i] + 2 * n);
	}
	perm(n, k);
	int res = 1e18;
	for (auto i : perms) {
		int cur = 0;
		for (int j = 0; j < m; ++j) {
			vector <int> id(i.size());
			for (int k = 0; k < i.size(); ++k) id[k] = k;
			int add = 1e18;
			do {
				int nx = 0;
				int now = 0;
				for (int v = 0; v < 2 * n; v += 2) {
					int L = a[i[id[nx]]].first;
					int R = a[i[id[nx]]].second; 
					if (tab[j][v] > R || tab[j][v] < L) now += min(abs(L - tab[j][v]), abs(R - tab[j][v]));
					if (tab[j][v + 1] > R || tab[j][v + 1] < L) now += min(abs(L - tab[j][v + 1]), abs(R - tab[j][v + 1]));
					nx++;
				}
				add = min(add, now);
			} while (next_permutation(id.begin(), id.end()));
			cur += add;
		}
		res = min(res, cur);
	}
	cout << res;
	return 0;
}