#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define endl '\n'
#define int long long

vector<pair<int, int> > order;
vector<pair<int, int> > p;
vector<vector<int> > v;
const int INF = 1e18;
int ans = INF;
int n, m, k;

int check() {
	int res = 0;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			if (!(v[i][j] >= order[j / 2].first && v[i][j] <= order[j / 2].second)) {
				res += min(abs(v[i][j] - order[j / 2].first), abs(v[i][j] - order[j / 2].second));
			}
		}
	}
	return res;
}

void rec(int cnt) {
	if (!cnt) {
		ans = min(ans, check());
		return;
	}
	for (int i = 0; i < p.size(); i++) {
		order.push_back(p[i]);
		rec(cnt - 1);
		order.pop_back();
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> m >> n >> k;

	p.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> p[i].first >> p[i].second;
	}

	v.resize(m, vector<int>(2 * n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> v[i][j];
		}
		sort(v[i].begin(), v[i].end());
	}

	rec(n);
	cout << ans;
}