#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<int> cnt0, next1, to0;

int get(int n, vector<bool> &v, int mid) {
    int ind = to0[mid];
    int cnt = mid;
    int k = 0;
    while (ind < n) {
        ind = next1[ind];
        if (ind >= n) {
            break;
        }
        cnt = cnt0[ind] + mid;
        ind = to0[cnt];
        if (ind >= n) {
            break;
        }
        k++;
    }
    return k;
//    int rest = mid;
//    int k = 0;
//    for (int i = 0; i < n; ++i) {
//        if (!v[i]) {
//            rest--;
//        }
//        else {
//            if (rest <= 0) {
//                k++;
//                rest = mid;
//            }
//        }
//    }
//    if (rest <= 0) {
//        return k;
//    }
//    else {
//        return max(0, k - 1);
//    }
}

int f(int k, int mid) {
    if (k == 0) {
        return 0;
    }
    else {
        return (k + 1) * mid + k;
    }
}

void print(int k, int r) {
    cout << f(k, r) << endl;
    for (int i = 0; i < k + 1; ++i) {
        if (i > 0) {
            cout << 1;
        }
        for (int j = 0; j < r; ++j) {
            cout << 0;
        }
    }
    cout << endl;
}

int main() {
    int n;
    cin >> n;
    vector<bool> v(n);
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        v[i] = (c == '1');
    }

    cnt0.resize(n);
    to0.resize(3 * n, n + 1);
    next1.resize(n);
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            cnt0[i] = cnt0[i - 1];
        }
        if (v[i] == 0) {
            cnt0[i]++;
            to0[cnt0[i]] = i;
        }
    }
    int last = n + 1;
    for (int i = n - 1; i >= 0; --i) {
        next1[i] = last;
        if (v[i] == 1) {
            last = i;
        }
    }

    int ans = n - cnt0[n - 1], ansk = n - cnt0[n - 1], ansi = 0;
    for (int i = 1; i < n; ++i) {
        int k = get(n, v, i);
        if (ans < f(k, i)) {
            ans = f(k, i);
            ansk = k;
            ansi = i;
        }
    }
    print(ansk, ansi);
}