// D.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const int maxn = 2000000;
const ll p1 = 10007, mod = 1000000007;
ll pw[maxn];

vector<ll> get_h(string s) {
	int n = (int)s.size();
	vector<ll> h(n + 1);
	for (int i = 0; i < n; i++) {
		h[i + 1] = (h[i] * p1 + s[i]) % mod;
	}
	return h;
}

ll h_seg(vector<ll>& h, int l, int r) {
	return ((h[r + 1] - h[l] * pw[r - l + 1]) % mod + mod) % mod;
}

int main()
{
	pw[0] = 1;
	for (int i = 1; i < maxn; i++) pw[i] = pw[i - 1] * p1 % mod;
	ios::sync_with_stdio(0);
	int m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	string s;
	vector<pair<string, ll> > all;
	for (int i = 0; i < n; i++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			string t;
			cin >> t;
			all.push_back({ t, 0 });
		}
		else {
			ll pos, len;
			cin >> pos >> len;
			all.back().second += len;
		}
	}
	//cout << s << endl;
	ll ans = 0;
	for (int i = 0; i < (int)all.size(); i++) {
		string cur = all[i].first;
		int cnt = all[i].second;
		for (int j = 0; j < (int)cur.size(); j++) {
			bool ok = 1;
			int ind = i, sub = 0, pos = j;
			for (int t = 0; t < m; t++) {
				if (ind >= all.size() || all[ind][min(pos, (int)all[ind].first.size() - 1)] != p[t]) {
					ok = 0;
					break;
				}
				if (pos == all[ind].first.size()) sub++;
				else pos++;
				if (sub > all[ind].second) ind++, pos = 0, sub = 0;
			}
			if (ok) ans++;
		}
	}
	cout << ans << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
