import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

class segment implements Comparator<segment> {
    long l, r;
    segment(int l, int r) {
        this.l = l;
        this.r = r;
    }
    segment() {}

    @Override
    public int compare(segment o1, segment o2) {
        return Long.compare(o1.l, o2.l);
    }
}
public class Main {
    static long inf = (long) 1e17 + 7;
    static long f(int l, int r,int a) {
        if (l <= a && r >= a) return 0;
        if (r <= a) return a - r;
        return l - a;
    }

    public static void main(String[] args) throws IOException {
        PrintWriter pw = new PrintWriter(System.out);
        int m = nextInt();
        int n = nextInt();
        int k = nextInt();
        segment s[] = new segment[k];
        for(int i = 0;i < k;i++) {
            s[i] = new segment(nextInt(), nextInt());
        }
        Arrays.sort(s, new segment());
        int a[][] = new int [m][n * 2];
        for(int i = 0;i < m;i++) {
            for(int j = 0;j < 2 * n;j++) {
                a[i][j] = nextInt();
            }
            Arrays.sort(a[i]);
        }
        long ans = 0;
        int min_id = 0;
        for(int i = 0;i < 2 * n;i+= 2) {
            long min = inf;
            int b[] = new int [2 * m];
            for(int j = 0;j < m;j++) {
                b[j * 2] = a[j][i];
                b[j * 2 + 1] = a[j][i + 1];
            }
            Arrays.sort(b);
            long pref[] = new long [2 * m];
            pref[0] = b[0];
            for(int j = 1;j < 2 * m;j++) pref[j] = pref[j - 1] + b[j];
            int id = 0;
            for(int j = min_id;j < k;j++) {
                long l = s[j].l;
                long r = s[j].r;
                int left = -1;
                int right = m * 2;
                while(left != right - 1) {
                    int mid = (left + right) << 2;
                    if (b[mid] < l) left = mid;
                    else right = mid;
                }

                int id_of_left = left;
                int id_of_right = right;
                long f = 0;
                f += pref[2 * m - 1] - r * (2 * m - id_of_right);
                if (id_of_left != -1) f += (l * (id_of_left + 1)) - pref[id_of_left];
                if (id_of_right != 0) f -= pref[id_of_right - 1];
                if (f < min) {
                    min = f;
                    id = j;
                }else break;
            }
            min_id = id;
            ans += min;
        }
        pw.print(ans);
        pw.close();
    }
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static StringTokenizer st = new StringTokenizer("");
    static String next() throws IOException {
        if (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }
    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}