#include<iostream>
#include<string>
#include<algorithm>
#include<vector>
#include<ctime>

using namespace std;

#pragma warning(disable : 4996)
#define all(aaa) aaa.begin(), aaa.end()
#define ll long long


const ll INF = 1e18;
const int N = 2000, MAX = 2e9;
vector<pair<int, int>> w, tmp;
vector<int> v[N];
ll sum[N];
int m, n, k;

ll brute() {
	ll ans = 0;
	for (int i = 0; i < n; i += 2) {
		vector<int> z;
		for (int j = 0; j < m; j++) {
			z.push_back(v[j][i]);
			z.push_back(v[j][i + 1]);
		}
		z.push_back(-1);
		z.push_back(MAX);
		sort(all(z));

		for (int j = 1; j < z.size(); j++) {
			sum[j] = sum[j - 1];
			if (j != z.size() - 1)
				sum[j] += z[j];
		}

		ll mn = INF;

		for (int i = 1; i < z.size(); i++) {
			for (int j = i; j < z.size(); j++) {
				for (int h = 0; h < w.size(); h++) {
					if (w[h].first >= z[i - 1] && w[h].first <= z[i] &&
						w[h].second >= z[j - 1] && w[h].second <= z[j]) {
						ll lc = i - 1, rc = z.size() - j - 1;
						ll cur = w[h].first * lc - sum[i - 1] +
							sum[z.size() - 1] - sum[j - 1] - w[h].second * rc;
						mn = min(mn, cur);
					}
				}
			}
		}

		ans += mn;
	}

	return ans;
}

void writeTest() {
	srand(time(0));
	freopen("input.txt", "w", stdout);
	int m = 10, n = 10, k = 2, mx = 100;
	cout << m << " " << n << " " << k << "\n";
	for (int i = 0; i < k; i++) {
		int x = 10,
			y = 10;
		if (x > y)
			swap(x, y);
		cout << x << " " << y << "\n";
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n * 2; j++) {
			cout << 10 << " ";
		}
		cout << "\n";
	}
}

signed main() {
	/*int ct = 1;
	while (ct--) {
		writeTest();*/
#ifdef HOME
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
#endif
		ios_base::sync_with_stdio(0);
		cin.tie(0);
		cin >> m >> n >> k;

		n *= 2;

		for (int i = 0; i < k; i++) {
			int l, r;
			cin >> l >> r;
			w.push_back({ l, r });
		}

		sort(all(w));
		w.erase(unique(all(w)), w.end());

		int mx = -1;
		for (int i = 0; i < w.size(); i++) {
			if (i == w.size() - 1 || w[i + 1].first != w[i].first) {
				if (w[i].second > mx)
					tmp.push_back(w[i]);
				mx = max(mx, w[i].second);
			}
		}

		swap(tmp, w);

		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				int x;
				cin >> x;
				v[i].push_back(x);
			}
			sort(all(v[i]));
		}

		ll ans = 0;
		for (int i = 0; i < n; i += 2) {
			vector<int> z;
			for (int j = 0; j < m; j++) {
				z.push_back(v[j][i]);
				z.push_back(v[j][i + 1]);
			}
			z.push_back(-1);
			z.push_back(MAX);
			sort(all(z));

			for (int j = 1; j < z.size(); j++) {
				sum[j] = sum[j - 1];
				if (j != z.size() - 1)
					sum[j] += z[j];
			}

			ll mn = INF;

			for (int j = 1; j < z.size(); j++) {
				int li = 0,
					ri = w.size() - 1;
				while (li < w.size() && w[li].first < z[j - 1])
					li++;
				while (ri >= 0 && w[ri].first > z[j])
					ri--;
				if (li > ri)
					continue;



				for (int h = li; h <= ri; h++) {
					int xi = 0, yi = w.size() - 1, q = 0;
					while (z[q] < w[h].second)
						q++;

					ll lc = j - 1, rc = z.size() - 1 - q;

					while (xi < w.size() && w[xi].second < z[q - 1]) //?????
						xi++;
					while (yi >= 0 && w[yi].second > z[q]) {
						yi--;
					}
					if (xi > yi)
						continue;
					int L = max(xi, li), R = min(yi, ri);

					ll cur;
					if (lc > rc) {
						cur = lc * w[L].first - sum[j - 1] +
							sum[z.size() - 1] - sum[q - 1] - rc * w[L].second;
					}
					else {
						cur = lc * w[R].first - sum[j - 1] +
							sum[z.size() - 1] - sum[q - 1] - rc * w[R].second;
					}
					mn = min(mn, cur);
				}

				for (int h = li; h <= ri; h++) {
					int xi = 0, yi = w.size() - 1, q = 0;
					while (z[q] <= w[h].second)
						q++;

					ll lc = j - 1, rc = z.size() - 1 - q;

					while (xi < w.size() && w[xi].second < z[q - 1]) //?????
						xi++;
					while (yi >= 0 && w[yi].second > z[q]) {
						yi--;
					}
					if (xi > yi)
						continue;
					int L = max(xi, li), R = min(yi, ri);

					ll cur = lc * w[L].first - sum[j - 1] +
						sum[z.size() - 1] - sum[q - 1] - rc * w[L].second;
					cur = min(cur, lc * w[R].first - sum[j - 1] +
						sum[z.size() - 1] - sum[q - 1] - rc * w[R].second);
					mn = min(mn, cur);
				}
			}

			ans += mn;
		}

		cout << ans;
		/*ll br = brute();
		if (ans != br) {
			cout << "WRONG";
			return 0;
		}

		cout << ans << " " << br << "\n";*/


		//cout << ans;

		//cout << "\n" << brute();

		for (int i = 0; i < m; i++)
			v[i].clear();
		w.clear();
		tmp.clear();
	}

	return 0;
}