#include<iostream>
#include<cstdlib>
#include<string>
#include<vector>
#include<algorithm>
#include<numeric>
#include<fstream>
#include<tuple>
#include<cassert>
  
using namespace std;
using nagai = long long;
  
const int N = 100100;
const int oo=0x3f3f3f3f;
const int mod=998244353;
  
int n,m,k;
/*
const int NN=1010;
int ans[NN][NN][2];
bool hole[NN][NN];
void stupid(){
    cin>>n>>m>>k;
    nagai ansich=0;
    for(int i=0;i<k;++i){
        int x,y,w;
        cin>>x>>y>>w;
        --x,--y;
        hole[x][y]=true;
        ans[x][y][0]=ans[x][y][1]=w;
        (ansich+=w)%=mod;
    }
    for(int i=n-1;i>=0;--i)
        for(int j=m-1;j>=0;--j){
            if(hole[i][j])continue;
            ans[i][j][0]=min(ans[i][j+1][1],ans[i+1][j][1]);
            ans[i][j][1]=max(ans[i][j+1][0],ans[i+1][j][0]);
            (ansich+=ans[i][j][0])%=mod;
        }
    for(int i=0;i<n;++i){
        for(int j=0;j<m;++j){
            if(hole[i][j])
                cerr<<'*'<<' ';
            else cerr<<ans[i][j][0]<<' ';
        }
        cerr<<'\n';
    }
    if(ansich<0)ansich+=mod;
    cout<<ansich<<'\n';
}
*/
struct cell{
    int x,y,w;
};
cell traps[N];
int diag(cell c){
    return c.x-c.y;
}
int dep(cell c){
    return c.x+c.y;
}
int main() {
#ifdef _DEBUG
    ifstream cin("input.txt");
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m>>k;
    for(int i=0;i<k;++i){
        int x,y,w;
        cin>>x>>y>>w;
        --x,--y;
        traps[i]={x,y,w};
    }
    sort(traps,traps+k,[&](cell a,cell b){
        return a.x-a.y<b.x-b.y;
    });
    nagai ans=0;
    vector<int>diags;
    for(auto x:traps)
        for(int i=diag(x)-2;i<=diag(x)+2;++i)diags.push_back(i);
    sort(diags.begin(),diags.end());
    diags.erase(unique(diags.begin(),diags.end()),diags.end());
    int ptr=0;
    for(int mydiag:diags){
        int le=mydiag-2;
        int ri=mydiag+2;
        while(ptr<k&&diag(traps[ptr])<mydiag)++ptr;
        int lep=ptr;
        int rip=ptr;
        vector<cell>v;
        while(lep>0&&diag(traps[lep-1])>=le)v.push_back(traps[lep-1]),--lep;
        while(rip<k&&diag(traps[rip])<=ri)v.push_back(traps[rip]),++rip;
        vector<int>dps;
        
        for(auto c:v)
            for(int i=dep(c)-2;i<=dep(c)+2;++i)
                dps.push_back(i);
                
        sort(dps.begin(),dps.end());
        dps.erase(unique(dps.begin(),dps.end()),dps.end());
        vector<vector<int>>ans1(dps.size(),vector<int>(3,oo)),ans2=ans1;
        for(auto&x:v){
            int d=dep(x);
            d=lower_bound(dps.begin(),dps.end(),d)-dps.begin();
            int ind=diag(x)-le;
            ind/=2;
            ans1[d][ind]=ans2[d][ind]=x.w;
        }
        int mydep=mydiag%2;
        if(mydep<0)mydep+=2;
        for(int i=dps.size()-3;i>=0;--i){
            if(dps[i]<0)break;
            int d=dps[i];
            int len=d%2==mydep%2?3:2;
            int len1=5-len;
            for(int j=0;j<len;++j){
                if(dps[i+1]%2==d%2)
                    ans1[i][j]=ans1[i+1][j],ans2[i][j]=ans2[i+1][j];
                else{
                    if(ans1[i][j]!=oo)
                        continue;
                    if(len==2){
                        ans1[i][j]=min(ans2[i+1][j],ans2[i+1][j+1]);
                        ans2[i][j]=max(ans1[i+1][j],ans1[i+1][j+1]);
                    }
                    else{
                        ans1[i][j]=oo,ans2[i][j]=-oo;
                        if(j-1>=0)
                            ans1[i][j]=min(ans1[i][j],ans2[i+1][j-1]),
                            ans2[i][j]=max(ans2[i][j],ans1[i+1][j-1]);
                        if(j<len1)
                            ans1[i][j]=min(ans1[i][j],ans2[i+1][j]),
                            ans2[i][j]=max(ans2[i][j],ans1[i+1][j]);
                    }
                    if(ans1[i][j]==oo)ans1[i][j]=ans2[i][j]=0;
                }
            }
            if(len==3){
                int x=(mydiag+dps[i])/2;
                int y=dps[i]-x;
                if(x<0||y<0)break;
                int ri=dps[i+1];
                if(ri%2!=dps[i]%2)++ri;
                int cnt=(ri-dps[i])/2;
                ans+=(nagai)cnt*ans1[i][1];
                //cerr<<x<<' '<<y<<' '<<ans1[i][1]<<'\n';
                ans%=mod;
            }
        }
    }
    if(ans<0)ans+=mod;
    cout<<ans<<'\n';
    system("pause");
}