#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#define int long long
using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

vector<int> zfunc(string s) {
    int n = s.size();
    vector<int> z(n);
    int j = -1, r = -1;
    for (int i = 1; i < n; i++) {
        if (i <= r) {
            z[i] = min(r - i + 1, z[i - j]);
        }
        while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
            z[i]++;
        }
        if (i + z[i] - 1 >= r) {
            j = i;
            r = i + z[i] - 1;
        }
    }
    return z;
}

signed main() {
    fast();
    int m, n;
    cin >> m >> n;
    if (n == 1 && m <= 2000) {
        string p;
        cin >> p;
        string t;
        for (int i = 0; i < n; i++) {
            int tp;
            cin >> tp;
            if (tp == 1) {
                string temp;
                cin >> temp;
                t += temp;
            } else {
                int pos, len;
                cin >> pos >> len;
                pos--;
                while (len > 0) {
                    len--;
                    t.push_back(t[pos]);
                    pos++;
                }
            }
        }
        string x = p + t;
        vector<int> z = zfunc(x);
        int answ = 0;
        for (int i = p.size(); i < z.size(); i++) {
            if (z[i] >= p.size()) answ++;
        }
        cout << answ;
        return 0;
    }
    string p;
    cin >> p;
    string t;
    string w;
    int cnt = 1;
    for (int i = 0; i < n; i++) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            string temp;
            cin >> temp;
            w = temp;
        } else {
            int pos, len;
            cin >> pos >> len;
            cnt += len / w.size();
        }
    }
    string x = w + p;
    vector<int> z = zfunc(x);
    vector<bool> d(w.size(), true);
    for (int i = 0; i < w.size(); i++) {
        for (int j = i; j < p.size(); j += w.size()) {
            if (z[j + w.size()] < min((int)p.size() - j, (int)w.size())) d[i] = false;
        }
    }
    string p2 = p;
    reverse(p2.begin(), p2.end());
    string w2 = w;
    reverse(w2.begin(), w2.end());
    string x2 = w2 + p2;
    vector<int> z2 = zfunc(x2);
    int answ = 0;
    for (int i = 0; i < w.size(); i++) {
        if (!d[i]) continue;
        if (i > 0 && z2[z2.size() - i] <= i) continue;
        if ((int)w.size() * cnt - (int)p.size() - i < 0) continue;
        answ += max(0ll, ((int)w.size() * cnt - (int)p.size() - i) / (int)w.size() + 1ll);
    }
    cout << answ;
    return 0;
}