#pragma GCC optimize("Ofast")
#pragma GCC target("sse,ssse3,avx")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXC = 4e5 + 40;
const int MAXK = 55;

int main()
{
#ifdef POSPELOV
    freopen("in", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    vector <pair <int, int>> ps(k);
    for (auto &i : ps)
        cin >> i.first >> i.second;
    sort(ps.begin(), ps.end());

    vector <vector <int>> arr(m, vector <int> (2 * n));
    vector <pair <int, int>> chs;
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            cin >> arr[i][j];
        }
        sort(arr[i].begin(), arr[i].end());
    }

    auto get = [&](int i, int j, int t)->int
    {
        int h1 = arr[i][2 * j], h2 = arr[i][2 * j + 1];
        int l = ps[t].first, r = ps[t].second;
        return (h1 <= l ? l - h1 : (h1 <= r ? 0 : h1 - r)) + (h2 <= l ? l - h2 : (h2 <= r ? 0 : h2 - r));
    };

    ll ans = 0;
    vector <vector <int>> cst(m, vector <int> (n));
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < n; j++)
        {
            int res = get(i, j, 0);
            ans += res;
        }
    }

    int last = 0;
    for (int j = 0; j < n; j++)
    {
        for (int i = last; i < k; i++)
        {
            ll delta = 0, deltaz = -1;
            ll curd = 0;
            for (int t = 0; t < m; t++)
                curd += get(t, j, i) - get(t, j, cst[0][j]);
            if (curd < delta)
            {
                delta = curd;
                deltaz = j;
            }

            if (delta < 0)
            {
                cst[0][deltaz] = i;
                ans += delta;
                last = i;
            }
        }
    }

    cout << ans;

    return 0;
}
