#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1010;
const int MOD = 998244353;

int dp[MAXN][MAXN][2];
bool good[MAXN][MAXN];

int pl(int a, int b)
{
    return ((a + b) % MOD + MOD) % MOD;
}

int main()
{
#ifdef POSPELOV
    freopen("in", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++)
    {
        int r, c, v;
        cin >> r >> c >> v;
        r--, c--;
        dp[r][c][0] = v;
        dp[r][c][1] = v;
        good[r][c] = 1;
    }

    int ans = 0;

    for (int i = n - 1; i >= 0; i--)
    {
        for (int j = m - 1; j >= 0; j--)
        {
            if (!good[i][j])
            {
                dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
                dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
            }
            ans = pl(ans, dp[i][j][0]);
        }
    }
    cout << ans;

    return 0;
}
