#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map> 

using namespace std;
#define int long long
#define double long double
int n, m;
string s;
void read() {
	cin >> m >> n >> s;
}

int ans = 0;

int get_ans(string have, string s) {
	int cnt = 0;
	int sz1 = have.size();
	int sz2 = s.size();
	int sz = sz1 - sz2;
	for (int i = 0; i <= sz; i++) {
		bool flag = true;
		for (int j = 0; j < s.length(); j++) {
			if (have[i + j] != s[j]) {
				flag = false;
				break;
			}
		}
		if (flag)
			cnt++;
	}
	return cnt;
}

vector <int> z_function(string s) {
	int n = s.length();
	vector <int> z(n);
	int l = 0, r = 0;
	for (int i = 1; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while (z[i] + i < n && s[z[i]] == s[z[i] + i])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}

int get_ans_smart(string have, string s) {
	have = s + "#" + have;
	auto fans = z_function(have);
	int cnt = 0;
	for (int i = s.length() + 1; i < fans.size(); i++) {
		if (fans[i] == s.length())
			cnt++;
	}
	return cnt;
}

void second_group() {
	string have = "";
	for (int i = 0; i < n; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			string x;
			cin >> x;
			have += x;
		}
		if (type == 2) {
			int pos, len;
			cin >> pos >> len;
			pos--;
			for (int j = 0; j < len; j++)
				have += have[j + pos];
		}
	}

	ans = get_ans_smart(have, s);
}

void run() {
	second_group();
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}