﻿/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse3,tune=native")*/

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll
const int INF = 1e18;
const int MOD = 998244353;

int getComf(int f, const pair<int, int> &prt)
{
	if (f < prt.first)
		return prt.first - f;
	if (f > prt.second)
		return f - prt.second;
	return 0;
}

bool comp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first)
		return a.first < b.first;
	return	a.second > b.second;
}

int getResult(const vector <int> &persons, const pair<int, int> &table)
{
	int res = 0;
	for (int i = 0; i < persons.size(); i++)
	{
		res += getComf(persons[i], table);
	}
	return res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> m >> n;
	string s;
	cin >> s;
	string answer = "#";
	for (int i = 0; i < n; i++)
	{
		int type;
		cin >> type;
		if (type == 1)
		{
			string k;
			cin >> k;
			answer += k;
		}
		else
		{
			int f, c;
			cin >> f >> c;
			for (int i = f; i < f + c; i++)
			{
				answer += answer[i];
			}
		}
	}
	string km = s + answer;
	//cout << km << endl;

	int ans = 0;
	vector <int> p(km.size() + 1);
	for (int i = 1; i < km.size(); i++)
	{
		int j = p[i - 1];
		while (j > 0 && km[i] != km[j])
			j = p[j - 1];
		if (km[i] == km[j])
			j++;
		p[i] = j;

		if (p[i] == s.size())
			ans++;
	}
/*	for (int i = 0; i < km.size(); i++)
	{
		cout << p[i];
	}*/
	cout << ans;
	return 0;

}