#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

bool corr(int z, int o, string& s)
{
	int zcnt = 0; int ocnt = 0;
	bool ok = false;
	for (char ch : s)
	{
		if (zcnt < z && ch == '0')
			zcnt++;
		else if (zcnt == z && ch == '1')
		{
			zcnt = 0;
			ocnt++;
		}
		if (zcnt == z && ocnt == o)
		{
			ok = true;
			break;
		}
	}
	return ok;
}

int len(int am, string& s)
{
	int l = 0, r = s.size() / 2 + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		if (corr(m, am, s))
			l = m;
		else
			r = m;
	}
	
	int ans = 0;
	if (corr(l, am, s))
		ans = l * (am + 1) + am;
	return ans;
}


signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;

	string gir;
	cin >> gir;

	int ocnt = 0;
	for (char ch : gir)
	{
		if (ch == '1')
			ocnt++;
	}

	int maxlen = -1;
	int maxam;
	for (int i = 1; i <= ocnt; i++)
	{
		int t = len(i, gir);
		if (t > maxlen)
		{
			maxlen = t;
			maxam = i;
		}
	}

	/*int l = 1, r = n;
	while (r - l > 2)
	{
		int m1 = l + (r - l) / 3;
		int m2 = r - (r - l) / 3;

		if (len(m1, gir) < len(m2, gir))
			l = m1;
		else
			r = m2;
	}

	vector<int> am = { l, l + 1, r };
	int maxlen = -1;
	int maxam;
	for (int i = 0; i < 3; i++)
	{
		int sz = len(am[i], gir);
		if (sz > maxlen)
		{
			maxlen = sz;
			maxam = am[i];
		}
	}*/

	int zam = (maxlen - maxam) / (maxam + 1);
	string ans;
	for (int i = 0; i < maxam + 1; i++)
	{
		for (int j = 0; j < zam; j++)
		{
			ans += '0';
		}
		ans += '1';
	}
	ans.pop_back();

	cout << maxlen << '\n' << ans << '\n';
	

	//system("pause");
	return 0;
}