#include<bits/stdc++.h>

using namespace std;


struct seg {
    int l, r;
};

#define ll long long
#define pb push_back

const ll INF = 1e18;
const int MAXN = 1e5;


int m, n, k;

vector<seg> desk;
vector<vector<seg>> kids;

int loc_k = 0;

ll len(seg a, int x) {
    if (x <= a.r && x >= a.l) {
        return (ll)0;
    } else {
        return min(abs(a.r-x), abs(a.l-x));
    }
}

ll dist(seg a, seg b) {
    return len(a, b.l) + len(a, b.r);
}

ll solve(int ind) {
    ll ans = INF;
    for (int i = 0; i < k; ++i) {
        ll loc = 0;
        for (int j = 0; j < m; ++j) {
            loc += dist(desk[i], kids[ind][j]);
        }
        ans = min(ans, loc);
    }
    return ans;
}

int main() {
    cin >> m >> n >> k;
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        desk.pb({min(x, y), max(x, y)});
    }
    kids.resize(n);
    for (int i = 0; i < m; ++i) {
        vector<int> loc;
        for (int j = 0; j < 2*n; ++j) {
            int x; cin >> x;
            loc.pb(x);
        }
        sort(loc.begin(), loc.end());
        for (int j = 0; j < n; ++j) {
            int a = loc[2*j], b = loc[2*j+1];
            kids[j].pb({min(a, b), max(a, b)});
        }
    }

    ll p = 0;
    for (int i = 0; i < n; ++i) {
        //cout << solve(i) << endl;
        p += solve(i);
    }
    cout << p;
    return 0;
}

