#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;

template<typename T1, typename T2> 
inline void chkmax(T1 &x, const T2 &y) {
	if (x < y) x = y;
}

template<typename T1, typename T2> 
inline void chkmin(T1 &x, const T2 &y) {
	if (x > y) x = y;
}

typedef pair<int, int> point;

int root = 0;
int n, m;
string s;
string ns;

const int N = 10005;

int lst = 1, cur_root = 0;
int go[N * 2][26];
int suf[N * 2], len[N * 2];

void add(char c) {
	int cur = lst++;
	len[cur] = len[cur_root] + 1;
	if (len[cur] == 1) {
		suf[cur] = 0;
	} else {
		suf[cur] = 0;
		int r = cur_root;
		while (r >= 0) {
			if (go[r][c]) {
				suf[cur] = go[r][c];
				break;
			} else {
				r = suf[r];
			}	
		}
	}
	go[cur_root][c] = cur;
	cur_root = cur;
	// cout << cur << ' ' << suf[cur] << endl;
}

bool used[N * 2][26];

int solve(int i, char c) {
	if (used[i][c] || go[i][c]) return go[i][c];
	used[i][c] = true;
	if (i == 0) return 0;
	return go[i][c] = solve(suf[i], c);
}

int main() {
	ios::sync_with_stdio(false);
	suf[0] = -1;
	cin >> n >> m;
	cin >> s;
	for (auto &c : s) c -= 'a';
	for (auto c : s) add(c);
	for (int i = 0; i <= s.size(); ++i) {
		for (int j = 0; j < 26; ++j) {
			solve(i, j);
		}
	}
	for (int i = 0; i < m; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			string ns;
			cin >> ns;
			for (auto &c : ns) c -= 'a';
			::ns += ns;
		} else {
			long long L, sz;
			cin >> L >> sz;
			--L;
			while (sz) {
				ns += ns[L];
				++L;
				--sz;
			}
		}	
	}
	int v = 0;
	int ans = 0;
	int my_len = 0;
	for (int i = 0; i < ns.size(); ++i) {
		v = go[v][ns[i]];
		if (len[v] == n) {
			++ans;
		}
	}
	cout << ans << '\n';
}
	