#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int inf = 2e9, mod = 998244353;

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<vector<int>>> dp(2, vector<vector<int>>(n + 1, vector<int>(m + 1, inf)));
	for (int i = 0; i <= n; ++i) {
		dp[0][i][m] = 0;
		dp[1][i][m] = 0;
	}
	for (int i = 0; i <= m; ++i) {
		dp[0][n][i] = 0;
		dp[1][n][i] = 0;
	}
	for (int i = 0; i < k; ++i) {
		int x, y, v;
		cin >> x >> y >> v;
		dp[0][x - 1][y - 1] = v;
		dp[1][x - 1][y - 1] = v;
	}
	for (int i = n - 1; i >= 0; --i)
		for (int j = m - 1; j >= 0; --j)
			if (dp[0][i][j] == inf) {
				dp[0][i][j] = min(dp[1][i + 1][j], dp[1][i][j + 1]);
				dp[1][i][j] = max(dp[0][i + 1][j], dp[0][i][j + 1]);
			}
	/*
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= m; ++j)
			cout << dp[0][i][j] << " ";
		cout << "\n";
	}
	cout << "\n";
	*/
	int64_t ans = 0;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			ans = ((ans + dp[0][i][j]) % mod + mod) % mod;
	cout << ans;
}
