#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main() {
	int m, n;
	cin >> m >> n;
	string p, s;
	cin >> p;
	for (int q = 0; q < n; ++q) {
		int type;
		cin >> type;
		if (type == 1) {
			string add;
			cin >> add;
			s += add;
		}
		else if (type == 2) {
			int pos, len;
			cin >> pos >> len;
			--pos;
			for (int i = 0; i < len; ++i)
				s.push_back(s[pos + i]);
		}
	}
	s = p + "#" + s + "!";
	int len_line = s.size();

	vector<int> z(len_line);
	int left = 0, right = 0;
	for (int i = 1; i < len_line; ++i) {
		z[i] = max(0, min(z[i - left], right - i));
		while (s[z[i]] == s[i + z[i]])
			++z[i];
		if (right <= i + z[i]) {
			left = i;
			right = i + z[i];
		}
	}

	int ans = 0;
	for (int i = p.size() + 1; i < len_line - 1; ++i)
		if (z[i] == p.size())
			++ans;

	cout << ans;
}
