#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define x first
#define y second
#define mp make_pair
using namespace std;

#define en aosnetuhaosentuhtaos

typedef pair<int, int> pii;
typedef long long ll;

int m, n, k;

const int N = 2e5;

vector<pii> range;
vector<pii> p[N];

int penalty(pii r, int x) {
	if (r.x <= x && x <= r.y) return 0LL;
	return min(abs(r.x - x), abs(r.y - x));
}

ll rez = 0;

void go(int l, int r, int cl, int cr) {
	if (l > r) return;
	if (cl == cr) {
		for (int k = 0; k < m; k++) {
			for (int i = l; i <= r; i++) {
				rez += penalty(range[cl], p[k][i].x) + penalty(range[cl], p[k][i].y);
			}
		}
	} else {
		int mid = (l + r) / 2;
		ll best = 1e18;
		int cut = -1;
		for (int cm = cl; cm <= cr; cm++) {
			ll cur = 0;
			for (int k = 0; k < m; k++) {
				cur += penalty(range[cm], p[k][mid].x) + penalty(range[cm], p[k][mid].y);
			}
			if (cur < best) {
				best = cur;
				cut = cm;
			}
		}
		rez += best;
		go(l, mid - 1, cl, cut);
		go(mid + 1, r, cut, cr);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> m >> n >> k;
	vector<pii> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i].x >> v[i].y;
	}
	sort(v.begin(), v.end(), [](pii a, pii b) {
		return mp(a.x, -a.y) < mp(b.x, -b.y);
	});
	int R = -1e9;
	for (pii p : v) {
		if (p.y <= R) continue;
		R = max(p.y, R);
		range.pb(p);
	}
	for (int i = 0; i < m; i++) {
		p[i].resize(n);
	}
	// p.resize(m, vector<pii>(n));
	for (int i = 0; i < m; i++) {
		vector<int> all(2 * n);
		for (int j = 0; j < 2 * n; j++) {
			cin >> all[j];
		}
		sort(all.begin(), all.end());
		for (int j = 0; j < n; j++) {
			p[i][j].x = all[j * 2];
			p[i][j].y = all[j * 2 + 1];
		}
	}
	go(0, n - 1, 0, len(range) - 1);
	cout << rez << endl;
}