#include "bits/stdc++.h"

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


using namespace std;


void solve() {
    ll n;
    string s;
    cin >> n >> s;
    ll l = -1, r = n;
    function<ll(ll)> get_ans = [&](ll len) {
        ll have_zeroes = 0;
        ll ans = 0;
        bool good = false;
        for (int i = 0; i < n; i++) {
            if (have_zeroes < len and s[i] == '0') {
                have_zeroes++;
                ans++;
            } else if (have_zeroes == len and s[i] == '1') {
                ans++;
                good = true;
                have_zeroes = 0;
            }
        }
        if (have_zeroes != len) {
            ans -= have_zeroes + 1;
        }
        if (!good) {
            ans = 0;
        }
        return ans;
    };
    while (r - l > 2) {
        ll d = (r - l) / 3;
        ll m1 = (l + d), m2 = l + d * 2;
        ll a1 = get_ans(m1), a2 = get_ans(m2);
        if (a1 > a2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    ll a = get_ans(l), b = get_ans(l + 1), c = get_ans(l + 2);
    ll kek = max(a, max(b, c));
    ll len;
    if (a == kek) {
        len = l;
    } else if (b == kek) {
        len = l + 1;
    } else {
        len = l + 2;
    }
    ll have_zeroes = 0;
    cout << kek << "\n";
    string answer;
    for (int i = 0; i < n; i++) {
        if (have_zeroes < len and s[i] == '0') {
            have_zeroes++;
            answer.pb('0');
        } else if (have_zeroes == len and s[i] == '1') {
            answer.pb('1');
            have_zeroes = 0;
        }
    }
    if (have_zeroes != len) {
        for (int i = 0; i < have_zeroes + 1; i++) {
            answer.pop_back();
        }
    }
    cout << answer;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}