#include "bits/stdc++.h"

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


const ll inf = 1e18;


using namespace std;


ll get_val(ll h, ll l, ll r) {
    if (h < l) {
        return l - h;
    }
    if (h > r) {
        return h - r;
    }
    return 0;
}


void solve() {
    ll m, n, k;
    cin >> m >> n >> k;
    vector<pair<ll, ll>> desks(k);
    for (int i = 0; i < k; i++) {
        cin >> desks[i].first >> desks[i].second;
    }
    vector<vector<ll>> h(m, vector<ll>(n * 2));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n * 2; j++) {
            cin >> h[i][j];
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        vector<pair<ll, ll>> will_put(m);
        ll res = inf;
        for (int j = 0; j < k; j++) {
            vector<pair<ll, ll>> now_put(m, {-1, -1});
            ll current = 0;
            for (int g = 0; g < m; g++) {
                for (int t = 0; t < n * 2; t++) {
                    if (h[g][t] == -1) {
                        continue;
                    }
                    if (now_put[g].first == -1 or
                        get_val(h[g][now_put[g].first], desks[j].first, desks[j].second) >= get_val(h[g][t], desks[j].first, desks[j].second)) {
                        now_put[g].second = now_put[g].first;
                        now_put[g].first = t;
                    } else if (now_put[g].second == -1 or
                            get_val(h[g][now_put[g].second], desks[j].first, desks[j].second) >= get_val(h[g][t], desks[j].first, desks[j].second))
                    {
                        now_put[g].second = t;
                    }
                }
                current += get_val(h[g][now_put[g].first], desks[j].first, desks[j].second);
                current += get_val(h[g][now_put[g].second], desks[j].first, desks[j].second);
            }
            if (res > current) {
                res = current;
                will_put = now_put;
            }
        }
        ans += res;
        for (int j = 0; j < m; j++) {
            h[j][will_put[j].first] = -1;
            h[j][will_put[j].second] = -1;
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}