#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define ll long long
#define ld long double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define pld pair<ld, ld>
#define mp make_pair
#define fs first
#define sc second

const int inf = 1e9;
const ll INF = 2e18;
const int maxn = 1001;
const ll M = 998244353;

pi a[maxn][maxn];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	cin >> n >> m >> k;

	for (int i = 0; i < k; i++)
	{
		int r, c, v;
		cin >> r >> c >> v;
		r--;
		c--;
		a[r][c] = { v, v };
	}
	
	for (int r = n-1; r > -1; r--)
	{
		for (int c = m-1; c > -1; c--)
		{
			if (a[r][c] != mp(0, 0))
				continue;
			a[r][c] = { min(a[r + 1][c].sc, a[r][c + 1].sc), max(a[r + 1][c].fs, a[r][c + 1].fs) };
		}
	}
	ll ans = 0;
	for (int r = 0; r < n; r++)
		for (int c = 0; c < m; c++)
			ans = (ans + a[r][c].fs + M*2) % M;

	

	cout << ans << '\n';
	/*for (int r = 0; r < n; r++)
	{
		for (int c = 0; c < m; c++)
			cout << a[r][c].fs << ' ';
		cout << '\n';
	}*/
}