#include <bits/stdc++.h>

#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

ostream& operator << (ostream& cout, vector<int> &a)
{
    for (int x : a)
        cout << x << ' ';
    cout << endl;
}

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x;
    cout << endl;
}

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    forn (i, n)
    {
        char c;
        cin >> c;
        a[i] = c - '0';
    }

    int cur = 0;
    vector<int> v;
    forn (i, n)
    {
        if (a[i] == 0)
            cur++;
        else
        {
            v.pb(cur);
            cur = 0;
        }
    }
    v.pb(cur);

    n = sz(v);
    int ans = 0, len = 0, numb = 0;

    vector<int> sum(n + 1, 0);
    forn (i, n)
        sum[i + 1] = sum[i] + v[i];

    for (int ln = 0; ln < 1e5; ln++)
    {
        int cnt = 0;
        cur = 0;
        int id = 0;
        while (id < n)
        {
            int l = id - 1, r = n - 1;
            while (l != r - 1)
            {
                int mid = (l + r) / 2;
                if (sum[mid + 1] - sum[id] >= ln)
                    r = mid;
                else
                    l = mid;
            }

            if (sum[r + 1] - sum[id] >= ln)
            {
                cnt++;
                id = r + 1;
            }
            else
                id = n;
        }
        //cout << ln << ' ' << cnt << endl;

        if (cnt != 1 && cnt != 0 && ans < ln * cnt + cnt - 1)
        {
            ans = ln * cnt + cnt - 1;
            len = ln;
            numb = cnt;
        }
    }

    cout << ans << endl;
    forn (i, numb - 1)
    {
        forn (j, len)
            cout << 0;
        cout << 1;
    }
    forn (j, len)
        cout << 0;
    return 0;
}
