#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

ostream& operator << (ostream& cout, pii &a)
{
    cout << a.ff << ' ' << a.ss << endl;
}

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x;
    cout << endl;
}

int dist(pii p, int h)
{
    if (p.ff <= h && h <= p.ss)
        return 0;
    if (h < p.ff)
        return p.ff - h;
    if (h > p.ss)
        return h - p.ss;
}

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    vector<pii> p(k);
    forn (i, k)
        cin >> p[i].ff >> p[i].ss;

    vector<vector<int> > a(m, vector<int>(2 * n));
    forn (i, m)
        forn (j, 2 * n)
            cin >> a[i][j];

    if (n == 1)
    {
        int ans = 1e9;
        forn (i, k)
        {
            int sum = 0;
            forn (j, m)
                forn (t, 2 * n)
                    sum += dist(p[i], a[j][t]);
            ans = min(sum, ans);
        }
        cout << ans;
        return 0;
    }

    return 0;
}
