#pragma optimize("SEX+ON+THE+BEACH")
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;

#define all(x) (x).begin(), (x).end()
#define ff first
#define ss second

#ifdef HOME
    #define debug(x) cout << #x << " : " << x << endl;
    #define debug_v(x) cout << #x << " : "; for (auto ii : x) cout << ii << " " ; cout << endl;
    #define PO cout << "POMELO" << endl;
    #define OL cout << "OLIVA" << endl;
#else
    #define debug(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

int pre = 0;

ll dis(int x, pair<int, int> y)
{
    if (x < y.ff)
        return y.ff - x;
    if (x > y.ss)
        return x - y.ss;
    return 0;
}

ll get(vector<int>& het, pair<int, int> x)
{
    ll ans = 0;
    for (int i : het)
        ans += dis(i, x);
    return ans;
}

ll bad(vector<int>& have, vector<pair<int, int>>& arr)
{
    vector<ll> s(arr.size());
    while (pre != arr.size() - 1 && get(have, arr[pre + 1]) < get(have, arr[pre]))
        ++pre;
    return get(have, arr[pre]);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;
    vector<vector<int>> temp(m, vector<int>(2 * n));
    vector<pair<int, int>> arr(k);
    for (int i = 0; i < k; ++i)
        cin >> arr[i].ff >> arr[i].ss;
    sort(all(arr));
    for (int i = 0; i < m; ++i)
    {
        for (int j = 0; j < 2 * n; ++j)
            cin >> temp[i][j];
        sort(all(temp[i]));
    }
    ll ans = 0;
    vector<int> have(m * 2);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            have[j * 2] = temp[j][i * 2];
            have[j * 2 + 1] = temp[j][i * 2 + 1];
        }
        ans += bad(have, arr);
    }
    cout << ans;
}

