#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int cnt(int a, pair<int, int> b)
{
    if (b.first <= a && a <= b.second) return 0;
    if (a > b.second) return a - b.second;
    return b.first - a;
}


int ss(vector<int> &s, int l, int r)
{
    if (r >= s.size() - 1) return 0;
    if (l < 0) return 0;
    if (l > r) return 0;
    return s[r + 1] - s[l];
}


int cnt(vector<int> &a, vector<int> &s, pair<int, int> b)
{
    int ans = 0;
    if (a.back() < b.first) return b.first * (int)a.size() - s.back();
    if (a[0] > b.second) return s.back() - b.second * a.size();
    if (a[0] < b.first)
    {
        int l = 0, r = a.size() - 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (a[m] < b.first) l = m;
            else r = m;
        }
        ans += b.first * (l + 1) - ss(s, 0, l);
    }
    if (a.back() > b.second)
    {
        int l = 0, r = a.size() - 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (a[m] > b.second) r = m;
            else l = m;
        }
        ans += ss(s, r, a.size() - 1) - (a.size() - r) * b.second;
    }
    return ans;
}


signed main()
{
    warp();
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<int, int> > bound(k);
    for (int i = 0; i < k; i++)
    {
        cin >> bound[i].first >> bound[i].second;
        bound[i].second *= -1;
    }
    sort(bound.begin(), bound.end());
    for (int i = 0; i < k; i++) bound[i].second *= -1;
    vector<vector<int> > h(m, vector<int> (2 * n));
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++) cin >> h[i][j];
        sort(h[i].begin(), h[i].end());
    }
    vector<pair<int, int> > temp;
    temp.push_back(bound[0]);
    for (int i = 1; i < bound.size(); i++)
    {
        if (bound[i].second <= bound[i - 1].second) continue;
        temp.push_back(bound[i]);
    }
    bound = temp;
    k = bound.size();
    int ans = 0;
    int cur = 0;
    for (int i = 0; i < 2 * n; i += 2)
    {
        vector<int> tmp;
        vector<int> s(1, 0);
        for (int j = 0; j < m; j++)
        {
            tmp.push_back(h[j][i]);
            tmp.push_back(h[j][i + 1]);
        }
        sort(tmp.begin(), tmp.end());
        for (int j = 0; j < tmp.size(); j++) s.push_back(s.back() + tmp[j]);
        vector<int> opt(k);
        int l = -1, r = tmp.size();
        while (r > 0 && tmp[r - 1] > bound[i].second) r--;
        for (int j = 0; j < bound.size(); j++)
        {
            while (l + 1 < tmp.size() && tmp[l + 1] < bound[j].first) l++;
            while (r + 1 < tmp.size() && tmp[r + 1] <= bound[j].second) r++;
            if (tmp[r] <= bound[j].second) r++;
            opt[j] = bound[j].first * (l + 1) - ss(s, 0, l) + ss(s, r, tmp.size() - 1) - (tmp.size() - r) * bound[j].second;
        }
        int best = opt[0];
        for (int i = 1; i < opt.size(); i++) best = min(best, opt[i]);
        ans += best;
    }
    cout << ans << endl;
    return 0;
}
