#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

std::vector<int> pref(const std::string &s) {
    std::vector<int> p(s.size());
    p[0] = 0;
    for (int i = 1; i < s.size(); ++i) {
        int k = p[i - 1];
        while (k > 0 && s[k] != s[i]) {
            k = p[k - 1];
        }
        if (s[k] == s[i]) {
            ++k;
        }
        p[i] = k;
    }
    return p;
}

int main() {
//    freopen("input", "r", stdin);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int m, n;
    std::string s, t;
    std::cin >> m >> n;
    std::cin >> s;
    for (int i = 0; i < n; ++i) {
        int tp;
        std::cin >> tp;
        if (tp == 1) {
            std::string s1;
            std::cin >> s1;
            t += s1;
        } else {
            int pos, len;
            std::cin >> pos >> len;
            --pos;
            for (int i = 0; i < len; ++i) {
                t.push_back(t[pos + i]);
            }
        }
    }
//    for (auto i : pref(s)) {
//        std::cout << i << ' ';
//    }
    t = s + '#' + t;
    auto p = pref(t);
    int k = 0;
    for (size_t i = s.size() + 1; i < t.size(); ++i) {
        if (p[i] == s.size()) {
            ++k;
        }
    }
    std::cout << k;
    return 0;
}