#include <bits/stdc++.h>
 
using namespace std;
 
#define ft first
#define sd second
#define pb push_back
#define sz(s) signed(s.size())
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
 
const int R = 998244353;
 
int f(int x, int y);
int g(int x, int y);
 
unordered_map< long long, int > fm, gm;
int n, m, k;
 
unordered_set<int> line;
 
int f(int x, int y) {
    if (y > m || x > n || !line.count(y)) return 0;
    long long hash = (((long long) x) << 32) + y;
    if (fm.count(hash)) return fm[hash];
    return fm[hash] = max(g(x + 1, y), g(x, y + 1));
}
 
int g(int x, int y) {
    if (x > n || y > m || !line.count(y)) return 0;
    long long hash = (((long long) x) << 32) + y;
    if (gm.count(hash)) return gm[hash];
    return gm[hash] = min(f(x + 1, y), f(x, y + 1));
}
 
void solve() {
    cin >> n >> m >> k;
    fm.max_load_factor(0.25);
    gm.max_load_factor(0.25);
    fm.reserve(k);
    gm.reserve(k);
    line.reserve(k * 7);
    line.max_load_factor(0.25);
    for (int i = 0; i < k; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        z %= R;
        long long hash = (((long long) x) << 32) + y;
        fm[hash] = z;
        gm[hash] = z;
        for (int k = - 10; k <= 10; ++k) {
            line.insert(y + k);
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j : line) {
            if (j >= 1 && j <= m) {
                ans += g(i, j);
                if (ans > R) ans -= R;   
            }
        }
    }
    cout << (ans + R) % R << endl;
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}