#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int get_ans(vector<int> &v, vector<int> &pref, vector<int> &go, int b, int &cnt, int v_sum) {
	int pos = 0;
	vector<int> a;

	while (pos < v.size()) {
		int cur = pref[pos];
		int ind = go[cur + b];
		a.push_back(pref[ind] - pref[pos]);
		if (ind == pos)
			ind++;
		pos = ind;
	}

	if (a.back() < b)
		a.pop_back();

	if (a.size() <= 1)
		return INF;

	cnt = a.size();

	return (v_sum - a.size() * b) + (int)v.size() - (int)a.size();
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	string s;
	cin >> s;
	n = s.size();

	int cur = 0;
	vector<int> v;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0')
			cur++;
		else {
			v.push_back(cur);
			cur = 0;
		}
	}
	v.push_back(cur);

	int v_sz = v.size();
	vector<int> pref(v_sz + 1, 0);
	for (int i = 0; i < v_sz; i++)
		pref[i + 1] = pref[i] + v[i];

	int pos = 0;
	vector<int> go(2 * n + 10, -1);
	for (int i = 0; i < go.size(); i++) {
		while (pos < v_sz && pref[pos] < i)
			pos++;
		go[i] = pos;
	}

	int ans = INF;
	int ans_sz = -1;

	int sz = 0;
	cur = INF;
	for (int b = 0; b <= n; b++) {
		cur = get_ans(v, pref, go, b, sz, pref.back());

		if (cur < ans) {
			ans = cur;
			ans_sz = b;
		}
	}

	string str;
	int count = (n - ans - ans_sz) / (ans_sz + 1);
	for (int i = 0; i < count; i++) {
		for (int j = 0; j < ans_sz; j++)
			str += '0';
		str += '1';
	}
	for (int j = 0; j < ans_sz; j++)
		str += '0';

	cout << str.size() << endl << str << endl;

	return 0;
}