#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int MAXN = 4e5 + 5;

int m, n, k, res;

pair<int, int> desk[MAXN];

int get(pair<int, int> d, pair<int, int> a) {
	int res = 0;
	if (a.first <= d.second && a.first >= d.first) {
		res += 0;
	}
	else if (a.first > d.second) {
		res += a.first - d.second;
	}
	else if (a.first < d.first) {
		res += d.first - a.first;
	}

	if (a.second <= d.second && a.second >= d.first) {
		res += 0;
	}
	if (a.second > d.second) {
		res += a.second - d.second;
	}
	else if (a.second < d.first) {
		res += d.first - a.second;
	}

	return res;
}

signed main() {
	cin >> m >> n >> k;
	for (int i = 0; i < k; ++i) {
		int l, r;
		cin >> l >> r;
		desk[i] = { l, r };
	}

	sort(desk, desk + k);

	vector<vector<int> > h;

	for (int q = 0; q < m; ++q) {
		vector<int> now;
		for (int i = 0; i < 2 * n; ++i) {
			int tmp;
			cin >> tmp;
			now.push_back(tmp);
		}
		sort(now.begin(), now.end());
		h.push_back(now);
	}
	for (int i = 0; i < n; ++i) {
		int best = 1e18;
		vector<int> now = h[i];

		int ql = 0, sl = 0, sr = 0, id = 0;
		for (int j = 0; j < now.size(); ++j) sr += now[j];

		for (int j = 0; j < k; ++j) {
			int x = desk[j].first;

			while (id < now.size() && now[id] < x) {
				++ql;
				sl += now[id];
				sr -= now[id];
				++id;
			}

			best = min(best, ql * x - sl + sr - (now.size() - ql) * x);
		}

		res += best;
	}
	cout << res << "\n";
	return 0;
}