//#include <bits/stdc++.h>
//using namespace std;
//
//#define vi vector<int>
//#define pb push_back
//#define ff first
//#define ss second
//#define pii pair<int, int>
//#define len(x) int((x).size())
//#define all(x) (x).begin(), (x).end()
//#define rall(x) (x).rbegin(), (x).rend()
//
//const int INF = 2.14e9+100;
//
//typedef long long ll;
//
//void init() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
////    freopen("input.txt", "r+", stdin);
////    freopen("output.txt", "w+", stdout);
//}
//
//int n;
//string s;
//
//void read() {
//    cin >> n;
//    cin >> s;
//}
//
//void solve() {
//    vi _0, _1;
//    for (int i = 0; i < len(s); ++i) {
//        if (s[i] == '0')
//            _0.pb(i);
//        else if (s[i] == '1')
//            _1.pb(i);
//    }
//
//    int ans_k, ans_l, mx = -INF;
//    for (int k = len(_0); k >= 0; --k) {
//        int cnt = 0;
//        int i;
//        if (k) i = _0[k - 1]; else i = 0;
//        while (1) {
//            i = lower_bound(all(_1), i) - _1.begin();
//            if (i >= len(_1)) break;
//
//            int q;
//            if (k != 0) {
//                q = lower_bound(all(_0), _1[i]) + (k-1) - _0.begin();
//                if (q >= len(_0)) break;
//
//                i = _0[q];
//            } else {
//                i = _1[i] + 1;
//            }
//
//            ++cnt;
//        }
//        //DEBUG START
////        cout << "k: " << k << " " << ans_l << " "  << ans_k << '\n';
//        //DEBUG END
//        //formula
//        if (cnt > 0 && mx < cnt*(k+1) + k) {
//            ans_l = cnt, ans_k = k;
//            mx = cnt*(k+1)+k; //formula
//        }
//    }
//
//    cout << mx << '\n';
//    for (int i = 0; i < (ans_k+1) * (ans_l+1) - 1; ++i) cout << (i % (ans_k + 1) == ans_k);
//}
//
//int main() {
//    init();
////    while (read()) {
////        solve();
////        cout.flush();
////    }
//    read();
//    solve();
//    cout.flush();
//}
///*
//10
//0100100000
//
//3
//111
//
//7
//0100101
//
//MY TESTS:
//9
//000001000
//*/



#include <bits/stdc++.h>
using namespace std;

#define vi vector<int>
#define pb push_back
#define ff first
#define ss second
#define pii pair<int, int>
#define len(x) int((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const int MOD = 998'244'353;
const int INF = 2.14e9+100;

struct cell { int x, y; };

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r+", stdin);
//    freopen("output.txt", "r+", stdout);
}

bool cmp(cell cell1, cell cell2) {
    return (cell1.x - cell1.y) < (cell2.x - cell2.y)  || ((cell1.x - cell1.y) == (cell2.x - cell2.y) && (cell1.x + cell1.y) < (cell2.x + cell2.y));
}

using CMP = integral_constant<decltype(&cmp), &cmp>;

int n, m, k;

int ans = 0;

int dx[3] = {+0, +1, +2};
int dy[3] = {-2, -1, 0};

set<cell, CMP> cells[2];
set<int> diags[2];
map<pii, int> cost;

void read() {
    cin >> n >> m >> k;
    m = max(n, m);
    for (int i = 0; i < k; ++i) {
        int x, y, v; cin >> x >> y >> v;
        //rotate
        --y, x = m - x;
        cost[{x, y}] = v;

        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                if (abs(dx[i] + dy[j]) <= 2) {
                    if ((x + dx[i]) >= 0 && (x + dx[i]) < m && (y + dy[j]) >= 0 && (y + dy[j]) < m) {
                        int odd_or_even = (x + dx[i] + y + dy[j]) % 2;
                        diags[odd_or_even].insert(x + dx[i] - y + dy[j]);
                        cells[odd_or_even].insert({x + dx[i], y + dy[j]});
                    }
                }
            }
        }
    }
}



void solve() {
        //DEBUG START
//    for (int i = 0; i <= 1; ++i) {
//        for (auto it = cells[i].begin(); it != cells[i].end(); ++it) {
//            cout << it->x << " " << it->y << endl;
//        }
//    }
//
//    for (int i = 0; i <= 1; ++i) {
//        for (auto it = diags[i].begin(); it != diags[i].end(); ++it) {
//            cout << *it << endl;
//        }
//    }
    //DEBUG END

    vector<pii> upd;
    unordered_map<int, int> dp;

    for (int odd_or_even = 0; odd_or_even <= 1; ++odd_or_even) {
        dp.clear();
        auto p = cells[odd_or_even].begin();
        auto q = diags[odd_or_even].begin();
        ll sum = 0, lst = -INF;

        //check diagonal
        while (q != diags[odd_or_even].end()) {
            int i = *q;
            int l = abs(i), r = 2 * m - l - 2;
            ans += (ll(i - lst)/2*(sum % MOD)) % MOD;
            if (i > 1) {
                if (dp.count(r + 2)) { sum -= dp[r + 2]; }
                if (dp.count(l - 2)) { sum -= dp[l - 2]; }

            }

            upd.clear();
            //пo клеткам
            while (p != cells[odd_or_even].end() && (p->x - p->y) == i) {
               int x, y;
                x = p->x, y = p->y;
                if (cost.find({x, y}) != cost.end()) {
                    upd.pb({x + y, cost[{x, y}]});
                } else {
                    int candidate1, candidate2;
                    if (cost.find({x - 1, y}) != cost.end()) candidate1 = cost[{x - 1, y}]; else candidate1 = max(dp.count(x + y) ? dp[x + y] : 0, dp.count(x + y - 2) ? dp[x + y - 2] : 0);
                    if (cost.find({x, y + 1}) != cost.end()) candidate2 = cost[{x, y + 1}]; else candidate2 = max(dp.count(x + y) ? dp[x + y] : 0, dp.count(x + y + 2) ? dp[x + y + 2] : 0);

                    upd.pb({x + y, min(candidate1, candidate2)});

                    //check border
                    if (x + y >= m - 1) {
                        diags[odd_or_even].insert(m - (x + y - (m - 1) - 2));
                    } else if (x + y < m - 2) {
                        diags[odd_or_even].insert(x + y + 2);
                    }
                }

                ++p;
            }

            for (pii p : upd) {
                if (l <= p.ff && p.ff <= r) sum -= dp[p.ff];
                dp[p.ff] = p.ss;
                if (l <= p.ff && p.ff <= r) sum += dp[p.ff];
            }

            lst = i;
            ++q;
        }

        if ((m & 1) == odd_or_even) {
            ans += (ll(m - lst) / 2 * (sum % MOD)) % MOD;
        } else {
            ans += (ll((m + 1) - lst) / 2*(sum % MOD)) % MOD;
        }

        //ans += ((ll)(((m & 1) == odd_or_even ? m : m + 1) - lst) / 2 * (sum % MOD)) % MOD;
    }

    if (ans < 0) cout << (ans + MOD) % MOD; else cout << ans;
}

int main() {
    init();
//    while (read()) {
//        solve();
//        cout.flush();
//    }
    read();
    solve();
    cout.flush();
}
/*
3 3 3
2 3 -2
3 1 3
1 2 1

2 4 3
1 2 2
2 4 -3
2 1 1
*/
