#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 5e5 + 228;
int g[MAXN];
vector<int> dp[MAXN];
int n;
int pref[MAXN];
vector<int> pos;

signed main() {
	fast_io();
	cin >> n;
	int b = 0;
	string g_s;
	cin >> g_s;
	for (int i = 0; i < n; i++) {
		g[i] = g_s[i] - '0';
		if (i != 0) {
			pref[i] = pref[i - 1];
		}
		if (!g[i]) {
			b++;
		}
		else {
			pref[i] = b;
			pos.pb(i);
		}
	}
	fill(dp, dp + b, vector<int>(n - b));
	int per = 0, flags = n - b;
	for (int i = 1; i < b; i++) {
		for (int j = 0; j < (n - b); j++) {
			dp[i][j] = pref[pos[j]] >= i;
			int l = -1, r = j;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (pref[pos[j]] - pref[pos[m]] >= i) {
					l = m;
				}
				else {
					r = m;
				}
			}
			if (l >= 0) {
				dp[i][j] = dp[i][l] + 1;
			}
		}
		int l = -1, r = n - b;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (b - pref[pos[m]] >= i) {
				l = m;
			}
			else {
				r = m;
			}
		}
		if (l != -1) {
			if ((i + 1) * (*max_element(dp[i].begin(), dp[i].begin() + l) + i > (per + 1) * flags + per) {
				per = i, flags = (*max_element(dp[i].begin(), dp[i].begin() + l);
			}
		}
	}
	cout << (per + 1) * flags + per << '\n';
	for (int i = 0; i < flags; i++) {
		for (int j = 0; j < per; j++) {
			cout << 0;
		}
		cout << 1;
	}
	for (int j = 0; j < per; j++) {
		cout << 0;
	}
	return 0;
}