#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 1e3 + 228;
const int MOD = 998244353;
int mn[MAXN][MAXN];
int mx[MAXN][MAXN];

signed main() {
	fast_io();
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int r, c, x;
		cin >> r >> c >> x;
		r--;
		c--;
		mn[r][c] = mx[r][c] = x;
	}
	int ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (mn[i][j] == 0) {
				mn[i][j] = min((j == m - 1 ? 0 : mx[i][j + 1]), (i == n - 1 ? 0 : mx[i + 1][j]));
				mx[i][j] = max((j == m - 1 ? 0 : mn[i][j + 1]), (i == n - 1 ? 0 : mn[i + 1][j]));
			}
			ans = (ans + mn[i][j] + 2 * MOD) % MOD;
		}
	}
	cout << ans;
	return 0;
}