#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll
const int INF = 1e9 + 10;
const ll BINF = 1e18 + 10;

vector<int> z_function(string s) {
  int n = SZ(s), l = 0, r = 1;
  vector<int> z(n);
  for (int i = 1; i < n; i++) {
    z[i] = min(z[i - l], max(r - i, 0ll));
    while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
      z[i]++;
    }
    if (i + z[i] > r) {
      l = i;
      r = i + z[i];
    }
  }
  return z;
}

int f(string &s, string &t) {
  vector<int> z = z_function(s + t);
  int ans = 0;
  for (int i = SZ(s); i < SZ(s) + SZ(t); i++) {
    if (z[i] >= SZ(s)) {
      ans++;
    }
  }
  return ans;
}

void source() {
  int m, n;
  cin >> m >> n;
  string s;
  cin >> s;
  bool one = true;
  for (int i = 1; i < m; i++) {
    if (s[i] != s[0]) {
      one = false;
    }
  }
  if (n == 1) {
    string t;
    cin >> t >> t;
    cout << f(s, t);
    exit(0);
  }
  string lst = "";
  int ans = 0;
  for (int i = 1; i <= n; i++) {
    int type;
    cin >> type;
    if (type == 1) {
      string add = "";
      cin >> add;
      string xx = lst;
      for (int j = 0; j < min(SZ(add), m - 1); j++) {
        xx.pb(add[j]);
      }
      ans += f(s, xx);
      ans += f(s, add);
      if (SZ(add) >= m - 1) {
        reverse(all(add));
        while (SZ(add) > m - 1) {
          add.pop_back();
        }
        reverse(all(add));
        lst = add;
      }
      else {
        reverse(all(lst));
        while (SZ(lst) + SZ(add) > m - 1) {
          lst.pop_back();
        }
        reverse(all(lst));
        lst += add;
      }
    }
    else {
      int pos, len;
      cin >> pos >> len;
      char c = lst.back();
      if (one && c == s[0] && len >= m) {
        ans += len - m + 1;
      }
      string add;
      for (int j = 0; j < min(len, m - 1); j++) {
        add.pb(c);
      }
      string xx = lst + add;
      ans += f(s, xx);
      if (SZ(add) >= m - 1) {
        reverse(all(add));
        while (SZ(add) > m - 1) {
          add.pop_back();
        }
        reverse(all(add));
        lst = add;
      }
      else {
        reverse(all(lst));
        while (SZ(lst) + SZ(add) > m - 1) {
          lst.pop_back();
        }
        reverse(all(lst));
        lst += add;
      }
    }
  }
  cout << ans;
}

signed main() {
#ifdef extraterrestrial_
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  source();
#ifdef extraterrestrial_
  cerr << "\n\nTIME :: " << clock() * 1.0 / CLOCKS_PER_SEC;
#endif
  return 0;
}
