#include <bits/stdc++.h>

#define pb push_back
#define ft first
#define sc second
#define int ll

using namespace std;
typedef long long ll;

const int maxn = 1e5 + 100;
ll mod = 998244353;
int inf = 1e9 + 100;

ll sgn(ll x) {
    if(x > 0)
        return 1;
    if(x < 0)
        return -1;
    return 0;
}

struct point {
    int x, y;
    bool operator < (point a) const {
        if(x < a.x)
            return 1;
        if(x > a.x)
            return 0;
        if(y < a.y)
            return 1;
        return 0;
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> diag(2 * maxn, 0);
    vector<bool> used(2 * maxn, 0);
    vector<pair<int, point>> have;
    ll sum = 0;
    for (int i = 0; i < k; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        sum += w;
        sum = sgn(sum) * (abs(sum) % mod);
        if((x == n - 1 && y == m - 1))
            continue;
        have.pb({w, {x, y}});
    }
    if(n == 1 || m == 1) {
        cout << (sum + mod) % mod << endl;
        return 0;
    }
    return -1;
    sort(have.begin(), have.end());
    int l = (-(m - 2) + maxn);
    int r = ((n - 2) + maxn);
    for (auto a : have) {
        int dr = a.sc.x - a.sc.y + maxn;
        int w = a.ft;
        for (int dx = -1; dx <= 1; dx++) {
            int rasm = dr + dx;
            if(rasm < l || rasm > r)
                continue;
            if(used[rasm])
                continue;
            used[rasm] = 1;
            diag[rasm] = w;
        }
    }
    ll cnt = 1;
    for (int i = 0; i < n - 1; i++) {
        int d = i - 0 + maxn;
        sum += cnt * (diag[d]);
        sum = sgn(sum) * (abs(sum) % mod);
        cnt = min((int)cnt + 1, min(n - 1, m - 1));
    }
    cnt = 1;
    for (int i = 0; i < m - 1; i++) {
        int d = 0 - i + maxn;
        if(i != 0) {
            sum += cnt * (diag[d]);
            sum = sgn(sum) * (abs(sum) % mod);
        }
        cnt = min((int)cnt + 1, min(n - 1, m - 1));
    }
    cout << sum << endl;
}
