#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

struct go
{
	int l, r;
};

const int inf = 1e18;

int m, n, k;
vector<go> a;

int get(go a, int h)
{
	if (a.l <= h && h <= a.r)
		return 0;
	if (h > a.r)
		return h - a.r;
	else
		return a.l - h;
}

int solve(vector<int> &h)
{
	int now = 0;
	for (int i = 0; i < 2 * n; i += 2)
	{
		int best = inf;
		for (go j : a)
		{
			int nw = get(j, h[i]) + get(j, h[i + 1]);
			best = min(best, nw);
		}
		now += best;
	}
	return now;
}

signed main()
{
	cin >> m >> n >> k;
	a.resize(k);
	for (int i = 0; i < k; i++)
	{
		cin >> a[i].l >> a[i].r;
	}

	int ans = 0;
	for (int i = 0; i < m; i++)
	{
		vector<int> h(2* n);
		for (int j = 0; j < 2 * n; j++)
			cin >> h[j];
		sort(h.begin(), h.end());
		//cout << solve(h);
		ans += solve(h);
	}
	cout << ans;
	return 0;
}