#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("data-sections")
#pragma GCC optimize("function-sections")
#pragma GCC optimize("section-anchors")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("unroll-loops")
*/

#define ALL(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

const int dv = 20;  // TODO log
vector<int> a1;
vector<vector<int>> a0;
int n;

int f(string const& s, int x) {
    int ans = 0;

    int i = 0;
    if (x) {
        while (i < n && s[i] == '1') i++;
    }

    while (i < n) {
        int now = x - 1;
        for (int j = dv - 1; j >= 0; j--) {
            if (now < (1 << j)) continue;
            now -= 1 << j;

            i = a0[i][j];
            if (i == n) break;
        }
        if (i == n) break;
        i = a1[i] + 1;

        if (ans || x == 0) ans++;
        ans += x;
    }

    return (ans == x ? 0 : ans);
}

void cout_ans(string const& s, int x) {
    int ans = 0;
    vector<char> anss;

    int now = x;
    int cnt = 0;
    for (int i = 0; i < s.size(); i++) {
        if (now && s[i] == '0') {
            now--;
            ans++;
            anss.push_back('0');
        } else if (now == 0 && s[i] == '1') {
            ans++;
            now = x;
            cnt++;
            anss.push_back('1');
        }
    }

    if (now) {
        for (int i = 0; i < (x - now) + 1; i++) anss.pop_back();
    }

    for (auto e : anss) cout << (char)e;
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n;
    string s;
    cin >> s;

    a1.resize(n);
    a0.assign(n, vector<int>(dv));

    int b1 = n, b0 = n;
    for (int i = n - 1; i >= 0; i--) {
        a0[i][0] = b0;

        if (s[i] == '1') b1 = i;
        else b0 = i;

        a1[i] = b1;
    }

    for (int i = n - 1; i >= 0; i--) {
        for (int j = 1; j < dv; j++) {
            if (a0[i][j - 1] == n) a0[i][j] = n;
            else {
                a0[i][j] = a0[a0[i][j - 1]][j - 1];
            }
        }
    }

    int ans = 0, k = 0;
    for (int i = 0; i < n; i++) {
        int ans_now = f(s, i);
        if (ans_now > ans) {
            ans = ans_now;
            k = i;
        }
    }

    cout << ans << endl;
    cout_ans(s, k);

    return 0;
}

/*
7
0100101
*/

/*

1 3 4
10 100
200 200
10 100
300 1000
5 10 20 15 200 90



*/

