#pragma GCC optimaze ("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
typedef long long ll;

const ll INF = 1e18;
const ll mod = 998244353;

ll get_z(string& s, ll m) {
	ll ans = 0;
	vector<ll> z(s.size());
	for (ll i = 1, l = 0, r = 1; i < s.size(); ++i) {
		if (i < r)
			z[i] = min(z[i - l], r - i);
		while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]])
			++z[i];
		if (z[i] == m)
			++ans;
		if (i + z[i] > r) {
			l = i, r = i + z[i];
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	ll n, m;
	cin >> m >> n;
	string s, h;
	cin >> s;
	s.push_back('#');
	for (int i = 0, pos, len; i < n; ++i) {
		ll type;
		cin >> type;
		if (type == 1) {
			cin >> h;
			s += h;
		}
		else {
			cin >> pos >> len;
			--pos;
			for (int j = pos + m + 1; j < pos + m  + 1 + len; ++j)
				s.push_back(s[j]);
		}
	}
	cout << get_z(s, m);
	return 0;
}


/*
3 4
aba
1 ab
2 1 3
2 3 3
2 1 8
*/