#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define forn(i, s, f) for (int i = s; i < f; ++i)
#define pii pair <int, int>
#define fs first
#define sc second
#define pb push_back
#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()

const int MOD = 1e9 + 7;
vector <int> p;

void init_p() {
    p.resize(1e6 + 5);
    p[0] = 1;
    forn (i, 1, sz(p))
        p[i] = (1LL * p[i - 1] * 29) % MOD;
}

vector <int> init_h(const string& s) {
    vector <int> h(sz(s) + 1);
    forn (i, 1, sz(h))
        h[i] = (1LL * h[i - 1] * 29 + s[i - 1] - 'a' + 1) % MOD;
    return h;
}

int get(const vector <int>& h, int l, int r) {
    return (1LL * h[r] - (1LL * h[l] * p[r - l]) % MOD + MOD) % MOD;
}

int main() {
	//ios_base::sync_with_stdio(0), cin.tie(0);
	int m, n;
	cin >> m >> n;
	string P;
	cin >> P;
	string t;
	forn (i, 0, n) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            string s;
            cin >> s;
            t += s;
        } else {
            int pos, len;
            cin >> pos >> len;
            pos--;
            forn (i, pos, pos + len)
                t += t[i];
        }
    }
    //cout << t << "\n";
    init_p();
    vector <int> ht = init_h(t), hp = init_h(P);
    int ans = 0;
    forn (i, 0, sz(t) - sz(P) + 1)
        ans += (get(ht, i, i + sz(P)) == get(hp, 0, sz(P)));
    cout << ans;
	return 0;
}
