#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()

const int INF = 2e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 5e5 + 7;
const int MOD = 998244353;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

int rnd(int a, int b) {
    uniform_int_distribution<> dis(a, b);
    return dis(myRand);
}

struct Trap {
    int x, y, cost;
};


signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<Trap> v(k);
    ll sum = 0;
    for (int i = 0; i < k; ++i) {
        cin >> v[i].x >> v[i].y >> v[i].cost;
        sum = (sum + v[i].cost + MOD) % MOD;
    }
    map<pii, int> ans, ans2, is;
    for (int i = 0; i < k; ++i) {
        int x = v[i].x, y = v[i].y, cost = v[i].cost;
        is[mp(x, y)] = cost;
        if (cost > 0)
            continue;
        /*while (x >= 1 && y >= 1) {
            ans[mp(x, y)] = min(ans[mp(x, y)], cost);
            x--, y--;
        }*/
        if (v[i].y > 1) {
            x = v[i].x,  y = v[i].y - 1;
            while (x >= 1 && y >= 1) {
                ans[mp(x, y)] = min(ans[mp(x, y)], cost);
                x--, y--;
            }
        }
        if (v[i].y <= m) {
            x = v[i].x - 1, y = v[i].y;
            while (x >= 1 && y >= 1) {
                ans[mp(x, y)] = min(ans[mp(x, y)], cost);
                x--, y--;
            }
        }
    }
    for (int i = 0; i < k; ++i) {
        int x = v[i].x, y = v[i].y, cost = v[i].cost;
        if (cost < 0)
            continue;
        /*while (x >= 1 && y >= 1) {
            ans2[mp(x, y)] = max(ans2[mp(x, y)], cost);
            x--, y--;
        }*/
        if (v[i].y > 1) {
            x = v[i].x,  y = v[i].y - 1;
            while (x >= 1 && y >= 1) {
                ans2[mp(x, y)] = max(ans2[mp(x, y)], cost);
                x--, y--;
            }
        }
        if (v[i].y <= m) {
            x = v[i].x - 1, y = v[i].y;
            while (x >= 1 && y >= 1) {
                ans2[mp(x, y)] = max(ans2[mp(x, y)], cost);
                x--, y--;
            }
        }
    }
    /*for (auto it = ans2.begin(); it != ans2.end(); ++it) {
        if (ans.find(it->f) == ans.end()) {
            sum = (sum + it->s) % MOD;
            cout << it->f.f << ' ' << it->f.s << ' ' << it->s << endl;
        }
    }*/
    map<pii, int> used;
    for (auto it = ans.begin(); it != ans.end(); ++it) {
        if (is.find(it->f) != is.end()) {
            used[it->f] = 1;
            continue;
        }
        int cost = it->s;
        bool b1 = (ans.find(mp(it->f.f + 1, it->f.s)) != ans.end()) ? (ans[mp(it->f.f + 1, it->f.s)] == cost) : 0;
        bool b2 = (ans.find(mp(it->f.f, it->f.s + 1)) != ans.end()) ? (ans[mp(it->f.f, it->f.s + 1)] == cost) : 0;
        int a1 = (ans2.find(mp(it->f.f + 1, it->f.s)) != ans2.end()) ? ans2[mp(it->f.f + 1, it->f.s)] : 0;
        int a1 = (ans2.find(mp(it->f.f, it->f.s + 1)) != ans2.end()) ? ans2[mp(it->f.f, it->f.s + 1)] : 0;
        cout << it->f.f << ' ' << it->f.s << ' ' << cost << ' ' << b1 << b2 << ' '<< a1 << ' ' << a2 << endl;
        if (b1 && b2) {
            if (a1 > 0 && a2 > 0) {
                sum = (sum + min(a1, a2)) % MOD;
            } else {
                sum = (sum + cost + MOD) % MOD;
            }
        } else if (b1) {
            if (a1 > 0)
                sum = (sum + a1) % MOD;
            else
                sum = (sum + cost + MOD) % MOD;
        } else if (b2) {
            if (a2 > 0)
                sum = (sum + a2) % MOD;
            else
                sum = (sum + cost + MOD) % MOD;
        } else sum = (sum + cost + MOD) % MOD;
        used[it->f] = 1;
        //sum = (sum + it->s + MOD) % MOD;
    }
    for (auto it = ans2.begin(); it != ans2.end(); ++it) {
        int x = it->f.f, y = it->f.s, cost = it->s;
    }
    cout << sum;
}
