#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*--------------------------------------------------------------------*/

void solve() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<pll> vec(k);
	for (auto &i : vec) cin >> i.X >> i.Y;
	sort(all(vec));
	vector<vector<ll>> v(m, vector<ll>(2 * n));
	for (auto &i : v) {
		for (auto &j : i) cin >> j;
		sort(all(i));
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		vector<ll> now, pr, suf;
		for (int q = 0; q < m; ++q) {
			now.emplace_back(v[q][i * 2]);
			now.emplace_back(v[q][i * 2 + 1]);
		}
		sort(all(now));
		pr = now;
		suf = now;
		for (int i = 1; i < now.size(); ++i) pr[i] += pr[i - 1], suf[now.size() - 1 - i] += suf[now.size() - i];
		ll now2 = 1e18;
		int qw = lower_bound(all(vec), mp(now[m], now[m])) - vec.begin();
		for (int j = max(0, qw - 5); j < min(k, qw + 5); ++j) {
			ll now1 = 0;
			auto p = lower_bound(all(now), vec[j].X) - now.begin();
			if (p != 0) now1 += p * vec[j].X - pr[p - 1];
			p = lower_bound(all(now), vec[j].Y) - now.begin();
			if (p != now.size()) now1 += suf[p] - (now.size() - p) * vec[j].Y;
			now2 = min(now2, now1);
		}
		ans += now2;
	}
	cout << ans;
}