#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN1 = 1 << 11;
const ll MOD = 998244353;

void solve();

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*--------------------------------------------------------------------*/

void add(int &a, int b) {
	a += b;
	while (a < 0) a += MOD;
	while (a >= MOD) a -= MOD;
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	map<int, int> m1;
	for (int i = 0; i < k; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		m1[a - b] = max(m1[a - b], min(a, b));
	}
	int ans = 0;
	for (auto &i : m1) {
		add(ans, i.Y);
	}
	cout << ans;
}