#include <bits/stdc++.h>

using namespace std;

long long INF = 2 * 1e18;
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    vector <pair<long long, long long>> d(k);
    for (auto &c : d) {
        cin >> c.first >> c.second;
    }
    sort(d.begin(),d.end());
    stack <pair<long long, long long>> st;
    for (int i = 0; i < k; i++) {
        if (st.empty()) {
            st.push(d[i]);
            continue;
        }
        if (st.top().second < d[i].second) {
            st.push(d[i]);
        }
    }
    d.clear();
    while (!st.empty()) {
        d.push_back(st.top());
        st.pop();
    }
    reverse(d.begin(), d.end());
    vector <vector<long long>> p(m, vector <long long> (2 * n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 2 * n; j++) {
            cin >> p[i][j];
        }
        sort(p[i].begin(), p[i].end());
    }
    long long ans = 0;
    int pointer = 0;
    k = d.size();
    for (int i = 0; i < 2 * n; i += 2) {
        long long best = INF;
        for (int t = pointer; t < k; t++) {
            long long l = d[t].first;
            long long r = d[t].second;
            long long now = 0;
            for (int j = 0; j < m; j++) {
                if (p[j][i] < l || p[j][i] > r) {
                    now += min(abs(l - p[j][i]), abs(r - p[j][i]));
                }
                if (p[j][i + 1] < l || p[j][i + 1] > r) {
                    now += min(abs(l - p[j][i + 1]), abs(r - p[j][i + 1]));
                }
            }
            if (best <= now) {
                break;
            }
            best = min(best, now);
            pointer = t;
        }
        ans += best;
    }
    cout << ans;
    return 0;
}
