#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>


using namespace std;


#define int long long


map<int, int> ans;


void upd(int x, int y) {
    ans[y - x] = max(ans[y - x], min(x, y) + 1);
}


const int INF = (int)2e9;
const int M = 998244353;


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


//#define cerr if (false) cerr


struct T {
    int x, y;

    T(int x, int y) : x(x), y(y) {};

    int v() const {
        return y - x;
    }

    int h() const {
        return x + y;
    }

    bool operator<(const T &t) const {
        int v1 = v();
        int v2 = t.v();

        if (v1 == v2) {
            return x > t.x;
        }

        return v1 < v2;
    }
};


signed main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<T> trs;

    int x, y, v;
    for (int i = 0; i < k; ++i) {
        cin >> x >> y >> v;

        --x;
        --y;

        trs.emplace_back(x, y);
    }

    sort(trs.begin(), trs.end());

    T cct(INF, 0);

    vector<T> ntrs;
    for (int i = 0; i < k; ++i) {
        if (trs[i].v() == cct.v()) {
            continue;
        }

        ntrs.push_back(trs[i]);

        cct = trs[i];
    }

    trs = ntrs;
    k = trs.size();

    for (int i = 0; i < k; ++i) {
        upd(trs[i].x, trs[i].y);

        for (int j = max(0LL, i - 5); j < min(k - 1, i + 5); ++j) {
            T ct = trs[j];

            int td = trs[i].v() - ct.v();

            if (td == 2) {
                if (trs[i].h() > ct.h()) {
                    upd(ct.x - 1, ct.y);
                } else {
                    upd(trs[i].x, trs[i].y - 1);
                }
            } else if (td == 3) {
                if (trs[i].h() > ct.h()) {
                    upd(ct.x - 1, ct.y);
                } else {
                    upd(trs[i].x, trs[i].y - 1);
                }
            } else if (td == 4) {
                if (trs[i].h() > ct.h()) {
                    upd(ct.x - 2, ct.y);
                } else {
                    upd(trs[i].x, trs[i].y - 2);
                }
            }
        }
    }

    int answ = 0;
    for (auto p : ans) {
        answ += p.second;
    }

    cout << mod(answ);

    return 0;
}


/*

3 3 3
2 3 -2
3 1 3
1 2 1

10 10 3
7 5 1
5 4 1
5 6 1

*/