#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

#define ll long long 
#define pii piar<int, int>

using namespace std;

const int NMAX = 1111;
const ll inf = 8e18;
const ll MOD = 998244353;

int u[NMAX][NMAX];
int trap[NMAX][NMAX];

int dp[NMAX][NMAX][2];

int main()
{
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i <= n + 1; i++)
		for (int j = 0; j <= m + 1; j++)
		{
			trap[i][j] = 1;
		}
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
		{
			trap[i][j] = 0;
		}
	for (int i = 1; i <= k; i++)
	{
		int r, c;
		cin >> r >> c;
		cin >> u[r][c];
		trap[r][c] = 1;
	}
	for (int i = n + 1; i >= 1; i--)
		for (int j = m + 1; j >= 1; j--)
		{
			if (trap[i][j])
			{
				dp[i][j][0] = u[i][j];
				dp[i][j][1] = u[i][j];
			}
			else
			{
				dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
				dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
			}
		}
	ll sum = 0;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
		{
			sum = (sum + dp[i][j][0] + 2 * MOD) % MOD;
		}
	cout << sum << endl;
	return 0;
}