#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll mod = 998244353;
const int INF = 1e9 + 7;
const int MAXN = 1050;
int cost[MAXN][MAXN];
int dp[MAXN][MAXN];
int n, m;

int g(int x, int y) {
	if (x >= n || y >= m) {
		return 0;
	}
	if (cost[x][y] != INF) {
		return cost[x][y];
	}
	if (dp[x][y] != INF) {
		return dp[x][y];
	}
	int a, b;
	if (x + 1 < n && cost[x + 1][y] != INF) {
		a = cost[x + 1][y];
	}
	else {
		a = max(g(x + 2, y), g(x + 1, y + 1));
	}
	if (y + 1 < m && cost[x][y + 1] != INF) {
		b = cost[x][y + 1];
	}
	else {
		b = max(g(x + 1, y + 1), g(x, y + 2));
	}
	dp[x][y] = min(a, b);
	return dp[x][y];
}

signed main() {
	FAST_IO();
	int k;
	cin >> n >> m >> k;
	fill(&cost[0][0], &cost[0][0] + MAXN * MAXN, INF);
	fill(&dp[0][0], &dp[0][0] + MAXN * MAXN, INF);
	for (int i = 0; i < k; ++i) {
		int r, c, w;
		cin >> r >> c >> w;
		r--;
		c--;
		cost[r][c] = w;
	}
	ll res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			res += g(i, j);
		}
	}
	res = (res + mod * mod) % mod;
	cout << res << '\n';
}