#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll INF = 1e18;

int main() {
	int m, n, k;
	cin >> m >> n >> k;

	vector<long long> left(k);
	vector<long long> right(k);

	for ( int i = 0; i < k; ++i )
		cin >> left[i] >> right[i];

	int puples = m*n*2;
	vector<ll> heights(puples);
	for ( int i = 0; i < puples; ++i )
		cin >> heights[i];

	sort(heights.begin(), heights.end());

	vector<ll> pref(puples+1, 0);
	for ( int i = 1; i <= puples; ++i )
		pref[i] = pref[i-1] + heights[i-1];

	ll best = INF;
	for ( int i = 0; i < k; ++i ) {
		int leftiers = lower_bound(heights.begin(), heights.end(), left[i]) - heights.begin() - 1;
		int rightiers = upper_bound(heights.begin(), heights.end(), right[i]) - heights.begin();

		ll badness = ((leftiers+1)*left[i]) - pref[leftiers+1];
		badness += pref.back() - pref[rightiers] - (puples - rightiers)*right[i];

		best = min(badness, best);
	}

	cout << best << endl;
	return 0;
}