#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <math.h>
#include <map>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e10;

ll get(ll h, ll l, ll r)
{
	if (h >= l && h <= r)
		return 0;
	return min(abs(h - l), abs(h - r));
}


vector<ll>  getans(vector<ll> used, vector<ll> a)
{
	vector<ll> cur;
	ll cnt1 = 0;
	for (int i = 0; i < a.size(); ++i)
	{
		if (a[i] == 0)
			cur.push_back(0);
		else if (used[i])
		{
			cur.push_back(1);
			cnt1 += 1;
		}
	}

	if (cnt1 == 0)
	{
		return {};
	}

	cur.push_back(1);

	ll minn = inf;
	ll cnt = 0;

	for (int i = 0; i < cur.size(); ++i)
	{
		if (cur[i] == 0)
			cnt += 1;

		if (cur[i] == 1)
		{
			minn = min(minn, cnt);
			cnt = 0;
		}
	}

	vector<ll> ans;
	for (int i = 0; i < cnt1; ++i)
	{
		for (int j = 0; j < minn; ++j)
			ans.push_back(0);
		ans.push_back(1);
	}
	for (int j = 0; j < minn; ++j)
		ans.push_back(0);

	return ans;
}


int main()
{
	
	ll n;
	cin >> n;

	string str;

	cin >> str;


		vector<ll> a(n);

		for (int i = 0; i < n; ++i)
			a[i] = str[i] - '0';//  cin >> a[i];

		ll cnt1 = 0;

		for (int i = 0; i < a.size(); ++i)
		{
			if (a[i] == 1)
				cnt1 += 1;
		}

		vector<ll> ans;
		for (ll msk = 0; msk < (1ll << cnt1); ++msk)
		{
			vector<ll> na;

			ll ind = 0;
			for (ll i = 0; i < n; ++i)
			{
				if (a[i] == 0)
					na.push_back(0);
				else if ((msk >> ind) & 1ll)
				{
					na.push_back(1);
					++ind;
				}
			}

			vector<ll> used(na.size(), 1);
			vector<ll> cur = getans(used, na);

			if (cur.size() > ans.size())
			{
				ans = cur;
			}

		}

		cout << ans.size() << endl;

		for (ll in : ans)
			cout << in;

		cout << endl;
	return 0;
}