#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;
typedef double db;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) ll(x.size())
const ll mod = 998244353;

struct Int {
    ll x = 0;
    Int (ll x = 0) : x(x) {};
    Int operator += (ll k) {
        ll p = x + k;
        while (p < 0)
            p += mod;
        return Int(x = p % mod);
    }
    Int operator + (ll k) {
        ll p = x + k;
        while (p < 0)
            p += mod;
        return Int(p % mod);
    }
};

const ll N = 4e6 + 5;
ll lst[5][N];
bool used[5][N];
ll res[5][N];
vector < pair < pair < ll, ll > , ll> > oh;
vector < pair < pair < ll, ll > , ll> > add;
ll n, k;

ll solve(ll st, ll m) {
    assert(m >= N);
    st = max(0, st - 6);
    m -= st - 1;
    for (ll i = 0; i < sz(add); i++) {
        ll x = add[i].F.S, y = add[i].F.F - st, v = add[i].S;
        used[x][y] = 1;
        lst[x][y] = v;
    }
    used[n - 1][m - 1] = 1;
    //Int ans = 0;
    for (ll j = m - 1; j >= 0; j--) {
        for (ll i = n - 1; i >= 0; i--) {
            if (used[i][j]) {
                if ((i + j) % 2 == 0)
                    res[i][j] = lst[i][j];
                continue;
            }
            if ((i + j) % 2 == 0) {
                lst[i][j] = min(lst[i + 1][j], lst[i][j + 1]);
                //ans += lst[i][j];
                res[i][j] = lst[i][j];
            } else
                lst[i][j] = max(lst[i + 1][j], lst[i][j + 1]);

        }
    }
    for (ll j = m - 1; j >= 0; j--) {
        for (ll i = n - 1; i >= 0; i--) {
            if (used[i][j]) {
                if ((i + j) % 2 == 1)
                    res[i][j] = lst[i][j];
                continue;
            }
            if ((i + j) % 2 == 0)
                lst[i][j] = max(lst[i + 1][j], lst[i][j + 1]);
            else {
                lst[i][j] = min(lst[i + 1][j], lst[i][j + 1]);
                //ans += lst[i][j];
                res[i][j] = lst[i][j];
            }

        }
    }
    Int ans = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            //cout << res[i][j] << ' ';
            ans += res[i][j];
            res[i][j] = 0, lst[i][j] = 0, used[i][j] = 0;
        }
        //cout << endl;
    }
    add.clear();
    //cout << ans.x << endl;
   return ans.x;
}


int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.in", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //cout << (Int(998244352) + ll(998244348)).x << endl;
    ll m;
    cin >> n >> m >> k;
    for (ll i = 0; i < k; i++) {
        ll x, y, v;
        cin >> x >> y >> v;
        x--, y--;
        //used[x][y] = 1;
        //lst[x][y] = v;
        oh.pb({{y, x}, v});
    }
    sort(all(oh));
    Int ans;
    ll st = -1;
    for (ll i = 0; i < k; i++) {
        add.pb(oh[i]);
        if (st == -1)
            st = oh[i].F.F;
        if (i + 1 == k || oh[i].F.F + 5 < oh[i + 1].F.F) {
            ans += solve(st, oh[i].F.F);
            //clr(st, oh[i].F.F);
        }
    }
    cout << ans.x;
    return 0;
}
