#include <bits/stdc++.h>

using namespace std;
#define MOD 998244353
#define und INT32_MAX
int add(int x, int y) {
    int res = x + y;
    res %= MOD;
    if (res < 0) {
        res += MOD;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> dpl(n + 1, vector<int>(m + 1, und));
    vector<vector<int>> dpg(n + 1, vector<int>(m + 1, und));
    for (int i = 0; i < k; ++i) {
        int r, c, v;
        cin >> r >> c >> v;
        dpl[r - 1][c - 1] = v;
        dpg[r - 1][c - 1] = v;
    }
    for (int l = 0; l < n; ++l) {
        dpl[l][m] = 0;
        dpg[l][m] = 0;
    }
    for (int l = 0; l < m; ++l) {
        dpl[n][l] = 0;
        dpg[n][l] = 0;
    }
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (dpl[i][j] == und) {
                dpl[i][j] = min(dpg[i + 1][j], dpg[i][j + 1]);
                dpg[i][j] = max(dpl[i + 1][j], dpl[i][j + 1]);
            }
            ans = add(ans, dpl[i][j]);
        }
    }
    cout << ans;
    return 0;
}