#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

int f(string& s, int k) {
	int res = 0;
	int cnt = 0;
	for (auto i : s) {
		if (i == '0') {
			++cnt;
		}
		if (i == '1') {
			if (cnt >= k) {
				cnt = 0;
				res += k + 1;
			}
		}
	}
	if (cnt < k) {
		res -= 1 + k;
	}
	if (res == 0) {
		return -1;
	}
	return res + k;
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	int n;
	cin >> n;
	string s;
	cin >> s;
	int res = f(s, 0);
	int x = 0;
	int left = 0;
	int right = n + 1;
	while (right - left > 100) {
		int mid = (left + right) / 2;
		if (f(s, mid) < f(s, mid + 1)) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	for (; left <= right; ++left) {
		int y = f(s, left);
		if (y > res) {
			x = left;
		}
	}
	int cnt = 0;
	int ans = 0;
	cout << res << endl;
	for (auto i : s) {
		if (i == '0') {
			++cnt;
		}
		if (i == '1') {
			if (cnt >= x) {
				cnt = 0;
				++ans;
			}
		}
	}
	if (cnt < x) {
		--ans;
	}
	for (int i = 0; i < ans; ++i) {
		for (int j = 0; j < x; ++j) {
			cout << "0";
		}
		cout << "1";
	}
	for (int i = 0; i < x; ++i) {
		cout << "0";
	}
	return 0;
}
