#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

vector <pair <int, int> > groups[N];
int l[N], r[N];
int m, n, k;

pair <ll, int> solve(int i, int _l, int _r)
{
    vector <int> gays;
    for (auto c : groups[i]) gays.push_back(c.first), gays.push_back(c.second);
    sort(gays.begin(), gays.end());
    vector <ll> pref_l(gays.size());
    vector <int> cnt_l(gays.size());
    vector <ll> suf_r(gays.size());
    vector <int> cnt_r(gays.size());
    for (int i = 0; i < (int) gays.size(); i++)
    {
        pref_l[i] += gays[i];
        cnt_l[i]++;
        if (i) pref_l[i] += pref_l[i - 1], cnt_l[i] += cnt_l[i - 1];
    }
    for (int i = (int) gays.size() - 1; i >= 0; i--)
    {
        suf_r[i] += gays[i];
        cnt_r[i]++;
        if (i != (int) gays.size() - 1) suf_r[i] += suf_r[i + 1], cnt_r[i] += cnt_r[i + 1];
    }
    ll cur = 1e18;
    int best = -1;
    for (int j = _l; j <= _r; j++)
    {
        int ind = upper_bound(gays.begin(), gays.end(), l[j]) - gays.begin() - 1;
        ll val = 0;
        if (ind >= 0) val += l[j] * (ll) cnt_l[ind] - pref_l[ind];
        ind = upper_bound(gays.begin(), gays.end(), r[j]) - gays.begin();
        if (ind < (int) gays.size()) val += suf_r[ind] - r[j] * (ll) cnt_r[ind];
        if (val < cur) best = j;
        cur = min(cur, val);
    }
    return make_pair(cur, best);
}

ll ans = 0;

void rec(int l, int r, int opt_l, int opt_r)
{
    if (l >= r) return;
    if (r - l == 1)
    {
        auto x = solve(l, opt_l, opt_r);
        ans += x.first;
    }
    else
    {
        int m = (l + r) / 2;
        auto x = solve(m, opt_l, opt_r);
        ans += x.first;
        rec(l, m, opt_l, x.second);
        rec(m + 1, r, x.second, opt_r);
    }
}

int main() {
  //  freopen("a.in", "r", stdin);
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++)
    {
        cin >> l[i] >> r[i];
    }
    for (int i = 0; i < m; i++)
    {
        vector <int> h(2 * n);
        for (int &x : h) cin >> x;
        sort(h.begin(), h.end());
        for (int i = 0; i < 2 * n; i += 2)
        {
            groups[i / 2].push_back({h[i], h[i + 1]});
        }
    }
    auto cost = [&] (int l, int r, int x)
    {
        if (l <= x && x <= r) return 0;
        if (x < l) return l - x;
        return x - r;
    };
    vector <pair <int, int> > segs;
    for (int i = 0; i < k; i++)
    {
        segs.push_back({l[i], r[i]});
    }
    sort(segs.begin(), segs.end());
    vector <pair <int, int> > e;
    for (int i = 0; i < (int) segs.size(); i++)
    {
        if (e.empty() || segs[i].second > e.back().second) e.push_back(segs[i]);
    }
    k = (int) segs.size();
    for (int i = 0; i < k; i++)
    {
        l[i] = segs[i].first, r[i] = segs[i].second;
    }
    rec(0, n, 0, k - 1);
    cout << ans << endl;
}