#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vint;
typedef string str;
#define pb push_back
#define int long long
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
#define fs first
#define sc second

const long long inf = 1000000000000000000;

const int base = 29;
const int mod = 1e9 + 7;

vector<pair<char, int>> compress(str s) {
    char cur = s[0]; int cnt = 0;
    vector<pair<char, int>> res;
    for (char i : s)
        if (i == cur)
            cnt++;
        else {
            res.pb({cur, cnt});
            cnt = 1;
            cur = i;
        }
    res.pb({cur, cnt});
    return res;
}
void run() {
    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;
    auto t = compress(p);

    vector<pair<char, int>> s;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            string w;
            cin >> w;
            for (auto j : compress(w)) {
                if (!s.empty() && s.back().fs == j.fs)
                    s.back().sc += j.sc;
                else
                    s.pb(j);
            }
        } else {
            int pos, len;
            cin >> pos >> len;
            pos--;

            s.back().sc += len;
        }
    }

    m = sz(t);
    int ans = 0;
    if (sz(t) == 1) {
        for (int i = 0; i < sz(s); i++)
            if (t[0].fs == s[i].fs && s[i].sc >= t[0].sc)
                ans += s[i].sc - t[0].sc + 1;
    } else {
        for (int i = 0; i < sz(s); i++) {
            bool fit = 1;
            for (int j = 0; j < sz(t); j++) {
                fit &= t[j].fs == s[i + j].fs;
                if (j == 0 || j == sz(t) - 1)
                    fit &= t[j].sc <= s[i + j].sc;
                else
                    fit &= t[j].sc == s[i + j].sc;
            }

            ans += fit;
        }
    }
    cout << ans;
}

signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
