#include <bits/stdc++.h>
#define sz(_a) (int)(a.size())
#define pb push_back

using namespace std;

const int K = 10000;
//const int K = 2;

typedef long long ll;
typedef pair<int, int> par;

struct T
{
    int len, l, r;
    T(){};
    T(int len, int l = -1, int r = -1): len(len), l(l), r(r) {};
};

int n;
string s;
vector <T> a;
set <par> st;

int f(int x)
{
    int cnt = 0, bal = 0;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
            bal++;
        else
        {
            if (bal >= x)
            {
                bal = 0;
                cnt++;
            }
        }
    }
    if (bal < x)
        cnt--;
    if (cnt == 0)
        return -1;
    return (cnt + 1) * (x + 1) - 1;
}

/*void rr(int id)
{
    int rt = a[id].r;
    a[id].len += a[rt].len;
    a[id].r = a[rt].r;
    a[a[id].r].l = id;
    st.erase(make_pair(a[rt].len, rt));
    st.insert(make_pair(a[id].len, id));
}*/

void rl(int id)
{
    int lt = a[id].l;
    st.erase(make_pair(a[lt].len, lt));
    st.erase(make_pair(a[id].len, id));
    a[id].len += a[lt].len;
    a[id].l = a[lt].l;
    if (a[id].l != -1)
        a[a[id].l].r = id;
    st.insert(make_pair(a[id].len, id));
}

par solve(int n, string &s)
{
    a.clear();
    st.clear();
    int bal = 0;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
            bal++;
        else
        {
            a.pb(T(bal));
            bal = 0;
        }
    }
    a.pb(T(bal));
    int k = sz(a);
    for (int i = 1; i < k; i++)
        a[i].l = i - 1, a[i - 1].r = i;

    for (int i = 0; i < k; i++)
        st.insert({a[i].len, i});

    int rez = 0, ans = 0;
    while (k > 1)
    {
        auto z = *st.begin();
        int l = z.first, id = z.second;
        if ((l + 1) * (k) - 1 > ans)
            ans = (l + 1) * (k) - 1, rez = l;
        //cout << l << ' ' << k << ' ' << ans << ' ' <<  rez << '\n';
        k--;
        if (a[id].r == -1)
        {
            rl(id);
        }
        else if (a[id].l == -1)
        {
            rl(a[id].r);
        }
        else
        {
            int z1 = a[a[id].l].len;
            int z2 = a[a[id].r].len;
            if (rand() % 2)
                rl(id);
            else
                rl(a[id].r);
        }
    }
    return make_pair(ans, rez);
}


int f(int x, string &s, int n)
{
    int cnt = 0, bal = 0;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
            bal++;
        else
        {
            if (bal >= x)
            {
                bal = 0;
                cnt++;
            }
        }
    }
    if (bal < x)
        cnt--;
    if (cnt == 0)
        return -1;
    return (cnt + 1) * (x + 1) - 1;
}

par solve2(int n, string &s)
{
    int rez = 0, ans = 0;
    for (int i = 0; i < n; i++)
    {
        int y = f(i, s, n);
        if (y < 0)
            break;
        if (y > ans)
            ans = y, rez = i;
    }
    return make_pair(ans, rez);
}

int main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    srand(time(0));
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS

    cin >> n;
    cin >> s;
    par z;
    if (n <= 1000)
        z = solve2(n, s);
    else
        z = solve(n, s);
    /*int n = 12;
    for (int i = 1; i < n; i++)
    {
        for (int j = 1; j < (1 << i); j++)
        {
            string z = "";
            for (int l = i - 1; l >= 0; l--)
                z.pb(char(int((j & (1 << l)) != 0) + '0'));
            //cerr << z << endl;
            if (z == "01")
                int yyy = 0;
            par z1 = solve(i, z);
            par z2 = solve2(i, z);
            if (z1.first != z2.first)
            {
                cout << z1.first << ' ' << z2.first << '\n';
                cout << i << ' ' << z;
                return 0;
            }
        }
        cout << i << endl;
    }*/

    int ans = z.first, rez = z.second;
    cout << ans << '\n';
    for (int i = 0; i < ans; i++)
    {
        if (i % (rez + 1) == rez)
            cout << 1;
        else
            cout << 0;
    }

    return 0;
}
