#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<int, int>> par(k);
    for (int i = 0; i < k; ++i) cin >> par[i].first >> par[i].second;
    vector<vector<pair<int, int>>> solve(n);
    for (int _ = 0; _ < m; ++_) {
        vector<int> now(n * 2);
        for (int i = 0; i < n * 2; ++i) cin >> now[i];
        sort(now.begin(), now.end());
        for (int i = 0; i < n * 2; i += 2) {
            solve[i / 2].push_back({now[i], now[i + 1]});
        }
    }
    long long ans = 0;
    for (int i = 0; i < n; ++i) {
        long long res = (int)1e18;
        for (int j = 0; j < k; ++j) {
            long long r1 = 0;
            for (int t = 0; t < solve[i].size(); ++t) {
                auto tt = solve[i][t];
                if (par[j].first <= tt.first && tt.first <= par[j].second) ;
                else r1 += min(abs(tt.first - par[j].second), abs(tt.first - par[j].first));

                if (par[j].first <= tt.second && tt.second <= par[j].second) ;
                else r1 += min(abs(tt.second - par[j].second), abs(tt.second - par[j].first));
            }
            res = min(res, r1);
        }
        ans += res;
    }
    cout << ans << endl;
    return 0;
}