#include <bits/stdc++.h>

#define sz(x) int((x).size())
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int m, n;
    cin >> m >> n;
    vector<int> a(m);
    vector<vector<int>> pos(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
        pos[a[i]].push_back(i);
    }
    vector<vector<int>> res;
    for (int i = 0; i < m; ++i) {
        if (pos[a[i]][0] < i) {
            continue;
        }
        res.push_back({a[i] + 1, pos[a[i]][0] + 1, pos[a[i]].back() + 1});
    }
    reverse(all(res));
    set<pair<int, int>> st;
    for (int i = 0; i < m; ++i) {
        st.insert(mp(i, a[i]));
    }
    for (auto p : res) {
        int c = p[0] - 1;
        int l = p[1] - 1;
        int r = p[2] - 1;
        auto it = st.lower_bound(mp(l, -1));
        vector<pair<int, int>> er;
        while (it != st.end() && it->first <= r) {
            if (it->second != c) {
                cout << "-1\n";
                return 0;
            }
            er.push_back(*it);
            ++it;
        }
        for (auto p : er) {
            st.erase(p);
        }
    }
    reverse(all(res));
    cout << sz(res) << "\n";
    for (auto p : res) {
        for (auto x : p) {
            cout << x << " ";
        }
        cout << "\n";
    }
    return 0;
}
