#include <bits/stdc++.h>

#define sz(x) int((x).size())
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int maxlog = 60;
const int inf = int(1e18);

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, x;
        cin >> u >> v >> x;
        --u; --v;
        g[u].push_back(x);
    }
    int d[maxlog][2] = {};
    for (int i = 0; i < maxlog; ++i) {
        d[i][0] = 0;
        d[i][1] = inf;
    }
    vector<int> res(q, 0);
    vector<pair<int, int>> qr(n);
    for (int i = 0; i < q; ++i) {
        int v, x;
        cin >> v >> x;
        --v;
        qr[v].push_back(mp(i, x));
    }
    int sum = 0;
    for (int i = 0; i + 1 < n; ++i) {
        if (g[i][0] > g[i][1]) {
            swap(g[i][0], g[i][1]);
        }
        sum += g[i][0];
        int x = g[i][1] - g[i][0];
        for (int j = 0; j < maxlog; ++j) {
            if (x <= (1LL << j)) {
                uax(d[j][0], x);
            }
            if (x > (1LL << j)) {
                uin(d[j][1], x);
            }
            if (j > 0) {
                for (int k = 0; k < 2; ++k) {
                    if (x + d[j - 1][k] <= (1LL << j)) {
                        uax(d[j][0], x + d[j - 1][k]);
                    }
                    if (x + d[j - 1][k] > (1LL << j)) {
                        uin(d[j][1], x + d[j - 1][k]);
                    }
                }
            }
        }
        for (auto p : qr[i + 1]) {
            int pos = p.first;
            x = p.second;
            for (int j = 0; j < maxlog; ++j) {
                if (sum + dp[j][0] >= x && sum + dp[j][0] <= 2 * x) {
                    res[pos] = 1;
                    break;
                }
                if (sum + dp[j][1] >= x && sum + dp[j][1] <= 2 * x) {
                    res[pos] = 1;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << res[i];
    }
    cout << "\n";
}

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    return 0;
}
