#include <bits/stdc++.h>
using namespace std;

#define int  long long

void dfs(int v, vector<int> &used, vector<vector<pair<int, int>>> &g, int dist)
{
    if(used[v] != 0)
        return;
    used[v] = dist;
    for(auto [to, cost] : g[v])
    {
        dfs(to, used, g, cost + dist);
    }
}

void solve()
{
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    vector<pair<pair<int, int>, int>> v;
    for(int i = 0; i < m; ++i){
        int a, b, c;
        cin >> a >> b >> c;
        v.push_back({{a, b}, c});
    }
    while(q--)
    {
        int to, r;
        cin >> to >> r;
        bool st = true;
        for(int i = 0; i < (1 << m); ++i) {
            vector<int> used(n + 1);
            vector<vector<pair<int, int>>> g(n + 1);
            for(int j = 0; j < m; ++j)
            {
                if((i >> j) & 1)
                {
                    int a = v[j].first.first;
                    int b = v[j].first.second;
                    int c = v[j].second;
                    g[a].push_back({b, c});
                    g[b].push_back({a, c});
                }

            }
            dfs(1, used, g, 1);
            if(used[to] == 0) continue;
            --used[to];
            if (r <= used[to] && used[to] <= (int)((double)r / (p - 1) * p)) {
                cout << 1;
                st = false;
                break;
            }
        }

        if(st)
            cout << 0;
    }
    cout <<
    '\n';

}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while(t--)
        solve();
}