#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll
#define pb push_back
#define len(x) (int)(x).size()
typedef pair<int, int> pii;
#define F first
#define S second
#define all(x) (x).begin(), (x).end()

int n, m, q;
vector<int> v1, v2;
const int INF = 1e9;

int solve(int x0, int y0, int x1, int y1, int k, int I) {
	int mn_dist = abs(x0 - x1) + abs(y0 - y1);
	int mx1 = 0;
	for (int i = min(x0, x1); i <= max(x0, x1); ++i) {
		mx1 = max(mx1, I - v1[i]);
	}
	if (mx1 <= k)
		return mn_dist;
	int mx2 = 0;
	for (int i = min(y0, y1); i <= max(y0, y1); ++i) {
		mx2 = max(mx2, I - v2[i]);
	}
	if (mx2 <= k)
		return mn_dist;
	bool b11 = (I - v1[x0] <= k);
	bool b12 = (I - v2[y0] <= k);
	bool b21 = (I - v1[x1] <= k);
	bool b22 = (I - v2[y1] <= k);
	if (!(b11 || b12))
		return -1;
	if (!(b21 || b22))
		return -1;
	if ((b11 && b22) || (b12 && b21)) {
		return mn_dist;
	}
	if (x0 == x1 && b11 && b21) {
		return mn_dist;
	}
	if (y0 == y1 && b12 && b22) {
		return mn_dist;
	}
	if (b11) {
		int l = y0;
		int r = y1;
		if (l > r)
			swap(l, r);
		int ans = INF;
		for (int i = 0; i < m; ++i) {
			if (v2[i]) {
				ans = min(ans, abs(l - i) + abs(r - i) + abs(x0 - x1));
			}
		}
		// cout << "+\n";
		return ans;
	} else {
		int l = x0;
		int r = x1;
		if (l > r)
			swap(l, r);
		int ans = INF;
		for (int i = 0; i < n; ++i) {
			if (v1[i]) {
				ans = min(ans, abs(l - i) + abs(r - i) + abs(y0 - y1));
			}
		}
		return ans;
	}
}

void run() {
	cin >> n >> m >> q;
	v1.resize(n);
	v2.resize(m);
	for (int i = 1; i <= q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			--x;
			v1[x] = i;
		}
		if (type == 2) {
			int x;
			cin >> x;
			--x;
			v2[x] = i;
		}
		if (type == 3) {
			int x0, y0, x1, y1, k;
			cin >> x0 >> y0 >> x1 >> y1 >> k;
			--x0, --y0, --x1, --y1;
			cout << solve(x0, y0, x1, y1, k, i) << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}