#include <iostream>

bool AskYesNo(int x);
bool GetCorrectDone(void);

int main(void) {
    int n = 0;
    std::cin >> n;
    do {
        bool fault = 0;
        int l = 0, r = n + 1;
        while (l < r - 1) {
            int med = (l + r) / 2;
            if (fault) {
                bool ans = AskYesNo(med);
                if (ans)
                    l = med;
                else
                    r = med;
            }
            else {
                bool ans1 = AskYesNo(med);
                bool ans2 = AskYesNo(med);
                if (ans1 == ans2) {
                    if (ans1)
                        l = med;
                    else
                        r = med;
                }
                else {
                    fault = 1;
                    bool ans3 = AskYesNo(med);
                    if (ans3)
                        l = med;
                    else
                        r = med;
                }
            }
        }
        std::cout << "! " << l << std::endl;
    } while (GetCorrectDone());
    return 0;
}

bool AskYesNo(int x) {
    std::cout << "? " << x << std::endl;
    std::string str = "";
    std::cin >> str;
    return (str == "Yes");
}

bool GetCorrectDone(void) {
    std::string str = "";
    std::cin >> str;
    return (str == "Correct");
}
