﻿#include <algorithm>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

#define x first
#define y second
#define int long long

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")

int n, m, q, p, r;
vector<vector<pair<int, int>>> a(500000);
bool flag;

void dfs(int l, int r, int v)
{
	if (flag) return;
	if (v == 0)
	{
		if (l <= 0 && r >= 0) flag = true;
		else flag = false;
		return;
	}
	for (auto i : a[v])
	{
		dfs(l - i.y, r - i.y, i.x);
		if (flag) return;
	}
}

void solve()
{
	int v, u, d;
	cin >> n >> m >> q >> p;
	for (int i = 0; i < n; i++) a[i].clear();
	for (int i = 0; i < m; i++)
	{
		cin >> v >> u >> d;
		v--;
		u--;
		a[u].push_back({ v, d });
	}
	string ans = "";
	for (int i = 0; i < q; i++)
	{
		cin >> v >> r;
		v--;
		flag = false;
		dfs(r, p * r / (p - 1), v);
		if (flag) ans += "1";
		else ans += "0";
	}
	cout << ans << '\n';
}

int32_t main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) solve();
	system("pause");
	return 0;
}