#include<iostream>
#include<vector>
#include<algorithm>
#include <stack>
#include<set>
#include<map>

using namespace std;

vector<pair<int, int>> t1, t2;

void up1(int v, int l, int r, int l1,int n) {
	if (r - l == 1 && l1 == l) {
		t1[v].first = n;
		t1[v].second = n;
		return;
	}
	if (r <= l1 || l > l1) {
		return;
	}
	up1(v * 2 + 1, l, (l + r) / 2, l1, n);
	up1(v * 2 + 2, (l + r) / 2, r, l1, n);
	t1[v].first = min(t1[v * 2 + 1].first, t1[v * 2 + 2].first);
	t1[v].second = max(t1[v * 2 + 1].second, t1[v * 2 + 2].second);
}

void up2(int v, int l, int r, int l1, int n) {
	if (r - l == 1 && l1 == l) {
		t2[v].first = n;
		t2[v].second = n;
		return;
	}
	if (r <= l1 || l > l1) {
		return;
	}
	up2(v * 2 + 1, l, (l + r) / 2, l1, n);
	up2(v * 2 + 2, (l + r) / 2, r, l1, n);
	t2[v].first = min(t2[v * 2 + 1].first, t2[v * 2 + 2].first);
	t2[v].second = max(t2[v * 2 + 1].second, t2[v * 2 + 2].second);
}

int gx1(int v, int l, int r, int ql, int qr) {
	if (l>=ql && r<=qr) {
		return t1[v].second;
	}
	if (qr<=l || ql>=r) {
		return -1e8;
	}
	return max(gx1(v * 2 + 1, l, (l + r) / 2, ql, qr), gx1(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gx2(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t2[v].second;
	}
	if (qr <= l || ql >= r) {
		return -1e8;
	}
	return max(gx2(v * 2 + 1, l, (l + r) / 2, ql, qr), gx2(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gn1(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t1[v].first;
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	return max(gn1(v * 2 + 1, l, (l + r) / 2, ql, qr), gn1(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gn2(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t2[v].first;
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	return max(gx1(v * 2 + 1, l, (l + r) / 2, ql, qr), gx1(v * 2 + 2, (l + r) / 2, r, ql, qr));
}


int main() {
	long long n, m, q;
	cin >> n >> m >> q;
	set<int> s1, s2;
	map<int, int> mp1, mp2;
	vector<vector<int>> qe(q);
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			s1.insert(r);
			qe[i] = { t,r };
		}
		if (t == 2) {
			int c;
			cin >> c;
			s2.insert(c);
			qe[i] = { t,c };
		}
		if (t == 3) {
			int r1,c1,r2,c2,k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			s1.insert(r1);
			s1.insert(r2);
			s2.insert(c1);
			s2.insert(c2);
			qe[i] = { t, r1,c1,r2,c2, k };
		}
	}
	int ll = 0;
	for (auto i : s1) {
		mp1[i] = ll;
		ll++;
	}
	ll = 0;
	for (auto i : s2) {
		mp2[i] = ll;
		ll++;
	}
	t1.resize(s1.size() * 4, { 0,0 });
	t2.resize(s2.size() * 4, { 0,0 });
	int t = 0;
	for (int i = 0; i < q; i++) {
		t++;
		if (qe[i][0] == 1) {
			up1(0, 0, s1.size(), mp1[qe[i][1]], -t);
		}
		if (qe[i][0] == 2) {
			up2(0, 0, s2.size(), mp2[qe[i][1]], -t);
		}
		if (qe[i][0] == 3) {
			int r1, c1, r2, c2, k;
			r1 = qe[i][1];
			c1 = qe[i][2];
			r2 = qe[i][3];
			c2 = qe[i][4];
			k = qe[i][5];
			if (t + gx1(0, 0, s1.size(), mp1[r1], mp1[r1] + 1) <= k && t + gx2(0, 0, s2.size(), mp2[c2], mp2[c2] + 1) <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
			}
			else {
				if (t + gx1(0, 0, s1.size(), mp1[r2], mp1[r2] + 1) <= k && t + gx2(0, 0, s2.size(), mp2[c1], mp2[c1] + 1) <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
				}
				else {
					if (t + gx1(0, 0, s1.size(), min(mp1[r2], mp1[r1]), max(mp1[r2], mp1[r1]) + 1) <= k) {
						cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
					}
					else {
						if (t + gx2(0, 0, s2.size(), min(mp2[c2], mp2[c1]), max(mp2[c2], mp2[c1]) + 1) <= k) {
							cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
						}
						else {
							if ((t + gx1(0, 0, s1.size(), mp1[r2], mp1[r2] + 1) > k && t + gx2(0, 0, s2.size(), mp2[c2], mp2[c2] + 1) > k) || (t + gx1(0, 0, s1.size(), mp1[r1], mp1[r1] + 1) > k && t + gx2(0, 0, s2.size(), mp2[c1], mp2[c1] + 1) > k)) {
								cout << -1 << "\n";
							}
							else {
								int ans = 1e8;
								if (t + gx1(0, 0, s1.size(), mp1[r2], mp1[r2] + 1) <= k) {
									for (auto j : mp2) {
										if (t + gx2(0, 0, s2.size(), j.second, j.second + 1) <= k) {
											ans = min(ans, abs(j.first - c1) + abs(j.first - c2) + abs(r1 - r2));
										}
									}
								}
								else {
									for (auto j : mp1) {
										if (t + gx1(0, 0, s1.size(), j.second, j.second + 1) <= k) {
											ans = min(ans, abs(j.first - r1) + abs(j.first - r2) + abs(c1 - c2));
										}
									}
								}
								cout << ans << "\n";
							}
						}
					}
				}
			}
		}
	}
	//system("pause");
}