#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 300 * 1000 + 228;

int a[N], b[N], fir[N], last[N];

bool cmp(int i, int j) {
	return fir[i] < fir[j];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		if (!fir[a[i]]) fir[a[i]] = i;
		last[a[i]] = i;
	}
	vector<int> v;
	for (int c = 1; c <= m; ++c) {
		if (fir[c]) {
			v.push_back(c);
		}
	}
	sort(v.begin(), v.end(), cmp);
	for (int c : v) {
		for (int i = fir[c]; i <= last[c]; ++i) {
			b[i] = c;
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (a[i] != b[i]) {
			cout << -1 << endl;
			return 0;
		}
	}
	cout << (int)v.size() << endl;
	for (int c : v) {
		cout << c << " " << fir[c] << " " << last[c] << endl;
	}
	return 0;
}