#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve2(int n, int m, int q, int p) {
    vector <pair <pair <int, int>, int> > g(m);
    for (int i = 0; i < m; ++i) cin >> g[i].first.first >> g[i].first.second >> g[i].second;
    sort(g.begin(), g.end());
    while (q) {
        --q;
        int v, x;
        cin >> v >> x;
        bool check1 = 0;
        for (int i = 0; i < (1 << m); ++i) {
            bool check = 1;
            int last = 1;
            int sum = 0;
            for (int j = 0; j < m; ++j) {
                if (i & (1 << j)) {
                    if (last != g[j].first.first) {
                        check = 0;
                        break;
                    }
                    sum += g[j].second;
                    last = g[j].first.second;
                }
            }
            if (check) {
                if (last == v && sum >= x && sum <= x * p / (p - 1)) {
                    check1 = 1;
                    break;
                }
            }
        }
        if (check1) cout << 1;
        else cout << 0;
    }
    cout << '\n';
}

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    if (n <= 10 && m <= 10 && q <= 10) {
        solve2(n, m, q, p);
        return;
    }
    vector <vector <pair <int, int> > > g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        if (v < u) swap(u, v);
        --v;
        --u;
        g[u].push_back({v, w});
    }
    vector <pair <int, int> > quest(q);
    int maxr = 0;
    for (int i = 0; i < q; ++i) {
        cin >> quest[i].first >> quest[i].second;
        --quest[i].first;
        maxr = max(maxr, quest[i].second);
    }
    //cout << 1;
    vector <vector <bool> > dp(n, vector <bool> (maxr * p / (p - 1) + 1));
    dp[0][0] = 1;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < dp[i].size(); ++j) {
            if (dp[i][j]) {
                for (auto el : g[i]) {
                    if (j + el.second < dp[i].size()) dp[el.first][j + el.second] = 1;
                }
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        bool check = 0;
        for (int j = quest[i].second; j <= quest[i].second * p / (p - 1); ++j) {
            if (dp[quest[i].first][j]) {
                check = 1;
                break;
            }
        }
        if (check) cout << 1;
        else cout << 0;
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t) {
        --t;
        solve();
    }
    return 0;
}
