#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

map<int, int> vals;
int best = 6;
int n = 7;
vector<int> a;
vector<bool> ans;

map<pair<vector<int>, vector<bool>>, int> mem;

int rec() {
    if (a.size() > best) return 0;
    if (ans.size() != a.size()) {
        // ans query
        {
            ans.push_back(true);
            int acnt = 0;
            for (int x = 1; x <= n; ++x) {
                int cnt = 0;
                for (int i = 0; i < a.size(); ++i) {
                    if (ans[i]) {
                        if (x < a[i]) {
                            cnt++;
                        }
                    } else {
                        if (x >= a[i]) {
                            cnt++;
                        }
                    }
                }

                if (cnt <= 1) acnt++;
            }
            if (acnt > 0) if (!rec()) {
                ans.pop_back();
                return false;
            }
            ans.pop_back();
        }

        {
            ans.push_back(false);
            int acnt = 0;
            for (int x = 1; x <= n; ++x) {
                int cnt = 0;
                for (int i = 0; i < a.size(); ++i) {
                    if (ans[i]) {
                        if (x < a[i]) {
                            cnt++;
                        }
                    } else {
                        if (x >= a[i]) {
                            cnt++;
                        }
                    }
                }

                if (cnt <= 1) acnt++;
            }
            if (acnt > 0) if (!rec()) {
                ans.pop_back();
                return false;
            }
            ans.pop_back();
        }

        return true;
    } else {
        // check for ans
        int acnt = 0;
        for (int x = 1; x <= n; ++x) {
            int cnt = 0;
            for (int i = 0; i < a.size(); ++i) {
                if (ans[i]) {
                    if (x < a[i]) {
                        cnt++;
                    }
                } else {
                    if (x >= a[i]) {
                        cnt++;
                    }
                }
            }

            if (cnt <= 1) acnt++;
        }
        if (acnt == 1) {
            // for (auto it : a) {
            //     cout << it << ' ';
            // }
            // for (auto it : ans) {
            //     cout << it;
            // }
            // cout << endl;
            return true;
        }

        for (int i = 1; i <= n; ++i) {
            a.push_back(i);
            if (rec()) {
                a.pop_back();
                mem[make_pair(a, ans)] = i;
                // for (auto it : a) {
                //     cout << it << ' ';
                // }
                // for (auto it : ans) {
                //     cout << it;
                // }
                // cout << " : " << i << endl;
                return true;
            }
            a.pop_back();
        }
        return false;
    }
}

bool ask(int x) {
    cout << "? " << x << endl;
    string s;
    cin >> s;
    return (s == "Yes");
}

void answer(int x) {
    cout << "! " << x << endl;
    string s;
    cin >> s;
    if (s == "Done") exit(0);
}

void solve() {
    int l = 1, r = n + 1;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        int a1 = ask(m), a2 = ask(m);
        int a;
        if (a1 == a2) {
            a = a1;
        } else {
            int a3 = ask(m);
            a = !(a1 ^ a2 ^ a3);
        }

        if (a) {
            l = m;
        } else {
            r = m;
        }
    }
    answer(l);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    if (n > 12) {
        while (true) solve();
        exit(-1);
    }

    if (n == 8) {
best = 7;
mem[{{}, {}}] = 1;
mem[{{1}, {1}}] = 3;
mem[{{1, 3}, {1, 1}}] = 6;
mem[{{1, 3, 6}, {1, 1, 1}}] = 8;
mem[{{1, 3, 6, 8}, {1, 1, 1, 1}}] = 8;
mem[{{1, 3, 6, 8, 8}, {1, 1, 1, 1, 1}}] = 9;
mem[{{1, 3, 6, 8, 8, 9}, {1, 1, 1, 1, 1, 1}}] = 9;
mem[{{1, 3, 6, 8, 8, 9, 9}, {1, 1, 1, 1, 1, 1, 0}}] = 9;
mem[{{1, 3, 6, 8, 8, 9}, {1, 1, 1, 1, 1, 0}}] = 9;
mem[{{1, 3, 6, 8, 8, 9, 9}, {1, 1, 1, 1, 1, 0, 1}}] = 9;
mem[{{1, 3, 6, 8, 8}, {1, 1, 1, 1, 0}}] = 1;
mem[{{1, 3, 6, 8, 8, 1}, {1, 1, 1, 1, 0, 1}}] = 8;
mem[{{1, 3, 6, 8, 8, 1, 8}, {1, 1, 1, 1, 0, 1, 1}}] = 9;
mem[{{1, 3, 6, 8, 8, 1, 8}, {1, 1, 1, 1, 0, 1, 0}}] = 7;
mem[{{1, 3, 6, 8}, {1, 1, 1, 0}}] = 7;
mem[{{1, 3, 6, 8, 7}, {1, 1, 1, 0, 1}}] = 8;
mem[{{1, 3, 6, 8, 7, 8}, {1, 1, 1, 0, 1, 1}}] = 8;
mem[{{1, 3, 6, 8, 7, 8, 8}, {1, 1, 1, 0, 1, 1, 1}}] = 9;
mem[{{1, 3, 6, 8, 7, 8}, {1, 1, 1, 0, 1, 0}}] = 7;
mem[{{1, 3, 6, 8, 7, 8, 7}, {1, 1, 1, 0, 1, 0, 0}}] = 7;
mem[{{1, 3, 6, 8, 7}, {1, 1, 1, 0, 0}}] = 6;
mem[{{1, 3, 6, 8, 7, 6}, {1, 1, 1, 0, 0, 1}}] = 7;
mem[{{1, 3, 6, 8, 7, 6, 7}, {1, 1, 1, 0, 0, 1, 1}}] = 7;
mem[{{1, 3, 6, 8, 7, 6}, {1, 1, 1, 0, 0, 0}}] = 5;
mem[{{1, 3, 6, 8, 7, 6, 5}, {1, 1, 1, 0, 0, 0, 1}}] = 6;
mem[{{1, 3, 6, 8, 7, 6, 5}, {1, 1, 1, 0, 0, 0, 0}}] = 4;
mem[{{1, 3, 6}, {1, 1, 0}}] = 5;
mem[{{1, 3, 6, 5}, {1, 1, 0, 1}}] = 5;
mem[{{1, 3, 6, 5, 5}, {1, 1, 0, 1, 1}}] = 7;
mem[{{1, 3, 6, 5, 5, 7}, {1, 1, 0, 1, 1, 1}}] = 8;
mem[{{1, 3, 6, 5, 5, 7, 8}, {1, 1, 0, 1, 1, 1, 1}}] = 9;
mem[{{1, 3, 6, 5, 5, 7, 8}, {1, 1, 0, 1, 1, 1, 0}}] = 6;
mem[{{1, 3, 6, 5, 5, 7}, {1, 1, 0, 1, 1, 0}}] = 6;
mem[{{1, 3, 6, 5, 5, 7, 6}, {1, 1, 0, 1, 1, 0, 1}}] = 6;
mem[{{1, 3, 6, 5, 5}, {1, 1, 0, 1, 0}}] = 1;
mem[{{1, 3, 6, 5, 5, 1}, {1, 1, 0, 1, 0, 1}}] = 4;
mem[{{1, 3, 6, 5, 5, 1, 4}, {1, 1, 0, 1, 0, 1, 1}}] = 5;
mem[{{1, 3, 6, 5}, {1, 1, 0, 0}}] = 4;
mem[{{1, 3, 6, 5, 4}, {1, 1, 0, 0, 1}}] = 4;
mem[{{1, 3, 6, 5, 4, 4}, {1, 1, 0, 0, 1, 1}}] = 5;
mem[{{1, 3, 6, 5, 4, 4, 5}, {1, 1, 0, 0, 1, 1, 1}}] = 5;
mem[{{1, 3, 6, 5, 4, 4}, {1, 1, 0, 0, 1, 0}}] = 1;
mem[{{1, 3, 6, 5, 4, 4, 1}, {1, 1, 0, 0, 1, 0, 1}}] = 4;
mem[{{1, 3, 6, 5, 4}, {1, 1, 0, 0, 0}}] = 3;
mem[{{1, 3, 6, 5, 4, 3}, {1, 1, 0, 0, 0, 1}}] = 4;
mem[{{1, 3, 6, 5, 4, 3, 4}, {1, 1, 0, 0, 0, 1, 1}}] = 4;
mem[{{1, 3, 6, 5, 4, 3}, {1, 1, 0, 0, 0, 0}}] = 2;
mem[{{1, 3, 6, 5, 4, 3, 2}, {1, 1, 0, 0, 0, 0, 1}}] = 3;
mem[{{1, 3}, {1, 0}}] = 1;
mem[{{1, 3, 1}, {1, 0, 1}}] = 2;
mem[{{1, 3, 1, 2}, {1, 0, 1, 1}}] = 3;
mem[{{1, 3, 1, 2, 3}, {1, 0, 1, 1, 1}}] = 6;
mem[{{1, 3, 1, 2, 3, 6}, {1, 0, 1, 1, 1, 1}}] = 8;
mem[{{1, 3, 1, 2, 3, 6, 8}, {1, 0, 1, 1, 1, 1, 1}}] = 9;
mem[{{1, 3, 1, 2, 3, 6, 8}, {1, 0, 1, 1, 1, 1, 0}}] = 7;
mem[{{1, 3, 1, 2, 3, 6}, {1, 0, 1, 1, 1, 0}}] = 4;
mem[{{1, 3, 1, 2, 3, 6, 4}, {1, 0, 1, 1, 1, 0, 1}}] = 5;
mem[{{1, 3, 1, 2, 3, 6, 4}, {1, 0, 1, 1, 1, 0, 0}}] = 3;
mem[{{1, 3, 1, 2, 3}, {1, 0, 1, 1, 0}}] = 1;
mem[{{1, 3, 1, 2, 3, 1}, {1, 0, 1, 1, 0, 1}}] = 2;
mem[{{1, 3, 1, 2, 3, 1, 2}, {1, 0, 1, 1, 0, 1, 0}}] = 2;
mem[{{1, 3, 1, 2}, {1, 0, 1, 0}}] = 1;
mem[{{1, 3, 1, 2, 1}, {1, 0, 1, 0, 1}}] = 1;
mem[{{1, 3, 1, 2, 1, 1}, {1, 0, 1, 0, 1, 1}}] = 2;
mem[{{1, 3, 1, 2, 1, 1, 2}, {1, 0, 1, 0, 1, 1, 1}}] = 2;
mem[{{1, 3, 1}, {1, 0, 0}}] = 1;
mem[{{1, 3, 1, 1}, {1, 0, 0, 1}}] = 1;
mem[{{1, 3, 1, 1, 1}, {1, 0, 0, 1, 1}}] = 1;
mem[{{1, 3, 1, 1, 1, 1}, {1, 0, 0, 1, 1, 1}}] = 1;
mem[{{1, 3, 1, 1, 1, 1, 1}, {1, 0, 0, 1, 1, 1, 1}}] = 2;
mem[{{1}, {0}}] = 1;
mem[{{1, 1}, {0, 1}}] = 1;
mem[{{1, 1, 1}, {0, 1, 1}}] = 1;
mem[{{1, 1, 1, 1}, {0, 1, 1, 1}}] = 2;
mem[{{1, 1, 1, 1, 2}, {0, 1, 1, 1, 1}}] = 6;
mem[{{1, 1, 1, 1, 2, 6}, {0, 1, 1, 1, 1, 1}}] = 8;
mem[{{1, 1, 1, 1, 2, 6, 8}, {0, 1, 1, 1, 1, 1, 1}}] = 9;
mem[{{1, 1, 1, 1, 2, 6, 8}, {0, 1, 1, 1, 1, 1, 0}}] = 7;
mem[{{1, 1, 1, 1, 2, 6}, {0, 1, 1, 1, 1, 0}}] = 4;
mem[{{1, 1, 1, 1, 2, 6, 4}, {0, 1, 1, 1, 1, 0, 1}}] = 5;
mem[{{1, 1, 1, 1, 2, 6, 4}, {0, 1, 1, 1, 1, 0, 0}}] = 3;
    } else if (n == 9) {
best = 7;
mem[{{}, {}}] = 3;
mem[{{3}, {1}}] = 6;
mem[{{3, 6}, {1, 1}}] = 8;
mem[{{3, 6, 8}, {1, 1, 1}}] = 8;
mem[{{3, 6, 8, 8}, {1, 1, 1, 1}}] = 9;
mem[{{3, 6, 8, 8, 9}, {1, 1, 1, 1, 1}}] = 9;
mem[{{3, 6, 8, 8, 9, 9}, {1, 1, 1, 1, 1, 0}}] = 9;
mem[{{3, 6, 8, 8, 9}, {1, 1, 1, 1, 0}}] = 9;
mem[{{3, 6, 8, 8, 9, 9}, {1, 1, 1, 1, 0, 1}}] = 9;
mem[{{3, 6, 8, 8}, {1, 1, 1, 0}}] = 1;
mem[{{3, 6, 8, 8, 1}, {1, 1, 1, 0, 1}}] = 8;
mem[{{3, 6, 8, 8, 1, 8}, {1, 1, 1, 0, 1, 1}}] = 9;
mem[{{3, 6, 8, 8, 1, 8}, {1, 1, 1, 0, 1, 0}}] = 7;
mem[{{3, 6, 8}, {1, 1, 0}}] = 7;
mem[{{3, 6, 8, 7}, {1, 1, 0, 1}}] = 8;
mem[{{3, 6, 8, 7, 8}, {1, 1, 0, 1, 1}}] = 8;
mem[{{3, 6, 8, 7, 8, 8}, {1, 1, 0, 1, 1, 1}}] = 9;
mem[{{3, 6, 8, 7, 8}, {1, 1, 0, 1, 0}}] = 7;
mem[{{3, 6, 8, 7, 8, 7}, {1, 1, 0, 1, 0, 0}}] = 7;
mem[{{3, 6, 8, 7}, {1, 1, 0, 0}}] = 6;
mem[{{3, 6, 8, 7, 6}, {1, 1, 0, 0, 1}}] = 7;
mem[{{3, 6, 8, 7, 6, 7}, {1, 1, 0, 0, 1, 1}}] = 7;
mem[{{3, 6, 8, 7, 6}, {1, 1, 0, 0, 0}}] = 5;
mem[{{3, 6, 8, 7, 6, 5}, {1, 1, 0, 0, 0, 1}}] = 6;
mem[{{3, 6, 8, 7, 6, 5}, {1, 1, 0, 0, 0, 0}}] = 4;
mem[{{3, 6}, {1, 0}}] = 5;
mem[{{3, 6, 5}, {1, 0, 1}}] = 5;
mem[{{3, 6, 5, 5}, {1, 0, 1, 1}}] = 7;
mem[{{3, 6, 5, 5, 7}, {1, 0, 1, 1, 1}}] = 8;
mem[{{3, 6, 5, 5, 7, 8}, {1, 0, 1, 1, 1, 1}}] = 9;
mem[{{3, 6, 5, 5, 7, 8}, {1, 0, 1, 1, 1, 0}}] = 6;
mem[{{3, 6, 5, 5, 7}, {1, 0, 1, 1, 0}}] = 6;
mem[{{3, 6, 5, 5, 7, 6}, {1, 0, 1, 1, 0, 1}}] = 6;
mem[{{3, 6, 5, 5}, {1, 0, 1, 0}}] = 1;
mem[{{3, 6, 5, 5, 1}, {1, 0, 1, 0, 1}}] = 4;
mem[{{3, 6, 5, 5, 1, 4}, {1, 0, 1, 0, 1, 1}}] = 5;
mem[{{3, 6, 5}, {1, 0, 0}}] = 4;
mem[{{3, 6, 5, 4}, {1, 0, 0, 1}}] = 4;
mem[{{3, 6, 5, 4, 4}, {1, 0, 0, 1, 1}}] = 5;
mem[{{3, 6, 5, 4, 4, 5}, {1, 0, 0, 1, 1, 1}}] = 5;
mem[{{3, 6, 5, 4, 4}, {1, 0, 0, 1, 0}}] = 1;
mem[{{3, 6, 5, 4, 4, 1}, {1, 0, 0, 1, 0, 1}}] = 4;
mem[{{3, 6, 5, 4}, {1, 0, 0, 0}}] = 3;
mem[{{3, 6, 5, 4, 3}, {1, 0, 0, 0, 1}}] = 4;
mem[{{3, 6, 5, 4, 3, 4}, {1, 0, 0, 0, 1, 1}}] = 4;
mem[{{3, 6, 5, 4, 3}, {1, 0, 0, 0, 0}}] = 2;
mem[{{3, 6, 5, 4, 3, 2}, {1, 0, 0, 0, 0, 1}}] = 3;
mem[{{3}, {0}}] = 1;
mem[{{3, 1}, {0, 1}}] = 2;
mem[{{3, 1, 2}, {0, 1, 1}}] = 3;
mem[{{3, 1, 2, 3}, {0, 1, 1, 1}}] = 6;
mem[{{3, 1, 2, 3, 6}, {0, 1, 1, 1, 1}}] = 8;
mem[{{3, 1, 2, 3, 6, 8}, {0, 1, 1, 1, 1, 1}}] = 9;
mem[{{3, 1, 2, 3, 6, 8}, {0, 1, 1, 1, 1, 0}}] = 7;
mem[{{3, 1, 2, 3, 6}, {0, 1, 1, 1, 0}}] = 4;
mem[{{3, 1, 2, 3, 6, 4}, {0, 1, 1, 1, 0, 1}}] = 5;
mem[{{3, 1, 2, 3, 6, 4}, {0, 1, 1, 1, 0, 0}}] = 3;
mem[{{3, 1, 2, 3}, {0, 1, 1, 0}}] = 1;
mem[{{3, 1, 2, 3, 1}, {0, 1, 1, 0, 1}}] = 2;
mem[{{3, 1, 2, 3, 1, 2}, {0, 1, 1, 0, 1, 0}}] = 2;
mem[{{3, 1, 2}, {0, 1, 0}}] = 1;
mem[{{3, 1, 2, 1}, {0, 1, 0, 1}}] = 1;
mem[{{3, 1, 2, 1, 1}, {0, 1, 0, 1, 1}}] = 2;
mem[{{3, 1, 2, 1, 1, 2}, {0, 1, 0, 1, 1, 1}}] = 2;
mem[{{3, 1}, {0, 0}}] = 1;
mem[{{3, 1, 1}, {0, 0, 1}}] = 1;
mem[{{3, 1, 1, 1}, {0, 0, 1, 1}}] = 1;
mem[{{3, 1, 1, 1, 1}, {0, 0, 1, 1, 1}}] = 1;
mem[{{3, 1, 1, 1, 1, 1}, {0, 0, 1, 1, 1, 1}}] = 2;
    } else if (n == 10) {
best = 7;
mem[{{}, {}}] = 4;
mem[{{4}, {1}}] = 7;
mem[{{4, 7}, {1, 1}}] = 9;
mem[{{4, 7, 9}, {1, 1, 1}}] = 9;
mem[{{4, 7, 9, 9}, {1, 1, 1, 1}}] = 10;
mem[{{4, 7, 9, 9, 10}, {1, 1, 1, 1, 1}}] = 10;
mem[{{4, 7, 9, 9, 10, 10}, {1, 1, 1, 1, 1, 0}}] = 10;
mem[{{4, 7, 9, 9, 10}, {1, 1, 1, 1, 0}}] = 10;
mem[{{4, 7, 9, 9, 10, 10}, {1, 1, 1, 1, 0, 1}}] = 10;
mem[{{4, 7, 9, 9}, {1, 1, 1, 0}}] = 1;
mem[{{4, 7, 9, 9, 1}, {1, 1, 1, 0, 1}}] = 9;
mem[{{4, 7, 9, 9, 1, 9}, {1, 1, 1, 0, 1, 1}}] = 10;
mem[{{4, 7, 9, 9, 1, 9}, {1, 1, 1, 0, 1, 0}}] = 8;
mem[{{4, 7, 9}, {1, 1, 0}}] = 8;
mem[{{4, 7, 9, 8}, {1, 1, 0, 1}}] = 9;
mem[{{4, 7, 9, 8, 9}, {1, 1, 0, 1, 1}}] = 9;
mem[{{4, 7, 9, 8, 9, 9}, {1, 1, 0, 1, 1, 1}}] = 10;
mem[{{4, 7, 9, 8, 9}, {1, 1, 0, 1, 0}}] = 8;
mem[{{4, 7, 9, 8, 9, 8}, {1, 1, 0, 1, 0, 0}}] = 8;
mem[{{4, 7, 9, 8}, {1, 1, 0, 0}}] = 7;
mem[{{4, 7, 9, 8, 7}, {1, 1, 0, 0, 1}}] = 8;
mem[{{4, 7, 9, 8, 7, 8}, {1, 1, 0, 0, 1, 1}}] = 8;
mem[{{4, 7, 9, 8, 7}, {1, 1, 0, 0, 0}}] = 6;
mem[{{4, 7, 9, 8, 7, 6}, {1, 1, 0, 0, 0, 1}}] = 7;
mem[{{4, 7, 9, 8, 7, 6}, {1, 1, 0, 0, 0, 0}}] = 5;
mem[{{4, 7}, {1, 0}}] = 6;
mem[{{4, 7, 6}, {1, 0, 1}}] = 6;
mem[{{4, 7, 6, 6}, {1, 0, 1, 1}}] = 8;
mem[{{4, 7, 6, 6, 8}, {1, 0, 1, 1, 1}}] = 9;
mem[{{4, 7, 6, 6, 8, 9}, {1, 0, 1, 1, 1, 1}}] = 10;
mem[{{4, 7, 6, 6, 8, 9}, {1, 0, 1, 1, 1, 0}}] = 7;
mem[{{4, 7, 6, 6, 8}, {1, 0, 1, 1, 0}}] = 7;
mem[{{4, 7, 6, 6, 8, 7}, {1, 0, 1, 1, 0, 1}}] = 7;
mem[{{4, 7, 6, 6}, {1, 0, 1, 0}}] = 1;
mem[{{4, 7, 6, 6, 1}, {1, 0, 1, 0, 1}}] = 5;
mem[{{4, 7, 6, 6, 1, 5}, {1, 0, 1, 0, 1, 1}}] = 6;
mem[{{4, 7, 6}, {1, 0, 0}}] = 5;
mem[{{4, 7, 6, 5}, {1, 0, 0, 1}}] = 5;
mem[{{4, 7, 6, 5, 5}, {1, 0, 0, 1, 1}}] = 6;
mem[{{4, 7, 6, 5, 5, 6}, {1, 0, 0, 1, 1, 1}}] = 6;
mem[{{4, 7, 6, 5, 5}, {1, 0, 0, 1, 0}}] = 1;
mem[{{4, 7, 6, 5, 5, 1}, {1, 0, 0, 1, 0, 1}}] = 5;
mem[{{4, 7, 6, 5}, {1, 0, 0, 0}}] = 4;
mem[{{4, 7, 6, 5, 4}, {1, 0, 0, 0, 1}}] = 5;
mem[{{4, 7, 6, 5, 4, 5}, {1, 0, 0, 0, 1, 1}}] = 5;
mem[{{4, 7, 6, 5, 4}, {1, 0, 0, 0, 0}}] = 3;
mem[{{4, 7, 6, 5, 4, 3}, {1, 0, 0, 0, 0, 1}}] = 4;
mem[{{4, 7, 6, 5, 4, 3}, {1, 0, 0, 0, 0, 0}}] = 2;
mem[{{4}, {0}}] = 1;
mem[{{4, 1}, {0, 1}}] = 3;
mem[{{4, 1, 3}, {0, 1, 1}}] = 4;
mem[{{4, 1, 3, 4}, {0, 1, 1, 1}}] = 7;
mem[{{4, 1, 3, 4, 7}, {0, 1, 1, 1, 1}}] = 9;
mem[{{4, 1, 3, 4, 7, 9}, {0, 1, 1, 1, 1, 1}}] = 10;
mem[{{4, 1, 3, 4, 7, 9}, {0, 1, 1, 1, 1, 0}}] = 8;
mem[{{4, 1, 3, 4, 7}, {0, 1, 1, 1, 0}}] = 5;
mem[{{4, 1, 3, 4, 7, 5}, {0, 1, 1, 1, 0, 1}}] = 6;
mem[{{4, 1, 3, 4, 7, 5}, {0, 1, 1, 1, 0, 0}}] = 4;
mem[{{4, 1, 3, 4}, {0, 1, 1, 0}}] = 2;
mem[{{4, 1, 3, 4, 2}, {0, 1, 1, 0, 1}}] = 3;
mem[{{4, 1, 3, 4, 2, 3}, {0, 1, 1, 0, 1, 0}}] = 3;
mem[{{4, 1, 3, 4, 2}, {0, 1, 1, 0, 0}}] = 1;
mem[{{4, 1, 3, 4, 2, 1}, {0, 1, 1, 0, 0, 1}}] = 2;
mem[{{4, 1, 3}, {0, 1, 0}}] = 2;
mem[{{4, 1, 3, 2}, {0, 1, 0, 1}}] = 2;
mem[{{4, 1, 3, 2, 2}, {0, 1, 0, 1, 1}}] = 3;
mem[{{4, 1, 3, 2, 2, 3}, {0, 1, 0, 1, 1, 1}}] = 3;
mem[{{4, 1, 3, 2, 2}, {0, 1, 0, 1, 0}}] = 1;
mem[{{4, 1, 3, 2, 2, 1}, {0, 1, 0, 1, 0, 1}}] = 2;
mem[{{4, 1, 3, 2}, {0, 1, 0, 0}}] = 1;
mem[{{4, 1, 3, 2, 1}, {0, 1, 0, 0, 1}}] = 2;
mem[{{4, 1, 3, 2, 1, 2}, {0, 1, 0, 0, 1, 1}}] = 2;
mem[{{4, 1}, {0, 0}}] = 1;
mem[{{4, 1, 1}, {0, 0, 1}}] = 1;
mem[{{4, 1, 1, 1}, {0, 0, 1, 1}}] = 1;
mem[{{4, 1, 1, 1, 1}, {0, 0, 1, 1, 1}}] = 2;
mem[{{4, 1, 1, 1, 1, 2}, {0, 0, 1, 1, 1, 1}}] = 3;
    } else if (n == 11) {
best = 7;
mem[{{}, {}}] = 6;
mem[{{6}, {1}}] = 8;
mem[{{6, 8}, {1, 1}}] = 10;
mem[{{6, 8, 10}, {1, 1, 1}}] = 10;
mem[{{6, 8, 10, 10}, {1, 1, 1, 1}}] = 11;
mem[{{6, 8, 10, 10, 11}, {1, 1, 1, 1, 1}}] = 11;
mem[{{6, 8, 10, 10, 11, 11}, {1, 1, 1, 1, 1, 0}}] = 11;
mem[{{6, 8, 10, 10, 11}, {1, 1, 1, 1, 0}}] = 11;
mem[{{6, 8, 10, 10, 11, 11}, {1, 1, 1, 1, 0, 1}}] = 11;
mem[{{6, 8, 10, 10}, {1, 1, 1, 0}}] = 1;
mem[{{6, 8, 10, 10, 1}, {1, 1, 1, 0, 1}}] = 10;
mem[{{6, 8, 10, 10, 1, 10}, {1, 1, 1, 0, 1, 1}}] = 11;
mem[{{6, 8, 10, 10, 1, 10}, {1, 1, 1, 0, 1, 0}}] = 9;
mem[{{6, 8, 10}, {1, 1, 0}}] = 9;
mem[{{6, 8, 10, 9}, {1, 1, 0, 1}}] = 10;
mem[{{6, 8, 10, 9, 10}, {1, 1, 0, 1, 1}}] = 10;
mem[{{6, 8, 10, 9, 10, 10}, {1, 1, 0, 1, 1, 1}}] = 11;
mem[{{6, 8, 10, 9, 10}, {1, 1, 0, 1, 0}}] = 9;
mem[{{6, 8, 10, 9, 10, 9}, {1, 1, 0, 1, 0, 0}}] = 9;
mem[{{6, 8, 10, 9}, {1, 1, 0, 0}}] = 8;
mem[{{6, 8, 10, 9, 8}, {1, 1, 0, 0, 1}}] = 9;
mem[{{6, 8, 10, 9, 8, 9}, {1, 1, 0, 0, 1, 1}}] = 9;
mem[{{6, 8, 10, 9, 8}, {1, 1, 0, 0, 0}}] = 7;
mem[{{6, 8, 10, 9, 8, 7}, {1, 1, 0, 0, 0, 1}}] = 8;
mem[{{6, 8}, {1, 0}}] = 6;
mem[{{6, 8, 6}, {1, 0, 1}}] = 8;
mem[{{6, 8, 6, 8}, {1, 0, 1, 1}}] = 8;
mem[{{6, 8, 6, 8, 8}, {1, 0, 1, 1, 1}}] = 10;
mem[{{6, 8, 6, 8, 8, 10}, {1, 0, 1, 1, 1, 1}}] = 11;
mem[{{6, 8, 6, 8, 8, 10}, {1, 0, 1, 1, 1, 0}}] = 9;
mem[{{6, 8, 6, 8, 8}, {1, 0, 1, 1, 0}}] = 1;
mem[{{6, 8, 6, 8, 8, 1}, {1, 0, 1, 1, 0, 1}}] = 7;
mem[{{6, 8, 6, 8}, {1, 0, 1, 0}}] = 7;
mem[{{6, 8, 6, 8, 7}, {1, 0, 1, 0, 1}}] = 7;
mem[{{6, 8, 6, 8, 7, 7}, {1, 0, 1, 0, 1, 0}}] = 7;
mem[{{6, 8, 6, 8, 7}, {1, 0, 1, 0, 0}}] = 7;
mem[{{6, 8, 6, 8, 7, 7}, {1, 0, 1, 0, 0, 1}}] = 7;
mem[{{6, 8, 6}, {1, 0, 0}}] = 1;
mem[{{6, 8, 6, 1}, {1, 0, 0, 1}}] = 4;
mem[{{6, 8, 6, 1, 4}, {1, 0, 0, 1, 1}}] = 6;
mem[{{6, 8, 6, 1, 4, 6}, {1, 0, 0, 1, 1, 1}}] = 7;
mem[{{6, 8, 6, 1, 4, 6}, {1, 0, 0, 1, 1, 0}}] = 5;
mem[{{6, 8, 6, 1, 4}, {1, 0, 0, 1, 0}}] = 2;
mem[{{6, 8, 6, 1, 4, 2}, {1, 0, 0, 1, 0, 1}}] = 3;
mem[{{6}, {0}}] = 3;
mem[{{6, 3}, {0, 1}}] = 5;
mem[{{6, 3, 5}, {0, 1, 1}}] = 6;
mem[{{6, 3, 5, 6}, {0, 1, 1, 1}}] = 8;
mem[{{6, 3, 5, 6, 8}, {0, 1, 1, 1, 1}}] = 10;
mem[{{6, 3, 5, 6, 8, 10}, {0, 1, 1, 1, 1, 1}}] = 11;
mem[{{6, 3, 5, 6, 8, 10}, {0, 1, 1, 1, 1, 0}}] = 9;
mem[{{6, 3, 5, 6, 8}, {0, 1, 1, 1, 0}}] = 6;
mem[{{6, 3, 5, 6, 8, 6}, {0, 1, 1, 1, 0, 1}}] = 7;
mem[{{6, 3, 5, 6}, {0, 1, 1, 0}}] = 4;
mem[{{6, 3, 5, 6, 4}, {0, 1, 1, 0, 1}}] = 5;
mem[{{6, 3, 5, 6, 4, 5}, {0, 1, 1, 0, 1, 0}}] = 5;
mem[{{6, 3, 5, 6, 4}, {0, 1, 1, 0, 0}}] = 1;
mem[{{6, 3, 5, 6, 4, 1}, {0, 1, 1, 0, 0, 1}}] = 4;
mem[{{6, 3, 5}, {0, 1, 0}}] = 4;
mem[{{6, 3, 5, 4}, {0, 1, 0, 1}}] = 4;
mem[{{6, 3, 5, 4, 4}, {0, 1, 0, 1, 1}}] = 5;
mem[{{6, 3, 5, 4, 4, 5}, {0, 1, 0, 1, 1, 1}}] = 5;
mem[{{6, 3, 5, 4, 4}, {0, 1, 0, 1, 0}}] = 1;
mem[{{6, 3, 5, 4, 4, 1}, {0, 1, 0, 1, 0, 1}}] = 4;
mem[{{6, 3, 5, 4}, {0, 1, 0, 0}}] = 3;
mem[{{6, 3, 5, 4, 3}, {0, 1, 0, 0, 1}}] = 4;
mem[{{6, 3, 5, 4, 3, 4}, {0, 1, 0, 0, 1, 1}}] = 4;
mem[{{6, 3, 5, 4, 3}, {0, 1, 0, 0, 0}}] = 2;
mem[{{6, 3, 5, 4, 3, 2}, {0, 1, 0, 0, 0, 1}}] = 3;
mem[{{6, 3}, {0, 0}}] = 1;
mem[{{6, 3, 1}, {0, 0, 1}}] = 2;
mem[{{6, 3, 1, 2}, {0, 0, 1, 1}}] = 3;
mem[{{6, 3, 1, 2, 3}, {0, 0, 1, 1, 1}}] = 4;
mem[{{6, 3, 1, 2, 3, 4}, {0, 0, 1, 1, 1, 1}}] = 5;
mem[{{6, 3, 1, 2, 3, 4}, {0, 0, 1, 1, 1, 0}}] = 3;
mem[{{6, 3, 1, 2, 3}, {0, 0, 1, 1, 0}}] = 2;
mem[{{6, 3, 1, 2, 3, 2}, {0, 0, 1, 1, 0, 0}}] = 2;
mem[{{6, 3, 1, 2}, {0, 0, 1, 0}}] = 1;
mem[{{6, 3, 1, 2, 1}, {0, 0, 1, 0, 1}}] = 2;
mem[{{6, 3, 1, 2, 1, 2}, {0, 0, 1, 0, 1, 1}}] = 2;
mem[{{6, 3, 1}, {0, 0, 0}}] = 1;
mem[{{6, 3, 1, 1}, {0, 0, 0, 1}}] = 1;
mem[{{6, 3, 1, 1, 1}, {0, 0, 0, 1, 1}}] = 1;
mem[{{6, 3, 1, 1, 1, 1}, {0, 0, 0, 1, 1, 1}}] = 2;
    } else if (n == 12) {
best = 7;
mem[{{}, {}}] = 7;
mem[{{7}, {1}}] = 9;
mem[{{7, 9}, {1, 1}}] = 11;
mem[{{7, 9, 11}, {1, 1, 1}}] = 11;
mem[{{7, 9, 11, 11}, {1, 1, 1, 1}}] = 12;
mem[{{7, 9, 11, 11, 12}, {1, 1, 1, 1, 1}}] = 12;
mem[{{7, 9, 11, 11, 12, 12}, {1, 1, 1, 1, 1, 0}}] = 12;
mem[{{7, 9, 11, 11, 12}, {1, 1, 1, 1, 0}}] = 12;
mem[{{7, 9, 11, 11, 12, 12}, {1, 1, 1, 1, 0, 1}}] = 12;
mem[{{7, 9, 11, 11}, {1, 1, 1, 0}}] = 1;
mem[{{7, 9, 11, 11, 1}, {1, 1, 1, 0, 1}}] = 11;
mem[{{7, 9, 11, 11, 1, 11}, {1, 1, 1, 0, 1, 1}}] = 12;
mem[{{7, 9, 11, 11, 1, 11}, {1, 1, 1, 0, 1, 0}}] = 10;
mem[{{7, 9, 11}, {1, 1, 0}}] = 10;
mem[{{7, 9, 11, 10}, {1, 1, 0, 1}}] = 11;
mem[{{7, 9, 11, 10, 11}, {1, 1, 0, 1, 1}}] = 11;
mem[{{7, 9, 11, 10, 11, 11}, {1, 1, 0, 1, 1, 1}}] = 12;
mem[{{7, 9, 11, 10, 11}, {1, 1, 0, 1, 0}}] = 10;
mem[{{7, 9, 11, 10, 11, 10}, {1, 1, 0, 1, 0, 0}}] = 10;
mem[{{7, 9, 11, 10}, {1, 1, 0, 0}}] = 9;
mem[{{7, 9, 11, 10, 9}, {1, 1, 0, 0, 1}}] = 10;
mem[{{7, 9, 11, 10, 9, 10}, {1, 1, 0, 0, 1, 1}}] = 10;
mem[{{7, 9, 11, 10, 9}, {1, 1, 0, 0, 0}}] = 8;
mem[{{7, 9, 11, 10, 9, 8}, {1, 1, 0, 0, 0, 1}}] = 9;
mem[{{7, 9}, {1, 0}}] = 7;
mem[{{7, 9, 7}, {1, 0, 1}}] = 9;
mem[{{7, 9, 7, 9}, {1, 0, 1, 1}}] = 9;
mem[{{7, 9, 7, 9, 9}, {1, 0, 1, 1, 1}}] = 11;
mem[{{7, 9, 7, 9, 9, 11}, {1, 0, 1, 1, 1, 1}}] = 12;
mem[{{7, 9, 7, 9, 9, 11}, {1, 0, 1, 1, 1, 0}}] = 10;
mem[{{7, 9, 7, 9, 9}, {1, 0, 1, 1, 0}}] = 1;
mem[{{7, 9, 7, 9, 9, 1}, {1, 0, 1, 1, 0, 1}}] = 8;
mem[{{7, 9, 7, 9}, {1, 0, 1, 0}}] = 8;
mem[{{7, 9, 7, 9, 8}, {1, 0, 1, 0, 1}}] = 8;
mem[{{7, 9, 7, 9, 8, 8}, {1, 0, 1, 0, 1, 0}}] = 8;
mem[{{7, 9, 7, 9, 8}, {1, 0, 1, 0, 0}}] = 8;
mem[{{7, 9, 7, 9, 8, 8}, {1, 0, 1, 0, 0, 1}}] = 8;
mem[{{7, 9, 7}, {1, 0, 0}}] = 1;
mem[{{7, 9, 7, 1}, {1, 0, 0, 1}}] = 5;
mem[{{7, 9, 7, 1, 5}, {1, 0, 0, 1, 1}}] = 7;
mem[{{7, 9, 7, 1, 5, 7}, {1, 0, 0, 1, 1, 1}}] = 8;
mem[{{7, 9, 7, 1, 5, 7}, {1, 0, 0, 1, 1, 0}}] = 6;
mem[{{7, 9, 7, 1, 5}, {1, 0, 0, 1, 0}}] = 3;
mem[{{7, 9, 7, 1, 5, 3}, {1, 0, 0, 1, 0, 1}}] = 4;
mem[{{7, 9, 7, 1, 5, 3}, {1, 0, 0, 1, 0, 0}}] = 2;
mem[{{7}, {0}}] = 4;
mem[{{7, 4}, {0, 1}}] = 6;
mem[{{7, 4, 6}, {0, 1, 1}}] = 7;
mem[{{7, 4, 6, 7}, {0, 1, 1, 1}}] = 9;
mem[{{7, 4, 6, 7, 9}, {0, 1, 1, 1, 1}}] = 11;
mem[{{7, 4, 6, 7, 9, 11}, {0, 1, 1, 1, 1, 1}}] = 12;
mem[{{7, 4, 6, 7, 9, 11}, {0, 1, 1, 1, 1, 0}}] = 10;
mem[{{7, 4, 6, 7, 9}, {0, 1, 1, 1, 0}}] = 7;
mem[{{7, 4, 6, 7, 9, 7}, {0, 1, 1, 1, 0, 1}}] = 8;
mem[{{7, 4, 6, 7}, {0, 1, 1, 0}}] = 5;
mem[{{7, 4, 6, 7, 5}, {0, 1, 1, 0, 1}}] = 6;
mem[{{7, 4, 6, 7, 5, 6}, {0, 1, 1, 0, 1, 0}}] = 6;
mem[{{7, 4, 6, 7, 5}, {0, 1, 1, 0, 0}}] = 1;
mem[{{7, 4, 6, 7, 5, 1}, {0, 1, 1, 0, 0, 1}}] = 5;
mem[{{7, 4, 6}, {0, 1, 0}}] = 5;
mem[{{7, 4, 6, 5}, {0, 1, 0, 1}}] = 5;
mem[{{7, 4, 6, 5, 5}, {0, 1, 0, 1, 1}}] = 6;
mem[{{7, 4, 6, 5, 5, 6}, {0, 1, 0, 1, 1, 1}}] = 6;
mem[{{7, 4, 6, 5, 5}, {0, 1, 0, 1, 0}}] = 1;
mem[{{7, 4, 6, 5, 5, 1}, {0, 1, 0, 1, 0, 1}}] = 5;
mem[{{7, 4, 6, 5}, {0, 1, 0, 0}}] = 4;
mem[{{7, 4, 6, 5, 4}, {0, 1, 0, 0, 1}}] = 5;
mem[{{7, 4, 6, 5, 4, 5}, {0, 1, 0, 0, 1, 1}}] = 5;
mem[{{7, 4, 6, 5, 4}, {0, 1, 0, 0, 0}}] = 3;
mem[{{7, 4, 6, 5, 4, 3}, {0, 1, 0, 0, 0, 1}}] = 4;
mem[{{7, 4, 6, 5, 4, 3}, {0, 1, 0, 0, 0, 0}}] = 2;
mem[{{7, 4}, {0, 0}}] = 2;
mem[{{7, 4, 2}, {0, 0, 1}}] = 3;
mem[{{7, 4, 2, 3}, {0, 0, 1, 1}}] = 4;
mem[{{7, 4, 2, 3, 4}, {0, 0, 1, 1, 1}}] = 5;
mem[{{7, 4, 2, 3, 4, 5}, {0, 0, 1, 1, 1, 1}}] = 6;
mem[{{7, 4, 2, 3, 4, 5}, {0, 0, 1, 1, 1, 0}}] = 4;
mem[{{7, 4, 2, 3, 4}, {0, 0, 1, 1, 0}}] = 3;
mem[{{7, 4, 2, 3, 4, 3}, {0, 0, 1, 1, 0, 0}}] = 3;
mem[{{7, 4, 2, 3}, {0, 0, 1, 0}}] = 2;
mem[{{7, 4, 2, 3, 2}, {0, 0, 1, 0, 1}}] = 3;
mem[{{7, 4, 2, 3, 2, 3}, {0, 0, 1, 0, 1, 1}}] = 3;
mem[{{7, 4, 2, 3, 2}, {0, 0, 1, 0, 0}}] = 1;
mem[{{7, 4, 2, 3, 2, 1}, {0, 0, 1, 0, 0, 1}}] = 2;
mem[{{7, 4, 2}, {0, 0, 0}}] = 1;
mem[{{7, 4, 2, 1}, {0, 0, 0, 1}}] = 2;
mem[{{7, 4, 2, 1, 2}, {0, 0, 0, 1, 1}}] = 2;
mem[{{7, 4, 2, 1, 2, 2}, {0, 0, 0, 1, 1, 1}}] = 3;
    } else {
        for (best = 1;; ++best) if (rec()) break;
    }

    vector<int> a;
    vector<bool> ans;
    while (true) {
        int p = mem[{a, ans}];
        a.push_back(p);
        bool r = ask(p);
        ans.push_back(r);

        // for (auto it : a) {
        //     cout << it << ' ';
        // }
        // for (auto it : ans) {
        //     cout << it;
        // }
        // cout << endl;

        int acnt = 0, ps;
        for (int x = 1; x <= n; ++x) {
            int cnt = 0;
            for (int i = 0; i < a.size(); ++i) {
                if (ans[i]) {
                    if (x < a[i]) {
                        cnt++;
                    }
                } else {
                    if (x >= a[i]) {
                        cnt++;
                    }
                }
            }

            if (cnt <= 1) {
                ps = x;
                acnt++;
            }
        }

        if (acnt == 1) {
            answer(ps);
            ans.clear();
            a.clear();
        }
    }
}