
#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int N = 300005;
int a[N], b[N], used[N];

void solve() {
	int m, n;
	cin >> m >> n;
	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
	}
	vector <pair<int, pair<int, int>>> ans;
	for (int i = 1; i <= m; ++i) {
		int color = a[i];
		if (used[color]) continue;
		used[color] = 1;
		int post = i;
		for (int j = i + 1; j <= m; ++j) {
			if (a[j] == color) {
				post = j;
			}
		}
		ans.push_back({ color, {i, post} });
		for (int j = i; j <= post; ++j)
			b[j] = color;
	}
	for (int i = 1; i <= m; ++i) {
		if (b[i] != a[i]) {
			cout << -1 << '\n';
			exit(0);
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first << ' ' << i.second.first << ' ' << i.second.second << '\n';
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
}