#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

typedef long long ll;

const ll N = 5500;
const ll MAXSUM = 15000;

vector <pair<ll, ll>> a[N], g[N];

ll dp[N][MAXSUM];
ll vis[N];

vector <ll> path;

void run() {
	ll n, m, q, p;
	cin >> n >> m >> q >> p;
	for (ll i = 1; i <= n; ++i) {
		a[i].clear(), g[i].clear();
		for (ll j = 0; j < MAXSUM; ++j)
			dp[i][j] = 0;
	}

	for (ll i = 0; i < m; ++i) {
		ll u, v, l;
		cin >> u >> v >> l;
		a[u].push_back(make_pair(v, l));
		g[v].push_back(make_pair(u, l));
	}
	dp[1][0] = 1;
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 0; j < MAXSUM; ++j) {
			if (dp[i][j]) {
				for (auto k : a[i]) {
					if (j + k.second >= MAXSUM) continue;
					dp[k.first][j + k.second] = 1;
				}
			}
		}
	}
	while (q--) {
		ll st, f;
		cin >> st >> f;
		bool is = 0;
		for (ll j = 0; j < MAXSUM; ++j) {
			if (dp[st][j] == 1) {
				if (f <= j && j * (p - 1) <= p * f)
					is = 1;
			}
		}
		cout << is;
	}
	cout << '\n';
}

void solve() {
	ll t;
	cin >> t;
	while (t--) run();
}

signed main(){
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}