#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

bool query(int x)
{
    cout << "? " << x << endl;
    string ans;
    cin >> ans;
    return ans[0] == 'Y';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    while (true)
    {
        set<int> cls = {1};
        set<int> crs = {n + 1};
        int l = 1;
        int r = n + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (query(m))
            {
                l = m;
                cls.insert(l);
            }
            else
            {
                r = m;
                crs.insert(r);
            }
        }

        auto it = cls.end();
        it--;
        cls.erase(it);
        crs.erase(crs.begin());

        if (!cls.empty() && !query(l))
            l = *cls.rbegin();
        else if (!crs.empty() && !query(r))
            r = *crs.begin();

        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (query(m))
                l = m;
            else
                r = m;
        }

        cout << "! " << l << endl;
        string ans;
        cin >> ans;
        if (ans[0] == 'D')
            break;
    }

    return 0;
}