#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct s
{
    int c, l, r;
    s() {};
    s(int _c, int _l, int _r)
    {
        c = _c, l = _l, r = _r;
    }
};

const int N = (int)3e5 + 22;
vector<int> pl[N], a;
vector<s> ans;

void f(int l, int r)
{
    if (l > r)
        return ;
    if (pl[a[l]].back() > r)
    {
        cout << -1;
        exit(0);
    }
    ans.push_back({a[l], l, pl[a[l]].back()});
    for (int i = 0; i < (int)pl[a[l]].size() - 1; i++)
        f(pl[a[l]][i] + 1, pl[a[l]][i + 1] - 1);
    f(pl[a[l]].back() + 1, r);
}

int main()
{
    int m, n;
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        pl[a[i]].push_back(i);
    }
    f(0, n - 1);
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i].c << ' ' << ans[i].l + 1 << ' ' << ans[i].r + 1 << '\n';
    return 0;
}
