#include <bits/stdc++.h>
using namespace std;
#define MAXN 1000100
#define INF 1000000000
int lastr[MAXN];
int lastc[MAXN];
int treer[MAXN*4];
int treec[MAXN*4];
vector<pair<int,int> > rline;
vector<pair<int,int> > cline;

void buildr(int v,int l,int r){
    treer[v] = 0;
    if(l==r) return;
    int m = (l+r)/2;
    buildr(v*2+1,l,m);
    buildr(v*2+2,m+1,r);
}

int updr(int v,int t,int z,int l,int r){
    if(l==r){
        treer[v] = z;
        return z;
    }
    int m = (l+r)/2;
    if(t<=m){
        updr(v*2+1,t,z,l,m);
    }
    else updr(v*2+2,t,z,m+1,r);
    treer[v] = min(treer[v*2+1],treer[v*2+2]);
    return treer[v];
}

int mxr(int v,int la,int ra,int l,int r){
    if(l == la && r == ra) return treer[v];
    int m = (l+r)/2;
    if(ra<=m) return mxr(v*2+1,la,ra,l,m);
    if(la>m) return mxr(v*2+2,la,ra,m+1,r);
    return min(mxr(v*2+1,la,m,l,m),mxr(v*2+2,m+1,ra,m+1,r));
}

void buildc(int v,int l,int r){
    treec[v] = 0;
    if(l==r) return;
    int m = (l+r)/2;
    buildc(v*2+1,l,m);
    buildc(v*2+2,m+1,r);
}

int updc(int v,int t,int z,int l,int r){
    if(l==r){
        treec[v] = z;
        return z;
    }
    int m = (l+r)/2;
    if(t<=m){
        updc(v*2+1,t,z,l,m);
    }
    else updc(v*2+2,t,z,m+1,r);
    treec[v] = min(treec[v*2+1],treec[v*2+2]);
    return treec[v];
}

int mxc(int v,int la,int ra,int l,int r){
    if(l == la && r == ra) return treec[v];
    int m = (l+r)/2;
    if(ra<=m) return mxc(v*2+1,la,ra,l,m);
    if(la>m) return mxc(v*2+2,la,ra,m+1,r);
    return min(mxc(v*2+1,la,m,l,m),mxc(v*2+2,m+1,ra,m+1,r));
}


int main()
{
    int n,m,q;
    cin >> n >> m >> q;
    buildr(0,0,n-1);
    buildc(0,0,m-1);
    for(int i = 0;i<n;i++){
        lastr[i] = 0;
    }
    for(int i = 0;i<m;i++){
        lastc[i] = 0;
    }
    for(int i = 1;i<=q;i++){
        int act,x1,y1,x2,y2,k;
        cin >> act;
        if(act == 1){
            cin >> y1;
            lastr[y1-1] = i;
            updr(0,y1-1,i,0,n-1);
            rline.push_back(make_pair(y1-1,i));
        }
        if(act == 2){
            cin >> x1;
            lastc[x1-1] = i;
            updc(0,x1-1,i,0,m-1);
            cline.push_back(make_pair(x1-1,i));
        }
        if(act == 3){
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            if(k>=i){
                cout << abs(x1-x2)+abs(y1-y2)<<"\n";
                continue;
            }
            if(i-mxr(0,min(y1,y2),max(y1,y2),0,n-1)<=k){
                cout << abs(x1-x2)+abs(y1-y2)<<"\n";
                continue;
            }
            if(i-mxc(0,min(x1,x2),max(x1,x2),0,m-1)<=k){
                cout << abs(x1-x2)+abs(y1-y2)<<"\n";
                continue;
            }
            if(i - lastr[y1]<=k && i - lastc[x2]<=k){
                cout << abs(x1-x2)+abs(y1-y2)<<"\n";
                continue;
            }
            if(i - lastr[y2]<=k && i - lastc[x1]<=k){
                cout << abs(x1-x2)+abs(y1-y2)<<"\n";
                continue;
            }
            if(i - lastr[y1]<=k && i - lastr[y2]<=k){
                int mnans = INF;
                for(int i = 0;i<cline.size();i++){
                    if(i-cline[i].second<=k) mnans = min(mnans,min(abs(cline[i].first-x1),abs(cline[i].first-x2)));
                }
                if(mnans != INF){
                    cout << abs(x1-x2)+abs(y1-y2)+mnans*2<<"\n";
                    continue;
                }
            }
            if(i - lastc[x1]<=k && i - lastc[x2]<=k){
                int mnans = INF;
                for(int i = 0;i<rline.size();i++){
                    if(i-rline[i].second<=k) mnans = min(mnans,min(abs(rline[i].first-y1),abs(rline[i].first-y2)));
                }
                if(mnans != INF){
                    cout << abs(x1-x2)+abs(y1-y2)+mnans*2<<"\n";
                    continue;
                }
            }
            cout << "-1\n";
        }
    }
    return 0;
}
/*
5 3 7
1 1
1 2
1 4
1 5
3 1 1 3 2 3
3 1 1 3 2 5
3 1 1 3 5 7
*/
