// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <array>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	vector<int> f1(n + 1, -1), f2(n + 1, -1);
	for (int i = 0; i < m; i++) {
		if (f1[a[i]] == -1) f1[a[i]] = i;
	}
	for (int i = 0; i < m; i++) {
		f2[a[i]] = i;
	}
	vector<int> b(m);
	vector<array<int, 3> > seg;
	for (int i = 0; i <= n; i++) {
		if (f1[i] != -1) seg.push_back({ f1[i], f2[i], i });
	}
	/*for (int i = 0; i < (int)seg.size(); i++) {
		cout << seg[i][0] << ' ' << seg[i][1] << ' ' << seg[i][2] << endl;
	}*/
	vector<vector<array<int, 2> > > ev(m);
	for (int i = 0; i < (int)seg.size(); i++) {
		ev[seg[i][0]].push_back({ -1, seg[i][2] });
		ev[seg[i][1]].push_back({ 1, seg[i][2] });
	}
	vector<int> st;
	for (int i = 0; i < m; i++) {
		for (auto elem : ev[i]) {
			if (elem[0] == -1) {
				st.push_back(elem[1]);
				//cout << "add " << elem[1] << endl;
			}
		}
		b[i] = st.back();
		for (auto elem : ev[i]) {
			if (elem[0] == 1) {
				//cout << "? " << elem[1] << endl;
				if (st.back() != elem[1]) {
					cout << -1 << endl;
					return 0;
				}
				st.pop_back();
			}
		}
	}
	/*for (int i = 0; i < m; i++) {
		cout << b[i] << ' ';
	}
	cout << endl;*/
	if (b != a) {
		cout << -1 << endl;
		return 0;
	}
	cout << (int)seg.size() << endl;
	sort(seg.begin(), seg.end());
	for (int i = 0; i < (int)seg.size(); i++) {
		cout << seg[i][2] << ' ' << seg[i][0] + 1 << ' ' << seg[i][1] + 1 << endl;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
