#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

int main()
{
	freopen("input.txt", "r", stdin);
	ios :: sync_with_stdio(false);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> rows(n);
	vector<int> cols(m);
	for (int i = 1; i <= q; ++i)
	{
		int c;
		cin >> c;
		if (c == 1)
		{
			int r;
			cin >> r;			
			--r;
			rows[r] = i;
		}
		else if (c == 2)
		{
			int c;
			cin >> c;
			--c;
			cols[c] = i;
		}
		else
		{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1; --c1; --r2; --c2;	
			int mn = INF;
			//cout << i << endl;
			for (int j = 0; j < n; ++j)
			{
				if (i - rows[j] > k)
				{
					continue;
				}
				if (j != r1 && i - cols[c1] > k)
				{
					continue;
				}
				if (j != r2 && i - cols[c2] > k)
				{
					continue;
				}
				int cur = abs(r1 - j) + abs(c1 - c2) + abs(r2 - j);
				//cout << j << " " << cur << endl;
				mn = min(mn, cur);
			}
			for (int j = 0; j < m; ++j)
			{
				if (i - cols[j] > k)
				{
					continue;
				}
				if (j != c1 && i - rows[r1] > k)
				{
					continue;
				}
				if (j != c2 && i - rows[r2] > k)
				{
					continue;
				}
				int cur = abs(c1 - j) + abs(r1 - r2) + abs(c2 - j);
				mn = min(mn, cur);
			}
			bool good = true;
			for (int j = min(r1, r2); j <= max(r1, r2); ++j)
			{
				good = good && (i - rows[j] <= k);
			}
			if (good)
				mn = abs(r1 - r2) + abs(c1 - c2);
			good = true;
			for (int j = min(c1, c2); j <= max(c1, c2); ++j)
			{
				good = good && (i - cols[j] <= k);
			}
			if (good)
				mn = abs(r1 - r2) + abs(c1 - c2);
			if (mn == INF)
			{
				cout << -1 << endl;
			}
			else
			{
				cout << mn << endl;
			}
		}
	}
}
