#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long t;
    cin >> t;
    for(long long qwe = 0; qwe<t; qwe++){
        long long n, m, q, p;
        cin >> n >> m >> q >> p;
        vector<vector<pair<long long, long long> > > g(n);
        for(long long i = 0; i<m; i++){
            long long a, b, c;
            cin >> a >> b >> c;
            a--;
            b--;
            if(b<a)
                swap(a, b);
            g[a].push_back({b, c});
        }
        vector<set<long long> > ans(n);
        ans[0] = {0};
        for(long long i = 0; i<n; i++){
            for(long long j = 0; j<g[i].size(); j++){
                long long to = g[i][j].first, len = g[i][j].second;
                for(auto it = ans[i].begin(); it!=ans[i].end(); it++)
                    ans[to].insert((*it)+len);
            }
        }
        /*for(long long i = 0; i<n; i++){
            for(long long j = 0; j<ans[i].size(); j++)
                cout << ans[i][j] << ' ';
            cout << endl;
        }*/
        for(long long i = 0; i<q; i++){
            long long it, r;
            cin >> it >> r;
            it--;
            bool kek = true;
            for(auto it1 = ans[it].begin(); it1!=ans[it].end(); it1++){
                //cout << it << ':' << ans[it][j] << endl;
                if(r<=(*it1)&&(*it1)<=(r*p)/(p-1)){
                    kek = false;
                    cout << 1;
                    break;
                }
            }
            if(kek)
                cout << 0;
        }
        cout << '\n';
    }

    return 0;
}
/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44

1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34
*/
