#define REL
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <map>
#include <set>
#include <cassert>

#define mp make_pair
#define pb push_back
#define pp " "
#define nn "\n"
#define all(x) x.begin(), x.end()

using namespace std;

int n, m, q, p;
vector <vector <pair<int, int>>> g;
vector <vector <int>> d;
vector <bool> used;
int t;

void bfs() {
	queue<int> q;
	q.push(0);
	d[0].pb(0);
	used[0] = true;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); i++) {
			if (!used[g[v][i].first]) {
				used[g[v][i].first] = true;
				q.push(g[v][i].first);
			}
			for (int j = 0; j < d[v].size(); j++) {
				d[g[v][i].first].pb(d[v][j] + g[v][i].second);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		sort(all(d[i]));
		d[i].resize(unique(all(d[i])) - d[i].begin());
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		g.assign(n, vector <pair<int, int>>());
		d.assign(n, vector <int>());
		used.assign(n, false);
		int x, y, z;
		for (int i = 0; i < m; i++) {
			cin >> x >> y >> z;
			x--; y--;
			g[x].pb(mp(y, z));
		}
		bfs();
		for (int i = 0; i < q; i++) {
			cin >> x >> y;
			x--;
			int l = y, r = y * p / (p - 1);
			for (int j = 0; j < d[x].size(); j++) {
				if (d[x][j] >= l && d[x][j] <= r) {
					cout << 1;
					goto ext;
				}
			}
			cout << 0;
			ext:;
		}
		cout << nn;
	}
}