#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allar(a) a, a + n
#define allv(a) a.begin(), a.end()

#include <iostream>
#include <algorithm>
#include <math.h>
#include <string>
#include <string.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int inf = (int)1e9 + 7;
const int N = (int)5e3;
const int R = (int)1e4;

int n, m, q, p;
vector <pll> adj_list[N], radj_list[N];
bool dp[N][R + 1], used[N];

void d(int v) {
	if (!used[v]) {
		used[v] = true;
		rep(R + 1, i) {
			dp[v][i] = false;
			for (auto u : radj_list[v]) {
				d(u.first);
				if (u.second <= i && dp[u.first][i - u.second])
					dp[v][i] = true;
			}
		}
	}
}

void clear() {
	rep(n, i) {
		adj_list[i].clear();
		radj_list[i].clear();
		used[i] = false;
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int t; scanf("%d", &t);
	rep(t, o) {
		scanf("%d%d%d%d", &n, &m, &q, &p);
		rep(m, i) {
			ll v, u, d;
			scanf("%lld%lld%lld", &v, &u, &d); --v; --u;
			adj_list[v].push_back(mp(u, d));
			radj_list[u].push_back(mp(v, d));
		}
		dp[0][0] = true;
		used[0] = true;
		rep(n, i)
			d(i);
		rep(q, i) {
			int f, ans = 0;
			ll r;
			scanf("%d%lld", &f, &r); --f;
			ll r2 = r + r / (p - 1);
			for (ll cur = r; cur <= r2; ++cur) {
				if (dp[f][cur]) {
					ans = 1;
					break;
				}
			}
			printf("%d", ans);
		}
		printf("\n");
		clear();
	}
	return 0;
}