import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Deque;
import java.util.Scanner;

public class Main {
    public static void main(String[] arg) {
        new Main().run();
    }

    PrintWriter out;
    Scanner sc;
    int n;

    public void run() {
        out = new PrintWriter(System.out);
        sc = new Scanner(System.in);
        n = nextInt();
        solve();

        out.close();
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public String nextToken() {
        return sc.next();
    }

    public void solve() {
        int l = 1;
        int r = n + 1;

        boolean up = true;
        while (l != r - 1) {
            System.out.println("? " + (l + r) / 2);
            if (nextToken().equals("Yes")) {
                l = (l + r) / 2;
                up = true;
            } else {
                r = (l + r) / 2;
                up = false;
            }
        }

        System.out.println("? " + l);
        if (nextToken().equals("Yes")) {
            System.out.println("! " + l);
            if (nextToken().equals("Correct")) {
                solve();
            }
            return;
        } else {
            up = false;
        }

        System.out.println("? " + l);
        if (nextToken().equals("Yes")) {
            System.out.println("! " + l);
            if (nextToken().equals("Correct")) {
                solve();
            }
            return;
        } else {
            up = false;
        }

        if (up) {
            l = l + 1;
            r = n + 1;
        } else {
            r = l;
            l = 1;
        }


        while (l != r - 1) {
            System.out.println("? " + (l + r) / 2);
            if (nextToken().equals("Yes")) {
                l = (l + r) / 2;
                up = true;
            } else {
                r = (l + r) / 2;
                up = false;
            }
        }

        System.out.println("! " + l);
        if (nextToken().equals("Correct")) {
            solve();
        }
    }
}