#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 3e5 + 47;

vector<tuple<int, int, int>> ans;

int n, m, a[MAX_N], sz[MAX_N], pr[MAX_N], c[MAX_N], l[MAX_N], r[MAX_N], must[MAX_N];

int how[MAX_N];

bool ok[MAX_N];

int find(int u)
{
  if (pr[u] == u)
  {
    return u;
  }
  return pr[u] = find(pr[u]);
}

void merge(int a, int b, int cc)
{
  a = find(a);
  b = find(b);
  if (sz[a] > sz[b])
  {
    swap(a, b);
  }
  sz[b] += sz[a];
  pr[a] = b;
  c[b] = cc;
  l[b] = min(l[a], l[b]);
  r[b] = max(r[a], r[b]);
}

void $main()
{
  cin >> m >> n;
  set<int> s;
  set<int> kek;
  for (int i = 1; i <= m; i++)
  {
    cin >> a[i];
    must[a[i]]++;
    sz[i] = 1;
    pr[i] = i;
    c[i] = a[i];
    l[i] = i;
    r[i] = i;
    s.insert(a[i]);
  }
  vector<int> roots;
  if (sz[1] == must[a[1]])
  {
    roots.push_back(1);
    ok[1] = 1;
  }
  how[a[1]]++;
  for (int i = 2; i <= m; i++)
  {
    if (a[i] == a[i - 1])
    {
      merge(i, i - 1, a[i]);
    }
    else
    {
      how[a[i]]++;
    }
    int j = find(i);
    if (sz[j] == must[c[j]])
    {
      roots.push_back(j);
      ok[j] = 1;
    }
  }
  while (roots.size())
  {
    int u = roots.back();
    roots.pop_back();
    cerr << l[u] << ' ' << r[u] << ' ' << c[u] << endl;
    ans.push_back({c[u], l[u], r[u]});
    kek.insert(c[u]);
    int rr = r[u];
    int ll = l[u];
    if (rr + 1 <= m && !ok[find(rr + 1)])
    {
      merge(rr, rr + 1, c[find(rr + 1)]);
      if (ll - 1 >= 1)
      {
        if (c[find(ll - 1)] == c[find(rr + 1)])
        {
          how[c[find(ll - 1)]]--;
          merge(ll, ll - 1, c[find(rr + 1)]);
        }
      }
      if (how[find(rr + 1)] == 1)
      {
        ok[find(rr + 1)] = 1;
        roots.push_back(find(rr + 1));
      }
    }
    else if (ll - 1 >= 1 && !ok[find(ll - 1)])
    {
      merge(ll, ll - 1, c[find(ll - 1)]);
      if (rr + 1 <= m)
      {
        if (c[find(rr + 1)] == c[find(ll - 1)])
        {
          how[find(rr + 1)]--;
          merge(rr, rr + 1, c[find(rr + 1)]);
        }
      }
      if (how[find(ll - 1)] == 1)
      {
        ok[find(ll - 1)] = 1;
        roots.push_back(find(ll - 1));
      }
    }
  }
  for (int i = 1; i <= m; i++)
  {
    if (!ok[find(i)])
    {
      cout << -1;
      exit(0);
    }
  }
  reverse(ans.begin(), ans.end());
  if (s.size() == ans.size() && kek.size() == ans.size())
  {
    cout << ans.size() << '\n';
    for (auto [c, l, r] : ans)
    {
      assert(l >= 1 && l <= m);
      assert(r >= 1 && r <= m);
      assert(l <= r);
      cout << c << ' ' << l << ' ' << r << '\n';
    }
  }
  else
  {
    cout << -1;
  }
}

signed main()
{
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  #ifdef _47
    freopen("4.cpp", "r", stdin), freopen("7.cpp", "w", stdout);
  #endif // _47
  $main();
  return 0;
}
