#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <random>

#define ll long long
#define ld long double
#define F first
#define S second
#define ep emplace_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m, n;
	cin >> m >> n;
	int a[m], i;
	for (i = 0; i < m; i++){
		cin >> a[i];
		a[i]--;
	}

	int l[n], r[n];
	fill(l, l + n, -1);
	fill(r, r + n, -1);
	for (i = 0; i < m; i++)
		r[a[i]] = i;
	for (i = m - 1; i >= 0; i--)
		l[a[i]] = i;

	vector<pair<pair<int, int>, int> > tos;

	for (i = 0; i < n; i++){
		if (l[i] != -1)
			tos.push_back({{l[i], r[i]}, i});
	}
	sort(tos.begin(), tos.end());

	vector<pair<int, pair<int, int> > > q;
	for (auto &it : tos){
		q.push_back({it.F.F, {1, it.S}});
		q.push_back({it.F.S + 1, {0, it.S}});
	}
	sort(q.begin(), q.end());
/*
	for (i = 0; i < q.size(); i++)
		cout << q[i].F << ' ' << q[i].S.F << ' ' << q[i].S.S << endl;
*/
	vector<int> st;
	int cur = 0;
	for (i = 0; i < m; i++){
		while (cur < q.size() && q[cur].F == i){
			if (q[cur].S.F == 0)
				st.pop_back();
			else
				st.ep(q[cur].S.S);
			cur++;
		}
		if (st.empty() || st.back() != a[i]){
			//cout << "> " << i << ' ' << st.back() << endl;
			cout << -1;
			return 0;
		}
	}

	cout << q.size() << '\n';
	for (auto &it : tos)
		cout << it.S + 1 << ' ' << it.F.F + 1 << ' ' << it.F.S + 1 << '\n';
}