#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <random>

#define ll long long
#define ld long double
#define F first
#define S second
#define ep emplace_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 5e5 + 10;
vector<pair<int, ll> > g[N];
int n, m, q, p;

bool dfs_case_1(int v, int f, ll r, ll cur = 0){
	if (v == f)
		return (r * (p - 1) <= cur * (p - 1) && cur * (p - 1) <= r * p);

	for (auto e : g[v])
		if (dfs_case_1(e.F, f, r, cur + e.S))
			return true;
	return false;
}

void solve_case_1(){
	while (q--){
		int v;
		ll r;
		cin >> v >> r;
		v--;
		cout << (dfs_case_1(0, v, r) ? '1' : '0');
	}
	cout << '\n';
}

void solve(){
	cin >> n >> m >> q >> p;
	int i;
	for (i = 0; i < n; i++)
		g[i].clear();
	int v, u;
	ll c;
	for (i = 0; i < m; i++){
		cin >> v >> u >> c;
		v--, u--;
		g[v].ep(u, c);
	}

	if (n <= 10 && m <= 10 && q <= 10)
		solve_case_1();
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	while (t--)
		solve();

}