#include <bits/stdc++.h>

using namespace std;

const int St = 1;
const int Fn = 2;

struct Event {
    int x;
    int cl;
    int type;

    bool operator<(const Event other) const {
        return x < other.x;
    }
};

struct Ans {
    int cl;
    int l;
    int r;
};

int main() {
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> mn(m, -1);
    vector<int> mx(m, 0);
    vector<bool> used(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        used[a[i]] = true;
        if (mn[a[i]] == -1) {
            mn[a[i]] = i;
        }
        mx[a[i]] = max(mx[a[i]], i);
    }
    vector<Event> ev;
    for (int i = 0; i < m; i++) {
        if (used[i]) {
            ev.push_back({mn[i], i, St});
            ev.push_back({mx[i], i, Fn});
        }
    }
    sort(ev.begin(), ev.end());
    vector<Ans> ans;
    vector<int> ans1(n);
    stack<pair<int, int>> st;
    for (auto item: ev) {
        if (item.type == St) {
            st.push({item.cl, item.x});
        } else {
            if (st.top().first == item.cl) {
                ans.push_back({item.cl, st.top().second, item.x});
                st.pop();
            } else {
                cout << -1;
                return 0;
            }
        }
    }

    reverse(ans.begin(), ans.end());
    for (auto i: ans){
        fill(ans1.begin() + i.l, ans1.begin() + i.r + 1, i.cl);
    }
    if (ans1 != a){
        cout << -1;
        return 0;
    }
    cout << ans.size() << '\n';
    for (auto i: ans) {
        cout << i.cl + 1 << ' ' << i.l + 1 << ' ' << i.r + 1 << '\n';
    }

}