#include <bits/stdc++.h>

using namespace std;

struct Node {
    int u;
    long long w;
};

void dfs(int v, long long w, vector<vector<Node>> &ed, int f, vector<long long> &ans) {
    if (v == f) {
        ans.push_back(w);
        return;
    }
    for (auto u: ed[v]) {
        dfs(u.u, w + u.w, ed, f, ans);
    }
}

void solve() {
    int n, m, q;
    long long p;
    string anss = "";
    cin >> n >> m >> q >> p;
    vector<vector<Node>> ed(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        long long w;
        cin >> v >> u >> w;
        v--;
        u--;
        ed[v].push_back({u, w});
    }
    for (int i = 0; i < q; i++) {
        int f;
        long long r;
        cin >> f >> r;
        f--;
        vector<long long> ans;
        dfs(0, 0, ed, f, ans);
        bool ff = true;
        for (auto item: ans) {
            if (r <= item && item * (p - 1) <= p * r) {
                anss += "1";
//                cerr << 1;
                ff = false;
                break;
            }
        }
        if (ff) {
            anss += "0";
//            cerr<<0;
        }
    }
    cout << anss;
    cout << endl;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}