#include <bits/stdc++.h>
#define int long long
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define endl '\n'
using namespace std;
void solve();

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
const int inf = (int) 1e9 + 7;


void solve(){
    int n, t; cin >> n >> t;
    vector<int> a(n); forn (i, n) cin >> a[i];
    vector<int> fst(t + 1, inf), lst(t + 1, -inf);
    forn (i, n){
        fst[a[i]] = min(fst[a[i]], i);
        lst[a[i]] = max(lst[a[i]], i);
    }
    vector<int> lvl(t + 1, -1); int cur_lvl = 0;
    forn (i, n){
        if (i == fst[a[i]]){
            cur_lvl++;
            lvl[a[i]] = cur_lvl;
        }
        if (i == lst[a[i]]){
            cur_lvl--;
        }
    }
    vector<pair<pair<int, int>, pair<int, int>>> toans;
    forn (i, t + 1){
        if (lvl[i] != -1){
            toans.push_back({{lvl[i], i}, {fst[i], lst[i]}});
        }
    }
    sort(all(toans));


    vector<int> b(n); forn (i, n) b[i] = lvl[a[i]];
    for (auto i : toans){
        int mval = inf;
        for (int j = i.second.first; j <= i.second.second; ++j)
            mval = min(mval, b[j]);
        if (mval != i.first.first){
            cout << -1 << endl;
            return;
        }
    }

    cout << len(toans) << endl;
    for (auto i : toans){
        cout << i.first.second << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << endl;
    }
}