#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define ld long double
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)1e6 + 10;
const int INF = (int)1e9 + 10;

int c[MAXN], r[MAXN];

int solve()
{
    int n, m, q;
    cin >> n >> m >> q;
    for (int x = 1; x <= q; x++)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int a;
            cin >> a;
            r[a] = x;
        }
        if (t == 2)
        {
            int a;
            cin >> a;
            c[a] = x;
        }

        if (t == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            bool f1, f2, f3, f4;
            f1 = f2 = f3 = f4 = false;
            if (x - r[x1] <= k)
                f1 = 1;
            if (x - c[y1] <= k)
                f2 = 1;
            if (x - r[x2] <= k)
                f3 = 1;
            if (x - c[y2] <= k)
                f4 = 1;
            if (f1 && f4 || f2 && f3)
            {
                cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                continue;
            }
            if (f1 && f3)
            {
                int ans = INF;
                for (int i = 1; i <= m; i++)
                {
                    if (x - c[i] > k)
                        continue;
                    int cur = abs(y1 - i) + abs(y2 - i) + abs(x1 - x2);
                    ans = min(ans, cur);
                }
                bool f = true;
                for (int i = min(x1, x2); i <= max(x1, x2); i++)
                    if (x - r[i] > k)
                    {
                        f = false;
                        break;
                    }
                if (f)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                if (ans == INF)
                    cout << -1 << '\n';
                else
                    cout << ans << '\n';
                continue;
            }
            if (f2 && f4)
            {
                int ans = INF;
                for (int i = 1; i <= n; i++)
                {
                    if (x - r[i] > k)
                        continue;
                    int cur = abs(x1 - i) + abs(x2 - i) + abs(y1 - y2);
                    ans = min(ans, cur);
                }
                bool f = true;
                for (int i = min(y1, y2); i <= max(y1, y2); i++)
                    if (x - c[i] > k)
                    {
                        f = false;
                        break;
                    }
                if (f)
                    ans = abs(x1 - x2) + abs(y1 - y2);
                if (ans == INF)
                    cout << -1 << '\n';
                else
                    cout << ans << '\n';
                continue;
            }
            cout << -1 << '\n';
        }
    }
    return 0;
}

