import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;
import java.util.StringTokenizer;

public class A {
    static BufferedReader in;
    static StringTokenizer st;

    static int nextInt(){
        return Integer.parseInt(st.nextToken());
    }
    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        st = new StringTokenizer(in.readLine());
        PrintWriter out = new PrintWriter(System.out);
        int m = nextInt();
        int n = nextInt();
        st = new StringTokenizer(in.readLine());
        int mas[] = new int[m];
        for (int i = 0; i < m; i++) {
            mas[i] = nextInt() - 1;
        }
        int otr[][] = new int[n][3];
        for (int i = 0; i < n; i++) {
            otr[i][0] = -1;
            otr[i][1] = -1;
            otr[i][2] = i;
        }
        int k = 0;
        for (int i = 0; i < m; i++) {
            if (otr[mas[i]][0] == -1) {
                k++;
                otr[mas[i]][0] = i;
                otr[mas[i]][1] = i;
            }
            otr[mas[i]][1] = i;
        }


        boolean ans = true;
        int st[] = new int[n + 1];
        int tek = 1;
        st[0] = -1;
        for (int i = 0; i < m && ans; i++) {
            int pr = 0;
            if (otr[mas[i]][0] == i) {
                st[tek++] = mas[i];
                pr = 1;
            }
            if (st[tek - 1] != mas[i]) ans = false;
            if (otr[mas[i]][1] == i) {
                tek--;
            }
        }
        if (ans) {
            out.println(k);
            Arrays.sort(otr, new Comparator<int[]>() {
                @Override
                public int compare(int[] o1, int[] o2) {
                    if (o1[0] > o2[0]) return 1;
                    else if (o1[0] < o2[0]) return -1;
                    return 0;
                }
            });
            for (int i = 0; i < n; i++) {
                if (otr[i][0] != -1) {
                    out.println((otr[i][2] + 1) + " " + (otr[i][0] + 1) + " " + (otr[i][1] + 1));
                }
            }
        } else {
            out.println(-1);
        }
        out.close();
    }
}
