#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>

#define int long long

using namespace std;

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<int>> res(n);
    for (int i = 0; i < m; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        g[y - 1].push_back({x - 1, z});
    }
    res[0].push_back(0);
    for (int i = 0; i < n; i++) {
        for (auto from : g[i]) {
            for (int j : res[from.first]) {
                if (j + from.second <= 1e17) {
                    res[i].push_back(j + from.second);
                }
            }
        }
    }
    for (int i = 0; i < q; i++) {
        int v, r;
        cin >> v >> r;
        int f = 0;
        for (int j : res[v - 1]) {
            if ((p - 1) * r <= j * (p - 1) && j * (p - 1) <= p * r) {
                f = 1;
                break;
            }
        }
        cout << f;
    }
    cout << "\n";
}

int32_t main() {
#ifdef local
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}