#include "bits/stdc++.h"
#define ll long long
#define all(x) x.begin(), x.end()
#define ull unsigned long long
#define pb push_back


const ll inf = 1e18;


using namespace std;


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


void solve() {
    ll n, m, q, p;
    cin >> n >> m >> q >> p;
    vector<vector<pair<ll, ll>>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        g[a - 1].pb({b - 1, c});
    }
    vector<set<ll>> dp(n);
    dp[0].insert(0);
    vector<vector<ll>> res(n);
    for (int v = 0; v < n; v++) {
        for (auto can : dp[v]) {
            for (auto u : g[v]) {
                dp[u.first].insert(u.second + can);
            }
        }
        for (auto c : dp[v]) {
            res[v].pb(c);
        }
    }
    string ans(q, '0');
    for (int i = 0; i < q; i++) {
        ll T, R;
        cin >> T >> R;
        for (auto c : res[T - 1]) {
            if (R <= c and c * (p - 1) <= R * p) {
                ans[i] = '1';
                break;
            }
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    cout.precision(30);
    ll t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}