#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, n;
    cin >> m >> n;
    vector<int> seq(m);
    vector<pair<int, int> > s(n, {-1, -1});
    for (int i = 0; i < m; i++)
    {
        int a;
        cin >> a;
        seq[i] = a - 1;
        if (s[seq[i]].first == -1)
        {
            s[seq[i]].first = i;
        }
    }
    for (int i = m - 1; i >= 0; i--)
    {
        if (s[seq[i]].second == -1)
        {
            s[seq[i]].second = i;
        }
    }
    set<int> r;
    vector<pair<int, pair<int, int> > > answer;
    r.insert(s[seq[0]].second);
    answer.push_back({seq[0] + 1, {1, s[seq[0]].second + 1}});
    for (int i = 1; i < m; i++)
    {
        if (*r.rbegin() > i)
        {
            int t = *r.upper_bound(i);
            if (s[seq[i]].first < s[seq[t]].first)
            {
                cout << -1;
                return 0;
            }
        }
        if (s[seq[i]].first == i)
        {
            answer.push_back({seq[i] + 1, {i + 1, s[seq[i]].second + 1}});
            r.insert(s[seq[i]].second);
        }
    }
    cout << answer.size() << endl;
    for (int i = 0; i < answer.size(); i++)
    {
        cout << answer[i].first << " " << answer[i].second.first << " " << answer[i].second.second << endl;
    }
    return 0;
}
