#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        vector<vector<pair<int, long long> > > graph(n);
        for (int j = 0; j < m; j++)
        {
            int a, b;
            long long d;
            cin >> a >> b >> d;
            graph[a - 1].push_back({b - 1, d});
        }
        for (int j = 0; j < q; j++)
        {
            int f;
            long long r;
            cin >> f >> r;
            queue<pair<int, long long> > qu;
            qu.push({0, 0});
            bool good = false;
            while (!qu.empty())
            {
                pair<int, long long> v = qu.front();
                qu.pop();
                if (v.first == f - 1 && r <= v.second && v.second * (p - 1) <= p * r)
                {
                    cout << 1;
                    good = true;
                    break;
                }
                for (int k = 0; k < graph[v.first].size(); k++)
                {
                    qu.push({graph[v.first][k].first, v.second + graph[v.first][k].second});
                }
            }
            if (!good)
            {
                cout << 0;
            }
        }
        cout << endl;
    }
    return 0;
}
