#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x << ' ';
    cout << endl;
}

bool cmp(const vector<int> &a, const vector<int> &b)
{
    return a[1] - a[0] > b[1] - b[0];
}

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m, n;
    cin >> m >> n;
    vector<int> a(m);
    forn (i, m)
    {
        cin >> a[i];
        a[i]--;
    }

    vector<int> first(n, -1), last(n, -1);

    forn (i, m)
    {
        if (first[a[i]] == -1)
            first[a[i]] = i;
        last[a[i]] = i;
    }

    vector<vector<int> > event;
    forn (i, n)
    {
        if (first[i] != -1)
            event.pb({first[i], -1, i});
        if (last[i] != -1)
            event.pb({last[i], 1, i});
    }

    sort(all(event));

    //forn (i, sz(event))
    //    cout << event[i][0] << ' ' << event[i][1] << ' ' << event[i][2] << endl;
    //cout << endl;


    stack<int> st;
    forn (i, sz(event))
    {
        if (event[i][1] == -1)
        {
            st.push(event[i][2]);
        }
        else
        {
            if (st.empty())
            {
                cout << -1;
                return 0;
            }

            if (st.top() != event[i][2])
            {
                cout << -1;
                return 0;
            }

            st.pop();
        }
    }

    vector<vector<int> > res;
    forn (i, n)
    {
        if (last[i] == -1)
            continue;
        res.pb({first[i], last[i], i});
    }
    sort(all(res), cmp);

    cout << sz(res) << '\n';
    forn (i, sz(res))
        cout << ++res[i][2] << ' ' << ++res[i][0] << ' ' << ++res[i][1] << '\n';
    return 0;
}
