#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
#define sz(s) signed(s.size())

const int INF = 2e9;

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	unordered_map<int, int> row, col;
	for (int i = 1; i <= q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			row[r] = - i;
		} else if (t == 2) {
			int c;
			cin >> c;
			col[c] = - i;
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (max(row[r1] , col[c2]) <= k - i || max(row[r2], col[c1]) <= k - i) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			bool test = true;
			for (int x = min(r1, r2); x <= max(r1, r2); ++x) {
				if (row[x] > k - i) {
					test = false;
					break;
				}
			}
			if (!test) {
				test = true;
				for (int x = min(c1, c2); x <= max(c1, c2); ++x) {
					if (col[x] > k - i) {
						test = false;
						break;
					}
				}
			}
			if (test) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}

			int ans = INF;
			if (max(col[c1], col[c2]) <= k - i) {
				for (auto x : row) {
					if (x.sd <= k - i) {
						ans = min(ans, abs(c1 - c2) + abs(x.ft - r1) + abs(x.ft - r2));
					}
				}
			}
			if (max(row[r1], row[r2]) <= k - i) {
				for (auto x : col) {
					if (x.sd <= k - i) {
						ans = min(ans, abs(r1 - r2) + abs(x.ft - c1) + abs(x.ft - c2));
					}
				}
			}
			cout << (ans == INF ? -1 : ans) << '\n';
		}
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}