#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define int long long

const int MAXN = 5e5 + 5;

int n, m, q, p, QQ;
vector<pair<int, long long> > g[MAXN];
int maxd[MAXN], mind[MAXN];

bool ok(long long to, long long need) {
	return to >= need && to * (p - 1) <= need * p;
}

bool lw(long long to, long long need) {
	return to < need;
}

bool up(long long to, long long need) {
	return to * (p - 1) > need * p;
}

signed main() {
	cin >> QQ;
	while (QQ--) {
		cin >> n >> m >> q >> p;

		//cleaning up
		for (int i = 1; i <= n; ++i) {
			g[i].clear();
		}

		for (int i = 0; i < m; ++i) {
			int u, v;
			long long d;
			cin >> u >> v >> d;
			g[u].push_back({ v, d });
		}

		mind[1] = maxd[1] = 0;
		for (int i = 2; i <= n; ++i) {
			mind[i] = min(g[i - 1][0].second, g[i - 1][1].second) + mind[i - 1];
			maxd[i] = max(g[i - 1][0].second, g[i - 1][1].second) + maxd[i - 1];
		}

		string ans = "";

		for (int i = 0; i < q; ++i) {
			int f;
			long long d;
			bool found = 0;
			cin >> f >> d;
			set<long long> now = { 0 };
			for (int i = 1; i < d; ++i) {
				if (found) break;

				set<long long> nw;

				for (long long x : now) {
					if (found) break;
					if (ok(x + maxd[f] - maxd[i], d)) found = 1;
					if (ok(x + mind[f] - mind[i], d)) found = 1;
					if (!up(x + mind[f] - mind[i], d) && !lw(x + maxd[f] - maxd[i], d)) {
						nw.insert(x + g[i][0].second);
						nw.insert(x + g[i][1].second);
					}
				}

				now = nw;
			}

			if (!found) {
				for (long long x : now) {
					if (found) break;
					if (ok(x, d)) found = 1;
				}
			}

			if (found) ans += '1';
			else ans += '0';
		}

		cout << ans << "\n";
	}
	return 0;
}

/*

1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34


*/