#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define IDB if (debug)

typedef long long ll;
typedef pair <int, int> pii;
const bool debug = 0;

int xx[4] = {-1, 0, 1, 0};
int yy[4] = {0, -1, 0, 1};

int n, m, q, CNT, CUS;
vector <vector <int> > g, ans, us;

void read() {
    cin >> n >> m >> q;
    g.resize(n + 1, vector <int> (m + 1, 0));
    ans.resize(n + 1, vector <int> (m + 1, 0));
    us.resize(n + 1, vector <int> (m + 1, 0));
}

void upd(int s) {
    int r;
    cin >> r;
    r--;
    if (s == 1)
        for (int i = 0; i < m; i++)
            g[r][i] = CNT;
    else
        for (int i = 0; i < n; i++)
            g[i][r] = CNT;

//    IDB
//        for (int i = 0; i < n; i++)
//            for (int j = 0; j < m; j++)
//                cout << g[i][j] << " \n"[j == m - 1];
}

void req() {
    int sr, sc, fr, fc, k;
    cin >> sr >> sc >> fr >> fc >> k;
    sr--; sc--; fr--; fc--; k += CNT;
    CUS++;

//    IDB
//        for (int i = 0; i < n; i++)
//            for (int j = 0; j < m; j++)
//                cout << g[i][j] << " \n"[j == m - 1];
//
//    IDB cout << "!" << CNT << endl;

    if (g[sr][sc] > k) {
        cout << -1 << endl;
        return;
    }

    queue <pii> q;
    ans[sr][sc] = 0;
    us[sr][sc] = CUS;
    q.push({sr, sc});

    bool ok = 0;

    while (!q.empty()) {
        if (ok) break;
        int x = q.front().F, y = q.front().S;
        q.pop();

        for (int i = 0; i < 4; i++) {
            int nx = x + xx[i], ny = y + yy[i];
            if (nx < 0 || ny < 0 || nx >= n || ny >= m || us[nx][ny] == CUS || g[nx][ny] > k) continue;

            if (us[nx][ny] != CUS || ans[nx][ny] > ans[x][y] + 1) {
                ans[nx][ny] = ans[x][y] + 1;
                us[nx][ny] = CUS;
                q.push({nx, ny});

                if (nx == fr && ny == fc) {
                    ok = 1;
                    break;
                }
            }
        }
    }

    cout << (ok ? ans[fr][fc] : -1) << endl;
}

void solve() {
    while (q--) {
        CNT--;
        int op;
        cin >> op;
        if (op < 3) upd(op);
        else req();
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    IDB freopen("in.txt", "r", stdin);

    read();
    solve();
}
