#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define IDB if (debug)

typedef long long ll;
typedef pair <int, int> pii;
const int oo = 1e9 + 4;
const bool debug = 0;

int n, m, q, CNT;
vector <int> R, C;

void read() {
    cin >> n >> m >> q;
}

void make() {
    int KR, KC;
    KR = KC = 1;
    while (KR <= n) KR *= 2;
    while (KC <= m) KC *= 2;

    R.resize(2 * KR + 10, 0);
    C.resize(2 * KC + 10, 0);

    R[0] = KR;
    C[0] = KC;
}

void upd(auto &g, int pos, int val) {
    pos += g[0];
//    cout << g[0] << ' ' << pos << ' ' << g.size() << endl;
    g[pos] = val;
    pos /= 2;
    while (pos > 0) {
        g[pos] = min(g[2 * pos], g[2 * pos + 1]);
        pos /= 2;
    }
}

void upd(int s) {
    int r;
    cin >> r;
    r--;
    if (s == 1) upd(R, r, CNT);
//    else upd(C, r, CNT);

//    IDB
//        for (int i = 0; i < n; i++)
//            for (int j = 0; j < m; j++)
//                cout << g[i][j] << " \n"[j == m - 1];
}

int get_min(auto &g, int l, int r, int v, int tl, int tr) {
    if (r < tl || tr < l) return oo;
    if (l <= tl && tr <= r) return g[v];
    int m = (tl + tr) / 2;
    return min(get_min(g, l, r, 2 * v, tl, m), get_min(g, l, r, 2 * v + 1, m + 1, tr));
}

void req() {
    int sr, sc, fr, fc, k;
    cin >> sr >> sc >> fr >> fc >> k;
    sr--; sc--; fr--; fc--;

    int mn = get_min(R, min(fr, sr), max(fr, sr), 1, 0, R[0] - 1);

    cout << (CNT - mn > k ? -1 : abs(fr - sr) + abs(fc - sc)) << endl;
}

void solve() {
    make();
    while (q--) {
        CNT++;
        int op;
        cin >> op;
        if (op < 3) upd(op);
        else req();
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    IDB freopen("in.txt", "r", stdin);

    read();
    solve();
}
