#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define IDB if (debug)
#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
const int oo = 1e9 + 4;
const int SZ = 1e5 + 4;
const int SZ1 = 1e4 + 4;
const bool debug = 0;

int n, m, q;
ld p;
vector <vector <pair <int, ll> > > rg;
vector <bitset <SZ1> > ex;
bitset <SZ> us;
bitset <SZ1> st[SZ1 + 4];

void read() {
    cin >> n >> m >> q >> p;
    p /= p - 1.;
    vector < vector <pair <int, ll > > >().swap(rg);
    vector < bitset <SZ1> >().swap(ex);
    rg.resize(n + 10);
    ex.resize(n + 10);
    for (int i = 0; i < m; i++) {
        ll f, t, w;
        cin >> f >> t >> w;
        if (t < f) swap(f, t);
        rg[t - 1].push_back({f - 1, w});
    }
}

void dfs(int v) {
    if (us[v]) return;
    us[v] = 1;
    for (auto to : rg[v]) {
        dfs(to.F);
        if (to.S <= SZ1)
            ex[v] |= (ex[to.F] << to.S);
    }
//    IDB cout << v << ' ' << ex[v] << endl;
}

void make() {
    ex[0][0] = 1;
    us = 0;

    for (int i = 0; i < n; i++)
        dfs(i);

    st[0][0] = 1;
    for (int i = 1; i < SZ1; i++) {
        st[i] = st[i - 1];
        st[i] <<= 1;
        st[i][0] = 1;
    }
}

void solve() {
    read();
    make();
    while (q--) {
        ll f, r;
        cin >> f >> r;
        f--;
        ll R = floor(r * p);
        auto A = ex[f];
        A >>= r;

        IDB cout << A << endl;

        bitset <SZ1> B;

        B = st[R - r];

        IDB cout << B << endl;

        A &= B;

        IDB cout << r << ' '<< R << ' ' << A << endl;
        if (A != 0) cout << 1; else cout << 0;

        IDB cout << endl;
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    IDB freopen("in.txt", "r", stdin);

    int tst; cin >> tst;
    while(tst--)
    solve();
}
