#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

//#define int long long
#define sz(x) (int) x.size()
#define pii pair<int, int>
#define pb push_back

const int N = 3e5 + 5;
pii tree[4 * N];
vector <int> pos[N];
struct seg {
    int l, r, c;
};

bool operator < (seg a, seg b) {
    return a.l < b.l;
}

int need[N];
vector <seg> kr;

void add(int i, int l, int r, int nl, int nr, int c, int in) {
    if (l > nr || r < nl)
        return;
    if (l >= nl && r <= nr) {
        tree[i] = {in, c};
        return;
    }
    int m = (l + r) / 2;
    add(2 * i,l,m,nl,nr,c,in);
    add(2 * i + 1, m + 1, r,nl,nr,c,in);
}

pii get(int i, int l, int r, int pos) {
    if (l == r)
        return tree[i];
    int m = (l + r) / 2;
    if (pos <= m)
        return max(tree[i], get(2 * i,l,m,pos));
    return max(tree[i], get(2 * i + 1,m + 1, r, pos));
}

signed main() {
    int n, m;
    cin >> m >> n;
    for (int i = 0; i < m; ++i) {
        int c;
        cin >> c;
        need[i] = c;
        pos[c].pb(i);
    }
    for (int i = 1; i <= n; ++i) {
        if (sz(pos[i]))
            kr.pb({pos[i].front(), pos[i].back(), i});
    }
    sort(kr.begin(), kr.end());
    int cnt = 0;
    for (seg tmp : kr) {
        ++cnt;
       // cout << tmp.l << " "<<tmp.r << " " << tmp.c << endl;
        add(1, 0, m - 1, tmp.l, tmp.r, tmp.c, cnt);
    }
    for (int i = 0; i < m; ++i) {
        pii cur = get(1, 0, m - 1, i);
      //  cout << i << " " << cur.second << endl;
        if (cur.second != need[i]) {
            cout << -1;
            return 0;
        }
    }
    cout << sz(kr) << endl;
    for (seg tmp : kr) {
        cout<< tmp.c << " " << tmp.l+1 <<  " " << tmp.r +1<< endl;
    }
    return 0;
}
