#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define fast ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define INF 10000000
const int N = 1000000;
int tnma[N * 4];
int tmma[N * 4];
int tmmi[N * 4];
int tnmi[N * 4];
int pn[N * 4];
int pm[N * 4];
int stn[N * 4];
int stm[N * 4];
int en[N * 4];
int em[N * 4];
int an[N];
int am[N];

void buildn(int v, int l, int r, int p = -1) {
    if (l + 1 == r) {
        pn[v] = p;
        stn[l] = v;
        en[v] = l;
        return;
    }
    pn[v] = p;
    int m = (l + r) / 2;
    buildn(v * 2, l, m, v);
    buildn(v * 2 + 1, m, r, v);
}

void buildm(int v, int l, int r, int p = -1) {
    if (l + 1 == r) {
        pm[v] = p;
        stm[l] = v;
        em[v] = l;
        return;
    }
    pm[v] = p;
    int m = (l + r) / 2;
    buildm(v * 2, l, m, v);
    buildm(v * 2 + 1, m, r, v);
}

int getnmi(int v, int l, int r, int lf, int rf) {
    if (l >= rf || lf >= r) {
        return INF;
    }
    if (l >= lf && r <= rf) {
        return tnmi[v];
    }
    int m = (l + r) / 2;
    return min(getnmi(v * 2, l, m, lf, rf), getnmi(v * 2 + 1, m, r, lf, rf));
}

int getmmi(int v, int l, int r, int lf, int rf) {
    if (l >= rf || lf >= r) {
        return INF;
    }
    if (l >= lf && r <= rf) {
        return tmmi[v];
    }
    int m = (l + r) / 2;
    return min(getmmi(v * 2, l, m, lf, rf), getmmi(v * 2 + 1, m, r, lf, rf));
}

int getnma(int v, int l, int r, int lf, int rf) {
    if (l >= rf || lf >= r) {
        return -INF;
    }
    if (l >= lf && r <= rf) {
        return tnma[v];
    }
    int m = (l + r) / 2;
    return max(getnma(v * 2, l, m, lf, rf), getnma(v * 2 + 1, m, r, lf, rf));
}

int getmma(int v, int l, int r, int lf, int rf) {
    if (l >= rf || lf >= r) {
        return -INF;
    }
    if (l >= lf && r <= rf) {
        return tmma[v];
    }
    int m = (l + r) / 2;
    return max(getmma(v * 2, l, m, lf, rf), getmma(v * 2 + 1, m, r, lf, rf));
}

void sm(int l, int x) {
    int v = stm[l];
    tmmi[v] = x;
    tmma[v] = x;
    v = pm[v];
    while (v != -1) {
        tmma[v] = max(tmma[v * 2], tmma[v * 2 + 1]);
        tmmi[v] = min(tmmi[v * 2], tmmi[v * 2 + 1]);
        v = pm[v];
    }
}

void sn(int l, int x) {
    int v = stn[l];
    tnmi[v] = tnma[v] = x;
    v = pn[v];
    while (v != -1) {
        tnma[v] = max(tnma[v * 2], tnma[v * 2 + 1]);
        tnmi[v] = min(tnmi[v * 2], tnmi[v * 2 + 1]);
        v = pn[v];
    }
}

int psn(int l, bool m, int x) {
    int v = stn[l];
    int k = 0;
    while (tnmi[v] > x && v != -1) {
        v = pn[v];
        k++;
    }
    if (v == -1) {
        return -1;
    }
    for (int i = 0; i < k; i++) {
        if (m) {
            v *= 2;
            if (tnmi[v] > x) {
                v++;
            }
        } else {
            v *= 2;
            v++;
            if (tnmi[v] > x)
                v--;
        }
    }
    return en[v];
}

int psm(int l, bool m, int x) {
    int v = stm[l];
    int k = 0;
    while (tmmi[v] > x && v != -1) {
        v = pm[v];
        k++;
    }
    if (v == -1) {
        return -1;
    }
    for (int i = 0; i < k; i++) {
        if (m) {
            v *= 2;
            if (tmmi[v] > x) {
                v++;
            }
        } else {
            v *= 2;
            v++;
            if (tmmi[v] > x)
                v--;
        }
    }
    return em[v];
}

int tb[50][50];
int lvl[50][50];
int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, 1, -1};

int main() {
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    for (int w = 0; w < q; w++) {
        int k;
        cin >> k;
        if (k == 3) {
            vector<vector<bool>> us(n, vector<bool>(m));
            queue<pair<int, int>> qw;
            int r1, c1, r2, c2, x;
            cin >> r1 >> c1 >> r2 >> c2 >> x;
            x -= w + 1;
            r1--;
            c1--;
            r2--;
            c2--;
            qw.push({r1, c1});
            tb[r1][c1] = 0;
            if(lvl[r1][c1] > x)
            {
                cout<<-1<<'\n';
                continue;
            }
            us[r1][c1] = true;
            while (!qw.empty()) {
                int i = qw.front().first;
                int j = qw.front().second;
                qw.pop();
                for (int e = 0; e < 4; e++) {
                    int ii = i + dx[e];
                    int jj = j + dy[e];
                    if (!(ii >= 0 && jj >= 0 && ii < n && jj < m))
                        continue;
                    if (us[ii][jj] || lvl[ii][jj] > x)
                        continue;
                    tb[ii][jj] = tb[i][j] + 1;
                    qw.push({ii, jj});
                    us[ii][jj] = true;
                }
            }
            if (us[r2][c2]) {
                cout << tb[r2][c2] << '\n';
            } else {
                cout << -1 << '\n';
            }
        }
        if (k == 1) {
            int t;
            cin >> t;
            t--;
            for (int i = 0; i < m; i++) {
                lvl[t][i] = -w - 1;
            }
        }
        if (k == 2) {
            int t;
            cin >> t;
            t--;
            for (int i = 0; i < n; i++) {
                lvl[i][t] = -w - 1;
            }
        }
    }
}