#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct go
{
	int c, l, r;
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	for (int& i : a)
		cin >> i;
	vector<int> arr(n + 1, -1);
	for (int i = 0; i < m; i++)
	{
		arr[a[i]] = i;
	}
	vector<bool> used(n + 1, false);
	int col = 0, last = -1;
	for (int i = 0; i < m; i++)
	{
		if (used[a[i]] && last >= i && col != a[i])
		{
			cout << -1;
			return 0;
		}
		used[a[i]] = true;
		last = arr[a[i]];
		col = a[i];
	}
	vector<go> ans;
	used.assign(n + 1, false);
	for (int i = 0; i < m; i++)
	{
		if (!used[a[i]])
		{
			ans.push_back({ a[i], i + 1, arr[a[i]] + 1 });
			used[a[i]] = true;
		}
	}
	cout << ans.size() << '\n';
	for (go i : ans)
	{
		cout << i.c << " " << i.l << " " << i.r << '\n';
	}
	return 0;
}