#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <ll, ll> pll;
typedef pair <int, int> pii;

#define all(a) a.begin(), a.end()
#define mp make_pair
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
template <typename T1, typename T2> inline void chkMin(T1 &x, T2 y) {if (x > y) x = y;}

const int MAXN = 1e4 + 100;

ll n, m, q, p;

vector <pll> g[MAXN];
bitset <MAXN> b[MAXN];

void solve(){
	cin >> n >> m >> q >> p;
	for (int i = 0; i < n; i++){
		g[i].clear();
		for (int j = 0; j < MAXN; j++){
			b[i][j] = 0;
		}
	}
	for (int i = 0; i < m; i++){
		ll u, v, c;
		cin >> u >> v >> c; u--, v--;
		g[u].push_back(mp(v, c));
	}
	b[0][0] = 1;
	for (int u = 0; u < n; u++){
		for (auto p : g[u]){
			ll v = p.first, c = p.second;
			if (c >= MAXN) continue;
			b[v] |= b[u] << c;
		}
	}
	for (int i = 0; i < q; i++){
		ll u, c;
		cin >> u >> c; u--;
		bool fl = false;
		for (ll d = c; d <= (p * c) / (p - 1); d++){
			if (b[u][d]){
				fl = true;
				break;
			}
		}
		cout << (fl ? 1 : 0);
	}
	cout << '\n';
	return;
}

int main(){
	i_o;
	int t;
	cin >> t;
	while (t--){
		solve();
	}
	return 0;
}