#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("rename-registers")

#define ALL(a) (a).begin(), (a).end()
#define endl "\n"

typedef long long ll;
typedef long double ld;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

struct edge {
    int to;
    ll x;
};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int tt;
    cin >> tt;
    for (int t = 0; t < tt; t++) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        assert(m == 2 * n - 2);

        vector<vector<edge>> g(n);
        for (int i = 0; i < m; i++) {
            ll u, v, d;
            cin >> u >> v >> d;
            u--; v--;
            g[u].push_back({v, d});
        }
        for (int i = 0; i < n - 1; i++) {
            if (g[i][0].x > g[i][1].x) swap(g[i][0], g[i][1]);
        }

        for (int qq = 0; qq < q; qq++) {
            int f;
            ll r;
            cin >> f >> r;
            f--;

            ll now = 0;
            vector<ll> a;
            for (int i = 0; i < f; i++) {
                now += g[i][0].x;
                a.push_back(g[i][1].x - g[i][0].x);
            }
            sort(ALL(a));

            if (now * (p - 1) > r * p) {
                cout << 0;
                continue;
            }
            if (now >= r) {
                cout << 1;
                continue;
            }

            bool go = 0;
            for (int i = a.size() - 1; i >= 0; i--) {
                if (now + a[i] < r) now += a[i];
                else if ((now + a[i]) * (p - 1) <= r * p) {
                    go = 1;
                }
            }

            cout << go;
        }

        cout << endl;
    }

    return 0;
}

/*

1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34

*/

