//#pragma GCC optimaze("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
typedef long long ll;

ll n, m, p, q;

void dfs(ll v, vector<vector<pair<ll, ll> > >& g, ll s, vector<vector<ll> > pd, vector<ll>& orb, vector<ll>& ans) {
	for (auto to : pd[v]) {
		if (s >= (p - 1) * orb[to] && s <= p * orb[to])
			ans[to] = 1;
	}
	for (auto to : g[v]) {
		dfs(to.first, g, s + to.second, pd, orb, ans);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		vector<vector<pair<ll, ll> > > g(n);
		for (int i = 0, x, y, z; i < m; ++i) {
			cin >> x >> y >> z;
			--x, --y;
			g[x].push_back({ y, z });
		}
		vector<ll> ans(q);
		vector<vector<ll> > pd(n);
		vector<ll> orb(q);
		for (int i = 0, x, y; i < q; ++i) {
			cin >> x >> y;
			--x;
			pd[x].push_back(i);
			orb[i] = y;
		}

		dfs(0, g, 0, pd, orb, ans);
		for (int i = 0; i < q; ++i)
			cout << ans[i];
		cout << '\n';
	}
	return 0;
}


/*


1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120 
3 4 4
4 90
4 2
4 10
4 37
2 34





*/