#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define forn(i, s, f) for(int i = s; i < f; ++i)
#define pii pair <int, int>
#define fs first
#define sc second
#define pb push_back
#define ll long long
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector <int> a, L, R;
vector <vector <int>> ans;
vector <bool> used;
vector <int> tr, to_add;

void push(int v, int vl, int vr) {
    if (to_add[v] == -1)
        return;
    if (vr - vl != 1)
        to_add[2 * v] = to_add[2 * v + 1] = to_add[v];
    tr[v] = to_add[v];
    to_add[v] = -1;
}

void upd(int v, int vl, int vr, int l, int r, int x) {
    push(v, vl, vr);
    if (vr <= l || r <= vl)
        return;
    if (l <= vl && vr <= r) {
        to_add[v] = x;
        push(v, vl, vr);
        return;
    }
    int vm = vl +vr >> 1;
    upd(2 * v, vl, vm, l, r, x), upd(2 * v + 1, vm, vr, l, r, x);
}

int get(int v, int vl, int vr, int i) {
    push(v, vl, vr);
    if (vr - vl == 1)
        return tr[v];
    int vm = vl + vr >> 1;
    if (i < vm)
        return get(2 * v, vl, vm, i);
    else
        return get(2 * v + 1, vm, vr, i);
}
int m;

void go(int l, int r) {
    if (r - l < 0)
        return;
    if (a[l] == get(1, 0, m, l)) {
        go(l + 1, r);
        return;
    }
    if (a[r] == get(1, 0, m, r)) {
        go(l, r - 1);
        return;
    }
    //cout << l << " " << r << "  " << a[l] << " " << a[r] << "\n";;
    if (a[l] == a[r]) {
        if (used[a[l]])
            cout << -1, exit(0);
        upd(1, 0, m, l, r + 1, a[l]);
        used[a[l]] = 1;
        ans.pb({a[l], l, r});
        go(l + 1, r - 1);
        return;
    }
    if (R[a[l]] >  L[a[r]])
        cout << -1, exit(0);
    if (used[a[l]])
        cout << -1, exit(0);
    if (used[a[r]])
        cout << -1, exit(0);
    used[a[l]] = used[a[r]] = 1;
    ans.pb({a[l], l, R[a[l]]}), ans.pb({a[r], L[a[r]], r});
    upd(1, 0, m, l, R[a[l]] + 1, a[l]);
    upd(1, 0, m, L[a[r]], r + 1, a[r]);
    go(l + 1, R[a[l]] - 1), go(R[a[l]] + 1, L[a[r]] - 1), go(L[a[r]] + 1, r - 1);
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int n;
	cin >> m >> n;
	a.resize(m);
	L.resize(n, m), R.resize(n, -1);
	forn (i, 0, m) {
        cin >> a[i], a[i]--;
        L[a[i]] = min(L[a[i]], i), R[a[i]] = max(R[a[i]], i);
	}
	tr.resize(4 * m, -1), to_add.resize(4 * m, -1);
	used.resize(n);
    go(0, m - 1);
    cout << sz(ans) << "\n";
    forn (i, 0, sz(ans))
        cout << ans[i][0] + 1 << " " << ans[i][1] + 1 << " " << ans[i][2] + 1 << "\n";
	return 0;
}
