#include <bits/stdc++.h>

using namespace std;

struct Item
{
    int l, r, clr;
};

int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> v(n), l(m + 1, n), r(m + 1);
    for(int &e : v) cin >> e;
    for(int i = 0; i < n; i++)
    {
        l[v[i]] = min(l[v[i]], i);
        r[v[i]] = max(r[v[i]], i);
    }
    vector<Item> g;
    for(int i = 1; i <= m; i++)
    {
        if(l[i] != n) g.push_back({l[i], r[i], i});
    }
    sort(g.begin(), g.end(), [](Item a, Item b)
         {
             return a.r > b.r;
         });
    vector<int> c(n);
    for(auto i : g)
    {
        c[i.l] = i.clr;
    }
    stack<int> last;
    last.push(c[0]);
    for(int i = 1; i < n; i++)
    {
        if(c[i]) last.push(c[i]);
        while(r[last.top()] < i) last.pop();
        c[i] = last.top();
    }
    //for(int i : c) cout << i << " "; cout << endl;
    if(c == v)
    {
        cout << g.size() << endl;
        for(auto i : g) cout << i.clr << " " << i.l + 1 << " " << i.r + 1 << endl;
    }
    else cout << -1;
}

/*
7 10
10 5 5 10 4 2 4
*/
