#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define printvi(arr) for (int x: arr) cout << x << " "; cout << endl;
#define myreverse(arr) reverse(arr.begin(), arr.end())
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define F first
#define S second
#define ll long long
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvpll vector<vpll>
#define vll vector<ll>
#define vvll vector<vll>

const int maxn = 3e5 + 2;
const int inf = 2 * 1024 * 1024 * 1023 - 1;
const ll inf1 = inf;
const ll INF = inf1 * inf1;

bool request(int x){
    cout << "? " << x << endl;
    fflush(stdout);
    string resp;
    cin >> resp;
    return (resp[0] == 'Y');
}

int main() {
    init();
    int n;
    cin >> n;
    while(true) {
        int l = 1, r = n;
        bool flag = 0;
        while (l != r) {
            int m = (l + r + 1) / 2;
            bool b1 = request(m);
            bool b2 = b1;
            if (!flag) b2 = request(m);
            if (b1 != b2) {
                flag = 1;
                b2 = request(m);
            }
            if (b2) l = m; else r = m - 1;
        }
        cout << "! " << l << endl;
        fflush(stdout);
        string resp;
        cin >> resp;
        if (resp[0] == 'D') break;
    }
    return 0;
}
/*
 2
 3 3 5 20
 1 2 20
 2 3 1
 1 3 10
 2 19
 2 20
 3 20
 3 21
 3 9
 7 10 5 5
 1 2 15
 1 3 10
 2 4 21
 3 4 30
 2 5 14
 3 5 31
 4 6 3
 5 6 14
 1 7 39
 5 7 13
 7 42
 7 43
 7 44
 5 39
 6 44
 */
