#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>


using namespace std;


#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;

        int v, u, d;

        vector<int> ws(n - 1);

        vector<int> voff(n - 1);

        for (int i = 0; i < m; ++i) {
            cin >> v >> u >> d;

            --v;
            --u;

            if (ws[v]) {
                voff[v] = min(ws[v], d);
                ws[v] = abs(ws[v] - d);
            } else {
                ws[v] = d;
            }
        }

        vector<int> off(n);
        for (int i = 0; i < n - 1; ++i) {
            off[i + 1] = off[i] + voff[i];
        }

        int f, r;

        for (int cq = 0; cq < q; ++cq) {
            cin >> f >> r;
            --f;

            int lb = r - off[f];
            int ub = r * p / (p - 1) - off[f];

            bool b;
            if (ub < 0) {
                b = false;
            } else {
                for (int i = 0; i < f; ++i) {
                    int cur = ws[i];

                    if (cur > ub) {
                        continue;
                    }

                    lb -= cur;
                }

                b = (lb <= 0);
            }

            cout << b;
        }

        cout << '\n';
    }

    return 0;
}


/*

1
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9

*/