#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 1e+6 + 2;

vector<int> tree;

void upd(int v, int tl, int tr, int pos, int val){
	if(tl + 1 == tr){
		tree[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	if(pos < tm) upd(2 *v + 1, tl, tm, pos, val);
	else upd(2 * v + 2, tm, tr, pos, val);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int tl, int tr, int l, int r){
	if(l >= r) return -1e+9;
	if(tl + 1 == tr){
		return tree[v];
	}
	int tm = (l + r) / 2;
	return max(get(2 * v + 1, tl, tm, l, min(r, tm)), get(2 * v + 2, tm, tr, max(l, tm), tr));
}

signed main(){
	int n, m, q;
	cin >> n >> m >> q;
	tree.resize(4 * n, 0);
	int r, c, rr, cc;
	int rw;
	int t;
	//vector<int> row(n, 0), col(m, 0);
	for(int i = 0; i < q; i++){
		cin >> t;
		if(t == 1){
			cin >> rw;
			rw--;
			//row[rw] = -i - 1;
			upd(0, 0, n, rw, - i - 1);
		}
		else if(t == 2) continue;
		else{
			cin >> r >> c >> rr >> cc;
			r--, c--, rr--, cc--;
			int k;
			cin >> k;
			int pth = get(0, 0, n, min(r, rr), max(r, rr) + 1);
			if(pth + i + 1 > k){
				cout << -1 << endl;
			}
			else{
				cout << abs(r - rr) + abs(c - cc) << endl;
			}
		}
	}
}