#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>

using namespace std;

#define int long long


void solve(){
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	vector<vector<pair<int, int> > > g(n);
	for(int i = 0; i < m; i++){
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].push_back(make_pair(v, w));
	}
	vector<set<int> > aval(n);
	aval[0].insert(0);
	for(int i = 0; i < n; i++){
		for(int j: aval[i]){
			for(auto to: g[i]){
				aval[to.first].insert(to.second + j);
			}
		}
	}
	for(int i = 0; i < q; i++){
		int f, r;
		cin >> f >> r;
		f--;
		int l = r, ri = (r * p) / (p - 1);
		auto a = aval[f].lower_bound(l), b = aval[f].upper_bound(ri);
		if(a == b) cout << 0;
		else cout << 1;
	}
	cout << endl;
}

signed main(){
	int t;
	cin >> t;
	for(int i = 0; i < t; i++){
		solve();
	}
}