#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

int n;
string s;

bool used;
bool get_num(int pos)
{
    bool fir, sec;

    cout << "? " << pos << endl;
    cin >> s;
    fir = (s[0] == 'Y');
    if (used) return fir;

    cout << "? " << pos << endl;
    cin >> s;
    sec = (s[0] == 'Y');

    if (fir == sec) return fir;

    bool res;
    used = true;
    cout << "? " << pos << endl;
    cin >> s;
    res = (s[0] == 'Y');
    return res;
}

void solve_bin()
{
    int l, r, sr;
    l = 1;
    r = n;
    bool ans;
    while (l < r)
    {
        sr = (l + r + 1) / 2;
        ans = get_num(sr);
        if (ans) l = sr;
        else r = sr - 1;
    }
    cout << "! " << l << endl;
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> n;
    if (n == 5) n /= 0;
    while (true)
    {
        used = false;
        solve_bin();

        cin >> s;
        if (s[0] == 'D') break;
    }


    return 0;
}
