#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
   
using namespace std;
using namespace __gnu_pbds;
   
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T> using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
  
#define all(x) (x).begin(), (x).end()
//#define int long long
  
void FAST_IO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n;
bool was = false;

bool ask(int x) {
	string res;
	int a = 0, b = 0;
	cout << "? " << x << endl;
	cin >> res;
	a += (res == "Yes");
	b += (res == "No");
	if (was) {
		if (a == 1) {
			return 1;
		}
		if (b == 1) {
			return 0;
		}
	}
	cout << "? " << x << endl;
	cin >> res;
	a += (res == "Yes");
	b += (res == "No");
	if (a == 2) {
		return 1;
	}
	if (b == 2) {
		return 0;
	}
	was = true;
	cout << "? " << x << endl;
	cin >> res;
	a += (res == "Yes");
	b += (res == "No");
	if (a == 2) {
		return 1;
	}
	if (b == 2) {
		return 0;
	}
}

void solve() {
	int lf = 1, rg = n + 1, mid;
	while (lf + 1 < rg) {
		mid = (lf + rg) >> 1;
		if (ask(mid)) {
			lf = mid;
		}
		else {
			rg = mid;
		}
	}
	cout << "! " << lf << endl;
	string nxt;
	cin >> nxt;
	if (nxt == "Done") {
		exit(0);
	}
}
  
signed main() {
    FAST_IO();
    cin >> n;
    while (true) {
    	was = false;
    	solve();
    }
}