#include<algorithm>
#include<iostream>
#include<utility>
#include<vector>
using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first) return a.first < b.first;
	return a.second > b.second;
}

int main()
{
	int n, m;
	cin >> m >> n;
	vector<int> first(n + 1), last(n + 1);
	vector<vector<int>> pos(n + 1);

	for (int i = 1, c; i <= m; i++)
	{
		cin >> c;
		pos[c].push_back(i);
		last[c] = i;
		if (first[c] == 0) first[c] = i;
	}

	vector<pair<int, int>> line;

	for (int i = 1; i <= n; i++)
	{
		if (pos[i].size() > 1)
		{
			for (int j = 1; j < pos[i].size(); j++)
			{
				line.push_back({ pos[i][j - 1], i });
				line.push_back({ pos[i][j], -i });
			}
		}
	}

	sort(line.begin(), line.end(), cmp);
	vector<int> st;

	for (int i = 0; i < line.size(); i++)
	{
		if (line[i].second > 0)
		{
			st.push_back(line[i].second);
		}
		else
		{
			if (st.empty() || st.back() != -line[i].second)
			{
				cout << -1;
				return 0;
			}
			else
			{
				st.pop_back();
			}
		}
	}

	if (!st.empty())
	{
		cout << -1;
		return 0;
	}

	vector<pair<pair<int, int>, int>> ans;
	for (int i = 1; i <= n; i++)
	{
		if (first[i] != 0)
		{
			ans.push_back({ { first[i], last[i] }, i });
		}
	}

	sort(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i].second << ' ' << ans[i].first.first << ' ' << ans[i].first.second << '\n';
	}
}