#include<algorithm>
#include<iostream>
#include<utility>
#include<vector>
using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first) return a.first < b.first;
	return a.second > b.second;
}

int main()
{
	int n, m;
	cin >> m >> n;
	vector<int> first(n + 1), last(n + 1), v(m + 1);

	for (int i = 1, c; i <= m; i++)
	{
		cin >> c;
		v[i] = c;
		last[c] = i;
		if (first[c] == 0) first[c] = i;
	}

	vector<pair<pair<int, int>, int>> ans;
	vector<pair<int, int>> line;
	for (int i = 1; i <= n; i++)
	{
		if (first[i] != 0)
		{
			ans.push_back({ { first[i], last[i] }, i });
			line.push_back({ first[i], i });
			line.push_back({ last[i], -i });
		}
	}

	vector<int> res(m + 1), st;
	sort(line.begin(), line.end(), cmp);
	int lst_p = 1, lst_c = 0;
	for (int i = 0; i < line.size(); i++)
	{
		if (line[i].second > 0)
		{
			while (lst_p < line[i].first)
			{
				res[lst_p++] = lst_c;
			}
			st.push_back(line[i].second);
			lst_c = line[i].second;
		}
		else
		{
			while (lst_p <= line[i].first)
			{
				res[lst_p++] = lst_c;
			}
			if (st.empty())
			{
				cout << -1;
				return 0;
			}
			st.pop_back();
			if (st.empty())
			{
				lst_c = 0;
			}
			else
			{
				lst_c = st.back();
			}
		}
	}

	for (int i = 1; i <= m; i++)
	{
		if (res[i] != v[i])
		{
			cout << -1;
			return 0;
		}
	}

	sort(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i].second << ' ' << ans[i].first.first << ' ' << ans[i].first.second << '\n';
	}
}