#include<algorithm>
#include<iostream>
#include<utility>
#include<vector>
#include<string>
#include<bitset>
#include<assert.h>
using namespace std;

const int N = 5e5 + 1, N_dp = 5e3 + 1;

vector<pair<int, long long>> r_g[N];
bitset<3 * N_dp> dp[N_dp];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		for (int i = 0, v, u; i < m; i++)
		{
			long long c;
			cin >> v >> u >> c;
			r_g[u].push_back({ v, c });
		}
		dp[1][0] = true;
		for (int i = 2; i <= n; i++)
		{
			for (auto u : r_g[i])
			{
				dp[i] |= (dp[u.first] << u.second);
			}
		}
		
		int f;
		long long r;
		string ans;
		while (q--)
		{
			cin >> f >> r;
			bool flag = false;
			for (long long j = r; j * (p - 1) <= r * p; j++)
			{
				assert(j < 3 * N_dp);
				flag |= dp[f][j];
			}
			if (flag)
			{
				ans += '1';
			}
			else
			{
				ans += '0';
			}
		}

		cout << ans << '\n';

		for (int i = 1; i <= n; i++)
		{
			r_g[i].clear();
			dp[i].reset();
		}
	}
}