#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e18;

struct node
{
	ll minn;
	node *l, *r;

	node() : minn(0), l(NULL), r(NULL) {};
};

ll getmin(node * t)
{
	if (t == NULL)
		return inf;
	return t->minn;
}

void upd(node *& t, ll tl, ll tr, ll pos, ll nval)
{
	if (tl == tr)
		t->minn = nval;
	else
	{
		ll tm = (tl + tr) / 2;

		if (pos <= tm)
		{
			if (t->l == NULL)
				t->l = new node();

			upd(t->l, tl, tm, pos, nval);
		}
		else
		{
			if (t->r == NULL)
				t->r = new node();

			upd(t->r, tm + 1, tr, pos, nval);
		}

		t->minn = min(getmin(t->l), getmin(t->r));
	}
}

ll get(node *t, ll tl, ll tr, ll l, ll r)
{
	if (l > r)
		return inf;

	if (tl == l && r == tr)
		return t->minn;

	ll tm = (tl + tr) / 2;

	if (t->l == NULL)
		t->l = new node();



	if (t->r == NULL)
		t->r = new node();

	return min(get(t->l, tl, tm, l, min(tm, r)), get(t->r, tm + 1, tr, max(tm + 1, l), r));

}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll  n, m, q;

	scanf("%lld%lld%lld", &n, &m, &q);//cin >> n >> m >> q;


	node * root = new node();

	for (int it = 1; it <= q; ++it)
	{


		ll type;

		scanf("%lld", &type);//cin >> type;

		if (type == 1)
		{
			ll ii;
			scanf("%lld", &ii);//cin >> ii;
			--ii;

			upd(root, 0, n - 1, ii, it);

		}
		else if (type == 2)
		{


		}
		else
		{
			ll i1, j1, i2, j2, k;

			scanf("%lld%lld%lld%lld%lld", &i1, &j1, &i2, &j2, &k);//cin >> i1 >> j1 >> i2 >> j2 >> k;
			--i1;
			--j1;
			--i2;
			--j2;

			ll ans = get(root, 0, n - 1, min(i1, i2), max(i1, i2));

			if (it - ans > k)
				printf("-1\n");//cout << -1 << endl;
			else
				printf("%lld\n", abs(i1 - i2) + abs(j2 - j1));//cout << abs(i1 - i2) + abs(j2 - j1) << endl;
		}

	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/