#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long

void solve() {
	int n, m;
	cin >> m >> n;
	vector <int> a(m);
	for (auto& i : a) {
		cin >> i;
		--i;
	}
	vector <int> f(n, -1), l(n, -1);
	for (int i = m - 1; i >= 0; --i) f[a[i]] = i;
	for (int i = 0; i < m; ++i) l[a[i]] = i;
	vector <pair <pair <int, int>, pair <int, int>>> otr;
	for (int i = 0; i < n; ++i) {
		if (f[i] == -1) continue;
		otr.push_back({ {l[i] - f[i] + 1, i} , {f[i], l[i]} });
	}
	sort(otr.rbegin(), otr.rend());
	//
	set <pair <int, int>> order;
	vector < pair <int, pair <int, int>>> events;
	for (int i = 0; i < otr.size(); ++i) {
		events.push_back({ otr[i].second.first, {-1, i} });
		events.push_back({ otr[i].second.second + 1, {1, i} });
	}
	sort(events.begin(), events.end());
	int p = 0;
	for (int i = 0; i < m; ++i) {
		while (p < events.size() && events[p].first == i) {
			int ind = events[p].second.second;
			int color = otr[ind].first.second;
			if (events[p].second.first == -1) {
				order.insert({ ind, color });
			}
			else {
				order.erase({ ind, color });
			}
			++p;
		}
			int bi = -1;
			if (order.size()) {
				auto it = *order.rbegin();
				bi = it.second;
			}
			if (a[i] != bi) {
				cout << "-1\n";
				return;
			}
	}
	//
	cout << otr.size() << "\n";
	for (auto& i : otr) {
		cout << i.first.second + 1 << " " << i.second.first + 1 << " " << i.second.second + 1 << "\n";
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef _DEBUG
	cout << "Execution time: " << (clock() + 0.0) / 1000 << "s.\n";
#endif
}