#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair < ll, ll > pii;
typedef double db;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) ll(x.size())
#ifndef MY
    #define endl '\n'
#endif // MY

//const ll N = 5e5 + 5;
//vector < pii > gr[N];
//bool fl = 0;
//
//void clr(ll n) {
//    for (ll i = 0; i < n; i++) {
//        {
//            vector < pii > a;
//            swap(gr[i], a);
//        }
//    }
//}
//
//void dfs(ll v, ll f, ll r, ll p, ll sum = 0) {
//    if (v == f) {
//        if (sum >= r && (p - 1) * sum <= r * p) {
//            fl = true;
//        }
//        return;
//    }
//    if (fl)
//        return;
//    for (auto k : gr[v]) {
//        ll u = k.F, w = k.S;
//        dfs(u, f, r, p, sum + w);
//    }
//}
//
//bool ok(ll f, ll r, ll p) {
//    fl = false;
//    dfs(0, f, r, p);
//    return fl;
//}
//
//void solve() {
//    ll n, m, q, p;
//    cin >> n >> m >> q >> p;
//    for (ll i = 0; i < m; i++) {
//        ll v, u, d;
//        cin >> v >> u >> d;
//        v--, u--;
//        gr[v].pb({u, d});
//    }
//    for (ll i = 0; i < n; i++)
//        sort(all(gr[i]));
//    for (ll i = 0; i < q; i++) {
//        ll f, r;
//        cin >> f >> r;
//        f--;
//        cout << ok(f, r, p);
//    }
//    cout << endl;
//    clr(n);
//}

ostream & operator << (ostream & out, set < ll > & lst) {
    for (auto k : lst)
        out << k << ' ';
    out << endl;
    return out;
}

const ll N = 5e5 + 5;
vector < ll > inp[N];
set < ll > dp[N];
ll lst[N];
ll sum[N];

void clr(ll n) {
    for (ll i = 0; i < n; i++) {
        inp[i].clear();
        {
            set < ll > a;
            swap(dp[i], a);
        }
        lst[i] = 0;
        sum[i] = 0;
    }
}

void build(ll n) {
    dp[0] = {0};
    for (ll i = 1; i < n; i++) {
        for (auto j : dp[i - 1]) {
            dp[i].insert(j);
            dp[i].insert(lst[i - 1] + j);
        }
        //cout << dp[i];
    }
}

bool ok(ll v, ll r, ll p) {
    if (sum[v] * (p - 1) > r * p)
        return false;
    ll k = r * p / (p - 1) - sum[v];
    if (k == 0)
        return false;
    auto hm = upper_bound(all(dp[v]), k);
//    if (hm == dp[v].begin())
//        return false;
    hm--;
    ll res = *hm;
    return sum[v] + res >= r;
}

void solve2() {
    ll n, m, q, p;
    cin >> n >> m >> q >> p;
    assert(m == 2 * n - 2);
    for (ll i = 0; i < m; i++) {
        ll v, u, d;
        cin >> v >> u >> d;
        inp[v - 1].pb(d);
    }
    ll s = 0;
    for (ll i = 0; i < n; i++) {
        sum[i] = s;
        if (i + 1 == n)
            continue;
        sort(all(inp[i]));
        s += inp[i][0];
        lst[i] = inp[i][1] - inp[i][0];
    }
    build(n);
    for (ll i = 0; i < q; i++) {
        ll f, r;
        cin >> f >> r;
        cout << ok(f - 1, r, p);
    }
    cout << endl;
    clr(n);
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.in", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve2();
    }

    return 0;
}
