#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> rr(n + 1, 0), cc(m + 1, 0);
    vector<int> x = {0, 1, 0, -1};
    vector<int> y = {1, 0, -1, 0};
    vector<vector<int> > used(n + 1), zz(n + 1);
    for (int i = 0; i <= n; i++) {
        used[i].resize(m + 1, -1);
        zz[i].resize(m + 1, 0);
    }
    int cnt = 1;
    for (int i = 1; i <= q; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int r;
            cin >> r;
            rr[r] = i;
            continue;
        }
        if (type == 2) {
            int c;
            cin >> c;
            cc[c] = i;
            continue;
        }
        int r1, c1, r2, c2, k;
        cin >> r1 >> c1 >> r2 >> c2 >> k;
        if (i - rr[r1] > k && i - cc[c1] > k) {
            cout << -1 << '\n';
            continue;
        }
        if (i - rr[r2] > k && i - cc[c2] > k) {
            cout << -1 << '\n';
            continue;
        }
        if (i - rr[r1] <= k && i - cc[c2] <= k) {
            cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
            continue;
        }
        if (i - rr[r2] <= k && i - cc[c1] <= k) {
            cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
            continue;
        }
        queue<pair<pair<int, int>, int> > q;
        q.push({{r1, c1}, 0});
        bool flag = false;
        while (!q.empty()) {
            pair<int, int> tmp = q.front().first;
            int d = q.front().second;
            q.pop();
            used[tmp.first][tmp.second] = d;
            zz[tmp.first][tmp.second] = cnt;
            if (tmp.first == r2 && tmp.second == c2) {
                cout << d << '\n';
                flag = true;
                break;
            }
            for (int j = 0; j < 4; j++) {
                if (tmp.first + x[j] <= n && tmp.first + x[j] >= 1 && tmp.second + y[j] <= m && tmp.second + y[j] >= 1 && i - max(rr[tmp.first + x[j]], cc[tmp.second + y[j]]) <= k) {
                    if (zz[tmp.first + x[j]][tmp.second + y[j]] < cnt) {
                        q.push({{tmp.first + x[j], tmp.second + y[j]}, d + 1});
                        zz[tmp.first + x[j]][tmp.second + y[j]] = cnt;
                    }
                }
            }
        }
        cnt++;
        if (!flag) {
            cout << -1 << '\n';
        }
    }
    return 0;
}
