#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>

using namespace std;

typedef int64_t ll;

vector<vector<pair<ll, ll>>> g;
vector<vector<pair<ll, ll>>> seg;
ll n, m, q, p;

int main() {
#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif

	int t;
	cin >> t;
	while (t--) {
		g.clear();
		seg.clear();
		cin >> n >> m >> q >> p;
		g.resize(n);
		seg.resize(n);
		for (ll i = 0; i < m; ++i) {
			ll v, u, w;
			cin >> v >> u >> w;
			g[v - 1].emplace_back(u - 1, w);
		}
		seg[0].emplace_back(0, 0);
		for (ll i = 1; i < n; ++i) {
			for (auto j : seg[i - 1]) {
				ll d = g[i - 1][0].second;
				seg[i].emplace_back(d * ((p - 1) / p) + j.first, d * (p / (p - 1)));
				d = g[i - 1][1].second;
				seg[i].emplace_back(d * ((p - 1) / p) + j.first, d * (p / (p - 1)));
			}
			vector<pair<ll, ll>> a;
			for (auto j : seg[i]) {
				a.emplace_back(j.first, 1);
				a.emplace_back(j.second, 2);
			}
			sort(a.begin(), a.end());
			ll cnt = 0;
			seg[i].clear();
			ll left;
			for (ll j = 1; j < a.size(); ++j) {
				if (a[j].second == 1) {
					if (cnt == 0) {
						left = a[j].first;
					}
					++cnt;
				}
				if (a[j].second == 2) {
					--cnt;
					if (cnt == 0) {
						seg[i].emplace_back(left, a[j]);
					}
				}
			}
		}
		string res;
		for (ll i = 0; i < q; ++i) {
			ll v, x;
			cin >> v >> x;
			bool f = false;
			for (auto j : seg[v]) {
				if (x >= j.first && x <= j.second) {
					f = true;
				}
			}
			if (f) {
				res.push_back('1');
			}
			else {
				res.push_back('0');
			}
		}
	}
	return 0;
}
