#include <bits/stdc++.h>
using namespace std;

const int inf = (int)1e9;

vector<int> a;
vector<int> rmq;
vector<int> p;

void push(int t, int l, int r) {
    if (!p[t]) return;
    if (r - l == 1) {
        rmq[t] += p[t];
        p[t] = 0;
        return;
    }
    p[t * 2 + 1] += p[t];
    p[t * 2 + 2] += p[t];
    rmq[t * 2 + 1] += p[t];
    rmq[t * 2 + 2] += p[t];
    p[t] = 0;
    rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
}

int get(int t, int l, int r, int x, int y) {
    if (y <= l || r <= x) return -inf;
    if (x <= l && r <= y) return rmq[t];
    int m = (l + r) / 2;
    return max(get(t * 2 + 1, l, m, x, y), get(t * 2 + 2, m, r, x, y));
}

void add1() {
    p[0] += 1;
    rmq[0] += 1;
}

void upd(int t, int l, int r, int x, int y) {
    if (y <= l || r <= x) return;
    push(t, l, r);
    if (x <= l && r <= y) {
        rmq[t] = 0;
        return;
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, y);
    upd(t * 2 + 2, m, r, x, y);
    rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
}

signed main() {
    ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    int n, m, q;
    cin >> n >> m >> q;
    a.resize(n);
    rmq.resize(n * 4);
    p.resize(n * 4);
    for (int i = 0; i < q; ++i) {
        add1();
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            --r;
            upd(0, 0, n, r, r + 1);
        }
        else if (t == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (r1 > r2) swap(r1, r2);
            if (get(0, 0, n, r1 - 1, r2) <= k) cout << (abs(r2 - r1) + abs(c2 - c1));
            else cout << -1;
            cout << "\n";
        }
    }
    return 0;
}