#include <bits/stdc++.h>

#define mp make_pair

using namespace std;

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

int n;
vector<int> a;

int get(int x) {
    if (x == 0) {
        int res = 0;
        for (int i = 0; i < n; ++i) {
            res += a[i];
        }
        return res;
    }
    int cnt = 0;
    int pos = 0;
    int tp = 0;
    int bal = 0;
    while (pos < n) {
        if (tp == 1 && a[pos] == 1) {
            tp = 0;
            ++cnt;
        }
        if (tp == 0 && a[pos] == 0) {
            ++bal;
            if (bal == x) {
                bal = 0;
                ++cnt;
                tp = 1;
            }
        }
        ++pos;
    }
    if (cnt < 3) {
        return 0;
    }
    if (cnt % 2 == 0) {
        --cnt;
    }
    return ((cnt + 1) / 2) * x + cnt / 2;
}

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        a[i] = c - '0';
    }
    pair<int, int> res = mp(0, 0);
    int l = 0;
    int r = n;
    while (l + 2 < r) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        if (get(m1) < get(m2)) {
            l = m1;
        } else {
            r = m2;
        }
    }
    for (int i = l; i <= r; ++i) {
        if (uax(res.first, get(i))) {
            res.second = i;
        }
    }
    cout << res.first << "\n";
    int cur = 0;
    while (res.first > 0) {
        if (cur == 0) {
            for (int i = 0; i < res.second; ++i) {
                cout << "0";
                --res.first;
            }
        } else {
            cout << "1";
            --res.first;
        }
        cur ^= 1;
    }
    cout << "\n";
    return 0;
}
