#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define all(v) v.begin(), v.end()

const long long MOD = 998244353;

struct Item {
	long long r, c, v;
	pair<long long, long long> mp() { return { r, c }; }
};
istream& operator>>(istream &in, Item &it) { return in >> it.r >> it.c >> it.v; }
bool operator<(Item a, Item b) { return a.mp() < b.mp(); }

const long long N = 1e5;
const long long INF = 1e9 + 7;
long long n, m, arr[3 * N];

long long main() {
	long long k;
	cin >> n >> m >> k;
	vector<Item> lov(k);
	for (long long i = 0; i < k; ++i) cin >> lov[i];
	sort(all(lov));
	long long ans = 0;
	for (auto l : lov) {
		arr[l.r - l.c + N] = l.v;
		ans = (ans + l.v) % MOD;
	}
	cerr << ans << endl << endl;
	for (long long i = 2; i < n; ++i) {
		long long d = max(arr[i - 1 + N], min(arr[(i - 1) - 1 + N], arr[(i - 1) + 1 + N])) * min(n - i, m - 1);
		cerr << d << endl;
		ans = (ans + d) % MOD;
	}
	cerr << endl;
	for (long long i = 2; i < m; ++i) {
		long long d = max(arr[-i + N], min(arr[(1 - i) - 1 + N], arr[(1 - i) + 1 + N])) * min(m - i, n - 1);
		ans = (ans + d) % MOD;
		cerr << d << endl;
	}
	cerr << endl;
	long long d = max(arr[N], min(arr[N - 1], arr[N + 1])) * min(n - 1, m - 1);
	cerr << d << endl << endl;
	ans = (ans + d) % MOD;
	cout << (ans + MOD) % MOD << endl;
	system("pause");
	return 0;
}
/*
3 3 3
2 3 -2
3 1 3
1 2 1
*/
/*
4 4 7
1 4 1
2 4 2
3 4 1
4 4 1
4 1 2
4 2 1
4 3 3
*/