#include <iostream>
#include <vector>
#include <string>

using namespace std;

vector<int> pf(vector<char> &s) {
	vector<int> p(s.size());
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j != 0 && s[i] != s[j]) j = p[j - 1];
		p[i] = j + (s[i] == s[j]);
	}
	return p;
}

int main() {
	int m, n;
	cin >> m >> n;
	string fn; cin >> fn;
	vector<char> s;
	for (int i = 0; i < m; ++i) s.push_back(fn[i]);
	s.push_back('#');
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			string t;
			cin >> t;
			for (int j = 0; j < t.size(); ++j) s.push_back(t[j]);
		}
		else {
			int pos, len;
			cin >> pos >> len;
			pos = pos + m;
			for (int i = pos; i < pos + len; ++i) s.push_back(s[i]);
		}
	}
	vector<int> p = pf(s);
	int ans = 0;
	for (int i = m + 1; i < s.size(); ++i) ans += (p[i] >= m);
	cout << ans << endl;
	system("pause");
	return 0;
}
/*
3 4
aba
1 ab
2 1 3
2 3 3
2 1 8
*/