#include "pch.h"
#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;
#define int long long

ifstream in("input.txt");
#define cin in

vector<int> z_func(string s)
{
	int n = s.length();
	vector<int> z(n);
	z[0] = 0;
	int l = 0, r = 0;
	for (int i = 1; i < n; i++)
	{
		if (i < r)
		{
			z[i] = min(r - i, z[i - l]);
			int pos = r;
			if (i + z[i] == r)
			{
				while (pos < n && s[pos] == s[z[i]])
				{
					z[i]++;
					pos++;
				}
			}
		}
		else
		{
			int pos = i;
			while (pos < n && s[pos] == s[pos - i])
			{
				z[i]++;
				pos++;
			}
		}
		if (z[i] > 0 && i + z[i] > r)
		{
			r = i + z[i];
			l = i;
		}
	}
	return z;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	string p;
	cin >> p;
	string s = "";
	for (int k = 0; k < m; k++)
	{
		int op;
		cin >> op;
		if (op == 1)
		{
			string a;
			cin >> a;
			s += a;
		}
		else
		{
			int a, b;
			cin >> a >> b;
			for (int i = a - 1; i < a + b - 1; i++)
			{
				s += s[i];
			}
		}
	}
	int ans = 0;
	vector<int> a = z_func(p + "#" + s);
	for (int i = p.size() + 1; i < a.size(); i++)
	{
		if (a[i] == p.size())
		{
			ans++;
		}
	}
	cout << ans;
}
