#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define L first
#define R second

const int p = 998244353;

using namespace std;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, m, k;
    cin >> m >> n >> k;

    vector<pair<int, int>> p(k);
    for(int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        p[i] = {x, y};
    }
    vector< vector< int > > s(m, vector< int >(n * 2));
    for(int i = 0; i < m; i++){
        for(int j = 0; j < 2 * n; j++){
            int x;
            cin >> x;
            s[i][j] = x;
        }
        sort(s[i].begin(), s[i].end());
    }

    vector<int> minimals(n);
    vector<int> maximals(n);

    for(int i = 0; i < n; i++){
        minimals[i] = s[0][2 * i];
        maximals[i] = s[0][2 * i + 1];
    }
    /*for(int i = 1; i < m; i++){
        for(int j = 0; j < n; j++){
            minimals[j] = min(s[i][2 * j], minimals[j]);
            maximals[j] = max(s[i][2 * j + 1], maximals[j]);
        }
    }*/

    int answer = 0;
    for(int j = 0; j < n; j++){
        int ans = 1000000000;
        for(int h = 0; h < k; h++){
            int sum = 0;
            for(int i = 0; i < m; i++){
                if(!(s[i][2 * j] >= p[h].L && s[i][j * 2] <= p[h].R)){
                    sum += min(abs(s[i][j * 2] - p[h].L), abs(s[i][j * 2] - p[h].R));
                }
                if(!(s[i][2 * j + 1] >= p[h].L && s[i][j * 2 + 1] <= p[h].R)){
                    sum += min(abs(s[i][j * 2 + 1] - p[h].L), abs(s[i][j * 2 + 1] - p[h].R));
                }
            }
            ans = min(ans, sum);
        }
        answer += ans;
    }

    cout << answer;

    return 0;
}