#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

const int p = 998244353;

using namespace std;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, m, k;
    cin >> n >> m >> k;

    vector< vector<int> > a(n + 1, vector<int>(m + 1, 0));
    vector< vector<bool> > b(n + 1, vector<bool>(m + 1, false));

    for(int i = 0; i < k; i++){
        int x, y, z;
        cin >> x >> y >> z;
        x--, y--;
        a[x][y] = z;
        b[x][y] = true;
    }
    for(int i = 0; i < n; i++){
        b[i][m] = true;
    }
    for(int i = 0; i <= m; i++){
        b[n][i] = true;
    }
    int sum = 0;
    for(int i = n - 1; i >= 0; i--){
        for(int j = m - 1; j >= 0; j--){
            if(!b[i][j]){
                if(b[i + 1][j]){
                    a[i][j] = a[i + 1][j];
                }else{
                    a[i][j] = max(a[i + 2][j], a[i + 1][j + 1]);
                }
                if(b[i][j + 1]){
                    a[i][j] = min(a[i][j], a[i][j + 1]);
                }else{
                    a[i][j] = min(a[i][j], max(a[i][j + 2], a[i + 1][j + 1]));
                }
            }
            sum += a[i][j];
            sum %= p;
        }
    }

    if(sum < 0) sum += p;

    cout << sum;

    return 0;
}