#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;

const ll inf = 1e18, mod = 998244353;
int n, m, k;
ll g[5][1000000][2], f[5][1000000], ans;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> k;
	m = min(m, 1000000);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < min(1000000, m); j++)
			f[i][j] = inf;
	while (k--)
	{
		int r, c, v;
		cin >> r >> c >> v;
		if(c <= m)
			f[r - 1][c - 1] = v;
	}
	if (f[n - 1][m - 1] != inf)
		g[n - 1][m - 1][0] = g[n - 1][m - 1][1] = f[n - 1][m - 1];
	for (int j = m - 2; j >= 0; j--)
	{
		if (f[n - 1][j] != inf)
			g[n - 1][j][0] = g[n - 1][j][1] = f[n - 1][j];
		else
		{
			g[n - 1][j][0] = max(0ll, g[n - 1][j + 1][1]);
			g[n - 1][j][1] = min(0ll, g[n - 1][j + 1][0]);
		}
	}
	for (int i = n - 2; i >= 0; i--)
	{
		if (f[i][m - 1] != inf)
			g[i][m - 1][0] = g[i][m - 1][1] = f[i][m - 1];
		else
		{
			g[i][m - 1][0] = max(0ll, g[i + 1][m - 1][1]);
			g[i][m - 1][1] = min(0ll, g[i + 1][m - 1][0]);
		}
	}
	for (int i = n - 2; i >= 0; i--)
		for (int j = m - 2; j >= 0; j--)
			if (f[i][j] != inf)
				g[i][j][0] = g[i][j][1] = f[i][j];
			else
			{
				g[i][j][0] = max(g[i][j + 1][1], g[i + 1][j][1]);
				g[i][j][1] = min(g[i][j + 1][0], g[i + 1][j][0]);
			}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			ans += g[i][j][1];
			//cout << g[i][j][1] << ' ';
		}
		//cout << '\n';
	}
	ans %= mod;
	ans += mod;
	cout << ans % mod;
	return 0;
}