#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <string>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;

int n, m, t[2000];
ll ans, pos[2000], len[2000];
string p, s, w[2000];

void calc_z_function(const string& s, vector<int>& z)
{
	for (int i = 1, l = 0, r = 0; i < s.length(); i++)
	{
		if (i < r)
			z[i] = min(z[i - l], r - i);
		while (i + z[i] < s.length() && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] > r)
		{
			l = i;
			r = i + z[i];
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> m >> n >> p;
	bool ch = true;
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
		if (i > 0)
			ch &= (t[i] == 2);
		if (t[i] == 1)
			cin >> w[i];
		else
		{
			cin >> pos[i] >> len[i];
			ch &= (pos[i] == 1 && len[i] % w[0].length() == 0);
		}
	}
	if (!ch)
	{
		for (int i = 0; i < n; i++)
		{
			if (t[i] == 1)
				s += w[i];
			else
			{
				pos[i]--;
				while (len > 0)
				{
					s += s[pos[i]];
					pos[i]++;
					len[i]--;
				}
			}
		}
		s = p + '#' + s;
		vector <int> z(s.length());
		calc_z_function(s, z);
		for (int i = p.length() + 1; i < s.length(); i++)
			ans += (z[i] == p.length());
		cout << ans;
		return 0;
	}
	ll pov = 1, povt = 0;
	for (int i = 1; i < n; i++)
		pov += len[i] / w[0].length();
	string s = "";
	while (povt < pov && s.length() < 2 * p.length())
	{
		s += w[0];
		povt++;
	}
	string ss = p + '#' + s;
	vector <int> z(ss.length());
	calc_z_function(ss, z);
	for (int i = p.length() + 1; i < p.length() + 1 + w[0].length(); i++)
	{
		if (z[i] == p.length())
		{
			ll pos = i - p.length() - 1;
			ll fin = pos + p.length() - 1;
			ll bl = fin / w[0].length();
			ans += pov - bl;
		}
	}
	cout << ans;
	return 0;
}