#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
#define int ll
#define pb push_back
#define kek pop_back
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define len(v) ((int)(v).size())
#define mp make_pair
 
template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
 
template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
 
const int INF = 1e18 + 666;
 
void run();
 
signed main() {
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}
 
const int mod = 998244353;
 
void run() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> points(k, vector<int>(3));
	for (auto &x : points) {
		for (auto &v : x) {
			cin >> v;
		}
		--x[0], --x[1];
	}
	sort(all(points), [](const vector<int> &v1, const vector<int> &v2) {
		return v1[1] < v2[1];
	});
	vector<int> events;
	for (auto &x : points) {
		for (int i = 0; i < 10; ++i) {
			if (x[1] - i >= 0) {
				events.pb(x[1] - i);
			}
		}
	}
	events.pb(-1);
	sort(all(events));
	events.resize(unique(all(events)) - events.begin());
	reverse(all(events));
	reverse(all(points));
	vector<int> mx(n + 1, 0), mn(n + 1, 0), pmx(n + 1, 0), pmn(n + 1, 0);
	int prv = 0;
	int pit = 0;
	int ans = 0;
	for (auto &x : events) {
		int sm = accumulate(all(pmn), 0ll);
		ans += sm * (prv - x);
		ans %= mod;
		mn.assign(n + 1, INF);
		mx.assign(n + 1, INF);
		mx[n] = 0;
		mn[n] = 0;
		while (pit < len(points) && points[pit][1] >= x) {
			mn[points[pit][0]] = points[pit][2];
			mx[points[pit][0]] = points[pit][2];
			++pit;
		}
		for (int i = n - 1; i > -1; --i) {
			if (mn[i] != INF) {
				continue;
			}
			mn[i] = min(pmx[i], mx[i + 1]);
			mx[i] = max(pmn[i], mn[i + 1]);
		}
		prv = x;
		swap(mx, pmx);
		swap(mn, pmn);
	}
	ans %= mod;
	ans += mod;
	ans %= mod;
	cout << ans << endl;
}