#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <iostream>


using namespace std;


#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math"
#define mod 998244353
#define x first
#define y second
#define int long long

int32_t main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n, m, k, r, c, v;
	cin >> n >> m >> k;
	vector<vector<pair<int, int>>> a(n, vector<pair<int, int>>(m, { 1e9, -1e9 }));
	for (int i = 0; i < k; i++)
	{
		cin >> r >> c >> v;
		r--;
		c--;
		a[r][c] = { v, v };
	}
	int ans = 0;
	pair<int, int> ttt = { 1e9, -1e9 };
	for (int i = n - 1; i >= 0; i--)
	{
		for (int j = m - 1; j >= 0; j--)
		{
			if (a[i][j] != ttt)
			{
				ans += a[i][j].x;
				continue;
			}
			if (i == n - 1 || j == m - 1)
			{
				a[i][j].x = min(a[i][j].x, 0);
				a[i][j].y = max(a[i][j].y, 0);
			}
			if (i + 1 < n)
			{
				a[i][j].x = min(a[i][j].x, a[i + 1][j].y);
				a[i][j].y = max(a[i][j].y, a[i + 1][j].x);
			}
			if (j + 1 < m)
			{
				a[i][j].x = min(a[i][j].x, a[i][j + 1].y);
				a[i][j].y = max(a[i][j].y, a[i][j + 1].x);
			}
			ans += a[i][j].x;
			ans %= mod;
		}
	}
	if (ans < 0) ans += mod;
	cout << ans;
	system("pause");
	return 0;
}