#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
#define int ll
const int INF = 1e9;
const int MOD = 1e9 + 7;
mt19937 rng(time(0));

int n, m;
string s, t;

int T = 179;
int tpow[MAXN];
int H = 0;

void init() {
	tpow[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		tpow[i] = (tpow[i - 1] * T) % MOD;
	}
	for (auto c : s) {
		H = (H * T + c - 'a' + 1) % MOD;
	}
}

void solve() {
	init();
	vector<int> cp;
	ll sum_b = 0;
	for (int i = 0; i < m; i++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			string x;
			cin >> x;
			for (auto c : x) {
				t.push_back(c);
			}
		}
		else {
			int a, b;
			cin >> a >> b;
			a--;
			sum_b += b;
			if (sum_b > 2e7) {
				cp.push_back(b);
			}
			else {
				for (int j = a; j < a + b; j++) {
					t.push_back(t[j]);
				}
			}
		}
	}
	sort(cp.begin(), cp.end());
	int h1 = 0;
	int pnt = 0;
	int ans = 0;
	for (int i = 0; i < t.size(); i++) {
		while (pnt < cp.size() && cp[pnt] == i) {
			pnt++;
		}
		h1 = (h1 * T + t[i] - 'a' + 1) % MOD;
		if (i >= s.size()) {
			h1 -= (t[i - s.size()] - 'a' + 1) * tpow[s.size()];
			h1 %= MOD;
			h1 += MOD;
			h1 %= MOD;
		}
		if (h1 == H) {
			ans += (cp.size() - pnt + 1);
		}
	}
	cout << ans << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("D.in", "r", stdin);
		freopen("D.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> s) {
		solve();
	}
	return 0;
}


