#include <bits/stdc++.h>

using namespace std;
vector<int> base_points;

int check(int k) {
    int bonus = 0;
    int deleted = 0;
    for (int i = 0; i < base_points.size(); ++i) {
        if (base_points[i] + bonus >= k) {
            bonus = 0;
            continue;
        }
        bonus = base_points[i];
        deleted++;
    }
    return deleted;
}

bool another_check(int k, int cnt_g) {
    int bonus = 0;
    int deleted = 0;
    for (int i = 0; i < base_points.size(); ++i) {
        if (base_points[i] + bonus >= k) {
            bonus = 0;
            continue;
        }
        bonus += base_points[i];
        deleted++;
    }
    return base_points.size() - deleted >= cnt_g;
}

int main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int last_one = -1;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            base_points.emplace_back(i - last_one - 1);
            last_one = i;
        }
    }
    base_points.emplace_back(n - 1 - last_one);

    int max_len = 0;
    int max_g = 0, max_l = 0;
    for (int i = 2; i <= base_points.size(); ++i) {
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (another_check(m, i)) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l * i + i - 1 > max_len) {
            max_len = l * i + i - 1;
            max_g = i;
            max_l = l;
        }
    }

    cout << max_len << endl;
    for (int i = 0; i < max_l; ++i) {
        cout << '0';
    }
    for (int i = 0; i < max_g - 1; ++i) {
        cout << '1';
        for (int j = 0; j < max_l; ++j) {
            cout << '0';
        }
    }
    cout << endl;
}