#include <iostream>
#include <fstream>

#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <functional>

#include <cstring>
#include <cstdio>
#include <climits>
using namespace std;
//#define DEBUG
#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif
#define endl '\n'
typedef long long ll;
typedef pair<ll, ll> pll;

ll delta(ll h, pll d) {
	if ((h >= d.first) && (h <= d.second)) return 0;
	return min(abs(h - d.first), abs(h - d.second));
}

int main() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<pll> decks;
	for (int i = 0; i < k; i++) {
		int l, r; cin >> l >> r;
		decks.push_back({ l,r });
	}

	vector<ll> *childs = new vector<ll>[n];
	vector<ll> clas(2 * n);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < (2 * n); j++) {
			cin >> clas[j];
		}
		sort(clas.begin(), clas.end());
		for (int j = 0; j < (2 * n); j++) childs[j / 2].push_back(clas[j]);
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		ll best = LLONG_MAX /2;
		for (int j = 0; j < k; j++) {
			ll tec = 0;
			for (auto x : childs[i]) {
				tec += delta(x, decks[j]);
			}
			if (tec < best)best = tec;
		}
		ans += best;

	}
	cout << ans;

}

