#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
typedef long long ll;
using namespace std;

const int N 	= 4e5 + 64;
const ll INF 	= 1e18;

int m, n, k;
int a_[N];
int &a(int i, int j) {
	return a_[i * 2 * n + j];
}
pair<int, int> srt[N];
int l[N], r[N];
vector<pair<int, int>> pep;

ll dist(ll t, ll x, ll y) {
	if (t < x) {
		return x - t;
	}
	if (t > y) {
		return t - y;
	}
	return 0;
}

ll dist(ll p, ll q, ll x, ll y) {
	return dist(p, x, y) + dist(q, x, y);
}

ll answer = 0;

ll solve(int j, int lk, int rk) {
	ll best = INF;
	int rec = -1;
	for (int p = lk; p <= rk; ++p) {
		ll cur = 0;
		for (int i = 0; i < m; ++i) {
			cur += dist(a(i, j), a(i, j + 1), l[p], r[p]);
		}
		if (cur < best) {
			best = cur;
			rec = p;
		}
	}
	answer += best;
	assert(rec != -1);
	return rec;
}

void solve(int lj, int rj, int lk, int rk) {
	if (lj > rj) {
		return;
	}
	int mj = (lj + rj) / 2;
	int mk =solve(2 * mj, lk, rk);
	solve(lj, mj - 1, lk, mk);
	solve(mj + 1, rj, mk, rk);
}

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> m >> n >> k;
	for (int i = 0; i < k; ++i) {
		cin >> srt[i].first >> srt[i].second;
	}
	sort(srt, srt + k);
	for (int i = 0; i < k; ++i) {
		tie(l[i], r[i]) = srt[i];
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) {
			cin >> a(i, j);
		}
		sort(&a(i, 0), &a(i, 2 * n));
	}
	solve(0, n - 1, 0, k - 1);
	/*for (int j = 0; j < 2 * n; j += 2) {
		answer += solve(j, 0, k - 1);
	}*/
	cout << answer << "\n";
	return 0;
}

