#include <bits/stdc++.h>

using namespace std;

const int NONE = 2e9;
const int MOD = 998244353;

vector<vector<int>> one;
vector<vector<int>> two;

void calc(int i, int j, int n, int m) {
    if (i == n || j == m) {
        one[i][j] = two[i][j] = 0;
        return;
    }
    if (one[i][j] != NONE)
        return;
    calc(i + 1, j, n, m);
    calc(i, j + 1, n, m);
    one[i][j] = min(two[i + 1][j], two[i][j + 1]);
    two[i][j] = max(one[i + 1][j], one[i][j + 1]);
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    one.resize(n + 1, vector<int> (m + 1, NONE));
    two.resize(n + 1, vector<int> (m + 1, NONE));
    for (int i = 0; i < k; i++) {
        int r, c, v;
        cin >> r >> c >> v;
        r--; c--;
        one[r][c] = two[r][c] = v;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            calc(i, j, n, m);
            ans = (ans + one[i][j] + MOD) % MOD;
        }
    }
    cout << ans << endl;
}
