#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 3005;
const ll mod = 998244353;
int n, m, k;
const int MX = MAXN + 5;
int mn[MX][MX];
int mx[MX][MX];
int a[MX][MX];

int ox, oy;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> k;
    if (n >= MAXN) ox = n - MAXN;
    if (m >= MAXN) oy = m - MAXN;

    rep(i, MX) {
        rep(j, MX) {
            a[i][j] = INT_MAX;
        }
    }
    rep(i, k) {
        int x, y, v;
        cin >> x >> y >> v;
        x--; y--;
        x -= ox;
        y -= oy;
        a[x][y] = v;
    }

    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != INT_MAX) {
                mn[i][j] = mx[i][j] = a[i][j];
                continue;
            }

            mn[i][j] = min(mx[i + 1][j], mx[i][j + 1]);
            mx[i][j] = max(mn[i + 1][j], mn[i][j + 1]);
        }
    }

    ll res = 0;
    rep(i, n) {
        rep(j, m) {
            res += mn[i][j];
            res %= mod;
        }
    }

    res = (res + mod) % mod;

    // cout << res << endl;

    // rep(i, n) {
    //     rep(j, m) {
    //         if (mn[i][j] >= 0) cout << ' ';
    //         cout << mn[i][j] << ' ';
    //     }
    //     cout << endl;
    // }

    // cout << endl;
    // rep(i, n) {
    //     rep(j, m) {
    //         if (mx[i][j] >= 0) cout << ' ';
    //         cout << mx[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
}