#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

vector <int> v = { 0 };

inline string cnt_ans(int d, vector <int> u) {
	string res = "";
	string q = "";
	for (int j = 0; j < d; j++) q += '0';
	int r = 0;
	while (!u.empty()) {
		if (u.back() < d) {
			auto t = u.back();
			u.pop_back();
			if (!u.empty())
				u.back() += t;
		}
		else {
			r++;
			res += q + '1';
			u.pop_back();
		}
	}
	if (r <= 1)
		return "";
	if (!res.empty())
		res.pop_back();
	return res;
}

pair <int, int> ans(int l = 0, int r = v.size() - 1) {
	if (l >= r) return { 0, 0 };
	int c = 0;
	for (int i = l; i <= r; i++) {
		c += v[i];
	}
	int d = 0;
	int mx = 0, ind = 0;
	for (int i = l; i <= r; i++) {
		if (mx < min(d, c)) {
			mx = min(d, c);
			ind = i;
		}
		d += v[i], c -= v[i];
	}
	if (mx == 0)
		return { 0, r - l + 1 };
	pair <int, int> tmp = { mx, 2 };
	auto L = ans(l, ind), R = ans(ind, r);
	int q = min(L.first, R.first);
	if (q * L.second + q * R.second + L.second + R.second - 1 > tmp.second * tmp.first) {
		tmp = { q, q * L.second + q * R.second + L.second + R.second - 1 };
	}
	return tmp;
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif
	string s;
	cin >> s >> s;
	for (auto i : s)
	{
		if (i == '0') v.back()++;
		else v.push_back(0);
	}
	string rs = "";
	reverse(v.begin(), v.end());
	int c = accumulate(v.begin(), v.end(), 0);
	int d = 0;
	int can_do = ans().first;
	rs = cnt_ans(can_do, v);
	cout << rs.size() << "\n" << rs;

}