#pragma GCC optimize("Ofast", "unroll-loops")
  
#include <bits/stdc++.h>
  
using namespace std;
  
#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(12);
#define RANDOM srand(14008)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define f first
#define s second
#define pb push_back
#define popb pop_back
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define hashmap unordered_map
#define hashset unordered_set
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
  
template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
  
ll get(ll a, ll l, ll r) {
    if (a >= l && a <= r) return 0;
    return min(abs(a - l), abs(a - r));
}
  
ll get(ll a, ll b, ll l, ll r) {
    return get(a, l, r) + get(b, l, r);
}
  
signed main() {
    FAST; FIXED; RANDOM;
    int m, n, k;
    cin >> m >> n >> k;
    vector<pll> lr(k);
    for (auto &i : lr) cin >> i.f >> i.s;
    sort(lr);
    for (int i = 1; i < sz(lr); ++i) checkmax(lr[i].s, lr[i - 1].s);
    ll ans = 0;
    vector<vector<int>> a(m, vector<int>(2 * n));
    cin >> a;
    for (auto &i : a) sort(i);
    vector<vector<pii>> b(n, vector<pii>(m));
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < 2 * n; j += 2)
            b[j / 2][i] = {a[i][j], a[i][j + 1]};
    for (auto &i : b) sort(i);
    for (auto bb : b) {
    	vector<int> byl(m), byr(m);
    	for (int i = 0; i < n; ++i) {
    		byl[i] = bb[i].f;
    		byr[i] = bb[i].s;
    	}
    	sort(byl);
    	sort(byr);
        ll add = inf;
        int l1 = 0, l2 = 0, r1 = 0, r2 = 0;
        ll sl1 = 0, sl2 = 0, sr1 = 0, sr2 = 0;
        for (auto i : byl) sl2 += i;
        for (auto i : byr) sr2 += i;
        for (auto i : lr) {
        	while (l1 < m && byl[l1] < i.f) sl1 += byl[l1++];
        	while (l2 < m && byl[l2] < i.s) sl2 -= byl[l2++];
        	while (r1 < m && byr[r1] < i.f) sr1 += byr[r1++];
        	while (r2 < m && byr[r2] < i.s) sr2 -= byr[r2++];
        	//cout << (sl2 + sr2) << '\n';
        	checkmin(add, (l1 + r1) * i.f - (sl1 + sr1) + (sl2 + sr2) - i.s * (2 * m - l2 - r2));
        }
        //cout << add << '\n';
        ans += add;
    }
    cout << ans;
    return 0;
}