//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()

#define int long long
#define INT_MAX LONG_LONG_MAX
#define INT_MIN LONG_LONG_MIN


using namespace std;

const int NMAX = 1002;
const int MOD = 998244353;
const int ZERO = 0ll;
int w, h, k;

int mat[NMAX][NMAX];
int isk[NMAX][NMAX];

int vis[NMAX][NMAX][2];
int ra[NMAX][NMAX][2];

int dfs(int x, int y, int f) {
    if (vis[x][y][f])
        return ra[x][y][f];

    if (isk[x][y])
        return ra[x][y][f] = mat[x][y];


    int maxi = INT_MIN;
    int mini = INT_MAX;
    if (x + 1 != w) {
        maxi = max(dfs(x + 1, y, !f), maxi);
        mini = min(dfs(x + 1, y, !f), mini);
    } else {
        maxi = max(maxi, ZERO);
        mini = min(mini, ZERO);
    }


    if (y + 1 != w) {
        maxi = max(dfs(x, y + 1, !f), maxi);
        mini = min(dfs(x, y + 1, !f), mini);
    } else {
        maxi = max(maxi, ZERO);
        mini = min(mini, ZERO);
    }

    vis[x][y][f] = 1;
    if (f)
        return ra[x][y][f] = mini;
    else
        return ra[x][y][f] = maxi;
}

void display() {
    for (int y = 0; y < h; ++y) {
        for (int x = 0; x < w; ++x) {
            cout << ra[x][y][1] << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

main() {
#ifdef DEBUGI
    freopen("test.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> h >> w >> k;

    for (int i = 0; i < k; ++i) {
        int x, y, v;
        cin >> y >> x >> v;
        --x;
        --y;
        isk[x][y] = 1;
        mat[x][y] += v;
    }

    int koka = 0;

    for (int x = 0; x < w; ++x) {
        for (int y = 0; y < h; ++y) {
            if (!vis[x][y][1])
                dfs(x, y, 1);
            if (ra[x][y][1] == INT_MAX || ra[x][y][1] == INT_MIN)
                return 1;
            koka += ra[x][y][1];
            while (koka < 0)
                koka += MOD;
            koka %= MOD;
        }
    }
    cout << koka << endl;

//    display();



    return 0;
}