//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")


#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()

//#define int long long
//#define INT_MAX LONG_LONG_MAX
//#define INT_MIN LONG_LONG_MIN


using namespace std;

const int NMAX = 20;
const int MOD = 998244353;
const int ZERO = 0ll;
int w, h, k;

unordered_map<int, int> mat[NMAX];
unordered_map<int, int> isk[NMAX];

unordered_map<int, int> vis[2][NMAX];

unordered_map<int, int> visa[NMAX];
unordered_map<int, int> ra[2][NMAX];

int dfs(int x, int y, int f, int mx, int my) {


    if (vis[f][y][x])
        return ra[f][y][x];

    if (isk[y][x])
        return ra[f][y][x] = mat[y][x];


    if (mx <= x)
        return 0;
    if (my <= y)
        return 0;


    int maxi = INT_MIN;
    int mini = INT_MAX;
    if (x + 1 != w) {
        maxi = max(dfs(x + 1, y, !f, mx, my), maxi);
        mini = min(dfs(x + 1, y, !f, mx, my), mini);
    } else {
        maxi = max(maxi, ZERO);
        mini = min(mini, ZERO);
    }


    if (y + 1 != h) {
        maxi = max(dfs(x, y + 1, !f, mx, my), maxi);
        mini = min(dfs(x, y + 1, !f, mx, my), mini);
    } else {
        maxi = max(maxi, ZERO);
        mini = min(mini, ZERO);
    }

    vis[f][y][x] = 1;
    if (f)
        return ra[f][y][x] = mini;
    else
        return ra[f][y][x] = maxi;
}

void display() {
    for (int y = 0; y < h; ++y) {
        for (int x = 0; x < w; ++x) {
            cout << ra[1][y][x] << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

vector<pair<int, int> > vc;

main() {
#ifdef DEBUGI
    freopen("test.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> h >> w >> k;

    for (int i = 0; i < k; ++i) {
        int x, y, v;
        cin >> y >> x >> v;
        --x;
        --y;
        isk[y][x] = 1;
        mat[y][x] += v;
        vc.emplace_back(x, y);
    }

    int koka = 0;

    sort(all(vc));
//    reverse(all(vc));


    for (auto v:vc) {
        for (int x = max(0, v.first - 5); x < min(w, v.first + 1); ++x) {
            for (int y = max(0, v.second - 5); y < min(h, v.second + 1); ++y) {
                if (!vis[1][y][x])
                    dfs(x, y, 1, v.first + 4, v.second + 4);
                if (!visa[y][x]) {
                    koka += ra[1][y][x];
                    visa[y][x] = 1;
                    while (koka < 0)
                        koka += MOD;
                    koka %= MOD;
                }
            }
        }
    }

    cout << koka << endl;

//    display();


    return 0;
}