#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <assert.h>
#include <algorithm>
#include <map>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define size(x) (int)x.size()
#define int ll

int m, n;

void solveA() {
	string s;
	cin >> s;
	string t;
	while (n--) {
		int y;
		cin >> y;
		if (y == 1) {
			string w;
			cin >> w;
			t += w;
		}
		else {
			int pos, len;
			cin >> pos >> len;
			--pos;
			while (len--) {
				t += t[pos++];
			}
		}
	}
	s += "#";
	s += t;
	vector<int> z(size(s) + 1);
	int l = -1, r = -1;
	for (int i = 1; i < size(s); i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < size(s) && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	int cnt = 0;
	for (int v : z) if (v == m) cnt++;
	cout << cnt;
	exit(0);
}

string s, te;
vector<pii> is;
ll res = 0;

int f(string s, string t) {
	s += "#";
	s += t;
	vector<int> z(size(s) + 1);
	int l = -1, r = -1;
	for (int i = 1; i < size(s); i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < size(s) && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	int cnt = 0;
	for (int v : z) if (v == m) cnt++;
	return cnt;
}

void solve() {
	cin >> m >> n;
	if (n == 1) solveA();
	cin >> s;
	bool flag = 1;
	for (int i = 1; i < size(s); i++) {
		if (s[i] != s[i - 1]) flag = 0;
	}
	int cnt = 1;
	char last = '#';
	while (n--) {
		int y;
		cin >> y;
		if (y == 1) {
			string w;
			cin >> w;
			string t = te;
			te += w;
			for (int i = size(t) - 1; i >= 0; i--) {
				if (i + m < size(t)) break;
				int j = i;
				bool good = 1;
				int pos = 0;
				for (char c : t) {
					if (t[j] != c) {
						good = 0;
						break;
					}
					pos++;
					j++;
					if (j == size(t)) break;
				}
				if (size(s) - pos > size(w)) break;
				j = 0;
				for (; pos < size(s); pos++) {
					if (pos != w[j++]) {
						good = 0;
						break;
					}
				}
				if (good) ++res;
			}
			res += f(s, w);
		}
		else {
			int p, c;
			cin >> p >> c;
			string t;
			if (last != '#') t = string(m, '#');
			else {
				for (int i = max(0LL, size(te) - m); i < size(te); i++) t += te[i];
			}
			for (int i = size(t) - 1; i >= 0; i--) {
				if (i + m < size(t)) break;
				int j = i;
				bool good = 1;
				int pos = 0;
				for (char c : t) {
					if (t[j] != c) {
						good = 0;
						break;
					}
					pos++;
					j++;
					if (j == size(t)) break;
				}
				if (size(s) - pos > c) break;
				for (; pos < size(s); pos++) {
					if (pos != t.back()) {
						good = 0;
						break;
					}
				}
				if (good) ++res;
			}
			if (c <= 3000) {
				t += string(c, t.back());
			}
			else {
				last = t.back();
			}
			if (flag)
				if (s[0] == t.back())
					res += max(0LL, size(t) - c + 1);
		}
	}
	cout << res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
}