#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define F first
#define S second

typedef long long ll;
const ll mod = 998244353;
int n, m;

/*void print(int ind)
{
    cout << "---------------\n";
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cout << a[ind][i][j] << ' ';
        cout << '\n';
    }
    cout << "---------------\n";
}*/

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int k;
    cin >> n >> m >> k;
    vector<pair<pair<int, int>, ll> > _k(k);
    bool small = true;
    for (int i = 0; i < k; i++)
    {
        int r, c;
        cin >> r >> c;
        r -= 1;
        c -= 1;
        _k[i] = {{r, c}, -1};
        if (r > 4)
            small = false;
        cin >> _k[i].S;
    }
    /*if (small)
    {
        get_ans_if_small();
        return 0;
    }*/
    vector<vector<vector<ll> > > a(2, vector<vector<ll> > (1001, vector<ll> (1001, 0)));
    vector<vector<bool> > used(1001, vector<bool> (1001, false));
    for (int i = 0; i < k; i++)
    {
        used[_k[i].F.F][_k[i].F.S] = true;
        a[0][_k[i].F.F][_k[i].F.S] = _k[i].S;
        a[1][_k[i].F.F][_k[i].F.S] = _k[i].S;
    }
    for (int i = n - 1; i >= 0; i--)
    {
        for (int j = m - 1; j >= 0; j--)
        {
            if (used[i][j])
                continue;
            a[0][i][j] = min(a[1][i + 1][j], a[1][i][j + 1]);
            a[1][i][j] = max(a[0][i + 1][j], a[0][i][j + 1]);
        }
    }

    ll ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            ans += a[0][i][j];

    cout << (ans % mod + mod) % mod;
    return 0;
}

