// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<int> pref(n + 1);
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') pref[i + 1] = pref[i] + 1;
		else pref[i + 1] = pref[i];
	}
	vector<int> near(n + 1, n);
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '1') near[i] = i;
		else near[i] = near[i + 1];
	}
	int mx = -1, ind = -1;
	for (int x = 0; x < n; x++) {
		//cout << "x = " << x << endl;
		int i = 0, ans = -1;
		int it = 0;
		while (i <= n) {
			//cout << i << endl;
			int j = lower_bound(pref.begin() + i, pref.end(), pref[i] + x) - pref.begin();
			if (j == n + 1) break;
			it++;
			j = near[j] + 1;
			ans += x + 1;
			i = j;
		}
		if (it > 1) {
			//cout << ans << endl;
			//mx = max(mx, ans);
			if (mx < ans) {
				mx = ans;
				ind = x;
			}
		}
	}
	cout << mx << endl;
	for (int i = 0; i < mx; i++) {
		if (i % (ind + 1) == ind) cout << '1';
		else cout << '0';
	}
	cout << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
