// C.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1000000001;
const int mod = 998244353;
using ll = long long;

int main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<vector<int> > > a(n + 1, vector<vector<int> >(m + 1, vector<int>(2)));
	vector<vector<int> > b(n, vector<int>(m, INF));
	for (int i = 0; i < k; i++) {
		int r, c, v;
		cin >> r >> c >> v;
		b[r - 1][c - 1] = v;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (b[i][j] != INF) {
				a[i][j] = { b[i][j], b[i][j] };
				continue;
			}
			a[i][j][0] = min(a[i + 1][j][1], a[i][j + 1][1]);
			a[i][j][1] = max(a[i + 1][j][0], a[i][j + 1][0]);
		}
	}
	ll sum = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			sum += a[i][j][0];
			sum %= mod;
		}
	}
	sum = (sum + mod) % mod;
	cout << sum << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
