#include <bits/stdc++.h>

using namespace std;

string get(const string& s)
{
	const int n = s.size();
	vector<int> p;
	int cur = 0;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '1')	
		{
			p.push_back(cur);	
			cur = 0;
		}
		else
		{
			++cur;
		}
	}
	p.push_back(cur);
	p[0] = min(p[1], p[0]);
	for (int i = 1; i < p.size() - 1; ++i)
		p[i] = min(min(p[i], p[i - 1]), p[i + 1]);
	p[p.size() - 1] = min(p[p.size() - 1], p[p.size() - 2]);
	for (int i = p.size() - 2; i > 0; --i)
		p[i] = min(min(p[i], p[i - 1]), p[i + 1]);
	p[0] = min(p[1], p[0]);
	string res;
	for (int i : p)
	{
		for (int j = 0; j < i; ++j)
			res.push_back('0');
		res.push_back('1');
	}
	res.pop_back();
	return res;
}

string make(const string& s, set<int>& ban)
{
	string res;
	for (int i = 0; i < s.size(); ++i)
		if (ban.find(i) == ban.end())
			res.push_back(s[i]);
	return res;
}

int main()
{
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<int> p;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '1')	
		{
			p.push_back(i);	
		}
	}
	vector<int> cnt(p.size());
	vector<pair<int, int>> rm;
	for (int i = 0; i < p.size(); ++i)
	{
		int prev = (i > 0) ? p[i - 1] : -1;
		int next = (i < p.size() - 1) ? p[i + 1] : n;
		cnt[i] = min(p[i] - prev, next - p[i]) - 1;
		rm.push_back({cnt[i], p[i]});
	}
	sort(rm.begin(), rm.end());
	string best = get(s);
	set<int> ban;
	for (int cur = 0; cur < rm.size() - 1; ++cur)
	{
		auto i = rm[cur];
		ban.insert(i.second);	
		//cout << make(s, ban) << endl;
		string res = get(make(s, ban));
		if (res.size() > best.size())
			best = res;
	}
	cout << best.size() << endl;
	cout << best;
}
