#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long m, n, k;
    cin >> m >> n >> k;
    vector<pair<long long, long long> > a(k);
    for(long long i = 0; i<k; i++)
        cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    vector<vector<long long> > b(m, vector<long long>(2*n));
    for(long long i = 0; i<m; i++){
        for(long long j = 0; j<2*n; j++)
            cin >> b[i][j];
        sort(b[i].begin(), b[i].end());
    }
    long long ans = 0;
    vector<vector<int> > c(n, vector<int>(2*m));
    vector<vector<long long> > pr(n, vector<long long>(2*m+1)), sf(n, vector<long long>(2*m+1));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            c[i][2*j] = b[j][2*i];
            c[i][2*j+1] = b[j][2*i+1];
        }
        sort(c[i].begin(), c[i].end());
        for(int j = 0; j<2*m; j++){
            pr[i][j+1] = pr[i][j]+c[i][j];
            sf[i][2*m-j-1] = sf[i][2*m-j]+c[i][2*m-j-1];
        }
    }
    for(int i = 0; i<n; i++){
        long long ans1 = 1000000000000000000;
        for(int j = 0; j<k; j++){
            long long ans2 = 0;
            int l = -1, r = 2*m;
            while(r-l>1){
                int m1 = (r+l)/2;
                if(c[i][m1]>a[j].first)
                    r = m1;
                else
                    l = m1;
            }
            ans2 += r*a[j].first-pr[i][r];
            //cout << i << ':' << j << ':' << r << ' ' << r*a[j].first << ':' << pr[i][r] << endl;
            l = -1, r = 2*m;
            while(r-l>1){
                int m1 = (r+l)/2;
                if(c[i][m1]>a[j].second)
                    r = m1;
                else
                    l = m1;
            }
            ans2 += sf[i][r]-(2*m-r)*a[j].second;
            //cout << i << ':' << j << ':' << r << ' ' << sf[i][r] << ':' << (2*m-r)*a[j].second << endl;
            ans1 = min(ans1, ans2);
        }
        ans += ans1;
    }
    cout << ans;

    return 0;
}
