#include<iostream>
#include<string>
#include<algorithm>
#include<vector>

using namespace std;

#pragma warning(disable : 4996)
#define all(aaa) aaa.begin(), aaa.end()
#define ll long long int

const ll INF = 1e18;
const int N = 1e6 + 5, MAX = 2e9;
vector<pair<int, int>> w, tmp;
vector<int> v[N];
int t[N];
ll sum[N];

int main() {
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int m, n, k;
	cin >> m >> n >> k;

	n *= 2;

	for (int i = 0; i < k; i++) {
		int l, r;
		cin >> l >> r;
		w.push_back({ l, r });
	}

	sort(all(w));
	w.erase(unique(all(w)), w.end());

	int mx = -1;
	for (int i = 0; i < w.size(); i++) {
		if (i == w.size() - 1 || w[i + 1].first != w[i].first) {
			if (w[i].second > mx)
				tmp.push_back(w[i]);
		}
		mx = max(mx, w[i].second);
	}

	swap(tmp, w);

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			int x;
			cin >> x;
			v[i].push_back(x);
		}
		sort(all(v[i]));
	}

	ll ans = 0;
	for (int i = 0; i < n; i += 2) {
		vector<int> z;
		for (int j = 0; j < m; j++) {
			z.push_back(v[j][i]);
			z.push_back(v[j][i + 1]);
		}
		z.push_back(-1);
		z.push_back(MAX);
		sort(all(z));

		for (int i = 1; i < z.size(); i++) {
			sum[i] = sum[i - 1];
			if (z[i] != MAX)
				sum[i] += z[i];
		}

		ll mn = INF;

		for (int j = 1; j < z.size(); j++) {
			//watch me!!!!!!!!!!!!!!!!
			int li = upper_bound(all(w), make_pair(z[j - 1], -1)) - w.begin(),
				ri = upper_bound(all(w), make_pair(z[j], MAX)) - w.begin() - 1;
			if (li > ri)
				continue;
			for (int h = li; h <= ri;) {
				int x = upper_bound(all(z), w[h].second) - z.begin();

				ll lc = j - 1, rc = z.size() - x - 1;

				int l = h, r = ri + 1;
				while (r - l > 1) {
					int p = (l + r) >> 1;
					if (w[p].second <= z[x])
						l = p;
					else
						r = p;
				}

				int R = l;

				l = h - 1, r = ri;
				while (r - l > 1) {
					int p = (l + r) >> 1;
					if (w[p].second >= z[x - 1])
						r = p;
					else
						l = p;
				}

				int L = r;

				ll cur = w[L].first * lc - sum[j - 1] +
					sum[z.size() - 1] - sum[x - 1] - w[L].second * rc;
				mn = min(mn, cur);

				cur = w[R].first * lc - sum[j - 1] +
					sum[z.size() - 1] - sum[x - 1] - w[R].second * rc;
				mn = min(mn, cur);


				h++;
			}
		}

		ans += mn;
	}

	cout << ans;


	return 0;
}