#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

string s;
vector <int > v;

bool check(int t, int k2)
{
	int id = 0, k = 0;
	while (id < v.size())
	{
		int sum = 0;
		while (id < v.size() && sum < t)
			sum += v[id], id++;
		if (t == 0)
			id++;
		if (sum < t)
			break;
		k++;
	}
	return k2 <= k;
}

int get(int k)
{
	int lt = 0, rt = s.size(), m;
	while (lt + 1 < rt)
	{
		m = (lt + rt) / 2;
		if (check(m, k))
			lt = m;
		else
			rt = m;
	}
	if (!check(lt, k))
		return -1;
	return lt;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	int n;
	cin >> n;
	cin >> s;
	int k = 0;
	for (int i = 0; i < s.size(); i++)
		if (s[i] == '0')
			k++;
		else
			v.push_back(k), k = 0;
	v.push_back(k);
	int ans = 0, it = 0, ik = 0;

	for (int k = 2; k <= n + 1; k++)
	{
		int t = get(k);
		if (ans < k * t + k - 1)
		{
			ans = max(ans, k * t + k - 1);
			it = t;
			ik = k;
		}
	}

	cout << ans << "\n";
	for (int i = 0; i < ik; i++)
	{
		for (int j = 0; j < it; j++)
			cout << 0;
		if (i + 1 != ik)
			cout << 1;
	}
	cin >> n;
	return 0;
}