#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

int _dist(int a, int b, int h) {
    if (h < a) return a - h;
    if (h > b) return h - b;
    return 0;
}

int dist(int a, int b, int h1, int h2) {
    return _dist(a, b, h1) + _dist(a, b, h2);
}

const int N = 2e5 + 10;
int l[N], r[N];

signed main() {
    fast();
    int m, n, k;
    cin >> m >> n >> k;
    vector<vector<int>> v(m, vector<int> (2 * n));
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> r[i];
    }
    int answ = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 2 * n; j++) {
            cin >> v[i][j];
        }
        sort(v[i].begin(), v[i].end());
    }
    for (int i = 0; i < 2 * n; i += 2) {
        int c = 1e18;
        for (int j = 0; j < k; j++) {
            int cc = 0;
            for (int p = 0; p < m; p++) {
                cc += dist(l[j], r[j], v[p][i], v[p][i + 1]);
            }
            c = min(c, cc);
        }
        answ += c;
    }
    cout << answ;
    return 0;
}