#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 random1(1893496);
int randlr(int l, int r) {
    return random1() % (r - l + 1) + l;
}

const int mod = 998244353;
const int inf = 1e15;

vector<pii> desks;
vector<int> chos;
vector<int> points[200009];
int m, n, k;

int answ = inf;
int dp[51][1009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> m >> n >> k;

    desks.resize(k);
    for (int i = 0; i < k; i ++) {
        cin >> desks[i].x >> desks[i].y;
    }

    for (int i = 0; i <= n; i ++) {
        for (int j = 0; j <= k ; j++)
            dp[j][i]= inf;
    }

    sort(desks.begin(), desks.end());

    for (int i = 0; i < m; i ++) {
        points[i].resize(n * 2);
        for (int j = 0; j < 2 * n; j++) {
            cin >> points[i][j];
        }

        sort(points[i].begin(), points[i].end());
    }

    dp[0][0] = 0;
    for (int i = 0; i < k ; i ++) {
        int l = desks[i].x, r = desks[i].y;
        vector<int> aos(n + 1);
        int out = 0;

        for (int c = 0; c < n ; c++) {
            if (c == 0) {
                int ao = 0, j = 0;

                for (int ci = 0; ci <= n - c; ci++) {
                    dp[i + 1][c + ci] = min(dp[i + 1][c + ci], dp[i][c] + ao);
                    for (int aaa = 0; aaa <= 1; ++aaa) {
                        if (j + aaa >= 2 * n) break;
                        for (int piu = 0; piu < m; piu++) {
                            int p = points[piu][j + aaa];
                            if (l <= p && p <= r) continue;
                            if (p < l) {
                                ao += l - p;
                            }

                            else {
                                ao += p - r;
                            }
                        }
                    }

                    j += 2;

                    aos[ci] = ao;
                }
            }

            else {
                for (int aaa = 0; aaa <= 1; ++aaa) {
                    if ((c - 1) * 2 + aaa >= 2 * n) break;
                    for (int piu = 0; piu < m; piu++) {
                        int p = points[piu][(c - 1) * 2 + aaa];
                        if (l <= p && p <= r) continue;
                        if (p < l) {
                            out += l - p;
                        }

                        else {
                            out += p - r;
                        }
                    }
                }

                for (int ci = 0; ci <= n - c; ci++) {
                    dp[i + 1][c + ci] = min(dp[i + 1][c + ci], dp[i][c] + aos[ci] - out);
                }
            }
        }
    }

    cout << dp[k][n];

    return 0;
}



