#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 random1(1893496);
int randlr(int l, int r) {
    return random1() % (r - l + 1) + l;
}

const int p = 27, mod = (1e9) + 9;
vector<int> prefh[4009];
string ques[4009];
int aft_symb[4009];
int powp[1000009];

void build(string &s, int &ind) {
    int n = s.size();
    powp[0] = 1;
    prefh[ind].resize(n + 1);

    for (int i = 1; i <= n; i ++) {
        powp[i] = (powp[i - 1] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        prefh[ind][i + 1] = (prefh[ind][i] * p + (s[i] - 'a')) % mod;
    }

    ind++;
}

int geth(int l, int r, int ind) {
   //cout << prefh[ind][r] << ' ' << ind << ' ' << prefh[ind].size() << ' ' << r <<  endl;
    return (prefh[ind][r] - prefh[ind][l] * powp[r - l] + mod * mod) % mod;
}

int findh(string &s) {
    int ao = 0;

    for (auto u : s) {
        ao = (ao * p + (u - 'a')) % mod;
    }

    return ao;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;
    string p1;
    cin >> p1;

    int curr = 0;
    build(p1, curr);


    for (int i = 0; i < n; i ++) {
        char type;
        cin >> type;

        if (type == '1') {
            string s;
            cin >> s;
            ques[curr] = s;
            build(s, curr);
        }

        else {
            int pos, len;
            cin >> pos >> len;
            aft_symb[curr - 1] += len;
        }
    }


    int answ = 0;
    for (int i = 1; i < curr; i ++) {
        //plain
        for (int j = 0; j <= ques[i].size() - m; j ++) {
            answ += (geth(j, j + m, i) == geth(0, m, 0));
        }

       // cout << i << ' ' << ques[i] << endl;
       assert(ques[i].size());

        int symb = ques[i].back() - 'a';
        int suph = symb;
        for (int lencut = m - 1; lencut > 0; lencut--) {
            if (aft_symb[i] < m - lencut) break;
            if (geth(lencut, m, 0) != suph) break;
            if (geth(0, lencut, 0) != geth(ques[i].size() - lencut, ques[i].size(), i)) continue;

            answ++;
            suph = (suph * p + symb) % mod;
        }

       // cout << symb << ' ' << suph << ' ' << geth(0, m, 0) << endl;

        if (aft_symb[i] >= m && suph == geth(0, m, 0)) {
            answ += aft_symb[i] - m + 1;
        }

        if (i != curr - 1) {
            suph = symb;
            for (int lencut = 1; lencut < m; lencut++) {
                if (aft_symb[i] < lencut) break;
                if (geth(0, lencut, 0) != suph) break;
                if (geth(lencut, m, 0) != geth(0, m - lencut, i + 1)) continue;

                answ++;
                suph = (suph * p + symb) % mod;
            }
        }
    }

    cout << answ;

    return 0;
}

