#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#pragma warning (disable : 4996)
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

const int MAXN = 1e3 + 10;
const long long MOD = 998244353;

int n, m, k;//, dp[MAXN][MAXN];
map < pair < int, int >, int > lel;
map < int, map < int, int > > dp;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int x, y, c;
		cin >> x >> y >> c;
		lel[make_pair(x, y)] = c;
	}
	long long ans = 0;
	for (int i = n; i > 0; i--) {
		for (int j = m; j > 0; j--) {
			if (lel.count(make_pair(i, j))) {
				dp[i][j] = lel[make_pair(i, j)];
			}
			else {
				int f, s;
				if (lel.count(make_pair(i + 1, j))) {
					f = dp[i + 1][j];
				}
				else {
					f = max(dp[i + 1][j + 1], dp[i + 2][j]);
				}
				if (lel.count(make_pair(i, j + 1))) {
					s = dp[i][j + 1];
				}
				else {
					s = max(dp[i + 1][j + 1], dp[i][j + 2]);
				}
				dp[i][j] = min(f, s);
			}
			ans += dp[i][j];
			//cout << dp[i][j] << " ";
		}
		//cout << "\n";
		ans %= MOD;
	}
	cout << (ans + MOD) % MOD;

	return 0;
}