import java.io.PrintWriter;
import java.util.*;

public class Main {
    public static void main(String [] arg) {
        new Main().run();
    }

    Scanner sc;
    PrintWriter out;
    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public String nextToken() {
        return sc.next();
    }

    ArrayList<Integer> arr;

    class Ind implements Comparable{
        int ind;

        public Ind(int ind) {
            this.ind = ind;
        }

        @Override
        public boolean equals(Object obj) {
            return ind == ((Ind) obj).ind;
        }

        @Override
        public int compareTo(Object o) {
            int i = ((Ind) o).ind;
            if (i == ind) {
                return 0;
            }
            if (arr.get(i) > arr.get(ind)) {
                return -1;
            } else {
                return 1;
            }
        }
    }

    public void solve() {
        int n = nextInt() + 1;
        String a = nextToken() + '1';

        arr = new ArrayList<>();

        int i = 0;
        while (i < n) {
            int j = i;
            while (a.charAt(j) != '1') {
                j++;
            }
            arr.add(j - i);
            i = j + 1;
        }

        int ans1 = 0;
        int ans2 = 0;
        while (arr.size() > 1) {
            int ind = 0;
            for (int j = 0; j < arr.size(); j++) {
                if (arr.get(ind) > arr.get(j)) {
                    ind = j;
                }
            }

            if (ans1 * ans2 + ans2 < arr.get(ind) * arr.size() + arr.size()) {
                ans1 = arr.get(ind);
                ans2 = arr.size();
            }

            int q = arr.remove(ind);
            if (ind == 0) {
                arr.set(ind, arr.get(ind) + q);
            } else if (ind == arr.size()) {
                arr.set(ind - 1, arr.get(ind - 1) + q);
            } else if (arr.get(ind - 1) > arr.get(ind)) {
                arr.set(ind, arr.get(ind) + q);
            } else {
                arr.set(ind - 1, arr.get(ind - 1) + q);
            }

        }


        out.println(ans1 * ans2 + ans2 - 1);
        for (i = 0; i < ans2 - 1; i++) {
            for (int j = 0; j < ans1; j++) {
                out.print(0);
            }
            out.print(1);
        }
        for (int j = 0; j < ans1; j++) {
            out.print(0);
        }
    }
}


