import java.util.Scanner;

public class Main {
    public static void main(String [] arg) {
        new Main().run();
    }

    Scanner sc;
    public void run() {
        sc = new Scanner(System.in);

        solve();
    }

    public int nextInt() {
        return sc.nextInt();
    }

    int mod = 998244353;
    public void solve() {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();

        int [][] dp1 = new int[n + 1][m + 1];
        int [][] dp2 = new int[n + 1][m + 1];
        boolean [][] trap = new boolean[n + 1][m + 1];
        for (int i = 0; i < k; i++) {
            int a = nextInt() - 1;
            int b = nextInt() - 1;
            int v = nextInt();
            dp1[a][b] = v;
            dp2[a][b] = v;
            trap[a][b] = true;
        }

        for (int i = n - 1; i >= 0; i--) {
            for (int j = m - 1; j >= 0; j--) {
                if (trap[i][j]) {
                    continue;
                }
                dp1[i][j] = Math.min(dp2[i + 1][j], dp2[i][j + 1]);
                dp2[i][j] = Math.max(dp1[i + 1][j], dp1[i][j + 1]);
            }
        }
        long ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ans += dp1[i][j];
                ans %= mod;
            }
        }
        ans = (ans + mod) % mod;
        System.out.println(ans);

    }
}

