#define _CRT_SECURE_NO_WARNINGS

#include <set>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = (int)1e3 + 7;
const int INF = (int)1e9 + 7;
long long MOD = 998244353;

#define mp make_pair

////////////////////////////////////////////

int n, m, k, f[N][N];
long long dp[N][N][2];

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> n >> m >> k;
	for (int i = 0; i < n + 2; i++)
		fill(f[i], f[i] + m + 2, -INF);
	for (int i = 0; i < k; i++) {
		int x, y, w;
		cin >> x >> y >> w;
		f[x][y] = w;
	}
	for (int i = n; i > 0; i--) {
		for (int j = m; j > 0; j--) {
			if (f[i][j] != -INF) {
				dp[i][j][0] = dp[i][j][1] = f[i][j];
				continue;
			}
			dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
			dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
		}
	}
	long long res = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			res += dp[i][j][0];
			while (res < 0)
				res += MOD;
			res %= MOD;
		}
	}
	cout << res;
}