#define _CRT_SECURE_NO_WARNINGS

#include <set>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = (int)3e3 + 7;
const int INF = (int)1e9 + 7;
long long MOD = 998244353;

#define mp make_pair

////////////////////////////////////////////

string p;
int m, n;

vector <int> z_func(const string &s) {
	vector <int> z(s.size());
	int l = 0, r = 0, n = s.size();
	for (int i = 1; i < n; i++) {
		if (i <= r)
			z[i] = min(i + z[i - l], r);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] < r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> m >> n >> p;
	string s = "";
	for (int i = 0; i < n; i++) {
		int t; cin >> t;
		if (t == 1) {
			string w; cin >> w;
			s += w;
		}
		else {
			int pos, len;
			cin >> pos >> len;
			pos--;
			for (int j = pos; len != 0; len--, j++)
				s += s[j];
		}
	}
	string res = p + '$' + s;
	auto z = z_func(res);
	int ans = 0;
	for (int i = 0; i < (int)z.size(); i++)
		ans += (z[i] >= (int)p.size() ? 1 : 0);
	cout << ans;
}