#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

const ll INF = 1e17;

void io() {
  //  freopen("a.in", "r", stdin);
	//freopen("a.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
}

ll m, n, k;
vector<pair<ll, ll>> vk;
vector<vector<ll>> sh;
ll ans;
inline ll d(pair<ll, ll> a, ll x) {
	if (a.first <= x && x <= a.second)
		return 0ll;
	return min(abs(a.first - x), abs(a.second - x));
}
signed main() {
	io();
	cin >> m >> n >> k;
	vk.resize(k);
	for (ll i = 0; i < k; i++)
		cin >> vk[i].first >> vk[i].second;
	sort(all(vk));
	sh.resize(m, vector<ll>(2 * n));
	ans = 0;
	for (ll i = 0; i < m; i++) {
		for (ll j = 0; j < 2 * n; j++) {
			cin >> sh[i][j];
		}
		sort(all(sh[i]));
	}
	ll lst = 0;
	for (int pt = 0; pt < k - 1 && lst < 2 * n; pt++) {
		ll a1 = 0;
		ll a2 = 0;
		for (int j = 0; j < m; j++) {
			a1 += d(vk[pt], sh[j][lst]) + d(vk[pt], sh[j][lst + 1]);
			a2 += d(vk[pt + 1], sh[j][lst]) + d(vk[pt + 1], sh[j][lst + 1]);
		}
		if (a1 <= a2)
			ans += a1, lst += 2, pt--;
	}
	while (lst != 2 * n) {
		ll pt = k - 1;
		for (int j = 0; j < m; j++) {
			ans += d(vk[pt], sh[j][lst]) + d(vk[pt], sh[j][lst + 1]);
		}
		lst += 2;
	}
	cout << ans;
	return 0;
}