#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,avx,avx2")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair



void io() {
    //freopen("a.in", "r", stdin);
	//freopen("a.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
}
const ll mod = 998244353;
const ll INF = 1e10;

signed main() {
	io();
	ll n, m, k;
	cin >> n >> m >> k;
	vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(m + 1, vector<ll>(2, 0)));
	vector<vector<ll>> ma(n, vector<ll>(m, INF));
	for (int i = 0; i < k; i++) {
		ll x, y, z;
		cin >> x >> y >> z;
		x--, y--;
		ma[x][y] = z;
	}
	for (int i = n - 1; i > -1; i--) {
		for (int j = m - 1; j > -1; j--) {
			if (ma[i][j] != INF) {
				dp[i][j][0] = dp[i][j][1] = ma[i][j];
				continue;
			}
			dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
			dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			ans = (ans + dp[i][j][0]) % mod;
	cout << (ans + mod) % mod;
	return 0;
}