# include <iostream>
# include <vector>
# include <map>
# include <set>
# include <math.h>
# include <cmath>
# include <algorithm>
# include <string>
# include <stack>

using namespace std;

int main() {

	int m, n, k;
	cin >> m;
	cin >> n;
	cin >> k;
	vector<pair<long long, long long>> x(k);
	for (int i = 0; i < k; i++) cin >> x[i].first >> x[i].second;
	sort(x.begin(), x.end());
	vector<pair<long long, long long>> nx;
	long long h = 0;
	for (int i = 0; i < k; i++) {
		if (x[i].second > h) {
			h = x[i].second;
			nx.push_back(x[i]);
		}
	
		
	}

	vector<vector<long long>> y(m, vector<long long>(2 * n));
	vector<vector<long long>> z(n, vector<long long>(2 * m));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n * 2; j++) {
			cin >> y[i][j];
		}
		sort(y[i].begin(), y[i].end());
		for (int j = 0; j < n; j++) {
			z[j][i * 2] = y[i][j * 2];
			z[j][i * 2 + 1] = y[i][j * 2 + 1];
		}
	}
	for (int i = 0; i < n; i++) sort(z[i].begin(), z[i].end());
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		long long ssum = 1e18;
		for (int j = 0; j < k; j++) {
			long long sum = 0;
			for (int q = 0; q < 2 * m; q++) {
				if (z[i][q] >= x[j].first && z[i][q] <= x[j].second) sum += 0;
				else sum += min(abs(z[i][q] - x[j].first), abs(z[i][q] - x[j].second));
			}
			ssum = min(ssum, sum);
		}
		ans += ssum;
	}
	cout << ans;
	cin >> n;
}
/*
1 2 2
5 25
50 90
60 5 10 40
*/