#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define is insert
#define er erase
#define pii pair<int, int>
#define X first
#define Y second
#define sz(a) (ll)a.size()

using namespace std;

const int MAX_N = 5e6;

const ll pm = 31;
const ll MOD = 1e9 + 7;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}

int m;
int n;

ll mult[MAX_N];
ll h[MAX_N];

ll ask(int l, int r)
{
    ll res;
    if (l == 0)
    {
        res = h[r];
    }
    else
    {
        res = (h[r] - h[l - 1] + MOD) % MOD;
    }
    return (res * mult[MAX_N - l - 1]) % MOD;
}

ll curHash = 0;

string t = "";
string p;

void solve1()
{
    for (int i = 0; i < m; ++i)
    {
        curHash = (curHash + (p[i] - 'a' + 1) * mult[i]) % MOD;
    }
    curHash = (curHash * mult[MAX_N - 1]) % MOD;
    for (int i = 1; i <= n; ++i)
    {
        int c;
        cin >> c;
        if (c == 1)
        {
            string s;
            cin >> s;
            t += s;
        }
        else
        {
            int pos;
            int len;
            cin >> pos >> len;
            pos--;
            for (int j = pos; j <= pos + len - 1; ++j)
            {
                t += t[j];
            }
        }
    }
    h[0] = t[0] - 'a' + 1;
    for (int i = 1; i < sz(t); ++i)
    {
        h[i] = (h[i - 1] + (t[i] - 'a' + 1) * mult[i]) % MOD;
    }
    ll ans = 0;
    for (int i = sz(p) - 1; i < sz(t); ++i)
    {
        if (curHash == ask(i - sz(p) + 1, i))
        {
            ans++;
        }
    }
    cout << ans << '\n';
    return;
}

ll del(ll a, ll b)
{
    if (a < 0)
    {
        return -20;
    }
    if (a % b == 0)
    {
        return a / b - 1;
    }
    return a / b;
}

void solve3()
{
    for (int i = 0; i < m; ++i)
    {
        curHash = (curHash + (p[i] - 'a' + 1) * mult[i]) % MOD;
    }
    curHash = (curHash * mult[MAX_N - 1]) % MOD;
    ll cnt = 0;
    for (int i = 1; i <= n; ++i)
    {
        int c;
        cin >> c;
        if (c == 1)
        {
            string s;
            cin >> s;
            t += s;
            cnt++;
        }
        else
        {
            int pos;
            ll len;
            cin >> pos >> len;
            pos--;
            cnt += len / sz(t);
        }
    }
    string c = "";
    while (sz(c) <= 3 * sz(p))
    {
        c += t;
    }
    //cerr << c << '\n';
    h[0] = c[0] - 'a' + 1;
    for (int i = 1; i < sz(c); ++i)
    {
        h[i] = (h[i - 1] + (c[i] - 'a' + 1) * mult[i]) % MOD;
    }
    ll ans = 0;
    for (ll i = 0; i < sz(t); ++i)
    {
        if (curHash == ask(i, i + sz(p) - 1))
        {
            ll k = del(cnt * (ll)sz(t) - (ll)sz(p) - i + 1, (ll)sz(t));
            //cerr << i << ' ' << k << '\n';
            if (k + 1 > 0)
            {
                ans += k + 1;
            }
        }
    }
    cout << ans << '\n';
    return;
}

int solve()
{
    mult[0] = 1;
    for (int i = 1; i < MAX_N; ++i)
    {
        mult[i] = (mult[i - 1] * pm) % MOD;
    }
    cin >> m >> n;
    cin >> p;
    if (n == 1)
    {
        solve1();
        return 0;
    }
    solve3();
    return 0;
}

