#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define endl "\n"

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const ll P = 998244353;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}

void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

int check(int p, int l, int r)
{
    if (p >= l && p <= r)
        return 0;
    return min(abs(r - p), abs(l - p));
}

signed main()
{
    hello();

    int n, m, k;
    cin >> n >> m >> k;
    vector <vector<pii>> field(n + 1, vector<pii>(m + 1, {P, -P}));
    for (int i = 0; i < n + 1; ++i)
        field[i][m] = {0, 0};
    for (int i = 0; i < m + 1; ++i)
        field[n][i] = {0, 0};
    for (int i = 0; i < k; ++i)
    {
        int x, y, v;
        cin >> x >> y >> v;
        v %= P;
        field[x - 1][y - 1].first = field[x - 1][y - 1].second = v;
    }

    for (int t = m - 1; t >= 0; --t)
    {
        int j = t;
        int i = n - 1;
        while (j != m && i != -1)
        {
            if (field[i][j].first != P)
            {
                ++j;
                --i;
                continue;
            }
            field[i][j].first = min(field[i + 1][j].second, field[i][j + 1].second);
            field[i][j].second = max(field[i + 1][j].first, field[i][j + 1].first);
            ++j;
            --i;
        }
    }

    for (int t = n - 2; t >= 0; --t)
    {
        int j = 0;
        int i = t;
        while (j != m && i != -1)
        {
            if (field[i][j].first != P)
            {
                ++j;
                --i;
                continue;
            }
            field[i][j].first = min(field[i + 1][j].second, field[i][j + 1].second);
            field[i][j].second = max(field[i + 1][j].first, field[i][j + 1].first);
            ++j;
            --i;
        }
    }
    int res = 0;
    for (auto i : field)
    {
        for (auto j : i)
            res = (res + j.first + P * P) % P;
    }
    cout << res << endl;
}
