#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = 1005;
const ll INF = (ll)1e9 + 7;
const ll MOD = 998244353;
const int K = 10;

map<pii, ll> dp[2];
vector<pii> v;

int solve()
{
    int n, m, k;
    cin >> n >> m >> k;
    ll ans = 0;
    for (int i = 0; i < k; i++)
    {
        int x, y, c;
        cin >> x >> y >> c;
        dp[0][mp(x, y)] = dp[1][mp(x, y)] = c;
        ans = (ans + c + MOD) % MOD;
        for (int j = max(1, x - K); j <= x; j++)
            for (int d = max(1, y - K); d <= y; d++)
                v.pb(mp(j, d));
    }
    sort(v.rbegin(), v.rend());
    for (int i = 0; i < (int)v.size(); i++)
    {
        int tx = v[i].X, ty = v[i].Y;
        if (dp[0].find(mp(tx, ty)) != dp[0].end())
            continue;
        dp[0][mp(tx, ty)] = min(dp[1][mp(tx + 1, ty)], dp[1][mp(tx, ty + 1)]);
        dp[1][mp(tx, ty)] = max(dp[0][mp(tx + 1, ty)], dp[0][mp(tx, ty + 1)]);
        ans = (ans + dp[0][mp(tx, ty)] + MOD) % MOD;
    }
    cout << ans << endl;
    return 0;
}


