#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define int long long

string s;
vector<int> arr;

int solve(int count) {
	int count1 = 0;
	int count2 = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '0' && count1 != count) {
			count1++;
		}
		if (count1 == count && s[i] == '1') {
			count2++;
			count1 = 0;
		}
	}
	if (count2 == 0) {
		return 0;
	}
	if (count1 == count) {
		return count2 + (count2 + 1) * count;
	}
	else {
		return count2 - 1 + (count2) * count;
	}
}

int dist(int a, pair<int, int> b) {
	if (a >= b.first && a <= b.second) {
		return 0;
	}
	if (a < b.first) {
		return b.first - a;
	}
	return a - b.second;
}

signed main() {
	int n, m, k;
	cin >> m >> n >> k;
	vector < vector<int>> arr(m, vector<int>(2 * n));
	vector<pair<int, int>> b(k);
	for (int i = 0; i < k; i++) {
		cin >> b[i].first >> b[i].second;
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> arr[i][j];
		}
	}
	if (m == 1) {
		sort(arr[0].begin(), arr[0].end());
		int ans = 0;
		for (int i = 0; i < 2 * n; i += 2) {
			int c = arr[0][i];
			int d = arr[0][i + 1];
			int ans1 = 10000000000LL;
			for (int j = 0; j < k; j++) {
				if (ans1 > dist(c, b[j]) + dist(d, b[j])) {
					ans1 = dist(c, b[j]) + dist(d, b[j]);
				}
			}
			ans += ans1;
		}
		cout << ans;
		return 0;
	}
	if (n == 1) {
		int ans = 100000000;
		for (int i = 0; i < k; i++) {
			int ans1 = 0;
			for (int j = 0; j < m; j++) {
				ans1 += dist(arr[j][0], b[i]) + dist(arr[j][1], b[i]);
			}
			ans = min(ans, ans1);
		}
		cout << ans;
	}
	system("pause");
}