#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool cmp(const pair <int, int> &a, const pair <int, int> &b){
    return a.first < b.first || (a.first == b.first && a.second > b.second);
}

long long count(vector <int> &h, pair <int, int> &p){
    long long tr2 = 0;
    for (auto hn : h){
        if (p.first > hn || hn > p.second){
            tr2 += min(abs(hn - p.first), abs(hn - p.second));
        }
    }
    return tr2;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, k;
    cin >> m >> n >> k;
    vector <pair <int, int> > cp(k);
    for (int i = 0; i < k; i++){
        cin >> cp[i].first >> cp[i].second;
    }
    sort(cp.begin(), cp.end(), cmp);
    vector <pair <int, int> > p;
    for (int i = 0; i < k; i++){
        if (p.empty() || cp[i].second > p.back().second){
            p.push_back(cp[i]);
        }
    }
    k = p.size();
    vector <vector <int> > h(n);
    for (int i = 0; i < m; i++){
        vector <int> tmp(n * 2);
        for (int j = 0; j < n * 2; j++){
            cin >> tmp[j];
        }
        sort(tmp.begin(), tmp.end());
        for (int j = 0; j < n * 2; j++){
            h[j / 2].push_back(tmp[j]);
        }
    }
    long long res = 0;
    int j = 0;
    for (int i = 0; i < n; i++){
        long long tr = count(h[i], p[j]);
        long long tr2 = (j + 1 < k ? count(h[i], p[j + 1]) : 1000000000000000000);
        while (j + 1 < k && tr2 < tr){
            tr = tr2;
            j++;
            tr2 = (j + 1 < k ? count(h[i], p[j + 1]) : 1000000000000000000);
        }
        res += tr;
    }
    cout << res;
    return 0;
}