#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e6 + 10, M = 2010;
const ll MOD = 998244353;

int m, n, k;
ll s[N];
vector<vector<int> > h, a;
vector<pair<int, int> > p;
ll ans;

ll sum(int l, int r) {
    return s[r + 1] - s[l];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> m >> n >> k;
    h.assign(m, vector<int>(2 * n, 0));
    a.resize(n);
    for (int i = 0; i < k; i++) {
        int l, r;
        cin >> l >> r;
        p.push_back({l, r});
    }
    sort(p.begin(), p.end());
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 2 * n; j++)
            cin >> h[i][j];
        sort(h[i].begin(), h[i].end());
    }
    for (int i = 0; i < 2 * n; i += 2) {
        for (int j = 0; j < m; j++) {
            a[i / 2].push_back(h[j][i]);
            a[i / 2].push_back(h[j][i + 1]);
        }
        sort(a[i / 2].begin(), a[i / 2].end());
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++)
            s[j + 1] = s[j] + a[i][j];
        ll ss = 5e18;
        for (int j = 0; j < k; j++) {
            int l = p[j].first, r = p[j].second;
            int lb = -1, rb = a[i].size();
            while (lb + 1 < rb) {
                int mb = (lb + rb) / 2;
                if (a[i][mb] <= l)
                    lb = mb;
                else
                    rb = mb;
            }
            ll w = (ll)(lb + 1) * l - sum(0, lb);
            lb = -1, rb = a[i].size();
            while (lb + 1 < rb) {
                int mb = (lb + rb) / 2;
                if (a[i][mb] < r)
                    lb = mb;
                else
                    rb = mb;
            }
            w += sum(rb, a[i].size() - 1) - (ll)(a[i].size() - rb) * r;
            ss = min(ss, w);
        }
        ans += ss;
    }
    cout << ans << endl;

    return 0;
}
