#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

bool check(int d, vector<int> &dist, int need) {
	int left = 0;
	int now = 0;
	for (int i = 0; i < dist.size(); i++) {
		left += dist[i];
		if (left >= d) {
			now++;
			left = 0;
		}
	}
	if (now >= need + 1) return 1;
	return 0;
}

int main() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<int> pref(n + 1);
	pref[0] = 0;
	vector<int> dist;
	int d = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') d++;
		else {
			dist.push_back(d);
			d = 0;
		}
	}
	dist.push_back(d);
	int k = dist.size() - 1;
	int cnt0 = 0;
	int cnt1 = 0;
	int ans = 0;
	//for (auto elem : dist) cout << elem << " "; cout << endl;
	for (int i = 1; i <= k; i++) {
		int L = 0;
		int R = n;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (check(M, dist, i)) L = M;
			else R = M;
		}
		int ans1 = L * (i + 1) + i;
		if (ans1 > ans) {
			ans = ans1;
			cnt0 = L;
			cnt1 = i;
		}
	}
	/*
	for (int i = 0; i < n; i++) {
		pref[i + 1] = pref[i];
		if (s[i] == '0') pref[i + 1]++;
	}
	int now = n;
	vector<int> next(n);
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '1') {
			now = i;
		}
		next[i] = now;
	}
	
	for (int i = 0; i < n; i++) {
		int pt = 0;
		int last = 0;
		int help = 0;
		while (pt <= n) {
			if (pref[pt] - pref[last] >= i) {
				help++;
				last = next[pt];
				pt = last;
			}
			else pt++;
		}
		if (last != n) help--;
		int ans1 = i * (help) + help - 1;
		if (help == 1) continue;
		if (ans1 > ans) {
			ans = ans1;
			cnt0 = i;
			cnt1 = help - 1;
		}
	}
	*/
	cout << ans << endl;
	for (int i = 0; i < cnt1; i++) {
		for (int j = 0; j < cnt0; j++) cout << '0';
		cout << '1';
	}
	for (int j = 0; j < cnt0; j++) cout << '0';
	cout << endl;
	//cin >> n;
}