import java.util.*;
import java.util.stream.Collectors;

public class A {
    public static void main(String[] args) {
        try (Scanner scanner = new Scanner(System.in);
             Formatter formatter = new Formatter(System.out)) {
            int n = scanner.nextInt();
            String t = scanner.next();
            List<Integer> sizes = Arrays.stream(t.split("1"))
                    .map(String::length)
                    .sorted(Comparator.naturalOrder())
                    .collect(Collectors.toList());
            int m = -1;
            for (int i = 0; i < sizes.size() - 1; i++) {
                m = Math.max(m, sizes.get(i) * (sizes.size() - i) + (sizes.size() - 1 - i));
            }
            for (int i = 0; i < sizes.size() - 1; i++) {
                if (m == sizes.get(i) * (sizes.size() - i) + (sizes.size() - 1 - i)) {
                    formatter.format("%d\n", m);
                    for (int k = 0; k < sizes.get(i); k++) {
                        formatter.format("0");
                    }
                    for (int j = 0; j < sizes.size() - 1 - i; j++) {
                        formatter.format("1");
                        for (int k = 0; k < sizes.get(i); k++) {
                            formatter.format("0");
                        }
                    }
                    formatter.format("\n");
                    break;
                }
            }
        }
    }
}
