#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    ll total_l = 0;
    ostringstream input_os;
    for (ll i = 0; i < n; i++) {
        ll f;
        cin >> f;
        if (f == 1) {
            string w;
            cin >> w;
            input_os << f << " " << w << endl;
            total_l += w.size();
        }
        if (f == 2) {
            ll pos, len;
            cin >> pos >> len;
            total_l += len;
            input_os << f << " " << pos << " " << len << endl;
        }
    }
    istringstream input_is(input_os.str());
    auto search = [&](string &t) {
        bool first = true;
        set<ll> y;
        for (ll pw : {31, 61, 998244353}) {
            vector<ll> power(max(p.size(), t.size()), 1);
            for (ll i = 1; i < power.size(); i++) {
                power[i] = power[i - 1] * pw;
            }
            ll p_hash = 0;
            for (ll i = 0; i < (ll) p.size(); i++) {
                p_hash = p_hash + ((ll) (p[i] - 'a') + 1) * power[i];
            }
            vector<ll> t_hashes((ll) t.size());
            for (ll i = 0; i < (ll) t.size(); i++) {
                t_hashes[i] = (i == 0 ? 0 : t_hashes[i - 1]) + ((ll) (t[i] - 'a') + 1) * power[i];
            }
            set<ll> c;
            for (ll i = 0; i <= (ll) t.size() - (ll) p.size(); i++) {
                if (i + (ll) p.size() - 1 >= 0 && i + (ll) p.size() - 1 < (ll) t.size() &&
                    p_hash * power[i] == t_hashes[i + (ll) p.size() - 1] - (i == 0 ? 0 : t_hashes[i - 1])) {
                    c.insert(i);
                }
            }
            if (first) {
                y = c;
                first = false;
            } else {
                vector<ll> v;
                set_intersection(y.begin(), y.end(), c.begin(), c.end(), back_inserter(v));
                y = set<ll>(v.begin(), v.end());
            }
        }
        return y;
    };
    if (total_l <= (ll) 1e6) {
        string t;
        for (ll i = 0; i < n; i++) {
            ll f;
            input_is >> f;
            if (f == 1) {
                string w;
                input_is >> w;
                t.insert(t.end(), w.begin(), w.end());
            }
            if (f == 2) {
                ll pos, len;
                input_is >> pos >> len;
                pos--;
                for (ll j = pos; j < pos + len; j++) {
                    t.push_back(t[j]);
                }
            }
        }
        cout << search(t).size() << endl;
    } else {
        set<ll> y, z;
        ll l1 = -1;
        ll count = 0;
        for (ll i = 0; i < n; i++) {
            ll f;
            input_is >> f;
            if (f == 1) {
                string w;
                input_is >> w;
                string o = w;
                while (o.size() <= p.size()) {
                    o += w;
                }
                for (ll j = 0; j < 20; j++) {
                    o += w;
                }
                y = search(o);
                for (ll v : set<ll>(y)) {
                    if (v >= (ll) w.size()) {
                        y.erase(v);
                    }
                }
                z = search(w);
                l1 = (ll) w.size();
                count++;
            }
            if (f == 2) {
                ll pos, len;
                input_is >> pos >> len;
                count += len / l1;
            }
        }
        if (total_l != l1 * count) {
            return -1;
        }
        cout << (ll) y.size() * (count - 1) + (ll) z.size() << endl;
    }
    return 0;
}
