#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int max_k = 15;

int main() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int best = -1, best_for_all;
	for (uint32_t mask = 0; mask < (1 << max_k); ++mask) {
		vector<int> cnt;
		cnt.reserve(max_k + 1);
		cnt.push_back(0);
		int k = 0, on_flags = 0;
		for (int i = 0; i < n; ++i)
			if (s[i] == '0')
				++cnt.back();
			else {
				bool use = (mask >> k) & 1;
				++k;
				if (use) {
					cnt.push_back(0);
					++on_flags;
				}
			}
		int for_all = *min_element(cnt.begin(), cnt.end());
		int now = on_flags + (on_flags + 1) * for_all;
		if (on_flags && (best < now)) {
			best = now;
			best_for_all = for_all;
		}
	}

	string ans(best, '0');
	for (int i = best_for_all; i < best; i += best_for_all + 1)
		ans[i] = '1';
	cout << best << "\n" << ans;
}