#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const int md = 998244353;
 
void add(int &a, int b) {
    a += b;
    if (a >= md) a -= md;
}
 
int n, m, k;
 
bool ok(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    cin >> n >> m >> k;
    map <pair <int, int>, int> val;
    for (int i = 0; i < k; ++i) {
        int x, y, v;
        cin >> x >> y >> v;
        --x, --y;
     	val[{x, y}] = v;
    }
    int a = min(n, (int)3000);
    int b = min(m, (int)3000);
   	vector <vector <vector <int>>> dp(a + 1, vector <vector <int>> (b + 1, vector <int> (2)));
        for (int i = a - 1; i >= 0; --i) {
            for (int j = b - 1; j >= 0; --j) {
                for (int t = 0; t < 2; ++t) {
                    if (t == 0) {
                    	int x = n - (a - i - 1) - 1;
                    	int y = m - (b - j - 1) - 1;
                        if (val.count({x, y})) dp[i][j][t] = val[{x, y}];
                        else dp[i][j][t] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
                    }
                    else {
                    	int x = n - (a - i - 1) - 1;
                    	int y = m - (b - j - 1) - 1;
                        if (val.count({x, y})) dp[i][j][t] = val[{x, y}];
                        else dp[i][j][t] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
                    }
                }
            }   
        }
        int ans = 0;
        for (int i = 0; i < a; ++i) {
            for (int j = 0; j < b; ++j) {
                add(ans, (dp[i][j][0] % md + md) % md);
            }
        }
        cout << ans << '\n';
}