#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 998244353LL;

signed main() {
	int n, m, k;
	cin >> n >> m >> k;

	vector< vector<int> > holes(n, vector<int>(m));
	vector< vector<bool> > has_hole(n, vector<bool>(m));

	for(int i = 0; i < k; i++) {
		int r, c, v;
		cin >> r >> c >> v;
		r--; c--;
		holes[r][c] = v;
		has_hole[r][c] = true;
	}

	vector< vector<int> > g1(n + 1, vector<int>(m + 1));
	vector< vector<int> > g2(n + 1, vector<int>(m + 1));
	int ans = 0;
	for(int r = n - 1; r >= 0; r--) {
		for(int c = m - 1; c >= 0; c--) {
			if(has_hole[r][c]) {
				g1[r][c] = g2[r][c] = holes[r][c];
			} else {
				g1[r][c] = min(g2[r][c + 1], g2[r + 1][c]);
				g2[r][c] = max(g1[r][c + 1], g1[r + 1][c]);
			}
			ans += g1[r][c];
			ans %= MOD;
		}
	}

	cout << ((ans % MOD) + MOD) % MOD;

	return 0;
}