#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

#define ll long long
#define ld long double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define pld pair<ld, ld>
#define mp make_pair
#define fs first
#define sc second

const int inf = 1e9;
const ll INF = 2e18;
const int maxn = 1001;
const ll M = 998244353;

pi a[maxn][maxn];
bool used[maxn][maxn];
map<pi, pi> a2;


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	cin >> n >> m >> k;
	
	if (n < 6)
	{
		vector<int> xp;
		for (int i = 0; i < k; i++)
		{
			int r, c, v;
			cin >> r >> c >> v;
			r--;
			c--;
			a2[{r, c}] = { v, v };
			xp.push_back(c);
			//used[r][c] = true;
		}
		sort(xp.begin(), xp.end());
		for (int i = (int)xp.size() - 1; i > -1; i--)
		{
			for (int r = n - 1; r > -1; r--)
			{
				for (int posd = 0; posd <= 7; posd++)
				{
					int c = xp[i] - posd;
					if (c < 0)
						break;
					if (a2.find({ r + 1,c }) == a2.end())
						a2[{r + 1, c}] = { 0,0 };
					if (a2.find({ r,c + 1 }) == a2.end())
						a2[{r, c + 1}] = { 0,0 };
					if (a2.find({ r, c }) != a2.end())
						continue;
					a2[{r, c}] = { min(a2[{r + 1,c}].sc, a2[{r,c + 1}].sc), max(a2[{r + 1,c}].fs, a2[{r,c + 1}].fs) };
				}
			}
		}
		ll ans = 0;
		for (auto p : a2)
		{
			ans = (ans + p.sc.fs + M * 2) % M;
		}
		cout << ans << '\n';
		/*cout << "\n\n\n";
		for (int r = 0; r < n; r++)
		{
			for (int c = 0; c < m; c++)
			{
				if (a2.find({ r, c }) == a2.end())
					cout << " 0";
				else { 
					if (a2[{r, c}].fs >= 0)
						cout << ' ';
					cout << a2[{r, c}].fs;
				}
					
			}
			cout << '\n';
		}*/
	}
	else
	{
		for (int i = 0; i < k; i++)
		{
			int r, c, v;
			cin >> r >> c >> v;
			r--;
			c--;
			a[r][c] = { v, v };
			used[r][c] = true;
		}

		for (int r = n - 1; r > -1; r--)
		{
			for (int c = m - 1; c > -1; c--)
			{
				if (used[r][c])
					continue;
				a[r][c] = { min(a[r + 1][c].sc, a[r][c + 1].sc), max(a[r + 1][c].fs, a[r][c + 1].fs) };
			}
		}
		ll ans = 0;
		for (int r = 0; r < n; r++)
			for (int c = 0; c < m; c++)
				ans = (ans + a[r][c].fs + M * 2) % M;
		cout << ans << '\n';
	}


	
	/*for (int r = 0; r < n; r++)
	{
		for (int c = 0; c < m; c++)
			cout << a[r][c].fs << ' ';
		cout << '\n';
	}*/
}