#include <iostream>
#include <vector>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<int, int> > table(k);
    for (int i = 0; i < k; i++)
    {
        cin >> table[i].first >> table[i].second;
    }
    vector<vector<int> > groups(m, vector<int>(2 * n));
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            cin >> groups[i][j];
        }
    }
    if (n == 1)
    {
        long long answer = 1000000000000000000;
        for (int i = 0; i < k; i++)
        {
            long long res = 0;
            for (int j = 0; j < m; j++)
            {
                if (groups[j][0] > table[i].second)
                {
                    res += groups[j][0] - table[i].second;
                }
                if (groups[j][0] < table[i].first)
                {
                    res += table[i].first - groups[j][0];
                }
                if (groups[j][1] > table[i].second)
                {
                    res += groups[j][1] - table[i].second;
                }
                if (groups[j][1] < table[i].first)
                {
                    res += table[i].first - groups[j][1];
                }
            }
            answer = min(answer, res);
        }
        cout << answer;
        return 0;
    }
    return 0;
}
