#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 7;
const int maxk = 1e5 + 5;
const int mod = 998244353;

struct lov {
    int x, y, t;
    lov() {}
    void read() {
        cin >> x >> y >> t;
        x--;
        y--;
    }
};

vector <lov> lovs;
vector <int> grs;
vector <int> grst;
int dp1[maxn][maxk], dp2[maxn][maxk];
bool islov[maxn][maxk];
unordered_map <int, int> M;

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int n, m, k;
    cin >> n >> m >> k;
    lovs.resize(k);
    for (int i = 0; i < k; i++) {
        lovs[i].read();
    }
    for (int i = 0; i < k; i++) {
        grs.push_back(lovs[i].y);
        if (lovs[i].y)
            grs.push_back(lovs[i].y - 1);
    }
    grs.push_back(m - 1);
    sort(grs.begin(), grs.end());
    for (int i = 0; i < grs.size(); i++) {
        if (!i || grs[i] != grs[i - 1]) {
            grst.push_back(grs[i]);
        }
    }
    grs = grst;
    for (int i = 0; i < grs.size(); i++) {
        M[grs[i]] = i;
    }
    for (int i = 0; i < k; i++) {
        lovs[i].y = M[lovs[i].y];
        dp1[lovs[i].x][lovs[i].y] = dp2[lovs[i].x][lovs[i].y] = lovs[i].t;
        islov[lovs[i].x][lovs[i].y] = true;
        //cerr << "islov " << lovs[i].x << " " << lovs[i].y << "\n";
    }
    int res = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = grs.size() - 1; j >= 0; j--) {
            if (islov[i][j])
                continue;
            dp1[i][j] = min(dp2[i + 1][j], dp2[i][j + 1]);
            dp2[i][j] = max(dp1[i + 1][j], dp1[i][j + 1]);
            //cerr << i << " " << j << " " << grs[j] << "   " << dp1[i][j] << " " << dp2[i][j] << "\n";
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = grs.size() - 1; j >= 0; j--) {
            ll t = (ll)dp1[i][j] * (grs[j] - (j ? grs[j - 1] : -1));
            t %= mod;
            res = (res + t) % mod;
            res = (res + mod) % mod;
        }
    }
    cout << res;
    return 0;
}
