#include <cstdio>
#include <vector>
#include <algorithm>

char s[600000];
std::vector <int> segments;
const int INF = 1e9;

int get_min() {
    int ans = INF;
    for (auto x : segments) {
        ans = std::min(ans, x);
    }
    return ans;
}

int main() {
#ifdef LOCAL
   freopen("input.txt", "r", stdin);
#endif // LOCAL
    int n;
    scanf("%d", &n);
    scanf("%s", s);
    int j = 0;
    for (int i = 0; i < n; i++) {
        int start = i;
        j = i;
        while (j < n && s[j] == '0') {
            j++;
        }
        segments.emplace_back(j - start);
        i = j;
    }
    if (s[n - 1] == '1') {
        segments.push_back(0);
    }
//    printf("%d\n", segments.size());
    int ans = get_min() * segments.size() + segments.size() - 1;
    int ansDist = get_min();
    int ansAmount = segments.size() - 1;
    int q = (int)segments.size();
    for (int i = 0; i < q - 2; i++) {
        int ind = std::min_element(segments.begin(), segments.end()) - segments.begin();
        //printf("%d\n", ind);
        if (ind == 0) {
            segments[1] += segments[ind];
        } else if (ind == (int)segments.size() - 1) {
            segments[ind - 1] += segments[ind];
        } else {
            if (segments[ind - 1] > segments[ind + 1]) {
                segments[ind + 1] += segments[ind];
            } else {
                segments[ind - 1] += segments[ind];
            }
        }
        segments.erase(segments.begin() + ind);
        int z =  get_min() * (int)segments.size() + (int)segments.size() - 1;
        if (z > ans) {
            ans = z;
            ansAmount = q - i - 2;
            ansDist = get_min();
        }
    }
    printf("%d\n", ans);
    for (int i = 0; i <= ansAmount; i++) {
        for (int j = 0; j < ansDist; j++) {
            printf("0");
        }
        if (i != ansAmount) {
            printf("1");
        }
    }
    return 0;
}
