#ifdef LCL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define pll pair<ll, ll>
#define all(v) v.begin(), v.end()
#define pas(v) cout << #v << ' ' << v << endl;

void solve() {
	ll n, m, k; cin >> n >> m >> k;
	vvi lov(n, vi(m));
	ll mod = 998244353;
	vector<vvi> dp(n + 1, vvi(m + 1, vi(2)));
	for (int i = 0; i < k; i++) {
		ll x, y; cin >> x >> y;
		x--, y--;
		lov[x][y] = 1;
		ll v; cin >> v;
		dp[x][y][0] = dp[x][y][1] = v;
	}
	for (int i = n - 1; i > -1; i--) {
		for (int j = m - 1; j > -1; j--) {
			if (lov[i][j]) continue;
			dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
			dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
		}
	}
	ll res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
				res += dp[i][j][0];
				res %= mod;
		}
	}
	res += mod;
	res %= mod;
	cout << res << endl;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();

	return 0;
}