#include <bits/stdc++.h>
  
using namespace std;
  
#define ft first
#define sd second
#define pb push_back
#define sz(s) signed(s.size())
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
  
#define int long long
  
const int R = 998244353;
  
int f(int x, int y);
int g(int x, int y);
  
unordered_map< int, int > fm, gm;
unordered_set<int> line, col;
int n, m, k;
  
inline int get_hash(int x, int y) { return (x << 32) | y; }
 
int f(int x, int y) {
    if (y > m || x > n || !col.count(x) || !line.count(y)) return 0;
    if (fm.count(get_hash(x, y))) return fm[get_hash(x, y)];
    return fm[get_hash(x, y)] = max(g(x + 1, y), g(x, y + 1));
}
  
int g(int x, int y) {
    if (x > n || y > m || !col.count(x) || !line.count(y)) return 0;
    if (gm.count(get_hash(x, y))) return gm[get_hash(x, y)];
    return gm[get_hash(x, y)] = min(f(x + 1, y), f(x, y + 1));
}
  
void solve() {
    cin >> n >> m >> k;
 
    line.max_load_factor(0.25);
    fm.max_load_factor(0.25);
    gm.max_load_factor(0.25);
    line.reserve(k);
    col.reserve(k);
    col.max_load_factor(0.25);
    fm.reserve(k);
    gm.reserve(k);
    for (int i = 0; i < k; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        z %= R;
        if (z < 0) z += R;
        fm[get_hash(x, y)] = z;
        gm[get_hash(x, y)] = z;
        for (int j = - 2200; j < 2200; ++j) {
        	if (y + j >= 1 && y + j <= m) {
        		line.insert(y + j);	
        	}
        }
        for (int j = - 2200; j < 2200; ++j) {
        	if (x + j >= 1 && x + j <= n) {
        		col.insert(x + j);	
        	}
        }
    }
    int ans = 0;
    for (auto i : col) {
        for (auto j : line) {
            ans += g(i, j);
            if (ans > R) ans -= R;   
        }
    }
    cout << (ans + R) % R << endl;
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}