#include <iostream>
#include <stdio.h>
#include <algorithm>

using namespace std;

typedef long long ll;

#define int long long

const int maxn = 3000;

ll c[maxn][maxn];
ll c1[maxn][maxn];
bool here[maxn][maxn];

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int r, s;
        ll v;
        cin >> r >> s >> v;
        c[r - 1][s - 1] = v;
        c1[r - 1][s - 1] = v;
        here[r - 1][s - 1] = true;
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = min(m - 1, maxn); j >= 0; j--) {
            if (!here[i][j] && (i + j) % 2 == 0) {
                ll leftCost, rightCost;
                if (!here[i][j + 1]) leftCost = max(c[i][j + 2], c[i + 1][j + 1]);
                else leftCost = c[i][j + 1];
                if (!here[i + 1][j]) rightCost = max(c[i + 2][j], c[i + 1][j + 1]);
                else rightCost = c[i + 1][j];
                c[i][j] = min(leftCost, rightCost);
            }
            if (!here[i][j] && (i + j) % 2 == 1) {
                ll leftCost, rightCost;
                if (!here[i][j + 1]) leftCost = min(c[i][j + 2], c[i + 1][j + 1]);
                else leftCost = c[i][j + 1];
                if (!here[i + 1][j]) rightCost = min(c[i + 2][j], c[i + 1][j + 1]);
                else rightCost = c[i + 1][j];
                c[i][j] = max(leftCost, rightCost);
            }
        }
    }


    for (int i = n - 1; i >= 0; i--) {
        for (int j = min(maxn, m - 1); j >= 0; j--) {
            if (!here[i][j] && (i + j) % 2 == 1) {
                ll leftCost, rightCost;
                if (!here[i][j + 1]) leftCost = max(c1[i][j + 2], c1[i + 1][j + 1]);
                else leftCost = c[i][j + 1];
                if (!here[i + 1][j]) rightCost = max(c1[i + 2][j], c1[i + 1][j + 1]);
                else rightCost = c[i + 1][j];
                c1[i][j] = min(leftCost, rightCost);
            }
            if (!here[i][j] && (i + j) % 2 == 0) {
                ll leftCost, rightCost;
                if (!here[i][j + 1]) leftCost = min(c1[i][j + 2], c1[i + 1][j + 1]);
                else leftCost = c[i][j + 1];
                if (!here[i + 1][j]) rightCost = min(c1[i + 2][j], c1[i + 1][j + 1]);
                else rightCost = c1[i + 1][j];
                c1[i][j] = max(leftCost, rightCost);
            }
        }
    }

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < min(m, maxn); j++) {
            //cout << c[i][j] << ' ';
            if ((i + j) % 2 == 0) answer += c[i][j];
            if ((i + j) % 2 == 1) answer += c1[i][j];
        }//cout << endl;
    }
    cout << (answer % 998244353LL + 998244353LL) % 998244353LL << endl;
    return 0;
}

/*

3 3 3
2 3 -2
3 1 3
1 2 1

2 4 3
1 2 2
2 4 -3
2 1 1
*/
