#include<bits/stdc++.h>

using namespace std;

const int MAXN=5e5+123;

struct Node {
    int x;
    int l;
    int r;
    Node(int x_=0, int l_=0, int r_=0) {
        x=x_;
        l=l_;
        r=r_;
    }
};

int q[MAXN];
Node tree[MAXN*4];

void Build(int i, int l, int r) {
    if (l==r) {
        tree[i]=Node(q[l], l-1, l);
    }
    else {
        int m=(l+r)/2;
        Build(2*i+1, l, m);
        Build(2*i+2, m+1, r);
        if (tree[2*i+1].x<tree[2*i+2].x)
            tree[i]=tree[2*i+1];
        else
            tree[i]=tree[2*i+2];
    }
}

void Set(int i, int l, int r, int pos, int x) {
    if (l==r) {
        tree[i].x=x;
    }
    else {
        int m=(l+r)/2;
        if (pos<=m) Set(2*i+1, l, m, pos, x);
        if (pos>m) Set(2*i+2, m+1, r, pos, x);
        if (tree[2*i+1].x<tree[2*i+2].x)
            tree[i]=tree[2*i+1];
        else
            tree[i]=tree[2*i+2];
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    int m=0;
    int cnt=0;
    for (int i=0; i<n; i++) {
        char c;
        cin >> c;
        if (c=='0')
            cnt++;
        else {
            q[m++]=cnt;
            cnt=0;
        }
    }
    q[m++]=cnt;
    int x=0;
    for (int i=0; i<m; i++)
        x=max(q[i], x);
    int ans=1e9, j_, sz_;
    for (int j=0; j<=n-x-m+1; j++) {
        int cnt=0, ans_=0, sz=0;
        for (int i=0; i<m; i++) {
            if (cnt!=0) {
                ans_++;
            }
            cnt+=q[i];
            if (cnt>=j) {
                ans_+=cnt-j;
                cnt=0;
                sz++;
            }
        }
        if (cnt!=0) {
            if (cnt>=j) {
                ans_+=cnt-j;
                cnt=0;
                sz++;
            }
            else {
                ans_+=cnt+1;
            }
        }
        if (ans>ans_) {
            ans=ans_;
            j_=j;
            sz_=sz;
        }
    }
    cout << n-ans << endl;
    for (int i=0; i<sz_; i++) {
        for (int i=0; i<j_; i++)
            cout << '0';
        if (i!=sz_-1)
            cout << '1';
    }
    cout << endl;
    //Build(0, 0, m-1);
}

