#include <bits/stdc++.h>
using namespace std;

#define vi vector<int>
#define pb push_back
#define ff first
#define ss second
#define pii pair<int, int>
#define len(x) int((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
//#define begin(x) (x).begin()
//#define end(x) (x).end()

struct query {
    string add;
    int t, pos, len;
};

int m, n;
string p;
vector<query> queries;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r+", stdin);
//    freopen("output.txt", "w+", stdout);
}

void read() {
    cin >> m >> n;
    cin >> p;
    queries.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> queries[i].t;
        if (queries[i].t == 1) {
            cin >> queries[i].add;
        } else {
            cin >> queries[i].pos >> queries[i].len;
            --queries[i].pos;
        }
    }
}

vector<int> z_function(string s) {
    int n = len(s);
    vi z(n);
    for (int i = 0, l = 0, r = 0; i < len(s); ++i) {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < n && s[z[i]] == s[i + z[i]])
            ++z[i];
        if (i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

void solve_stupid(string t, vector<query> &queries) {
    string res = "";
    for (auto &query : queries) {
        if (query.t == 1) res += query.add;
        else
            for (int i = query.pos, c_len = query.len; c_len; ++i, --c_len)  res += res[i];

    }

    vector<int> z = z_function(t + res);
    int ans = 0; for (int i = 0; i < len(z) - len(t); ++i) ans += (z[i + len(t)] >= len(t));
    cout << ans;
}

int main() {
    init();
//    while (read()) {
//        solve();
//        cout.flush();
//    }
    read();
    solve_stupid(p, queries);
    cout.flush();
}
