#include <bits/stdc++.h>
using namespace std;

#define IDB if (debug)
#define int ll

typedef long long ll;
const ll oo = 1e18 + 4;
const int SZ = 1e3 + 4;
const ll M = 998244353;
const bool debug = 0;

int n, m, k;
ll mn[SZ][SZ], mx[SZ][SZ];
bool us[SZ][SZ];
ll ans;

void read() {
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--; y--;
        mn[x][y] = mx[x][y] = w;
        us[x][y] = 1;
    }
    us[n - 1][m - 1] = 1;
}

void upd(int i, int j) {
    mn[i][j] = oo;
    mx[i][j] = -oo;
    if (i < n - 1) {
        mn[i][j] = min(mn[i][j], mx[i + 1][j]);
        mx[i][j] = max(mx[i][j], mn[i + 1][j]);
    }
    if (j < m - 1) {
        mn[i][j] = min(mn[i][j], mx[i][j + 1]);
        mx[i][j] = max(mx[i][j], mn[i][j + 1]);
    }
    if (j == m - 1 || i == n - 1) {
        mn[i][j] = min(0ll, mn[i][j]);
        mx[i][j] = max(0ll, mx[i][j]);
    }
    us[i][j] = 1;
}

void upd() {
    ans %= M;
    ans += M;
    ans %= M;
}

void solve() {
    for (int i = n - 1; i >= 0; i--)
        for (int j = m - 1; j >= 0; j--) {
            if (!us[i][j]) upd(i, j);
//            IDB cout << mn[i][j] << " \n"[j == 0];
            ans += mn[i][j];
            upd();
        }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    IDB freopen("in.txt", "r", stdin);

    read();
    solve();
}
