#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second

const long long mod = 998244353;

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    //freopen("in2.txt", "r", stdin);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<pair<long long, long long>>> lst(n + 1, vector<pair<long long, long long>> (m + 1));
    vector<vector<bool>> used(n, vector<bool> (m));
    int x, y, value;
    for (int i = 0; i < k; i++){
        cin >> x >> y >> value;
        x--; y--;
        lst[x][y] = {value, value};
        used[x][y] = true;
    }

    for (int i = n - 1; i >= 0; i--)
        for (int j = m - 1; j >= 0; j--){
            if (used[i][j])
                continue;
            lst[i][j].f = min(lst[i + 1][j].s, lst[i][j + 1].s);
            lst[i][j].s = max(lst[i + 1][j].f, lst[i][j + 1].f);
        }

    long long ans = 0;
    for (int i = n - 1; i >= 0; i--){
        for (int j = m - 1; j>= 0; j--){
            ans += lst[i][j].f;
            //cout << lst[i][j].f << " ";
        }
        //cout << endl;
    }


    if (ans >= 0)
        cout << ans % mod;
    else if (ans % mod == 0)
        cout << 0;
    else
        cout << mod + (ans % mod);
    return 0;
}