#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll
const int INF = 1e9 + 10;
const ll BINF = 1e18 + 10;

vector<int> z_function(string s) {
  int n = SZ(s), l = 0, r = 1;
  vector<int> z(n);
  for (int i = 1; i < n; i++) {
    z[i] = min(z[i - l], max(r - i, 0ll));
    while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
      z[i]++;
    }
    if (i + z[i] > r) {
      l = i;
      r = i + z[i];
    }
  }
  return z;
}

int f(string s, string t) {
  vector<int> z = z_function(s + t);
  int ans = 0;
  for (int i = SZ(s); i < SZ(s) + SZ(t); i++) {
    if (z[i] >= SZ(s)) {
      ans++;
    }
  }
  return ans;
}

const int N = 1e7 + 10;
const int P = 239017;
string s, t;
int p_pow[N], hs[N], clc;
int pref[N];
int get_hash(int l, int r) {
  int res = hs[r];
  if (l > 0) res -= hs[l - 1];
  return res * p_pow[10000000 - r];
}

void add_char(char c) {
  //cout << c << '\n';
  int ind = SZ(t);
  if (ind == 0) {
    hs[0] = c * p_pow[0];
    t.pb(c);
  }
  else {
    hs[ind] = hs[ind - 1] + c * p_pow[ind];
    t.pb(c);
  }
  //cout << get_hash(SZ(t) - SZ(s), SZ(t) - 1) << '\n';
  if (SZ(t) >= SZ(s) && get_hash(SZ(t) - SZ(s), SZ(t) - 1) == clc) {
    pref[ind + 1] = pref[ind] + 1;
  }
  else {
    pref[ind + 1] = pref[ind];
  }
  //cout << ind << ' ' << pref[ind] << ' ' << pref[ind + 1] << '\n';
}

void source() {
  p_pow[0] = 1;
  for (int i = 1; i <= 1e7; i++) {
    p_pow[i] = p_pow[i - 1] * P;
  }
  //cout << p_pow[1] << ' ' << p_pow[2] << '\n';
  int m, n;
  cin >> m >> n;
  cin >> s;
  for (int i = 0; i < m; i++) {
    clc += s[i] * p_pow[i];
  }
  clc *= p_pow[10000000 - (m - 1)];
  bool one = true;
  for (int i = 1; i < m; i++) {
    if (s[i] != s[0]) {
      one = false;
    }
  }
  if (n == 1) {
    string t;
    cin >> t >> t;
    cout << f(s, t);
    exit(0);
  }
  string lst = "";
  int ans = 0;
  for (int i = 1; i <= n; i++) {
    int type;
    cin >> type;
    if (type == 1) {
      string add;
      cin >> add;
      ans += f(s, add);
      string xx = lst;
      for (int j = 0; j < min(m - 1, SZ(add)); j++) {
        xx.pb(add[j]);
      }
      ans += f(s, xx);
      int ptr = 0;
      while (ptr < SZ(add) && SZ(t) < 1e7) {
        add_char(add[ptr++]);
      }
      if (SZ(add) >= m - 1) {
        reverse(all(add));
        while (SZ(add) > m - 1) {
          add.pop_back();
        }
        reverse(all(add));
        lst = add;
      }
      else {
        reverse(all(lst));
        while (SZ(lst) + SZ(add) > m - 1) {
          lst.pop_back();
        }
        reverse(all(lst));
        lst += add;
      }
    }
    else {
      int pos, len;
      cin >> pos >> len;
      for (int j = 0; j < len; j++) {
        if (SZ(t) == 1e7) {
          break;
        }
        add_char(t[pos - 1 + j]);
      }
      ans += pref[len];
      string xx = lst, add;
      for (int j = 0; j < min(len, m - 1); j++) {
        add += t[pos - 1 + j];
      }
      xx += add;
      ans += f(s, xx);
      if (SZ(add) >= m - 1) {
        lst = {};
        for (int j = len - (m - 1) + 1; j <= len; j++) {
          lst.pb(t[pos - 2 + j]);
        }
      }
      else {
        reverse(all(lst));
        while (SZ(lst) + SZ(add) > m - 1) {
          lst.pop_back();
        }
        reverse(all(lst));
        lst += add;
      }
    }
  }
  cout << ans;
}

signed main() {
#ifdef extraterrestrial_
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  source();
#ifdef extraterrestrial_
  cerr << "\n\nTIME :: " << clock() * 1.0 / CLOCKS_PER_SEC;
#endif
  return 0;
}
