#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
#include <assert.h>

using namespace std;

int n;
string s;
vector<int> cnt, nx;

int solve(int ots)
{
	int l = 0, r = n, mi = 0, have = 0;
	
	while (l + 1 < r)
	{
		int m = (l + r) / 2;
		if (cnt[m] - mi >= ots)
			r = m;
		else
			l = m;
	}
	
	/*while (l < n)
	{
		if (cnt[l + 1] >= ots)
			break;
		l++;
	}*/
	int pos = l + 1;

	//pos = l;

	if (cnt[pos + 1] < ots)
	{
		return 0;
	}
	l = nx[l] + 1;
	if (l >= n)
		return 0;
	int count = 0;
	while (l < n)
	{
		r = n;
		int st = cnt[l];
		
		while (l + 1 < r)
		{
			int m = (l + r) / 2;
			if (cnt[m + 1] - st >= ots)
				r = m;
			else
				l = m;
		}
		/*while (l < n)
		{
			if (cnt[l + 1] - st >= ots)
				break;
			l++;
		}*/
		int pos = l + 1;

		//pos = l;

		if (cnt[pos + 1] - st < ots)
		{
			if (have == 0)
				return 0;
			return have + ots;
		}
		have += 1;
		have += ots;
		l = nx[l + 1] + 1;
	}
	return have + ots;

}

bool good(string s)
{
	int i = 0;
	while (i < s.size())
	{
		if (s[i] == '1')
			break;
		i++;
	}
	if (i >= s.size())
		return false;
	int st = i + 1;
	for (int j = i; j < s.size(); j++)
	{
		if (s[j] == '1')
		{
			if ((j + 1) % st != 0)
				return false;
		}
		else
		{
			if ((j + 1) % st == 0)
				return false;
		}
	}
	for (int j = s.size() - 1; j > (int)s.size() - st; j--)
		if (s[j] != '0')
			return false;
	return true;
}

string stress(int n, string s)
{
	string ans;
	for (int mask = 0; mask < (1 << 16); mask++)
	{
		string nw;
		for (int i = 0; i < n; i++)
		{
			if (mask & (1 << i))
				nw += s[i];
		}
		if (good(nw))
		{
			good(nw);
			if (nw.size() >= ans.size())
				ans = nw;
		}
	}
	return ans;
}

signed main()
{
	for (int it = 0; it < 1; it++)
	{
		cin >> n;
		cin >> s;
		/*
		//n = 10;
		//s.clear();
		for (int i = 0; i < n; i++)
		{
			if (rand() % 2)
				s += '1';
			else
				s += '0';
		}
		*/
		//string real_ans = stress(n, s);

		cnt.resize(n + 5, 0);
		nx.resize(n + 5, 0);
		for (int i = 0; i < n; i++)
		{
			cnt[i + 1] = cnt[i];
			if (s[i] == '0')
				cnt[i + 1]++;
		}
		cnt[n + 1] = cnt[n];
		int last = n;
		for (int i = n - 1; i >= 0; i--)
		{
			if (s[i] == '1')
				last = i;
			nx[i] = last;
		}
		for (int i = n; i < n + 5; i++)
			nx[i] = n + 1;
		int ANS = 0;
		for (int i = 0; i < n; i++)
			if (s[i] == '1')
				ANS++;
		int ans = ANS, gt = 0;

		for (int i = 1; i <= n + 5; i++)
		{
			int x = solve(i);
			if (ans < x)
			{
				ans = x;
				gt = i;
			}
		}
		//cout << s << '\n';
		//cout << ans << '\n';
		int nw = 0;
		string get;
		while (nw != ans)
		{
			for (int i = 0; i < gt; i++)
				get += '0';
			nw += gt;
			if (nw != ans)
			{
				get += '1';
				nw++;
			}
		}
		cout << get.size() << "\n" << get << '\n';
		return 0;
		/*
		//cout << s;
		if (get != real_ans)
		{
			cout << s << '\n';
			cout << real_ans << " " << get << '\n';
		}
		cout << it << '\n';
		//return 0;
		*/
	}
}