#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

struct go
{
	int l, r;
};

const int inf = 1e18;

int m, n, k, opt = 0;
vector<go> a;
vector<vector<int>> h;

int get(go a, int h)
{
	if (a.l <= h && h <= a.r)
		return 0;
	if (h > a.r)
		return h - a.r;
	else
		return a.l - h;
}

int gg(int pos, int j)
{
	int now = 0;
	for (int i = 0; i < m; i++)
	{
		now += get(a[pos], h[i][j]) + get(a[pos], h[i][j + 1]);
	}
	return now;
}

int solve(int j)
{
	int best = inf;
	int l = 0, r = k - 1;

	while (l + 2 < r)
	{
		int m1 = l + (r - l) / 3, m2 = l + (r - l) * 2 / 3;
		if (gg(m1, j) < gg(m2, j))
			r = m2;
		else
			l = m1;
	}
	while (l < r)
	{
		best = min(best, gg(l, j));
		l++;
	}
	return best;
}

signed main()
{
	cin >> m >> n >> k;
	a.resize(k);
	for (int i = 0; i < k; i++)
	{
		cin >> a[i].l >> a[i].r;
	}
	sort(a.begin(), a.end(), [](const go& a, const go& b) {return a.l < b.l; });
	h.resize(m, vector<int>(2 * n));
	int ans = 0;
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
			cin >> h[i][j];
		sort(h[i].begin(), h[i].end());
	}
	for (int j = 0; j < 2 * n; j += 2)
	{
		ans += solve(j);
	}
	cout << ans;
	return 0;
}