#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

const int mod = 998244353, inf = 1e9;

signed main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector < vector<int> > dp(n + 1, vector<int>(m + 1, (int)0)), bd(n + 1, vector<int>(m + 1, (int)0));
	for (int nm = 0; nm < k; nm++)
	{
		int i, j, c;
		cin >> i >> j >> c;
		//swap(i, j);
		dp[--i][--j] = c;
		bd[i][j] = c ;
	}
	int sm = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		for (int j = m - 1; j >= 0; j--)
		{
			if (!dp[i][j])
			{
				dp[i][j] = inf, bd[i][j] = -inf;
				dp[i][j] = min(bd[i][j + 1], bd[i + 1][j]);
				bd[i][j] = max(dp[i][j + 1], dp[i + 1][j]);
			}
			sm = sm + dp[i][j];
		}

	}
	while (sm < 0)
		sm += mod;
	cout << sm % mod << endl;
	return 0;
}