#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

const int mod = 998244353;

struct go
{
	int i, j, c;
};

signed main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<go> obn;
	for (int nm = 0; nm < k; nm++)
	{
		int i, j, c;
		cin >> i >> j >> c;
		obn.push_back({ --i, --j, c });
	}
	sort(obn.begin(), obn.end(), [](const go& a, const go& b) {return a.i > b.i; });
	
	vector<int> dp1(m + 1, 0), bd1(m + 1, 0), dp2(m + 1, 0), bd2(m + 1, 0);
	int pos = 0;
	int sm = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		for (int nw = pos; nw < k; nw++)
		{
			if (obn[nw].i == i)
			{
				dp1[obn[nw].j] = obn[nw].c;
				bd1[obn[nw].j] = obn[nw].c;
			}
			else
				break;
			pos++;
		}
		for (int j = m - 1; j >= 0; j--)
		{
			if (!dp1[j])
			{
				dp1[j] = min(bd1[j + 1], bd2[j]);
				bd1[j] = max(dp1[j + 1], dp2[j]);
			}
			sm = sm + dp1[j];
		}
		dp2 = dp1;
		bd2 = bd1;
		dp1.assign(m + 1, 0);
		bd1.assign(m + 1, 0);

	}
	//sm += (1000 * 1000) * mod;
	while (sm <= 0)
		sm += mod;
	cout << sm % mod << endl;
	return 0;
}