#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

pair <int, int> otr[200005];
int optimum[200005];
vector <pair <int, int> > seg;
vector <vector <int> > spis;
int n, m, k;

bool cmp(pair <int, int> A, pair <int, int> B)
{
    return (A.x < B.x) || (A.x == B.x && A.y > B.y);
}

void find_optimum(int lef, int rig, int grl, int grr)
{
    if (lef > rig) return;

    int mid = (lef + rig) / 2;
    ll mins = -1;
    for (int i = grl; i <= grr; i++)
    {
        pair <int, int> A = seg[i];
        ll tek = 0;
        for (int z = 1; z <= m; z++)
        {
            if (spis[z][2 * mid] < A.x) tek += (ll) (A.x - spis[z][2 * mid]);
            if (spis[z][2 * mid] > A.y) tek += (ll) (spis[z][2 * mid] - A.y);
            if (spis[z][2 * mid + 1] < A.x) tek += (ll) (A.x - spis[z][2 * mid + 1]);
            if (spis[z][2 * mid + 1] > A.y) tek += (ll) (spis[z][2 * mid + 1] - A.y);
        }
        if (mins == -1) optimum[mid] = i, mins = tek;
        else
        {
            if (tek < mins) mins = tek, optimum[mid] = i;
        }
    }
    find_optimum(lef, mid - 1, grl, optimum[mid]);
    find_optimum(mid + 1, rig, optimum[mid], rig);
    return;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> m >> n >> k;

    for (int i = 1; i <= k; i++) cin >> otr[i].x >> otr[i].y;
    sort(otr + 1, otr + k + 1, cmp);
    seg.pb(otr[1]);
    int last = otr[1].y;
    for (int i = 2; i <= k; i++)
        if (otr[i].y > last)
        {
            seg.pb(otr[i]);
            last = otr[i].y;
        }

    spis.resize(m + 1);
    for (int i = 1; i <= m; i++)
    {
        spis[i].resize(2 * n);
        for (int j = 0; j < 2 * n; j++) cin >> spis[i][j];
        sort(spis[i].begin(), spis[i].end());
    }

    find_optimum(0, n - 1, 0, (int) seg.size() - 1);

    ll answer = 0;
    for (int i = 0; i < 2 * n; i += 2)
    {
        pair <int, int> A = seg[optimum[i / 2]];
        for (int z = 1; z <= m; z++)
        {
            if (spis[z][i] < A.x) answer += (ll) (A.x - spis[z][i]);
            if (spis[z][i] > A.y) answer += (ll) (spis[z][i] - A.y);
            if (spis[z][i + 1] < A.x) answer += (ll) (A.x - spis[z][i + 1]);
            if (spis[z][i + 1] > A.y) answer += (ll) (spis[z][i + 1] - A.y);
        }
    }
    cout << answer;
    return 0;
}

