#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const ll MOD = 998244353;

struct triple
{
    int lef, rig;
    ll val;
    triple(int a = 0, int b = 0, ll c = 0) {lef = a, rig = b, val = c;}
};

set <pair <int, ll> > spis[100005];
vector <triple> dp1, dp2, cop1, cop2;

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 1; i <= k; i++)
    {
        int row, col;
        ll val;
        cin >> row >> col >> val;
        spis[row].insert(mp(col, val));
    }

    ll answer = 0;
    dp1.pb(triple(1, m + 1, 0));
    dp2.pb(triple(1, m + 1, 0));
    for (int i = n; i >= 1; i--)
    {
        int uk = m;
        cop1.clear(), cop2.clear();
        cop1.pb(triple(m + 1, m + 1, 0)), cop2.pb(triple(m + 1, m + 1, 0));
        while (uk > 0)
        {
            while (!dp1.empty() && !dp2.empty() && uk < dp1.back().lef) dp1.pop_back(), dp2.pop_back();
            while (!dp1.empty() && !dp2.empty() && dp1.back().val == cop1.back().val && dp2.back().val == cop2.back().val && cop1.back().val == cop2.back().val)
            {
                if (!spis[i].empty())
                {
                    pair <int, ll> A = *spis[i].rbegin();
                    if (A.x >= dp1.back().lef)
                    {
                        if (A.x != dp1.back().rig)
                        {
                            cop1.pb(triple(A.x + 1, dp1.back().rig, dp1.back().val)), cop2.pb(triple(A.x + 1, dp2.back().rig, dp2.back().val));
                            uk = A.x;
                        }
                        cop1.pb(triple(A.x, A.x, A.y)), cop2.pb(triple(A.x, A.x, A.y));
                        uk--;
                        spis[i].erase(A);
                    }
                    else
                    {
                        cop1.pb(dp1.back()), cop2.pb(dp2.back());
                        uk = dp1.back().lef - 1;
                    }
                }
                else
                {
                    cop1.pb(dp1.back()), cop2.pb(dp2.back());
                    uk = dp1.back().lef - 1;
                }
                while (!dp1.empty() && !dp2.empty() && uk < dp1.back().lef) dp1.pop_back(), dp2.pop_back();
            }

            while (!dp1.empty() && !dp2.empty() && (dp1.back().val != cop1.back().val || dp2.back().val != cop2.back().val || cop1.back().val != cop2.back().val))
            {
                if (!spis[i].empty())
                {
                    pair <int, ll> A = *spis[i].rbegin();
                    if (A.x == uk)
                    {
                        cop1.pb(triple(A.x, A.x, A.y)), cop2.pb(triple(A.x, A.x, A.y));
                        uk--;
                        spis[i].erase(A);
                    }
                    else
                    {
                        ll a = cop1.back().val, b = cop2.back().val;
                        cop1.pb(triple(uk, uk, min(dp2.back().val, b)));
                        cop2.pb(triple(uk, uk, max(dp1.back().val, a)));
                        uk--;
                    }
                }
                else
                {
                    ll a = cop1.back().val, b = cop2.back().val;
                    cop1.pb(triple(uk, uk, min(dp2.back().val, b)));
                    cop2.pb(triple(uk, uk, max(dp1.back().val, a)));
                    uk--;
                }
                while (!dp1.empty() && !dp2.empty() && uk < dp1.back().lef) dp1.pop_back(), dp2.pop_back();
            }
        }

        dp1.clear(), dp2.clear();
        for (int i = (int) cop1.size() - 1; i >= 0; i--)
        {
            if (!cop1.empty() && !cop2.empty() && !dp1.empty() && dp1.back().val == cop1.back().val && !dp2.empty() && dp2.back().val == cop2.back().val)
            {
                dp1.back().rig = cop1.back().rig;
                dp2.back().rig = cop2.back().rig;
            }
            else dp1.pb(cop1.back()), dp2.pb(cop2.back());
            ll c = cop1.back().val;
            while (c < 0) c += MOD;
            c %= MOD;
            answer = (answer + (ll) (cop1.back().rig - cop1.back().lef + 1) * c % MOD) % MOD;
            cop1.pop_back(), cop2.pop_back();
        }
    }
    cout << answer;
    return 0;
}

