#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("data-sections")
#pragma GCC optimize("function-sections")
#pragma GCC optimize("section-anchors")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("unroll-loops")*/

#define ALL(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

int ans = 0;
const int mod = 998244353;

void solve_dp(int n, int m, vector<vector<int>> const& a, vector<vector<pair<int, int>>> &dp) {
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == (int)-2e9) {
                dp[i][j].first = min(dp[i + 1][j].second, dp[i][j + 1].second);
                dp[i][j].second = max(dp[i + 1][j].first, dp[i][j + 1].first);
            }

            int x = dp[i][j].first;
            while (x < 0) x += mod;
            x %= mod;

            ans = (ans + x) % mod;
        }
    }
}

struct obj {
    int i, j, x;
};

bool operator < (obj o1, obj o2) {
    return o1.j < o2.j;
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    assert(n <= 5);

    vector<obj> a(k);

    for (int i = 0; i < k; i++) {
        cin >> a[i].i >> a[i].j >> a[i].x;
        a[i].i--; a[i].j--;
    }
    sort(ALL(a));

    int last = 0;
    for (int i = 1; i <= k; i++) {
        if (i == k || a[i].j - a[i - 1].j > 2 * n) {
            int st = max(0, a[last].j - 2 * n);
            vector<vector<int>> aa(n + 1, vector<int>(a[i - 1].j - st + 2, (int)-2e9));
            vector<vector<pair<int, int>>> dp(aa.size(), vector<pair<int, int>>(aa[0].size()));

            for (int j = last; j < i; j++) {
                aa[a[j].i][a[j].j - st] = a[j].x;
                dp[a[j].i][a[j].j - st] = {a[j].x, a[j].x};
            }

            solve_dp(aa.size() - 1, aa[0].size() - 1, aa, dp);
            last = i;

        }
    }

    cout << ans;

    return 0;
}

/*

1 3 4
10 100
200 200
10 100
300 1000
5 10 20 15 200 90



*/
