#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fr(i, n) for(int i = 0; i < n; ++i)
#define fr_o(i, n) for(int i = 1; i < n; ++i)
#define inp(a, n) for(int i = 0; i < n; cin >> a[i++]);
#define ret return 0;
#define skip cout << '\n';
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")

ll INF = (ll) 1e20;

ll minim[1000][1000];
ll maxim[1000][1000];

void get(ll i, ll j, ll n, ll m) {
    ll dminim, rminim;
    ll dmaxim, rmaxim;
    if(i == n - 1) {
        dminim = 0;
        dmaxim = 0;
    }
    else {
        if(minim[i + 1][j] == INF) get(i + 1, j, n, m);
        dminim = minim[i + 1][j];
        dmaxim = maxim[i + 1][j];
    }
    if(j == m - 1) {
        rminim = 0;
        rmaxim = 0;
    }
    else {
        if(minim[i][j + 1] == INF) get(i, j + 1, n, m);
        rminim = minim[i][j + 1];
        rmaxim = maxim[i][j + 1];
    }
    minim[i][j] = min(rmaxim, dmaxim);
    maxim[i][j] = max(rminim, dminim);
}

int main() {
    fast
    ll n, m, k;
    cin >> n >> m >> k;
    fr(i, n) {
        fr(j, m) {
            minim[i][j] = INF;
            maxim[i][j] = INF;
        }
    }
    fr(i, k) {
        ll r, c, v;
        cin >> r >> c >> v;
        minim[r - 1][c - 1] = v;
        maxim[r - 1][c - 1] = v;
    }
    ll ans = 0;
    fr(i, n) {
        fr(j, m) {
            if(minim[i][j] == INF) {
                get(i, j, n, m);
            }
            ans += minim[i][j];
            ans += 998244353;
            ans %= 998244353;
        }
    }
    cout << ans;
}