#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

void solve(int n, string str){
    int m = (1 << n);
    vi p(20);
    p[0] = 1;
    for (int i = 1; i < 20; ++i) p[i] = p[i - 1] * 2;
    int ans = 0;
    string opt = "";
    for (int mask = 0; mask < m; ++mask){
        string str1 = "";
        for (int j = 0; j < n; ++j){
            if ((mask & p[j]) > 0) str1 += str[j];
        }
        vpii a;
        for (int i = 0; i < str1.length(); ++i) {
            if (str1[i] == '1') {
                a.pb({0, 0});
                int j = i;
                while (j >= 0) {
                    j--;
                    if (str1[j] == '1') {
                        break;
                    }
                }
                j++;
                a.back().F = i - j;
                j = i;
                while (j < str1.length()) {
                    j++;
                    if (str1[j] == '1') {
                        break;
                    }
                }
                j--;
                a.back().S = j - i;
            }
        }
        int cnt = 0;
        for (int j = 0; j < str1.size(); ++j) cnt += (str1[j] == '1');
        int x = 100;
        for (int i = 0; i < cnt; ++i) x = min(x, min(a[i].F, a[i].S));
        if (cnt + (cnt + 1) * x > ans && x != 100){
            ans = cnt + (cnt + 1) * x;
            opt = str1;
        }
    }
    cout << ans << endl << opt << endl;
}

int main() {
    init();
    int n;
    string str;
    cin >> n >> str;
    solve(n, str);
    return 0;
    vpii a;
    for (int i = 0; i < n; ++i) {
        if (str[i] == '1') {
            a.pb({0, 0});
            int j = i;
            while (j >= 0) {
                j--;
                if (str[j] == '1') {
                    break;
                }
            }
            j++;
            a.back().F = i - j;
            j = i;
            while (j < n) {
                j++;
                if (str[j] == '1') {
                    break;
                }
            }
            j--;
            a.back().S = j - i;
        }
    }
    set<pii> set1;
    int m = a.size();
    for (int i = 0; i < m; ++i){
        set1.insert({min(a[i].F, a[i].S), i});
    }
    int ans = m + (m + 1) * set1.begin() -> F;
    int cnt = m;
    vi lt(m, -1), rt(m, -1);
    for (int i = 0; i < m; ++i){
        if (i > 0) lt[i] = i - 1;
        if (i + 1 < m) rt[i] = i + 1;
    }
    int opt = set1.begin() -> F;
    while (cnt > 0){
        cnt--;
        pii p = *set1.begin();
        set1.erase(p);
        int i = p.S;
        int i1 = lt[i], i2 = rt[i];
        if (i1 != -1){
            rt[i1] = rt[i];
            if (rt[i] != -1) lt[rt[i]] = i1;
            set1.erase({min(a[i1].F, a[i1].S), i1});
            a[i1].S += a[i].S;
            set1.insert({min(a[i1].F, a[i1].S), i1});
        }
        if (i2 != -1){
            lt[i2] = lt[i];
            if (lt[i] != -1) rt[lt[i]] = i2;
            set1.erase({min(a[i2].F, a[i2].S), i2});
            a[i2].F += a[i].F;
            set1.insert({min(a[i2].F, a[i2].S), i2});
        }
        int x = set1.begin() -> F;
        int y = x * cnt + x + cnt;
        if (y > ans){
            opt = x;
            ans = y;
        }
    }
    cout << ans << endl;
    string ANS = "";
    int z = set1.begin() -> F;
    for (int i = 0; i < opt; ++i) ANS += "0";
    while (ANS.length() < ans){
        ANS += "1";
        for (int i = 0; i < opt; ++i) ANS += "0";
    }
    cout << ANS << endl;
    return 0;
}
