#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>
#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

int n, m, k;

vpll b0;
const ll inf = 1024 * 1024 * 1023 * 2 - 1;
const ll INF = inf * inf;

int main() {
    init();
    cin >> m >> n >> k;
    b0.resize(k);
    for (int i = 0; i < k; ++i) cin >> b0[i].F >> b0[i].S;
    ll ans = 0;
    vvll a0(m, vll(2 * n));
    for (int i = 0; i < m; ++i){
        for (int j = 0; j < 2 * n; ++j) cin >> a0[i][j];
        sort(a0[i].begin(), a0[i].end());
    }
    vll b(k);
    for (int i = 0; i < k; ++i) b[i] = b0[i].F;
    for (int i = 0; i < m; ++i){
        int j = 0;
        for (int i1 = 0, i2 = 1; i1 < 2 * n; i1 += 2, i2 += 2){
            ll x1 = a0[i][i1], x2 = a0[i][i2];
            while (j < k){
                if (b[j] >= x1) break;
                j++;
            }
            if (j == k) j--;
            ll add1 = abs(b[j] - x1) + abs(b[j] - x2);
            ll add2 = INF, add3 = INF;
            if (j + 1 < k){
                add2 = abs(b[j + 1] - x1) + abs(b[j + 1] - x2);
            }
            if (j > 0){
                add3 = abs(b[j - 1] - x1) + abs(b[j - 1] - x2);
            }
            ans += min(add1, min(add2, add3));
        }
    }
    cout << ans << endl;
    return 0;
}
