#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>
#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvi vector<vi>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const int inf = 1024 * 1024 * 1023 * 2 - 1;
int n, m, k;
const ll mod = 998244353;

int main() {
    init();
    cin >> n >> m >> k;
    vvll mx(n, vll(m, -inf));
    vvll mn(n, vll(m, inf));
    vvi used(n, vi(m));
    for (int i = 0; i < k; ++i){
        int r, c, v;
        cin >> r >> c >> v;
        r--, c--;
        mx[r][c] = mn[r][c] = v;
        used[r][c] = 1;
    }
    for (int i = 0; i < n; ++i){
        if (used[i][m - 1] != 1){
            mn[i][m - 1] = mx[i][m - 1] = 0;
            if (i != n - 1 && used[i + 1][m - 1]){
                ll x = mx[i + 1][m - 1];
                mn[i][m - 1] = min(mn[i][m - 1], x);
                mx[i][m - 1] = max(mx[i][m - 1], x);
            }
        }
    }
    for (int i = 0; i < m; ++i){
        if (used[n - 1][i] != 1){
            mn[n - 1][i] = mx[n - 1][i] = 0;
            if (i != m - 1 && used[n - 1][i + 1]){
                ll x = mx[n - 1][i + 1];
                mn[n - 1][i] = min(mn[n - 1][i], x);
                mx[n - 1][i] = max(mx[n - 1][i], x);
            }
        }
    }
    for (int i = n - 2; i >= 0; --i){
        for (int j = m - 2; j >= 0; --j){
            if (used[i][j] == 1) continue;
            mn[i][j] = min(mx[i + 1][j], mx[i][j + 1]);
            mx[i][j] = max(mn[i + 1][j], mn[i][j + 1]);
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            ans += mn[i][j];
        }
    }
    ans %= mod;
    cout << (ans + mod) % mod << endl;
    return 0;
}
