#include <iostream>
#include "set"
#include "vector"
#include "algorithm"


using namespace std;

#define pb push_back
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ll long long
#define int long long

struct line
{
    int first, second, centre;
};
bool cmp(line a, line b)
{
    if (a.centre < b.centre)
        return true;
    if (a.centre > b.centre)
        return false;
    if (a.second - a.first > b.second - b.first)
        return true;
    return false;
}

 main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m, k;
    cin >> m >> n >> k;
    vector <line> v;
    set <pair<int, int> > st;
    for (int i = 0; i < k; i++)
    {
        int x, y;
        cin >> x >> y;
        st.insert({x, y});
    }
    for (auto it : st)
    {

        line t = {it.first, it.second, (it.first + it.second) / 2};
        v.pb(t);
    }
    sort(all(v), cmp);
    vector <int> sh[m];
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            int x;
            cin >> x;
            sh[i].pb(x);
        }
        sort(all(sh[i]));
    }
    int ans = 0;
    for (int i = 0; i < 2 * n; i += 2)
    {
        int sum = 0, num = 2 * m;
        vector <int> flex;
        for (int j = 0; j < m; j++)
        {
            flex.pb(sh[j][i]);
            flex.pb(sh[j][i+1]);
        }
        sort(all(flex));
        sum = flex[len(flex) / 2];
        int res = 2e18, ind = 0;
        int l = 0, r = len(v) - 1;
        while (l <= r)
        {
            int mid = (l + r ) /2;
            if (v[mid].centre >= sum)
            {
                r = mid - 1;
                ind = mid;
            }
            else
                l = mid + 1;
        }
        for (int g = max((ll)0, ind - 100); g < min(len(v), ind+250); g++)
        {
            int x = 0;
            for (int j = 0; j < m; j++)
            {
                x += max({(ll)0, v[g].first - sh[j][i], sh[j][i] - v[g].second});
                x += max({(ll)0, v[g].first - sh[j][i+1], sh[j][i+1] - v[g].second});
            }
            res = min(res, x);
        }
        ans += res;
    }
    cout << ans;
    return 0;
}