#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()

const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 5e5 + 7;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> v;
    int len = 0, cntOne = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            v.pb(len);
            cntOne++;
            len = 0;
        } else len++;
    }
    v.pb(len);
    sort(all(v));
    ll maxAns = cntOne, ansLen = 0, sumAns = cntOne + 1;
    vector<ll> prefSum(sz(v) + 1);
    for (int i = 1; i <= sz(v); ++i) {
        prefSum[i] = prefSum[i - 1] + v[i - 1];
    }
    for (int i = 1; i < n; ++i) {
        int indx = lower_bound(all(v), i) - v.begin();
        if (prefSum[indx] % i != 0)
            continue;
        ll cnt = min(1LL * cntOne + 1, prefSum[indx] / i + (sz(v) - indx));
        if (cnt == 1)
            continue;
        ll sum = cnt * i;
        if (sum > maxAns) {
            maxAns = sum + cnt - 1;
            ansLen = i;
            sumAns = cnt;
        }
    }
    cout << maxAns << endl;
    while (sumAns) {
        for (int j = 0; j < ansLen; ++j)
            cout << '0';
        if (sumAns > 1)
            cout << '1';
        sumAns--;
    }
}
