#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()

const int INF = 2e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 1005;
const ll MOD = 998244353;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

int rnd(int a, int b) {
    uniform_int_distribution<> dis(a, b);
    return dis(myRand);
}

ll minDp[MAXN][MAXN];
ll maxDp[MAXN][MAXN];
ll t[MAXN][MAXN];
ll is[MAXN][MAXN];

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, m, k, x, y, cost;
    cin >> n >> m >> k;
    for(ll i = 0; i < k; ++i) {
        cin >> x >> y >> cost;
        x--, y--;
        cost = (cost + MOD) % MOD;
        t[x][y] = cost;
        is[x][y] = 1;
    }
    for (ll i = n - 1; i >= 0; --i) {
        for (ll j = m - 1; j >= 0; --j) {
            if (is[i][j]) {
                minDp[i][j] = maxDp[i][j] = t[i][j];
                continue;
            }
            if (i + 1 == n)
                minDp[i][j] = 0;
            else
                minDp[i][j] = maxDp[i + 1][j];
            if (j + 1 == m)
                minDp[i][j] = min(minDp[i][j], 0LL);
            else
                minDp[i][j] = min(minDp[i][j], maxDp[i][j + 1]);

            if (i + 1 == n)
                maxDp[i][j] = 0;
            else
                maxDp[i][j] = minDp[i + 1][j];
            if (j + 1 == m)
                maxDp[i][j] = max(maxDp[i][j], 0LL);
            else
                maxDp[i][j] = max(maxDp[i][j], minDp[i][j + 1]);
        }
    }
    ll sum = 0;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            sum = (sum + minDp[i][j] + MOD) % MOD;
        }
    }
    cout << sum;
}
