#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

long long md = 998244353;

long long get(int n, int m, vector <int> x, vector <int> y, vector <int> z)
{
    long long val[n+1][m+1], b[n+1][m+1];

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) b[i][j] = 0;

    int k = x.size();
    //cout << k << " " << n <<  " " << m << "!!!\n";
    for (int i = 0; i < k; i++)
    {
        b[x[i]][y[i]] = 1;
        val[x[i]][y[i]] = z[i];
    }

    long long dp[n+1][m+1][2];

    for (int i = 0; i <= n; i++)
    {
        dp[i][m][0] = 0;
        dp[i][m][1] = 0;
        val[i][m] = 0;
        b[i][m] = 1;
    }

    for (int i = 0; i <= m; i++)
    {
        dp[n][i][0] = 0;
        dp[n][i][1] = 0;
        val[n][i] = 0;
        b[n][i] = 1;
    }

    long long sum = 0;

    for (int i = n-1; i >= 0; i--)
        for (int j = m-1; j >= 0; j--)
        {
            if (b[i][j])
            {
                dp[i][j][0] = val[i][j];
                dp[i][j][1] = val[i][j];
            }
            else
            {
                dp[i][j][0] = min(dp[i+1][j][1], dp[i][j+1][1]);
                dp[i][j][1] = max(dp[i+1][j][0], dp[i][j+1][0]);
            }

            sum = (sum + dp[i][j][0])%md;
        }

    sum = sum%md;
    sum = (sum + md)%md;

    return sum;
}


int main()
{
    int n, m, k;
    cin >> n >> m >> k;

    pair<pair<int, int>, int > v[k];

    for (int i = 0; i < k; i++)
    {
        cin >> v[i].first.second >> v[i].first.first >> v[i].second;
        v[i].first.second--;
        v[i].first.first--;
    }

    sort(v, v+k);

    vector <int> x, y, z;

    long long del = 0;
    int mx = 0, cc = 10;
    long long ans=  0;

    for (int i = 0; i <= k; i++)
    {
        if (i == k || mx < v[i].first.first - cc)
        {
            ans = (ans + get(n, mx-del+1, x, y, z))%md;
            x.clear();
            y.clear();
            z.clear();
            if (i == k) break;
            del = max(v[i].first.first-cc, 0);
            mx = v[i].first.first;
        }

            x.push_back(v[i].first.second);
            y.push_back(v[i].first.first - del);
            z.push_back(v[i].second);
            mx = max(mx, v[i].first.first);
    }

    ans = (ans%md + md)%md;

    cout << ans << "\n";
    return 0;
}
