#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

#define ll long long 
#define pii pair<int, int>
#define x first
#define y second

using namespace std;

const int NMAX = 211111;
const ll inf = 8e18;
const ll MOD = 998244353;

int dp[1111][2];

vector<int> x;
pair<pii, int> trap[NMAX];

int main()
{
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	int k;
	cin >> k;
	x.push_back(m);
	x.push_back(1);
	for (int i = 1; i <= k; i++)
	{
		cin >> trap[i].x.y >> trap[i].x.x >> trap[i].y;
		for (int y = max(1, trap[i].x.x - 10); y <= trap[i].x.x; y++)
			x.push_back(y);
	}
	sort(x.begin(), x.end());
	x.resize(unique(x.begin(), x.end()) - x.begin());
	reverse(x.begin(), x.end());
	sort(trap + 1, trap + k + 1);
	int cur = k;
	ll ans = 0;
	ll sum = 0;
	for (int i = 0; i < x.size(); i++)
	{
		if (i != 0 && x[i] != x[i - 1] - 1)
		{
			ans = (ans + sum * (x[i] - x[i - 1] - 1) + 2 * MOD) % MOD;
		}
		sum = 0;
		for (int j = n; j >= 1; j--)
		{
			if (cur != 0 && trap[cur].x.x == x[i] && trap[cur].x.y == j)
			{
				dp[trap[cur].x.y][0] = trap[cur].y;
				dp[trap[cur].x.y][1] = trap[cur].y;
				cur--;
			}
			else
			{
				int x = dp[j][0];
				int y = dp[j][1];
				dp[j][0] = min(dp[j + 1][1], y);
				dp[j][1] = max(dp[j + 1][0], x);
			}
		}
		for (int j = n; j >= 1; j--)
			sum = (sum + dp[j][0] + 2 * MOD) % MOD;
		ans = (ans + sum + 2 * MOD) % MOD;
	}
	cout << ans << endl;
	return 0;
}