#include<set>
#include<vector>
#include<string>
#include<utility>
#include<iostream>
#include<algorithm>
#include<assert.h>
#include<unordered_map>
using namespace std;

vector<int> len, pos;

int check(int m)
{
	int c = 0;
	for (int j = 0, cnt = 0; j < len.size(); j++)
	{
		cnt += len[j];
		if (cnt >= m)
		{
			cnt = 0;
			++c;
		}
	}
	return c;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	len.push_back(0);
	for (int i = 1; i <= n; i++)
	{
		char c;
		cin >> c;
		if (c == '1')
		{
			if (i != 1 && i != n) len.push_back(0);
			pos.push_back(i);
		}
		else
		{
			++len.back();
		}
	}

	int a_c = pos.size() - 1, a_k = 0;

	int l = 1, r = *max_element(len.begin(), len.end()) + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		int c_l = check(m), c_r = check(m + 1);
		if (c_l == 1 || c_r == 1)
		{
			r = m;
			continue;
		}
		if (c_l * m + c_l - 1 < c_r * (m + 1) + c_r - 1)
		{
			if (c_r * (m + 1) + c_r - 1 > a_c * a_k + a_c - 1)
			{
				a_c = c_r;
				a_k = m + 1;
			}
			l = m;
		}
		else
		{
			if (c_l * m + c_l - 1 > a_c * a_k + a_c - 1)
			{
				a_c = c_l;
				a_k = m;
			}
			r = m;
		}
	}
	int x = check(l);
	if (x * l + x - 1 > a_c * a_k + a_c - 1)
	{
		a_c = x;
		a_k = l;
	}

	if (a_k == 0)
	{
		cout << a_c + 1 << '\n';
		for (int i = 0; i <= a_c; i++)
		{
			cout << 1;
		}
	}
	else
	{
		cout << a_c * a_k + a_c - 1 << '\n';
		for (int i = 0; i < a_c - 1; i++)
		{
			for (int i = 0; i < a_k; i++) cout << 0;
			cout << 1;
		}
		for (int i = 0; i < a_k; i++) cout << 0;
	}
}