#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <math.h>
#include <map>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e10;

ll get(ll h, ll l, ll r)
{
	if (h >= l && h <= r)
		return 0;
	return min(abs(h - l), abs(h - r));
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll m, n, k;

	cin >> m >> n >> k;

	vector<ll> l(k), r(k);

	for (int i = 0; i < k; ++i)
		cin >> l[i] >> r[i];

	vector<vector<ll>> h(m, vector<ll>(2 * n));

	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < 2 * n; ++j)
		{
			cin >> h[i][j];
		}

		sort(h[i].begin(), h[i].end());
	}

	/*
	vector<vector<ll>> nh(n);

	for (int i = 0; i < n; ++i)
	{
		for (int day = 0; day < m; ++day)
		{
			nh[i].push_back(h[day][2 * i]);
			nh[i].push_back(h[day][2 * i + 1]);
		}
		sort(nh[i].begin(), nh[i].end());
	}
	vector<vector<ll>> ps(n, vector<ll> (2 *m));
	for (int day = 0; day < n; ++day)
	{
		ps[day][0] = 0;
		ll del = 0;
		for (int j = 1; j < nh[day].size(); ++j)
		{
			del += nh[day][j] - nh[day][j - 1];

			ps[day][j] = del * j;
		}
	}
	*/

	ll sum = 0;
	for (int i = 0; i < 2 * n; i += 2)
	{
		ll minn = inf;

		vector<ll> cond;

		map<ll, ll> ps;
		for (int day = 0; day < m; ++day)
		{
			ps[h[day][i]] += 1;
			ps[h[day][i + 1]] += 1;
		}
		for (int i = 0; i < k; ++i)
		{
			ps[l[i]] += 1;
			ps[r[i]] += 1;
		}

		ll pred = 0;
		for (auto in : ps)
		{
			ps[in.first] += pred;
			pred = ps[in.first];
		}

		for (int i = 0; i < k; ++i)
		{
			if (ps[l[i]] >= n / 2)
			{
				cond.push_back(i);
			}

			if (ps[r[i]] >= n / 2)
			{
				cond.push_back(i);
				cond.push_back(i + 1);
			}
		}

		for (ll t : cond)
		{
			ll cur = 0;
			for (int day = 0; day < m; ++day)
			{
				cur += get(h[day][i], l[t], r[t]);
				cur += get(h[day][i + 1], l[t], r[t]);
			}

			

			minn = min(minn, cur);
		}

		sum += minn;
	}

	cout << sum << endl;

	return 0;
}