#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

int mas[500010];
int nl[500010];
int n;
vector<pair<int, int>> ed;

int check(int l) {
	int lst = 0;
	int kol = 0;
	int lg = -1, r = ed.size() - 1, m;
	while (r - lg > 1) {
		m = (r + lg) / 2;
		if (ed[m].first >= lst + l) {
			r = m;
		}
		else {
			lg = m;
		}
	}
	while (r != ed.size() - 1) {
		if (nl[n] - nl[ed[r].second] < l) 
			break;
		lst += ed[r].first;
		kol += l + 1;
		lg = r, r = ed.size() - 1, m;
		while (r - lg > 1) {
			m = (r + lg) / 2;
			if (ed[m].first >= lst + l) {
				r = m;
			}
			else {
				lg = m;
			}
		}
	}
	if (kol == 0) {
		return 0;
	}
	return kol + l;
}

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	char c;
	for (int i = 0; i < n; i++) {
		cin >> c;
		mas[i] = c - '0';
	}
	for (int i = 0; i < n; i++) {
		if (mas[i] == 1) {
			ed.push_back({ i - ed.size(), i });
		}
	}
	ed.push_back({ 1e9, n });
	for (int i = 0; i < n; i++) {
		nl[i + 1] = nl[i];
		if (mas[i] == 0)
			nl[i + 1]++;
	}
	int maxk = 0;
	int ch = 0;
	for (int i = 0; i < n; i++) {
		if (maxk < check(i)) {
			maxk = check(i);
			ch = i;
		}
	}
	int kol = 0;
	cout << maxk << "\n";
	for (int i = 0; i < maxk; i++) {
		if (kol < ch) {
			cout << 0;
			kol++;
		}
		else {
			cout << 1;
			kol = 0;
		}
	}
	return 0;
}