#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <string>
using namespace std;
#define int long long

int f(string& s, int k) {
	int p = 0;
	int cnt = 0;
	for (auto& i : s) {
		char a = (cnt == k ? '1' : '0');
		if (i == a) {
			++p;
			cnt = (cnt + 1) % (k + 1);
		}
	}
	if (cnt != k && p >= k + 1) {
		p -= cnt + 1;
	}
	if (p < k + 1) p = 0;
	return p;
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	int last = -1;
	set <int> d;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			d.insert(i - last - 1);
			last = i;
		}
	}
	int rk = 0;
	int ans = 0;
	for (auto& k : d) {
		if (ans < f(s, k)) {
			ans = f(s, k);
			rk = k;
		}
	}
	string sans = "";
	int p = 0;
	int cnt = 0;
	for (auto& i : s) {
		char a = (cnt == rk ? '1' : '0');
		if (i == a) {
			++p;
			cnt = (cnt + 1) % (rk + 1);
			sans.push_back(i);
		}
	}
	if (cnt != rk && p >= rk + 1) {
		while (cnt + 1) {
			sans.pop_back();
			--cnt;
			//--ans;
		}
	}
	if (p < rk + 1) {
		while (p) {
			--p;
			sans.pop_back();
		}
	}
	cout << sans.size() << "\n" << sans;

}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef  _DEBUG
	cout << "Exec. time: " << (clock() + 0.0) / 1000 << "\n";
#endif
	return 0;
}