#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 998244353;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<pair<int, ll> > > used(n + 2);
    vector<vector<ll> > ans(n + 2);
    for (int i = 0; i <= n + 1; i++) {
        used[i].resize(m + 2, {0, 0});
        ans[i].resize(m + 2, 0);
    }
    for (int i = 0; i < k; i++) {
        int x, y;
        ll c;
        cin >> x >> y >> c;
        used[x][y] = {1, c};
    }
    ll sum = 0;
    for (int i = n; i > 0; i--) {
        for (int j = m; j > 0; j--) {
            if (used[i][j].first == 1) {
                ans[i][j] = used[i][j].second;
                sum += ans[i][j];
                sum = (sum + MOD) % MOD;
                continue;
            }
            ans[i][j] = 1e18;
            if (i == n || j == m) {
                ans[i][j] = 0;
            }
            if (i + 1 <= n && used[i + 1][j].first == 1) {
                ans[i][j] = min(ans[i][j], used[i + 1][j].second);
            }
            if (j + 1 <= m && used[i][j + 1].first == 1) {
                ans[i][j] = min(ans[i][j], used[i][j + 1].second);
            }
            if (i + 1 <= n && used[i + 1][j].first == 0) {
                ans[i][j] = min(ans[i][j], max(ans[i + 2][j], ans[i + 1][j + 1]));
            }
            if (j + 1 <= m && used[i][j + 1].first == 0) {
                ans[i][j] = min(ans[i][j], max(ans[i][j + 2], ans[i + 1][j + 1]));
            }
            sum += ans[i][j];
            sum = (sum + MOD) % MOD;
        }
    }
    sum = (sum + MOD) % MOD;
    cout << sum;
    return 0;
}
