#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>

using namespace std;

long long int INF = 1e18;
long long int mod = 998244353;
int n, m, k;

int main() {
	scanf("%d %d %d", &n, &m, &k);
	long long int** mas1 = new long long int*[n];
	long long int** mas2 = new long long int*[n];
	for (int i = 0; i < n; i++) {
		mas1[i] = new long long int[m];
		mas2[i] = new long long int[m];
		for (int j = 0; j < m; j++) {
			mas1[i][j] = INF;
			mas2[i][j] = INF;
		}
	}
	long long int i, j, v;
	for (int q = 0; q < k; q++) {
		scanf("%lld %lld %lld", &i, &j, &v);
		i--; j--;
		mas1[i][j] = v;
		mas2[i][j] = v;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (mas1[i][j] != INF) continue;
			if ((i + j) % 2 == 0){
				if (i == n - 1 && j == m - 1) mas1[i][j] = 0;
				else if (i == n - 1) mas1[i][j] = min(0ll, mas1[i][j + 1]);
				else if (j == m - 1) mas1[i][j] = min(0ll, mas1[i + 1][j]);
				else  mas1[i][j] = min(mas1[i + 1][j], mas1[i][j + 1]);
				if (i == n - 1 && j == m - 1) mas2[i][j] = 0;
				else if (i == n - 1) mas2[i][j] = max(0ll, mas2[i][j + 1]);
				else if (j == m - 1) mas2[i][j] = max(0ll, mas2[i + 1][j]);
				else  mas2[i][j] = max(mas2[i + 1][j], mas2[i][j + 1]);
			}
			else {
				if (i == n - 1 && j == m - 1) mas1[i][j] = 0;
				else if (i == n - 1) mas1[i][j] = max(0ll, mas1[i][j + 1]);
				else if (j == m - 1) mas1[i][j] = max(0ll, mas1[i + 1][j]);
				else  mas1[i][j] = max(mas1[i + 1][j], mas1[i][j + 1]);
				if (i == n - 1 && j == m - 1) mas2[i][j] = 0;
				else if (i == n - 1) mas2[i][j] = min(0ll, mas2[i][j + 1]);
				else if (j == m - 1) mas2[i][j] = min(0ll, mas2[i + 1][j]);
				else  mas2[i][j] = min(mas2[i + 1][j], mas2[i][j + 1]);
			}
		}
	}
	long long int res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if((i + j) % 2 == 0)
				res += mas1[i][j];
			else res += mas2[i][j];
		}
	}
	printf("%lld", ((res % mod) + mod) % mod);
	system("pause");
	return 0;
}