#pragma GCC optimaze("Ofast, no-stack-protectorz");
#pragma GCC optimaze("unroll-loops");
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<complex>
#include<map>
#include<set>
#include<math.h>
#include<random>
#include<chrono>

using namespace std;

mt19937 rng{ 197 };

const int maxn = 1e4 + 113;
long long dp[maxn];
long long zn[maxn][100];

signed main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	cout.setf(ios::fixed);
	cout.precision(10);
	int n, m, k;
	cin >> m >> n >> k;
	vector<vector<int>> sp;
	vector<pair<int, int>> te;
	for (int i = 0; i < k; i++)
	{
		int l, r;
		cin >> l >> r;
		te.push_back({ l, r });
	}
	sort(te.begin(), te.end());
	for (int i = 0; i < m; i++)
	{
		vector<int> gh;
		for (int i = 0; i < 2 * n; i++)
		{
			int a;
			cin >> a;
			gh.push_back(a);
		}
		sort(gh.begin(), gh.end());
		sp.push_back(gh);
	}
	for (int i = 0; i < k; i++)
	{
		int lk = te[i].first;
		int rk = te[i].second;
		for (int j = 0; j < n; j++)
		{
			long long su = 0;
			for (int u = 0; u < m; u++)
			{
				int f1 = sp[u][2 * j];
				int f2 = sp[u][2 * j + 1];
				if (lk >= f1 || f1 >= rk)
					su += min(abs(lk - f1), abs(rk - f1));
				if (lk >= f2 || f2 >= rk)
					su += min(abs(lk - f2), abs(rk - f2));
			}
			zn[j][i] = su;
		}
	}
	for (int i = 0; i <= n; i++)
		dp[i] = 1e18 + 113;
	dp[0] = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < k; j++)
		{
			long long su = 0;
			for (int u = 1; u <= n; u++)
			{
				su += zn[i + u - 1][j];
				dp[i + u] = min(dp[i + u], dp[i] + su);
			}
		}
	}
	cout << dp[n];
	//system("pause");
}

/*
1 2 2
5 25
50 90
60 5 10 40

2 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300
*/