#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vint;
typedef string str;
#define pb push_back
#define int long long
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
#define fs first
#define sc second

string s;
vint arr;
string makeAnswer(int d) {
    if (d == 0) {
        string t = "";
        rep(i, 0, sz(arr) - 1)
            t += "1";
        return t;
    }
    vint rawRes = {0};
    rep(i, 0, sz(arr)) {
        if (arr[i] + rawRes.back() >= d) {
            rawRes.back() = d;
            rawRes.pb(0);
        } else
            rawRes.back() += arr[i];
    }

    rawRes.pop_back();

    if (sz(rawRes) == 1 || rawRes.back() != d)
        assert(0);

    string res = "";
    for (int i : rawRes) {
        rep(j, 0, i)
            res += "0";
        res += "1";
    }

    res.pop_back();
    return res;
}

const int N = 5e5 + 1;
int repr[N], siz[N], cnt[N];
int ffind(int a) { return (a == repr[a]) ? a : repr[a] = ffind(repr[a]); }
int unite(int a, int b) {
    a = ffind(a);
    b = ffind(b);
    assert(a != b);
    if (siz[a] > siz[b])
        swap(a, b);
    repr[a] = b;
    siz[b] += siz[a];
    cnt[b] += cnt[a];
    return b;
}

void run() {
    int n;
    cin >> n;
    cin >> s;

    int cur = 0;
    for (char i : s) {
        if (i == '1') {
            arr.pb(cur);
            cur = 0;
        } else
            cur++;
    }
    arr.pb(cur);
    for (int i : arr) cerr << i << " "; cerr << endl;
    int m = sz(arr);
    for (int i = 0; i < m; i++) {
        repr[i] = i;
        siz[i] = 1;
        cnt[i] = arr[i];
    }

    set<pair<int, int>> curElements;
    set<pair<int, int>> groups;
    for (int i = 0; i < m; i++) {
        curElements.insert({arr[i], i});
        groups.insert({i, arr[i]});
    }

    int d = (*curElements.begin()).fs, res = d * sz(curElements) + sz(curElements) - 1;
    while (sz(curElements) != 1) {
        auto z = *curElements.begin();
        groups.erase(make_pair(z.sc, z.fs));
        curElements.erase(z);

        auto pp = groups.lower_bound(make_pair(z.sc, 0));
        pair<int, int> pos = {-1, 1000000000};
        if (pp != groups.end())
            pos = *pp;

        if (pp != groups.begin()) {
            pp--;
            auto ppos = *pp;
            if (ppos.sc < pos.sc)
                pos = ppos;
        }

        groups.erase(pos);
        curElements.erase({pos.sc, pos.fs});

        int b = unite(z.sc, pos.fs);
        groups.insert({b, cnt[b]});
        curElements.insert({cnt[b], b});

        if (sz(curElements) == 1)
            break;

        int pd = (*curElements.begin()).fs, pres = pd * sz(curElements) + sz(curElements) - 1;
        if (res < pres) {
            d = pd;
            res = pres;
        }
    }

    cout << res << endl;
    cout << makeAnswer(d) << endl;
}

signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
